var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Hello World</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Hello World</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"hello-world\"></a></div>\n\
<p>この基本的な Maya Hello World C++ ソース コードは、Maya 出力ウィンドウに「Hello World」を出力するプラグインを作成します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">#include  &lt;maya/MSimple.h&gt;\n\
#include &lt;maya/MIOStream.h&gt;\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"DeclareSimpleCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gaf3b44fe07495c3792b926494fca7b517&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">DeclareSimpleCommand</a>( helloWorld, &quot;Autodesk&quot;, &quot;2020&quot;);\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> helloWorld::doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; )\n\
{\n\
    cout &lt;&lt; &quot;Hello World\\n&quot; &lt;&lt; endl;\n\
    return MS::kSuccess;\n\
}\n\
</pre></div><p>このコードをプラグインにコンパイルするには、<span class=\'code\'>helloWorld</span> フォルダを作成し、このフォルダにこのコードを <span class=\'code\'>helloWorld.cpp</span> というファイル名で保存します。</p>\n\
<p>このプロジェクトの <a href=\'#!/url=./dev_help/Building-Your-Own-Plugin/The-CMakeList-File.html\' title=\'\'><span class=\'code\'>CMakeLists.txt</span></a> ファイルを作成し、<span class=\'code\'>HelloWorld</span> フォルダに保存します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">cmake_minimum_required(VERSION 2.8)\n\
\n\
set(PROJECT_NAME helloWorld)\n\
project(${PROJECT_NAME})\n\
\n\
include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)\n\
  \n\
\n\
set(SOURCE_FILES\n\
    helloWorld.cpp\n\
)\n\
\n\
\n\
set(LIBRARIES\n\
    OpenMaya Foundation\n\
)\n\
  \n\
build_plugin()\n\
</pre></div><p><a href=\'#!/url=./dev_help/Building-Your-Own-Plugin/Building-with-cmake.html\' title=\'\'>CMake および該当するジェネレータ</a>を使用して、コードのプロジェクトをビルドします。</p>\n\
<ul>\n\
<li><span class=\'code\'>cmake -H. -Bbuild -G &quot;Visual Studio 15 2017 Win64&quot;</span>: Windows でビルドする場合</li>\n\
<li><span class=\'code\'>cmake -H. -Bbuild -G Xcode</span>: MacOS で Xcode を使用してビルドする場合</li>\n\
<li><span class=\'code\'>cmake -H. -Bbuild -G &quot;Unix Makefiles&quot;</span>: Linux または MacOS で makefile を使用してビルドする場合</li>\n\
</ul>\n\
<p>プロジェクトが正常にビルドされたら、CMake を再度使用して、プラグインをビルドします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake --build build\n\
</pre></div><p>これで、プラグイン マネージャを使用して<a href=\'#!/url=./dev_help/Loading-Samples-Plug-ins-Into-Maya.html\' title=\'\'>プラグインを Maya にロード</a>できるようになりました。プラグイン マネージャにアクセスするには、Maya メニューの<strong>ウィンドウ &gt; 設定/プリファレンス &gt; プラグイン マネージャ(Window &gt; Settings/Preferences &gt; Plug-in Manager)</strong>を使用します。</p>\n\
<p>プラグインがロードされたら、Maya コマンド ウィンドウで <span class=\'code\'>helloWorld</span> を実行します。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/HelloWorldcmd.png\' title=\'代替テキスト\' /></div>\n\
<p>出力が Maya 出力ウィンドウに書き込まれます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/HelloWorldOutput.png\' title=\'代替テキスト\' /></div>\n\
<p>プラグインに渡された引数を使用してあいさつをカスタマイズする機能を持つバージョンも作成できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">#include &lt;maya/MSimple.h&gt;\n\
#include &lt;maya/MIOStream.h&gt;\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"DeclareSimpleCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gaf3b44fe07495c3792b926494fca7b517&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">DeclareSimpleCommand</a>( helloWorld, &quot;Autodesk&quot;, &quot;2020&quot;);\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> helloWorld::doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; args )\n\
{\n\
    cout &lt;&lt; args.asString( 0 ).asChar() &lt;&lt;  &quot; &quot; &lt;&lt; args.asString( 1 ).asChar() &lt;&lt; endl;\n\
    return MS::kSuccess;\n\
}\n\
</pre></div><p>プラグインを再コンパイルする前に、<span class=\'code\'>unloadPlugin</span> コマンドを使用して<a href=\'#!/url=./dev_help/Unloading-Plug-ins.html\' title=\'\'>プラグインを Maya からアンロード</a>します。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/UnloadHelloWorld.png\' title=\'代替テキスト\' /></div>\n\
<p>プラグイン プロジェクトを再作成する必要はありません。必要な作業は、<span class=\'code\'>cmake --build build</span> を使用してプラグインを再コンパイルすることだけです。</p>\n\
<p>プラグインを再ロードし、次に示す 2 つの引数を指定して実行します。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/HelloWorldHiThere.png\' title=\'代替テキスト\' /></div>\n\
<p>あいさつが Maya 出力ウィンドウに出力されます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/HelloWorldHiThereOutput.png\' title=\'代替テキスト\' /></div>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";