var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>付録 E: イメージ プラグインの追加</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>付録 E: イメージ プラグインの追加</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"付録-e-イメージ-プラグインの追加\"></a></div>\n\
<p>Maya の特長は、固有のイメージ ファイル トランスレータ機能を作成できる外部プラグイン モジュール機構です。これは Maya に新しいイメージを追加するためのシステムであり、Maya API とは異なります。これらのプラグイン モジュールは、アプリケーションを開始するときにいつでも使用可能です。イメージ ファイルにアクセスする場合に表示されるイメージ ファイル タイプのリストからこれらにアクセスできます。</p>\n\
<p>プラグイン イメージ モジュールは動的な共有オブジェクトとして実装され(DSO または DLL)、C または C++ で記述できます。この場合、イメージ ファイルの読み取りと書き込みを行うアルゴリズムを実装するだけです。ユーザ インタフェースとフロー制御は Maya によって暗黙的に処理されます。</p>\n\
<p>この文書では、イメージ プラグイン モジュールを記述するためのプロトコルについて説明します。複数のフレームまたはムービー ファイルのサポート方法については説明しません。サンプル コードは Developer Kit の image サブフォルダに収められています。</p>\n\
<p>このセクションでは次の項目について説明します。</p>\n\
<ul>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#overview\' title=\'\'>概要</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#about-entry-points\' title=\'\'>エントリ ポイント</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#mandatory-entry-points\' title=\'\'>必須のエントリ ポイント</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#optional-entry-points\' title=\'\'>オプションのエントリ ポイント</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#library-functions\' title=\'\'>ライブラリ関数</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#capability-settings\' title=\'\'>機能設定</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#data-structures\' title=\'\'>データ構造</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#compiling-your-plug-in\' title=\'\'>プラグインのコンパイル</a></li>\n\
</ul>\n\
<p>イメージ ファイル フォーマット プラグインを書き込むと、これをコンパイルして、Maya にロードできる共有オブジェクトを作成する必要があります。gcc コンパイラを使用したサンプルを構築するための、Makefile と buildconfig が Developer Kit に用意されています。Windows では、Visual C++ でイメージ プラグインを構築するためのソリューションとプロジェクト ファイルが用意されています。イメージ プラグインのサンプルを構築する前に、最初に MAYA_LOCATION を設定する必要があります。構築するプラグインは、Maya が新しいイメージ フォーマットにアクセスする前に、$MAYA_LOCATION/bin/plug-ins/image フォルダにコピーしてください。イメージ プラグインは、Maya にロードできるように用意されたコンパイラとリンカーのフラグを使用して構築する必要があります。</p>\n\
<div class=\'section\'><a id=\"概要\"></a><h2 id=\"概要\">概要</h2></div>\n\
<p>Maya は、主にイメージ ファイルの読み取りと書き込みのためにイメージ プラグインから関数を起動します。これが発生する場所には、レンダリング ウィンドウなどがあります。このウィンドウでは、特定のフォーマットとしてイメージを保存することを選択できます。さらに、このウィンドウに既存のレンダリング イメージをロードすることも可能です。このウィンドウの読み取り操作および書き込み操作用に定義したカスタム フォーマットを選択することができます。</p>\n\
<div class=\'section\'><a id=\"エントリ-ポイント\"></a><h2 id=\"エントリ-ポイント\">エントリ ポイント</h2></div>\n\
<p>各プラグインには、定義数のエントリ ポイントがあります。Maya はこれらのエントリ ポイントを使用して、イメージ プラグインがサポートする機能を定義します。</p>\n\
<p>エントリ ポイントは変数や関数などです。たとえば、プラグインの名前は変数エントリ ポイント <span class=\'code\'>imageName</span> で定義され、読み取り用のイメージ ファイルを開く関数は、関数エントリ ポイント <span class=\'code\'>imageReadOpen</span> で定義されます。</p>\n\
<p>エントリ ポイントには必須とオプションのものがあります。必須のエントリ ポイントについては次のセクションで説明します。オプションのエントリ ポイントについては「オプション エントリ ポイント」で説明します。</p>\n\
<blockquote>\n\
<p><strong>ヒント: </strong> 作成するプラグインに Maya との互換性を持たせる場合、必須のエントリ ポイントを実装するだけです。作成するプラグインのオプションのエントリ ポイントは、Maya で起動できない場合があるため、必須ではありません。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"必須のエントリ-ポイント\"></a><h2 id=\"必須のエントリ-ポイント\">必須のエントリ ポイント</h2></div>\n\
<p>次のエントリ ポイントは定義する必要があります。</p>\n\
<ul>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#program\' title=\'\'>program</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#type\' title=\'\'>type</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#version\' title=\'\'>version</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#imagekey\' title=\'\'>imageKey</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#imageisfile\' title=\'\'>imageIsFile</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#imagename\' title=\'\'>imageName</a></li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#imagereadopen\' title=\'\'>imageReadOpen</a> およびこれとコネクトされるルックアップ テーブルの読み取り、スキャンラインの読み取り、終了関数(プラグインが <a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#imageaccess\' title=\'\'>imageAccess</a> エントリ ポイントによって指定されたように読み取ることができない場合)</li>\n\
<li><a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#imagewriteopen\' title=\'\'>imageWriteOpen</a> およびこれとコネクトされるスキャンラインの書き込みと終了関数( <a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#imageaccess\' title=\'\'>imageAccess</a> エントリ ポイントと一緒に指定されていない場合)</li>\n\
</ul>\n\
<p>必須のエントリ ポイントが削除されると、プラグインがロードされないため、その名前はメニューに表示されません。</p>\n\
<div class=\'section\'><a id=\"program\"></a><h3 id=\"program\">program</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>char *program</span></p>\n\
<p>説明</p>\n\
<p>このエントリ ポイントは、プラグインを使用できるアプリケーションを指定します。すべてのアプリケーションがこのプラグインでサポートされるイメージ ファイルの読み取りと書き込みを実行できるようにするには、これに Wavefront を設定します。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> このエントリ ポイントの定義は必須です。</p>\n\
</blockquote>\n\
<p>例</p>\n\
<p><span class=\'code\'>char *program = &quot;Wavefront&quot;;</span></p>\n\
<div class=\'section\'><a id=\"type\"></a><h3 id=\"type\">type</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>char *type</span></p>\n\
<p>修正される問題</p>\n\
<p>このエントリ ポイントは、構築するプラグインのタイプを示します。Maya のイメージ ファイル プラグインのタイプは、<span class=\'code\'>image</span> です。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> このエントリ ポイントの定義は必須です。</p>\n\
</blockquote>\n\
<p>例</p>\n\
<p><span class=\'code\'>char *type = &quot;image&quot;;</span></p>\n\
<div class=\'section\'><a id=\"version\"></a><h3 id=\"version\">version</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>char *version</span></p>\n\
<p>説明</p>\n\
<p>このエントリ ポイントは、プラグインを記述したプロトコルのバージョンを示します。常に <span class=\'code\'>IMF_PROTOCOL_CURRENT</span> を使用します。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> このエントリ ポイントの定義は必須です。</p>\n\
</blockquote>\n\
<p>例</p>\n\
<p><span class=\'code\'>char *version = IMF_PROTOCOL_CURRENT;</span></p>\n\
<div class=\'section\'><a id=\"imagekey\"></a><h3 id=\"imagekey\">imageKey</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>char *imageKey</span></p>\n\
<p>説明</p>\n\
<p>このエントリ ポイントは、プラグインを特定するための固有のキーを指定します。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> このエントリ ポイントの定義は必須です。</p>\n\
</blockquote>\n\
<p>例</p>\n\
<p><span class=\'code\'>char *imageKey = &quot;myFormat&quot;;</span></p>\n\
<div class=\'section\'><a id=\"imagename\"></a><h3 id=\"imagename\">imageName</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>char *imageName</span></p>\n\
<p>説明</p>\n\
<p>このエントリ ポイントは、メニューに表示されるプラグインの名前を定義します。ユーザが区別できるように固有の名前を定義する必要があります。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> このエントリ ポイントの定義は必須です。</p>\n\
</blockquote>\n\
<p>例</p>\n\
<p><span class=\'code\'>char *imageName = &quot;My Image Format&quot;;</span></p>\n\
<div class=\'section\'><a id=\"imagereadopen\"></a><h3 id=\"imagereadopen\">imageReadOpen</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>int imageReadOpen</span></p>\n\
<p><span class=\'code\'>(</span></p>\n\
<p><span class=\'code\'>IMF_OBJECT *imf</span></p>\n\
<p><span class=\'code\'>}</span></p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
パラメータ\n\
</th>\n\
<th class=\"table-heading\">\n\
型\n\
</th>\n\
<th class=\"table-heading\">\n\
修正される問題\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">imf</span>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F3E3\"></a>\n\
<p class=\"table-body\">\n\
Modified\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F3E4\"></a>\n\
<p class=\"table-body\">\n\
イメージ ファイル ヘッダ\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
戻り値\n\
</td>\n\
<td class=\"table-body\">\n\
 \n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F3E5\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">IMF_C_NORMAL</span> イメージが正常に開かれた場合。<span class=\"code\">IMF_C_</span> エラーが発生した場合。\n\
</p>\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p>修正される問題</p>\n\
<p>この関数は、読み取り用にファイルを開くときにコールされます。</p>\n\
<p><span class=\'code\'>imf</span> パラメータには、ファイルの読み取りに必要なすべての情報が含まれます。<span class=\'code\'>imageReadOpen</span> を呼び出す前に、ここにファイル名を含めます。このルーチンの実行後、ここにファイルにアクセスするルーチンへのポインタ、サイズの情報、読み取るイメージの他のアトリビュート、イメージの走査線を読み込むバッファなども含める必要があります。</p>\n\
<p>この関数を記述する基本手順を以下に示します。</p>\n\
<ul>\n\
<li>ファイルを開きます。</li>\n\
<li>ファイルからヘッダを読み取ります。ファイルにルックアップ テーブルを含める場合、このときに読み取ります。</li>\n\
<li><span class=\'code\'>close</span>、<span class=\'code\'>scanline read,</span>、および LUT <span class=\'code\'>read</span> ルーチンを <span class=\'code\'>imf</span> に割り当てます。</li>\n\
<li><span class=\'code\'>imf-&gt;info.image[0</span>] でイメージのパラメータを定義します。</li>\n\
<li>走査線を収めるバッファを配分します。</li>\n\
<li>ファイル記述子などを定義するプライベート データを割り当てて、<span class=\'code\'>imf-&gt;data</span> に関連付けます。</li>\n\
</ul>\n\
<p>複数のイメージ(フル イメージやサムネール表示など)を含むイメージ ファイルもあります。ここでは、ファイルからメイン イメージのみを読み取る場合について説明しています。</p>\n\
<p>詳細な手順を次に示します。</p>\n\
<ol>\n\
<li>ファイル名が完全でない場合は補完します。次に、指定したファイルを開きます。正常に開かれた場合にのみ続行します。失敗した場合は、<span class=\'code\'>ERR_printf</span> を使用してメッセージを生成し、<span class=\'code\'>imf__err</span> を <span class=\'code\'>IMF_C_CANNOT_OPEN</span> に設定して、<span class=\'code\'>FALSE</span> を返します。</li>\n\
<li>イメージ カウントを 1 に設定して、1 つのイメージ構造を配分および初期化して、このイメージに関する情報を含めます。</li>\n\
</ol>\n\
<p>``` imf-&gt;info.count = 1; imf-&gt;info.image = malloc( sizeof( IMF_IMAGE ) ); (void) imf__init_ifd( imf );</p>\n\
<p>```</p>\n\
<ol>\n\
<li><span class=\'code\'>malloc</span> を使用して、割り当てた固有のデータ構造に、ファイルを記述するフォーマット固有の情報を保存します。このプライベート データ構造には、現在のファイル記述子、最新のスキャンラインの読み取り、アクティブ ウィンドウなどの項目を含めることができます。:</li>\n\
</ol>\n\
<p>``` private = malloc( sizeof( PRIVATE ) ); private-&gt;... = ...; imf-&gt;data = malloc( sizeof( POINTER ) ); imf-&gt;data[0] = private;</p>\n\
<p>```</p>\n\
<ol>\n\
<li>イメージ アクセス ルーチンを <span class=\'code\'>imf-&gt;scan</span> および <span class=\'code\'>imf-&gt;close</span> に割り当てます。イメージ ファイルにルックアップ テーブルが含まれている場合は、<span class=\'code\'>imf-&gt;lut_read</span> にルックアップ テーブルを読み取るルーチンも指定します。</li>\n\
<li>ファイル フォーマットで入力機能が定義されている場合は、<span class=\'code\'>imf-&gt;info.settings</span> から抽出します (詳細については、<a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#imf_capability\' title=\'\'>IMF_CAPABILITY</a> を参照してください)。</li>\n\
<li>ファイルからヘッダ情報を読み取り、プライベート データ構造にこれを格納します。さらに、<span class=\'code\'>imf-&gt;info</span> と <span class=\'code\'>imf-&gt;info.image[0]</span> のデータ構造内で各種フィールドも定義する必要があります。</li>\n\
</ol>\n\
<p><span class=\'code\'>imf-&gt;info</span> 構造では、イメージがルックアップ テーブルを含むかどうかに応じて、<span class=\'code\'>lut_exists field</span>を設定します。</p>\n\
<p><span class=\'code\'>program</span>、<span class=\'code\'>machine</span>、<span class=\'code\'>user</span>、<span class=\'code\'>date</span>、<span class=\'code\'>time</span>、<span class=\'code\'>frame</span> 番号、<span class=\'code\'>job_num</span>、および色度情報(<span class=\'code\'>red_pri</span>、<span class=\'code\'>green_pri</span>、<span class=\'code\'>blue_pri</span>、<span class=\'code\'>white_pt</span>)がファイル自体に格納されている場合は、これらも設定できます。</p>\n\
<p>また、<span class=\'code\'>imf-&gt;info.image[0]</span> ですべてのフィールドを設定する必要があります。<span class=\'code\'>aux_format</span>、<span class=\'code\'>aux_count</span>、<span class=\'code\'>aux_type</span>、および <span class=\'code\'>aux_bits</span> フィールドは z チャネル情報を示します。<span class=\'code\'>curve.gamma</span> フィールドには、ファイル内で定義したガンマを設定するか、または <span class=\'code\'>IMF_def_input_gamma</span> を呼び出して既定のガンマを設定する必要があります。</p>\n\
<ol>\n\
<li>スキャンラインの読み取りルーチンが 1 行のピクセルを読み取るスキャンライン バッファを配分します。</li>\n\
</ol>\n\
<p>``` private_data_ptr-&gt;buffer = IMF_chan_alloc( imf-&gt;info.image, image_width, imf-&gt;info.key, NULL );</p>\n\
<p>```</p>\n\
<ol>\n\
<li>関数が正常に開き、イメージ ファイル ヘッダを読み取った場合は <span class=\'code\'>TRUE</span>、エラーが発生した場合は <span class=\'code\'>FALSE</span> を返します。</li>\n\
</ol>\n\
<blockquote>\n\
<p><strong>注:</strong> このエントリ ポイントの定義は必須です。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"スキャンライン読み取り関数\"></a><h3 id=\"スキャンライン読み取り関数\">スキャンライン読み取り関数</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>int your_scan_read_func</span></p>\n\
<p><span class=\'code\'>(</span></p>\n\
<p><span class=\'code\'>POINTER data,</span></p>\n\
<p><span class=\'code\'>int scan,</span></p>\n\
<p><span class=\'code\'>POINTER **line_buff</span></p>\n\
<p><span class=\'code\'>)</span></p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
パラメータ\n\
</th>\n\
<th class=\"table-heading\">\n\
型\n\
</th>\n\
<th class=\"table-heading\">\n\
修正される問題\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">data</span>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F409\"></a>\n\
<p class=\"table-body\">\n\
入力\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F40A\"></a>\n\
<p class=\"table-body\">\n\
イメージにコネクトするプライベート データ\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">scan</span>\n\
</td>\n\
<td class=\"table-body\">\n\
入力\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F40B\"></a>\n\
<p class=\"table-body\">\n\
読み取るスキャンライン\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">line_buff</span>\n\
</td>\n\
<td class=\"table-body\">\n\
出力\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F40C\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">imageReadOpen</span> に配分されるスキャンライン バッファ。読み取られたピクセル行を含みます。\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
戻り値\n\
</td>\n\
<td class=\"table-body\">\n\
 \n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F40D\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">IMF_C_BAD_SCAN</span> スキャンがイメージの範囲外である場合。<span class=\"code\">IMF_C_NORMAL</span> スキャンラインが正常に読み取られた場合。および <span class=\"code\">IMF_C_READ_ERR</span> エラーが発生した場合。\n\
</p>\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p>修正される問題</p>\n\
<p>この関数は Maya によってコールされ、イメージ ファイルからスキャンラインを読み取ります。イメージ ファイルはイメージの方向に基づいて、下から上または上から下のいずれかの方向に読み取られます。</p>\n\
<p>以下の手順に従って、スキャンライン読み取り関数を作成します。</p>\n\
<ol>\n\
<li>指定したスキャンラインを読み取ります。スキャンライン番号は下から上の順序に基づきます。たとえば、イメージ サイズが 480 ラインで、方向が <span class=\'code\'>IMF_C_TOP_LEFT</span> である場合、スキャンラインは 479 (一番上)、478 (上から 2 番目)、477、... 0 (一番下)の順序で読み取られます。順序が <span class=\'code\'>IMF_C_BOT_LEFT</span> である場合は、0 (一番下)、1 (下から 2 番目)、2、...479 (一番上)の順序で読み取られます。</li>\n\
<li><span class=\'code\'>imageReadOpen</span> に割り当てられたバッファにスキャンラインを転送します。<span class=\'code\'>IMF_chan_alloc</span> によって割り当てられたバッファには、ファイルのチャネル単位のビット数に応じて、8、16、32 ビットの符号なしの数字が含まれます (チャネル単位のビット数はニアレストの数字に切り上げられます)。</li>\n\
</ol>\n\
<p>スキャンラインの各成分は個別の隣接しているバッファに格納されます。これらは、割り当てられた成分へのポインタの配列であるパラメータ <span class=\'code\'>line_buff</span> に格納されて返されます。</p>\n\
<p><span class=\'code\'>/*</span></p>\n\
<p><span class=\'code\'>* Unsigned char&#39;s are used for 1 to 8-bit values;</span></p>\n\
<p><span class=\'code\'>* unsigned short&#39;s, for 8 to 16-bit values;</span></p>\n\
<p><span class=\'code\'>* unsigned long&#39;s, for 17 to 32-bit values.</span></p>\n\
<p><span class=\'code\'>*/</span></p>\n\
<p><span class=\'code\'>*line_buff = data-&gt;buffer;</span></p>\n\
<p><span class=\'code\'>pr = (unsigned char *) data-&gt;buffer[0];</span></p>\n\
<p><span class=\'code\'>pg = (unsigned char *) data-&gt;buffer[1];</span></p>\n\
<p><span class=\'code\'>pb = (unsigned char *) data-&gt;buffer[2];</span></p>\n\
<p><span class=\'code\'>pm = (unsigned char *) data-&gt;buffer[3];</span></p>\n\
<p><span class=\'code\'>for ( i = 0; i &lt; data-&gt;image_width; ++i )</span></p>\n\
<p><span class=\'code\'>{</span></p>\n\
<p><span class=\'code\'>*(pr++) = red_values[i];</span></p>\n\
<p><span class=\'code\'>*(pg++) = green_values[i];</span></p>\n\
<p><span class=\'code\'>*(pb++) = blue_values[i];</span></p>\n\
<p><span class=\'code\'>*(pm++) = matte_values[i];</span></p>\n\
<p><span class=\'code\'>}</span></p>\n\
<p>ファイルにルックアップ テーブルが含まれている場合は、<span class=\'code\'>line_buff</span> でルックアップ テーブルにインデックスではなく、RGB データを返す必要があります。</p>\n\
<ol>\n\
<li>必要に応じて、<span class=\'code\'>IMF_C_BAD_SCAN</span>、<span class=\'code\'>IMF_C_NORMAL</span>、または <span class=\'code\'>IMF_C_READ_ERR</span> を返します。</li>\n\
</ol>\n\
<p>スキャンライン読み取り関数は、イメージの最新のスキャンラインを読み取るとは限りません。これは Maya が読み取る必要のない最新のスキャンラインをスキップする場合があるためです。プラグインでは、<span class=\'code\'>imageReadOpen</span> の呼び出し後に Maya が いつでも終了関数を呼び出せるように許可する必要があります。</p>\n\
<div class=\'section\'><a id=\"終了関数\"></a><h3 id=\"終了関数\">終了関数</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>int your_close_func</span></p>\n\
<p><span class=\'code\'>(</span></p>\n\
<p><span class=\'code\'>IMF_OBJECT *imf</span></p>\n\
<p><span class=\'code\'>)</span></p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
パラメータ\n\
</th>\n\
<th class=\"table-heading\">\n\
型\n\
</th>\n\
<th class=\"table-heading\">\n\
修正される問題\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">imf</span>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F430\"></a>\n\
<p class=\"table-body\">\n\
Modified\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F431\"></a>\n\
<p class=\"table-body\">\n\
イメージ ファイル記述子\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
戻り値\n\
</td>\n\
<td class=\"table-body\">\n\
 \n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F432\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">IMF_C_NORMAL</span> ファイルが閉じられ、メモリの再配分が成功した場合。<span class=\"code\">IMF_C_failure_code</span> エラーが発生した場合(<span class=\"code\">IMF_C_WRITE_ERR</span> など)。\n\
</p>\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<div class=\'section\'><a id=\"修正される問題\"></a><h3 id=\"修正される問題\">修正される問題</h3></div>\n\
<p>この関数は、Maya でイメージ ファイルの読み取りまたは書き込みが完了するたびにコールされます。以下の手順に従って、終了関数を作成します。</p>\n\
<ol>\n\
<li>イメージ ファイルを閉じます。</li>\n\
<li><span class=\'code\'>imf-&gt;data</span> で示されるプライベート データの割り当てを解除して、<span class=\'code\'>imf-&gt;data</span> を <span class=\'code\'>NULL</span> に設定します。<span class=\'code\'>imageReadOpen</span> または <span class=\'code\'>imageWriteOpen</span> のスキャンライン バッファの割り当てを解除するには、<span class=\'code\'>IMF_chan_free</span> を使用します。</li>\n\
<li>ファイルの終了およびメモリのクリーンアップに成功した場合は、<span class=\'code\'>IMF_C_NORMAL</span> を返します。失敗した場合は、<span class=\'code\'>IMF_C_failure_code</span> を返します。</li>\n\
</ol>\n\
<div class=\'section\'><a id=\"imagewriteopen\"></a><h3 id=\"imagewriteopen\">imageWriteOpen</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>int imageWriteOpen</span></p>\n\
<p><span class=\'code\'>(</span></p>\n\
<p><span class=\'code\'>IMF_OBJECT *imf</span></p>\n\
<p><span class=\'code\'>)</span></p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
パラメータ\n\
</th>\n\
<th class=\"table-heading\">\n\
型\n\
</th>\n\
<th class=\"table-heading\">\n\
修正される問題\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">imf</span>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F43F\"></a>\n\
<p class=\"table-body\">\n\
Modified\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F440\"></a>\n\
<p class=\"table-body\">\n\
イメージ ファイル記述子\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
戻り値\n\
</td>\n\
<td class=\"table-body\">\n\
 \n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F441\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">TRUE</span> イメージが正常に開かれた場合。<span class=\"code\">FALSE</span> エラーが発生した場合。\n\
</p>\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p>修正される問題</p>\n\
<p>この関数は、書き込み用にファイルを開くときにコールされます。</p>\n\
<p><span class=\'code\'>imf</span> パラメータには、ファイルの書き込みに必要なすべての情報が含まれます。<span class=\'code\'>imageWriteOpen</span> を呼び出す前に、ここにファイル名を含めます。このルーチンの実行後、ファイルにアクセスするルーチンのポインタ、サイズの情報、および書き込むイメージの他のアトリビュートなども含める必要があります。</p>\n\
<p>この関数を作成する基本手順を以下に示します。</p>\n\
<ul>\n\
<li>ファイルを開きます。</li>\n\
<li>ヘッダを書き込みます。ファイルにルックアップ テーブルを含める場合、このときに必要に応じて書き込んでください。</li>\n\
<li><span class=\'code\'>close</span> および <span class=\'code\'>scanline``write</span> ルーチンを <span class=\'code\'>imf</span> に割り当てます。</li>\n\
<li>ファイル記述子などを定義するプライベート データを割り当てて、<span class=\'code\'>imf-&gt;data</span> に関連付けます。</li>\n\
</ul>\n\
<p>詳細な手順を次に示します。</p>\n\
<ol>\n\
<li>指定したファイルを開きます。正常に開かれた場合にのみ続行します。失敗した場合は、<span class=\'code\'>ERR_printf</span> を使用してメッセージを生成し、<span class=\'code\'>imf__err</span> を <span class=\'code\'>IMF_C_CANNOT_OPEN</span> に設定して、<span class=\'code\'>FALSE</span> を返します。</li>\n\
<li><span class=\'code\'>imf-&gt;info</span> および <span class=\'code\'>imf-&gt;info.image[0]</span> を使用して、書き込むファイルに関するアトリビュートを抽出します。</li>\n\
<li><span class=\'code\'>malloc</span> を使用して、割り当てた固有のデータ構造に、ファイルを記述するフォーマット固有の情報を保存します。このプライベート データ構造には、現在のファイル記述子、アクティブ ウィンドウなどの項目を含めることができます。:</li>\n\
</ol>\n\
<p>``` private = malloc( sizeof( PRIVATE ) ); private-&gt;... = ...; imf-&gt;data = malloc( sizeof( POINTER ) ); imf-&gt;data[0] = private;</p>\n\
<p>```</p>\n\
<ol>\n\
<li><span class=\'code\'>imf-&gt;scan</span> および <span class=\'code\'>imf-&gt;close</span> でイメージ アクセス ルーチンを指定します。</li>\n\
<li>ファイル フォーマットで出力機能が定義されている場合は、<span class=\'code\'>imf-&gt;info.settings</span> から抽出します (詳細については、<a href=\'#!/url=./dev_help/Appendices/Appendix-E-Adding-Image-Plug-ins.html#imf_capability\' title=\'\'>IMF_CAPABILITY</a> を参照してください)。</li>\n\
<li>定義する場合は、ファイル ヘッダとルックアップ テーブルを書き込みます。</li>\n\
<li>関数が正常に開き、イメージ ファイル ヘッダを読み取った場合は <span class=\'code\'>IMF_C_NORMAL</span> を返します。エラーが発生した場合は、<span class=\'code\'>IMF_C_failure_code</span> を返します。</li>\n\
</ol>\n\
<p>イメージ ファイルを開こうとして失敗した場合、Maya は <span class=\'code\'>imf__free_obj( imf )</span> を呼び出して、<span class=\'code\'>imageWriteOpen</span> に渡された <span class=\'code\'>IMF_OBJECT</span> を解放します。したがって、エラー処理コードで <span class=\'code\'>imf__free_obj</span> を呼び出さないでください。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> このエントリ ポイントの定義は必須です。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"スキャンライン書き込み関数\"></a><h3 id=\"スキャンライン書き込み関数\">スキャンライン書き込み関数</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>int your_scan_write_func</span></p>\n\
<p><span class=\'code\'>(</span></p>\n\
<p><span class=\'code\'>POINTER data,</span></p>\n\
<p><span class=\'code\'>int scan,</span></p>\n\
<p><span class=\'code\'>POINTER *line_buff</span></p>\n\
<p><span class=\'code\'>)</span></p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
パラメータ\n\
</th>\n\
<th class=\"table-heading\">\n\
型\n\
</th>\n\
<th class=\"table-heading\">\n\
修正される問題\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">data</span>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F45F\"></a>\n\
<p class=\"table-body\">\n\
入力\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F460\"></a>\n\
<p class=\"table-body\">\n\
イメージにコネクトするプライベート データ\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">scan</span>\n\
</td>\n\
<td class=\"table-body\">\n\
入力\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F461\"></a>\n\
<p class=\"table-body\">\n\
書き込むスキャンライン\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
line_buff\n\
</td>\n\
<td class=\"table-body\">\n\
出力\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F462\"></a>\n\
<p class=\"table-body\">\n\
現在のスキャンラインのピクセルを含むバッファ\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
戻り値\n\
</td>\n\
<td class=\"table-body\">\n\
 \n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F463\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">IMF_C_BAD_SCAN</span> スキャンがイメージの範囲外である場合。<span class=\"code\">IMF_C_NORMAL</span> スキャンラインが正常に書き込まれた場合。<span class=\"code\">IMF_C_WRITE_ERR</span> エラーが発生した場合。\n\
</p>\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p>修正される問題</p>\n\
<p>この関数は Maya によってコールされ、スキャンラインをイメージ ファイルに書き込みます。イメージ ファイルはイメージの方向に基づいて、下から上または上から下のいずれかの方向に書き込まれます。</p>\n\
<p>以下の手順に従って、スキャンライン書き込み関数を作成します。</p>\n\
<ol>\n\
<li>指定したスキャンラインを書き込みます。スキャンライン番号は下から上の順序に基づきます。たとえば、イメージ サイズが 480 ラインで、方向が <span class=\'code\'>IMF_C_TOP_LEFT</span> である場合、スキャンラインは 479 (一番上)、478 (上から 2 番目)、477、... 0 (一番下)の順序で書き込まれます。順序が <span class=\'code\'>IMF_C_BOT_LEFT</span> である場合、0 (一番下)、1 (下から 2 番目)、2、...479 (一番上)の順序で書き込まれます。</li>\n\
<li><span class=\'code\'>line_buff</span> が Maya によって渡されたスキャンライン バッファである場合、<span class=\'code\'>line_buff[0]</span> からは赤、<span class=\'code\'>line_buff[1]</span> からは緑、<span class=\'code\'>line_buff[2]</span> からは青のカラー チャネル情報を取得します。マット チャネルは、<span class=\'code\'>line_buff[3]</span> にあります(存在する場合)。z チャネルは、<span class=\'code\'>line_buff[4]</span> にあります(存在する場合)。ピクセルは左から右に格納されます。</li>\n\
</ol>\n\
<p>``` pr = (unsigned char <em>) line_buff[0]; pg = (unsigned char </em>) line_buff[1]; pb = (unsigned char <em>) line_buff[2]; pm = (unsigned char </em>) line_buff[3]; for ( i = 0; i &lt; data-&gt;image_width; ++i ) { red_values[i] = <em>(pr++); green_values[i] = </em>(pg++); blue_values[i] = <em>(pb++); matte_values[i] = </em>(pm++); }</p>\n\
<p>```</p>\n\
<p>ファイル フォーマットで使用されるフォーマットに値を変換して、スキャンラインをファイルに書き込みます。</p>\n\
<ol>\n\
<li><span class=\'code\'>IMF_C_BAD_SCAN</span>、<span class=\'code\'>IMF_C_NORMAL</span>、または <span class=\'code\'>IMF_C_READ_ERR</span> を返します。</li>\n\
</ol>\n\
<div class=\'section\'><a id=\"オプションのエントリ-ポイント\"></a><h2 id=\"オプションのエントリ-ポイント\">オプションのエントリ ポイント</h2></div>\n\
<p>いくつかの追加のエントリ ポイントが存在します。オプションのエントリ ポイントが定義されていない場合、既定値が使用されます。使用するファイル フォーマットが機能をサポートしていない場合、無視されるオプションのエントリ ポイントもあります。</p>\n\
<div class=\'section\'><a id=\"imageaccess\"></a><h3 id=\"imageaccess\">imageAccess</h3></div>\n\
<p>定義</p>\n\
<p><span class=\'code\'>unsigned int imageAccess</span></p>\n\
<p>説明</p>\n\
<p>この変数はプラグインがサポートする読み取りおよび書き込みメソッドを指定します。記述する定数はビット フィールドです。</p>\n\
<ul>\n\
<li><span class=\'code\'>IMF_C_LUT_READ</span> は、プラグインがファイルからのパレットの読み取りをサポートすることを示します。LUT 読み取り関数は、<span class=\'code\'>imageReadOpen</span> ルーチン内で定義して、 <span class=\'code\'>mf-&gt;lut_read</span> に割り当てる必要があります。</li>\n\
<li><span class=\'code\'>IMF_C_LUT_WRITE</span> は、プラグインがファイルへのパレットの書き込みをサポートすることを示します。</li>\n\
<li><span class=\'code\'>IMF_C_READ</span> は、プラグインがスキャンラインの連続読み取りをサポートすることを示します。</li>\n\
<li><span class=\'code\'>IMF_C_READ_RANDOM</span> は、プラグインがスキャンラインのランダム読み取りをサポートすることを示します。</li>\n\
<li><span class=\'code\'>IMF_C_WRITE</span> は、プラグインがスキャンラインの連続書き込みをサポートすることを示します。</li>\n\
<li><span class=\'code\'>IMF_C_WRITE_RANDOM</span> は、プラグインがスキャンラインのランダム書き込みをサポートすることを示します。</li>\n\
</ul>\n\
<p>既定値は <span class=\'code\'>IMF_C_READ</span>|<span class=\'code\'>IMF_C_WRITE</span> です。</p>\n\
<p>例</p>\n\
<p>この例は、ルックアップ テーブルをサポートするファイル用です。</p>\n\
<p>``` unsigned int imageAccess = IMF_C_LUT_READ | IMF_C_LUT_WRITE | IMF_C_READ | IMF_C_WRITE;</p>\n\
<p>```</p>\n\
<p>イメージ プラグインの追加の詳細については、引き続き、<a href=\'#!/url=./dev_help/Appendices/Appendix-E-Part-2.html\' title=\'\'>付録 E のパート 2</a> で説明します。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";