var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>MPxCommandMPxCommand</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>MPxCommandMPxCommand</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"mpxcommandmpxcommand\"></a></div>\n\
<p>先ほどの新しい hello コマンドでは、プロキシ オブジェクトを使用して新しい機能を Maya に追加しています( <a href=\'#!/url=./dev_help/Command-plug-ins/MFnPlugin.html\' title=\'\'>MFnPlugin</a> を参照)。このプロキシ オブジェクトは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> から派生します。このオブジェクトは、コマンドを内蔵コマンドのように扱うために必要なすべての機能を提供します。</p>\n\
<p>最低でも 2 つのメソッドを定義する必要があります。2 つのメソッドとは、<strong>doIt() メソッドと creator</strong> です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class hello : public <a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a>\n\
{\n\
public:\n\
    Status doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; args );\n\
    static void* creator();\n\
};\n\
\n\
</pre></div><div class=\'section\'><a id=\"doit-メソッドと-redoit-メソッド\"></a><h2 id=\"doit-メソッドと-redoit-メソッド\">doIt() メソッドと redoIt() メソッド</h2></div>\n\
<p><span class=\'code\'>doIt()</span> メソッドは純粋仮想メソッドです。ベースクラス内で creator が定義されていないので、<span class=\'code\'>doIt()</span>と creator の両方を定義する必要があります。</p>\n\
<p>単純なコマンドの場合、<span class=\'code\'>doIt()</span> メソッドはコマンドのアクションを実行します。複雑なコマンドの場合、<span class=\'code\'>doIt()</span> メソッドは、引数リスト、セレクション リスト、その他必要なものを解析します。次にこの情報を使用してコマンドの内部にデータを設定してから <span class=\'code\'>redoIt()</span> メソッドを呼び出し、一括して作業を実行します。これにより、<span class=\'code\'>doIt()</span> メソッドと <span class=\'code\'>redoIt()</span> の間でコードの重複を避けることができます。</p>\n\
<div class=\'section\'><a id=\"メソッドがコールされるタイミングを確認する\"></a><h3 id=\"メソッドがコールされるタイミングを確認する\">メソッドがコールされるタイミングを確認する</h3></div>\n\
<p>次の単純なプラグインでは、Maya によってプラグインのメソッドのどれかがコールされた場合に文字列が出力されます。これを使用すると、メソッドがコールされるタイミングを確認できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#include &lt;stdio.h&gt;\n\
#include &lt;maya/MString.h&gt;\n\
#include &lt;maya/MArgList.h&gt;\n\
#include &lt;maya/MFnPlugin.h&gt;\n\
#include &lt;maya/MPxCommand.h&gt;\n\
#include &lt;maya/MIOStream.h&gt;\n\
class commandExample : public <a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a>\n\
{\n\
    public:\n\
        commandExample();\n\
        virtual ~commandExample();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> redoIt();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> undoIt();\n\
        bool isUndoable() const;\n\
        static void* creator();\n\
};\n\
commandExample::commandExample() {\n\
    cout &lt;&lt; &quot;In commandExample::commandExample()\\n&quot;;\n\
}\n\
commandExample::~commandExample() {\n\
    cout &lt;&lt; &quot;In commandExample::~commandExample()\\n&quot;;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> commandExample::doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; ) {\n\
    cout &lt;&lt; &quot;In commandExample::doIt()\\n&quot;;\n\
    return MS::kSuccess;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> commandExample::redoIt() {\n\
    cout &lt;&lt; &quot;In commandExample::redoIt()\\n&quot;;\n\
    return MS::kSuccess;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> commandExample::undoIt() {\n\
    cout &lt;&lt; &quot;In commandExample::undoIt()\\n&quot;;\n\
    return MS::kSuccess;\n\
}\n\
bool commandExample::isUndoable() const {\n\
    cout &lt;&lt; &quot;In commandExample::isUndoable()\\n&quot;;\n\
    return true;\n\
}\n\
void* commandExample::creator() {\n\
    cout &lt;&lt; &quot;In commandExample::creator()\\n&quot;;\n\
    return new commandExample();\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> initializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> obj )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin</a> plugin( obj, &quot;My plug-in&quot;, &quot;1.0&quot;, &quot;Any&quot; );\n\
    plugin.registerCommand( &quot;commandExample&quot;, commandExample::creator );\n\
    cout &lt;&lt; &quot;In initializePlugin()\\n&quot;;\n\
    return MS::kSuccess;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> uninitializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> obj )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin</a> plugin( obj );\n\
    plugin.deregisterCommand( &quot;commandExample&quot; );\n\
    cout &lt;&lt; &quot;In uninitializePlugin()\\n&quot;;\n\
    return MS::kSuccess;\n\
}\n\
\n\
</pre></div><p>このプラグインを初めてロードすると、すぐに「In initializePlugin()」と出力されます。コマンド ウィンドウに「commandExample」と入力すると、以下が出力されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">In commandExample::creator()\n\
In commandExample::commandExample()\n\
In commandExample::doIt()\n\
In commandExample::isUndoable()\n\
\n\
</pre></div><p>デストラクタがコールされていないことに注意してください。コマンド オブジェクトを永続的に残し、元に戻すややり直し(取り消された後)ができるようにするためです。</p>\n\
<p>Maya の元に戻す(undo)メカニズムはこのように機能します。コマンド オブジェクトには、必要な場合に自分自身を元に戻す(undo)ことができるようにする情報が含まれています。元に戻す待ち行列の末尾からコマンドが落ちた場合、取り消されてやり直しされない場合、あるいはプラグインがアンロードされた場合に、デストラクタがコールされます。</p>\n\
<p>編集 &gt; 元に戻す(Edit &gt; Undo) (または MEL の undo コマンド)と編集 &gt; やり直し(Edit &gt; Redo) (または MEL の redo コマンド)を使用すると、これらのメニュー項目が呼び出されるときに、コマンドの <span class=\'code\'>undoIt()</span> メソッドと <span class=\'code\'>redoIt()</span> メソッドが呼び出されます。</p>\n\
<p>この例を、<span class=\'code\'>isUndoable()</span> メソッドが true ではなく false を返すように変更すると(リコンパイルする前に、忘れずにプラグインをアンロードしてください)、実行時に次のように出力されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">In commandExample::creator()\n\
In commandExample::commandExample()\n\
In commandExample::doIt()\n\
In commandExample::isUndoable()\n\
In commandExample::~commandExample()\n\
\n\
</pre></div><p>この場合は、コマンドを元に戻すことができないので、デストラクタがすぐにコールされます。Maya では、元に戻すことができないコマンドはシーンにまったく影響しないアクションとして扱います。つまりコマンドの実行後に情報を保存する必要がなく、コマンドの元に戻すとやり直しが要求されても、何も変更されていないのでそれらは実行されません。</p>\n\
<div class=\'section\'><a id=\"元に戻すとやり直しを含むらせんのサンプル\"></a><h3 id=\"元に戻すとやり直しを含むらせんのサンプル\">元に戻すとやり直しを含むらせんのサンプル</h3></div>\n\
<p>以下は、らせんのプラグインを別の方法で実装したサンプルです。このバージョンは、元に戻すとやり直しを含む、フル コマンドとして実装されています。選択したカーブを処理してらせんに変形するというように動作します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#include &lt;stdio.h&gt;\n\
#include &lt;math.h&gt;\n\
#include &lt;maya/MFnPlugin.h&gt;\n\
#include &lt;maya/MFnNurbsCurve.h&gt;\n\
#include &lt;maya/MPointArray.h&gt;\n\
#include &lt;maya/MDoubleArray.h&gt;\n\
#include &lt;maya/MPoint.h&gt;\n\
#include &lt;maya/MSelectionList.h&gt;\n\
#include &lt;maya/MItSelectionList.h&gt;\n\
#include &lt;maya/MItCurveCV.h&gt;\n\
#include &lt;maya/MGlobal.h&gt;\n\
#include &lt;maya/MDagPath.h&gt;\n\
#include &lt;maya/MString.h&gt;\n\
#include &lt;maya/MPxCommand.h&gt;\n\
#include &lt;maya/MArgList.h&gt;\n\
class helix2 : public <a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a> {\n\
public:\n\
    helix2();\n\
    virtual ~helix2();\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> redoIt();\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> undoIt();\n\
    bool isUndoable() const;\n\
    static void* creator();\n\
\n\
</pre></div><p>コマンドは、前のサンプルと同様に、定義するメソッドの宣言から始まります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    private:\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> fDagPath;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPointArray</a> fCVs;\n\
    double radius;\n\
    double pitch;\n\
};\n\
\n\
</pre></div><p>このコマンドはモデルを編集します。変更内容を取り消せるようにするため、カーブの元の定義を保存するスペースが割り当てられます。また、らせんの説明も保存し、redoIt メソッドがコールされた場合にらせんを再作成できるようにします。</p>\n\
<p>このコマンドでは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> のポインタを保存するのではなく、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a></span> を使用して元に戻すとやり直しのカーブを参照することに注意してください。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> は、コマンドが次回実行された際に有効であるとは限りません。その結果、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> を使用すると、Mayaは <span class=\'code\'>undoIt()</span> か <span class=\'code\'>redoIt()</span> を実行した場合にコア ダンプを作成する可能性が高くなります。しかし <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a></span> は、カーブへのパスを記述しているだけなので、コマンドがいつ実行されても正確です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">void* helix2::creator() {\n\
    return new helix2;\n\
}\n\
\n\
</pre></div><p>creator は単にオブジェクトのインスタンスを返します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">helix2::helix2() : radius( 4.0 ), pitch( 0.5 ) {}\n\
\n\
</pre></div><p>コンストラクタが半径とピッチを初期化します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">helix2::~helix2() {}\n\
\n\
</pre></div><p>プライベートなデータは自動的にクリーンアップされるので、デストラクタは何も実行する必要がありません。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> Maya が所有するデータは削除しないでください。</p>\n\
</blockquote>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> helix2::doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; args ) {\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    // Parse the arguments.\n\
    for ( int i = 0; i &lt; args.length(); i++ )\n\
        if ( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>( &quot;-p&quot; ) == args.asString( i, &amp;status )\n\
            &amp;&amp; MS::kSuccess == status )\n\
        {\n\
            double tmp = args.asDouble( ++i, &amp;status );\n\
            if ( MS::kSuccess == status )\n\
                pitch = tmp;\n\
        }\n\
        else if ( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>( &quot;-r&quot; ) == args.asString( i, &amp;status )\n\
            &amp;&amp; MS::kSuccess == status )\n\
        {\n\
            double tmp = args.asDouble( ++i, &amp;status );\n\
            if ( MS::kSuccess == status )\n\
                radius = tmp;\n\
        }\n\
        else\n\
        {\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> msg = &quot;Invalid flag: &quot;;\n\
            msg += args.asString( i );\n\
            displayError( msg );\n\
            return MS::kFailure;\n\
        }\n\
\n\
</pre></div><p>前と同じように、これは <span class=\'code\'>doIt()</span> メソッドに渡された引数を解析して使用し、内部の半径フィールドとピッチ フィールドを設定します。このフィールドは <span class=\'code\'>redoIt()</span> メソッドによって使用されます。<span class=\'code\'>doIt()</span> メソッドのみが引数を受け取ります。<span class=\'code\'>undoIt()</span> メソッドと <span class=\'code\'>redoIt()</span> メソッドは、コマンド自体の内部データからそれぞれのデータを取ります。</p>\n\
<p>最後の else 節では、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> から継承された <span class=\'code\'>displayError()</span> メソッドが、コマンド ウィンドウとコマンド出力ウィンドウにメッセージを出力します。<span class=\'code\'>displayError()</span> でのメッセージ出力には、「Error:」というプリフィックスが付いています。もう 1 つのオプションとして、メッセージに「Warning:」というプリフィックスが付く <span class=\'code\'>displayWarning()</span> があります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    // Get the first selected curve from the selection list.\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSelectionList</a> slist;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a6d81d38246555884897fb153c93aaf42&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::getActiveSelectionList</a>( slist );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItSelectionList</a> list( slist, <a href=\"javascript:void(0)\" data-symbol=\"MFn::kNurbsCurve\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a9366a44db1c93f593f8e65fcbec6a1b9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kNurbsCurve</a>, &amp;status );\n\
    if (MS::kSuccess != status) {\n\
        displayError( &quot;Could not create selection list iterator&quot; );\n\
        return status;\n\
    }\n\
    if (list.isDone()) {\n\
        displayError( &quot;No curve selected&quot; );\n\
        return MS::kFailure;\n\
    }\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> component;\n\
    list.getDagPath( fDagPath, component );\n\
\n\
</pre></div><p>このコードでは、セレクション リストから最初のカーブ オブジェクトを取得します。コマンドの fDagPath フィールドは、現在の選択項目に設定されます。詳細については、「<a href=\'#!/url=./dev_help/Selecting-with-the-API/MItSelectionList.html\' title=\'\'>MItSelectionList</a>」を参照してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    return redoIt();\n\
}\n\
\n\
</pre></div><p>コマンドの内部データが設定されると、<span class=\'code\'>redoIt()</span> メソッドが呼び出されます。<span class=\'code\'>doIt()</span> メソッドは、必要なアクションを自分自身で実行できますが、このアクションは <span class=\'code\'>redoIt()</span> が実行するアクションと常に同じなので、<span class=\'code\'>doIt()</span> で <span class=\'code\'>redoIt()</span> を呼び出すと、コードの重複を減らすことができます。</p>\n\
<p>なぜ <span class=\'code\'>doIt()</span> で <span class=\'code\'>redoIt()</span> を呼び出すのでしょうか。逆ではないのでしょうか。redoIt() メソッドがキャッシュされたデータを取って <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a></span> に変換し、doIt() に渡すこともできますが、これははるかに非効率的です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> helix2::redoIt()\n\
{\n\
    unsigned i, numCVs;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsCurve\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_curve.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnNurbsCurve</a> curveFn( fDagPath );\n\
    numCVs = curveFn.numCVs();\n\
    status = curveFn.getCVs( fCVs );\n\
    if ( MS::kSuccess != status )\n\
    {\n\
        displayError( &quot;Could not get curve’s CVs&quot; );\n\
        return MS::kFailure;\n\
    }\n\
\n\
</pre></div><p>このコードでは選択したカーブの CV を取得し、コマンドの内部 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPointArray</a></span> に保存します。保存された CV の位置は、カーブを元の形に戻す undoIt() メソッドがコールされるときに使用されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    <a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPointArray</a> points(fCVs);\n\
    for (i = 0; i &lt; numCVs; i++)\n\
    points[i] = <a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPoint</a>( radius * cos( (double)i ),\n\
        pitch * (double)i, radius * sin( (double)i ) );\n\
    status = curveFn.setCVs( points );\n\
    if ( MS::kSuccess != status )\n\
    {\n\
        displayError( &quot;Could not set new CV information&quot; );\n\
        fCVs.clear();\n\
        return status;\n\
    }\n\
\n\
</pre></div><p>このコードでは、これまでに紹介したらせんのサンプルと同じように、カーブの CV の位置を設定してらせんを形成します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    status = curveFn.updateCurve();\n\
    if ( MS::kSuccess != status )\n\
    {\n\
        displayError( &quot;Could not update curve&quot; );\n\
        return status;\n\
    }\n\
\n\
</pre></div><p><span class=\'code\'>updateCurve()</span> メソッドを使用し、カーブのジオメトリが変更されたことを Maya に通知します。ジオメトリが変更された後でこのメソッドを呼び出さないと、オブジェクトの表示は変更されません。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    return MS::kSuccess;\n\
}\n\
\n\
</pre></div><p>関数の完了時に <span class=\'code\'>MS::kSuccess</span> を返すことにより、操作が問題なく完了したことが Maya に通知されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> helix2::undoIt()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnNurbsCurve\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_nurbs_curve.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnNurbsCurve</a> curveFn( fDagPath );\n\
    status = curveFn.setCVs( fCVs );\n\
    if ( MS::kSuccess != status)\n\
    {\n\
        displayError( &quot;Could not set old CV information&quot; );\n\
        return status;\n\
    }\n\
\n\
</pre></div><p>この数行では、保存された CV の位置(カーブの CV の元の位置)を取得してそれを再設定します。</p>\n\
<blockquote>\n\
<p>注: 変更される CV の数、または undo 関数で削除されるカーブについて気にする必要はありません。コマンドが元に戻された後に実行されたものはすべて、<span class=\'code\'>undoIt()</span> が呼び出される前に取り消されます。その結果、モデルはコマンドが完了した直後の状態に戻ります。</p>\n\
</blockquote>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    status = curveFn.updateCurve();\n\
    if ( MS::kSuccess != status )\n\
    {\n\
        displayError( &quot;Could not update curve&quot; );\n\
        return status;\n\
    }\n\
    fCVs.clear();\n\
    return MS::kSuccess;\n\
}\n\
\n\
</pre></div><p>ここでは、念のため <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPointArray</a></span> がクリアされます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">bool helix2::isUndoable() const\n\
{\n\
    return true;\n\
}\n\
\n\
</pre></div><p>このコマンドは元に戻すことができます。このコマンドはモデルを編集しますが、<span class=\'code\'>undoIt()</span> メソッドが提供されているので、コマンドが実行される前の状態にモデルを戻すことができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> initializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> obj )\n\
{ \n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin</a> plugin( obj, &quot;Autodesk&quot;, &quot;1.0&quot;, &quot;Any&quot;);\n\
    plugin.registerCommand( &quot;helix2&quot;, helix2::creator );\n\
    return MS::kSuccess;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> uninitializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> obj )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin</a> plugin( obj );\n\
    plugin.deregisterCommand( &quot;helix2&quot; );\n\
    return MS::kSuccess;\n\
}\n\
\n\
</pre></div><p>プラグインは、通常の initialize 関数と uninitialize 関数で終了します。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";