var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>カスタム エバリュエータの概要</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>カスタム エバリュエータの概要</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"カスタム-エバリュエータの概要\"></a></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/New_Odd.png\' title=\'\' /></div>\n\
<p>このセクションでは、Maya にカスタム エバリュエータを追加するために使用する API のクラスとメソッドについて説明します。カスタム エバリュエータにより、評価マネージャが DG ノードをスケジュールして実行する方法を変更することができます。Maya 2016 で導入されたシーン評価の変更を確認する場合は、詳細について、ホワイトペーパー『<em>Improving Performance with Parallel Evaluation</em>(英語)』(<a href=\'http://www.autodesk.com/maya-docs-jpn\' title=\'\' target=\'_blank\'>http://www.autodesk.com/maya-docs-jpn</a>)を参照してください。</p>\n\
<p>このセクションでは、評価マネージャで評価グラフを作成、パーティション化、およびスケジュールする方法を簡単に確認した後、新しい API クラスを紹介し、最後に新しい API クラスの使用を促進する簡単な例を説明します。devkit では追加の例を参照できます。</p>\n\
<div class=\'section\'><a id=\"基礎知識\"></a><h2 id=\"基礎知識\">基礎知識</h2></div>\n\
<p>Maya 2016 で導入された評価マネージャ(EM)では、ディペンデンシー グラフ(DG)ノードの同時評価をサポートすることにより、再生と操作のパフォーマンスが向上しました。</p>\n\
<p>EM では、シーンの異なるパーツのカスタマイズ処理を可能とする特別なエバリュエータを使用します。Maya 2016 では、次の 3 つのエバリュエータが用意されています。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
エバリュエータ\n\
</th>\n\
<th class=\"table-heading\">\n\
詳細\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
デフォーマ\n\
</td>\n\
<td class=\"table-body\">\n\
高密度のジオメトリをよりすばやく変形するために、GPU ハードウェアを活用\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
ダイナミクス\n\
</td>\n\
<td class=\"table-body\">\n\
シーンにサポートされない旧式ダイナミクスが含まれているかを検出し、検出した場合は並列評価を無効化\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
ルートを削減\n\
</td>\n\
<td class=\"table-body\">\n\
ノードスケジュールのオーバーヘッドを減らすために評価中のアニメーション カーブをグループ化\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<div class=\'section\'><a id=\"評価マネージャの確認\"></a><h3 id=\"評価マネージャの確認\">評価マネージャの確認</h3></div>\n\
<p>EM ではシーンの評価時、グラフの構築、グラフのパーティション化、およびグラフのスケジュールという 3 つの主要手順が実行されます。それぞれを以下に説明します。</p>\n\
<div class=\'section\'><a id=\"グラフの構築\"></a><h4 id=\"グラフの構築\">グラフの構築</h4></div>\n\
<p>従来の Maya の評価とは異なり、EM はフレームごとに何を評価するかを決定するために、ダーティな伝播に依存することはありません。代わりに、EM は DG ノード間の依存関係をエンコードする評価グラフ(EG)を作成します。</p>\n\
<p>EG の構築中に、アニメートされた各ノードに対してプラグのリストを作成します。このリストには、特定のノード上の下流の従属で必要なすべてのプラグが含まれており、特定のノードが評価されるたびに、すべての上流の依存関係が確実に最新の状態に保たれます。</p>\n\
<div class=\'section\'><a id=\"グラフのパーティション化\"></a><h4 id=\"グラフのパーティション化\">グラフのパーティション化</h4></div>\n\
<p>EG が構築されると、EM ではグラフのさまざまなパーツの評価方法を計算する必要があります。これを行うために、有効化されたエバリュエータが優先順にノードのサブグラフの所有権を要求することが可能となります。ノードを要求するには、エバリュエータは対象となるノードをマークする必要があります。</p>\n\
<p>走査中に、1 つまたは複数の入力に接続した 1 つまたは複数の出力を持つ、あらゆるノード レベルのサイクルは、EM によって<em>クラスタ</em>としてグループ化されます。異なるエバリュエータによって要求されているサブグラフもクラスタに追加されます。</p>\n\
<p>クラスタは単一のユニットとして一緒に評価され、相互に排他的です(つまり、1 つの評価ノードは最大 1 つのクラスタに属することができます)。したがって、すべてのクラスタのセットが、EG のパーティションを提供します。</p>\n\
<p>クラスタは階層状にレイヤ化され、現在のクラスタがノードの評価に失敗した場合、コントロールは親クラスタに渡されます。優先順位の高いものから順に、クラスタのレイヤは次のとおりです。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
レイヤ\n\
</th>\n\
<th class=\"table-heading\">\n\
詳細\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
カスタム\n\
</td>\n\
<td class=\"table-body\">\n\
カスタム エバリュエータ クラスタのレイヤ。ノードがカスタム エバリュエータのクラスタにある場合、そのエバリュエータがノードの評価に対する責任を持ちます。\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
サイクル\n\
</td>\n\
<td class=\"table-body\">\n\
正確性を確保するために特別な評価が必要となることが多い DG ノードレベルのサイクルのレイヤ(コンストレイントなど)。\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
ベース シェーダ\n\
</td>\n\
<td class=\"table-body\">\n\
クラスタなしの既定レイヤ。ノードは、特別な処理が不要で直接評価されます。\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<blockquote>\n\
<p><strong>注:</strong> グラフの構築とスケジュール中に、クラスタが作成および破棄されます。グラフが無効な場合は、クラスタが破棄されます。カスタム エバリュエータは、クラスタの初期化のみに依存し、コールバックを終了して、前のクラスタにはポインタをキャッシュすることはありません。現在、各クラスタは単一のユニットとして表現およびスケジュールされ、必要に応じてカスタム エバリュエータがノードを処理することができます。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"グラフのスケジュール\"></a><h4 id=\"グラフのスケジュール\">グラフのスケジュール</h4></div>\n\
<p>パーティションの後、EM は適切な順序で評価するノードをスケジュールする必要があります。上流のノードがすべての従属の前に評価されるように、ノードはスケジュールされます。これ以外で、特定の順序による評価を確実に実行することはできません。</p>\n\
<p>たとえば、単純なグラフでは、</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/CustomEval_GraphSchedule1.png\' title=\'\' /></div>\n\
<p>ノード A は B より前に評価されます。より複雑なグラフでは、</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/CustomEval_GraphSchedule2.png\' title=\'\' /></div>\n\
<p>A は B と C の前に評価されるように保証されますが、B と C の評価の正確なタイミングについては保証されません。B と C のスケジュール タイプに応じて、同時に評価される場合もあります。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> ノードにスケジュールが設定されていても、フリーズしている場合、ノードの評価はスキップされます。</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";