var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>複数のシェイプを持つトランスフォーム</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>複数のシェイプを持つトランスフォーム</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"複数のシェイプを持つトランスフォーム\"></a></div>\n\
<p>トランスフォーム ノードは、子として任意の数のトランスフォーム ノードを持つことができます。一般的には、トランスフォーム ノードが子として持てるシェイプ ノードは 1 つのみです。UI ウィンドウで DAG を表示すると、常にこのようになっています。しかし DAG を API から見ると、トランスフォームに複数のシェイプ ノードが子として含まれている場合があることに気付きます。このことが起きるのは、トランスフォームの下にあるオリジナルのシェイプ ノードが、ディペンデンシー グラフで変更されている場合です。ディペンデンシー グラフの結果に変換を保持するには、オリジナルのノードと同じトランスフォームの下にその結果を配置します。新しいノードには、元と同じ DAG トランスフォームが適用されていますが、CV が移動しているなど、何らかの方法で修正されています。この場合、UI ウィンドウには最終結果のみが可視になり、元のノードはヒストリとして残ります。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/comp_Transform04.png\' title=\'\' /></div>\n\
<p>|Transform1|Shape1 がオリジナルのオブジェクトですが、|Transform1|Shape1a が、UI ウィンドウで可視になる、実際のオブジェクトです。|Transform1|Shape1 は中間オブジェクトとも呼ばれ、後でディペンデンシー グラフを操作するときに重要となります。</p>\n\
<p>警告: 複数のシェイプを持つトランスフォームが最終ノードになっているパスで <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath::extendToShape()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html#a658d9664035ff84ffefa217c0e45cc88&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a6bbdc34b5bfd9747bfc59ad21771f7c6&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath::extendToShape()</a></span> メソッドを使用した場合、最初の子シェイプ ノードがパスの末尾に追加されます。これが目的のノードでない場合、<span class=\'code\'>extendToShape()</span> メソッドを使用しないでください。その代わりに <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath::child()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html#acf3680f39b19e4b44fe459efa2b76219&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#ad2623788dfe214b4e010f22d8b5d6b6a&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath::child()</a></span> メソッドと <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath::childCount()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html#a4545b4a1547fa72221afb9fa9f149412&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#abc2e6e8bf06454a962d1c0b72b63eab0&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath::childCount()</a></span> メソッドを使用し、目的のシェイプ ノードを参照したりアクセスしたりします。</p>\n\
<p>さらに、正しい子シェイプへ拡張するために使用できる <span class=\'code\'>MDagPath::extendToShapeDirectlyBelow(unsigned int index)</span> メソッドがあります。</p>\n\
<div class=\'section\'><a id=\"アンダーワールド\"></a><h2 id=\"アンダーワールド\">アンダーワールド</h2></div>\n\
<p>「アンダーワールド」は、NURBS サーフェスの UV 空間など、シェイプ ノードのパラメータ空間に付けられた名前です。このアンダーワールド空間内で、ノード、およびノードのサブグラフ全体を定義できます。</p>\n\
<p>例として、NURBS サーフェス上のカーブを定義するトランスフォーム ノードとシェイプ ノードが挙げられます。カーブを定義するコントロール ポイントは、サーフェスの UV 空間内にあります。アンダーワールドのノードを一意に識別するパスは、アンダーワールドのパラメータ空間を定義するシェイプ ノード内をルートとします。アンダーワールドパスの第 1 ノードは、シェイプを含んだパラメータ空間内で定義される第 1 ノードです。この第 1 ノードは、トランスフォーム ノードであることがほとんどです。</p>\n\
<p>アンダーワールド パスは、通常のパスと同じように指定します。つまり、パス内のノード名は「|」で区切ります。ただし、追加の命名規則として「-&gt;」を使用します。これは、アンダーワールド パスのシェイプ ノードとルート ノード間のトランジションを表します。</p>\n\
<p>たとえば NURBS サーフェスのサーフェス ノード上にあるカーブのパスを完全に指定すると、|SurfaceTransform|NURBSSurface -&gt; UnderworldTransform|CurvesShape となります。シェイプを定義するパラメータ空間がある限り、アンダーワールドのシェイプにアンダーワールドを再帰的に定義できます。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a></span> には、シェイプからアンダーワールドに至る、さまざまなパスにアクセスするメソッドが含まれています。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath::pathCount()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html#a8f653e0d5b6dca7a9d4ae9a635f3cd92&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a98605c367077c3a3f1dbeb00d01fab2a&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath::pathCount()</a></span> メソッドは、指定した <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a></span> インスタンスが表すパスの総数を返します。前述のカーブ オンサーフェスの例では、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a></span> インスタンスがアンダーワールドのカーブ シェイプまでのパスを表す場合は、pathCount は 2 となります。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath::getPath()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html#a45d0e6118fefc8c6e0b86b50234da810&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a54df9190d589a6e0ac25740b139a0718&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath::getPath()</a></span> メソッドは、アンダーワールドまたは 3 次元空間のいずれかでパスを返します。Path 0 では常に 3D パスを指定します。パス 1 は、パス 0 の最後にあるシェイプのすぐ内側にあるアンダーワールドでパスを指定します。パス 2 は、パス 1 の最後にあるシェイプのすぐ内側にあるアンダーワールドでパスを指定します。以下同様に続きます。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";