var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ディペンデンシー グラフ プラグイン</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ディペンデンシー グラフ プラグイン</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ディペンデンシー-グラフ-プラグイン\"></a></div>\n\
<p>このセクションでは、ディペンデンシー グラフ(DG)について紹介します。さらに、Maya API を拡張して統合するプラグインを記述するために、Maya API を使用する方法についても説明します。</p>\n\
<p>ディペンデンシー グラフは Maya の中核です。適用した操作と順番が記録された、シーンのコンストラクション ヒストリが保持されています。グラフは一連の相互接続されたノードで構成されており、各ノードは単一の操作または単一の計算セットをカプセル化しています。各ノードは、明確に定義された特定の入力データ セットを受け取り、そのデータに基づいて計算を実行し、1 つまたは複数の出力値を生成します。ノード、接続、およびディペンデンシー グラフの仕組みに関する背景情報については、「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/About-the-dependency-graph.html\' title=\'\'>ディペンデンシー グラフについて</a>」を参照してください。</p>\n\
<p>Maya API を使用して、受信データに基づいてカスタム操作を実行する、独自のカスタム ディペンデンシー グラフ ノードを作成できます。記述する各種ノードは、基本的な <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> クラスから派生するクラスによって表され、ディペンデンシー グラフに接続するために必要なメイン インタフェースを提供します。また、Maya API は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> から派生する他の複数のベース クラスも提供しますが、このクラスは異なる用途に対する動作に特化しています。たとえば、カスタム デフォーマを実装するために、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxNode</a></span> の代わりに <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDeformerNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_deformer_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MPxDeformerNode</a></span> からカスタム ノード クラスを派生させることができます。Maya は、カスタム ノードが組み込みタイプのデフォーマを処理するときと同じ方法で、カスタム ノードを処理します。これらの基本クラスの説明については、「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/Base-dependency-node-classes.html\' title=\'\'>ベース ディペンデンシー ノード クラス</a>」を参照してください。</p>\n\
<p>すべてのノード クラスは、いくつかのアトリビュート**を設定する必要があります。アトリビュートでは、ノードが受け取る入力データのタイプおよびノードが生成する出力データのタイプを定義します。詳細については、「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/Attributes-and-plugs.html\' title=\'\'>アトリビュートとプラグ</a>」および「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/Complex-and-Dynamic-Attributes.html\' title=\'\'>複雑なダイナミック アトリビュート</a>」を参照してください。</p>\n\
<p>各ディペンデンシー グラフ ノードの主な処理は、通常、その仮想メソッド <span class=\'code\'>compute()</span> 内で実行され、使用するカスタム クラスに実装する必要があります。実装を記述する場合の注意点については、「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/Implementing-the-compute-method.html\' title=\'\'>ディペンデンシー グラフ ノードに compute()メソッドを実装する</a>」を参照してください。Maya は、専用データ ブロック内の各ノードに関連するデータをすべて保持し、ノードの出力値を再計算する必要があるたびにこのメソッドに渡します。ハンドルを使用して、このブロックから入力データを読み込み、出力データをブロックに書き込みます。詳細については、「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/Working-with-data-blocks.html\' title=\'\'>データ ブロックを使用する</a>」を参照してください。</p>\n\
<p>新しいタイプのディペンデンシー グラフ ノードを定義するプラグインの操作例については、「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/A-basic-dependency-node-example.html\' title=\'\'>ディペンデンシー ノードの基本例</a>」および「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/A-more-complex-dependency-graph.html\' title=\'\'>より複雑なディペンデンシー グラフの例</a>」を参照してください。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";