var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ディペンデンシー ノードの基本例</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ディペンデンシー ノードの基本例</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ディペンデンシー-ノードの基本例\"></a></div>\n\
<p>次の例では、基本的な <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a></span> 親クラスから派生する単純なカスタム ディペンデンシー グラフ ノードについて説明します。単一の浮動小数値を入力値として取り、この数値の正弦値を計算し、結果を出力します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#include &lt;string.h&gt;\n\
#include &lt;iostream&gt;\n\
#include &lt;math.h&gt;\n\
#include &lt;maya/MString.h&gt; \n\
#include &lt;maya/MFnPlugin.h&gt;\n\
\n\
</pre></div><p>これはプラグインでもあるため、<span class=\'code\'>MFnPlugin.h</span> も必要です。ただし、ノードを登録するには、コマンドではなく別のメソッドを使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#include &lt;maya/MPxNode.h&gt; \n\
#include &lt;maya/MTypeId.h&gt; \n\
#include &lt;maya/MPlug.h&gt;\n\
#include &lt;maya/MDataBlock.h&gt;\n\
#include &lt;maya/MDataHandle.h&gt;\n\
\n\
</pre></div><p>これらのヘッダ ファイルは、ほとんどのプラグイン ディペンデンシー グラフ ノードで使用されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#include &lt;maya/MFnNumericAttribute.h&gt;\n\
\n\
</pre></div><p>さまざまなアトリビュート型が数多くあります(これらについては後で説明します)。必要なアトリビュート型は、作成するノードの種類によって決まります。このサンプルでは数値データのみを使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class sine : public <a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a>\n\
{\n\
\n\
</pre></div><p>ユーザ定義ディペンデンシー グラフ ノードは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a></span> クラスから派生します。</p>\n\
<p><strong>コンストラクタ:</strong></p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    public:\n\
        sine();\n\
\n\
</pre></div><p>このノードのインスタンスが作成されるたびに、ノードのコンストラクタがコールされます。<span class=\'code\'>createNode</span> コマンドを呼び出すときや <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnDependencyNode::create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dependency_node.html#aae69364b2e9c744f9e36acb18dccaf30&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dependency_node.html#a90d460ba7d96be2aefd5d18bb273aa0e&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnDependencyNode::create()</a></span> メソッドを起動するときなどがこれにあたります。</p>\n\
<p><strong>デストラクタ:</strong></p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">        virtual ~sine();\n\
\n\
</pre></div><p>ノードを本当に削除する場合のみ、デストラクタがコールされます。Maya には元に戻す(undo)待ち行列があるので、ノードを削除しても実際にノードのデストラクタはコールされません。削除を元に戻した場合に、ノードを再作成せずに復元できるようにするためです。一般的に削除したノードのデストラクタは、元に戻す待ち行列がフラッシュされた場合にのみコールされます。</p>\n\
<p><strong>compute() 関数:</strong></p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> compute( const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; plug,\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataBlock</a>&amp; data );\n\
\n\
</pre></div><p><span class=\'code\'>compute()</span> メソッドはノードの頭脳です。ノードの入力を使用してノードの実際の作業を実行し、出力を生成します。</p>\n\
<p><strong>creator() 関数</strong></p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">        static void* creator();\n\
\n\
</pre></div><p><span class=\'code\'>creator()</span> メソッドは、コマンドの creator メソッドと同じ目的で動作します。つまり、Maya でこのノードのインスタンスをインスタンス化できるようにします。このメソッドは、<span class=\'code\'>createNode</span> コマンドまたは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnDependencyNode::create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dependency_node.html#aae69364b2e9c744f9e36acb18dccaf30&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dependency_node.html#a90d460ba7d96be2aefd5d18bb273aa0e&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnDependencyNode::create()</a></span> メソッドがノードの新しいインスタンスを要求するたびに呼び出されます。</p>\n\
<p><strong>initialize() 関数:</strong></p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">        static <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> initialize();\n\
\n\
</pre></div><p><span class=\'code\'>initialize()</span> メソッドは、ディペンデンシー ノードのための登録メカニズムで呼び出されます。このため、ユーザ定義ノードを含むプラグインがロードされた直後に一度コールされます。ノードの入出力(たとえばアトリビュート)を定義するために使用されます。</p>\n\
<p><strong>ノード アトリビュート:</strong></p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    public:\n\
        static <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> input;\n\
        static <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> output;\n\
\n\
</pre></div><p>この 2 つの <span class=\'code\'>MObjects</span> は正弦(sine)ノードのアトリビュートです。ノードのアトリビュートには任意の名前を自由に使用できます。ここでは分かりやすくするため、入力(input)と出力(output)を使用します。</p>\n\
<p><strong>ノード タイプ:</strong></p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">        static <a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> id;\n\
\n\
</pre></div><p>それぞれのノードには固有の識別子が必要です。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnDependencyNode::create()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dependency_node.html#aae69364b2e9c744f9e36acb18dccaf30&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dependency_node.html#a90d460ba7d96be2aefd5d18bb273aa0e&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnDependencyNode::create()</a></span> は、この識別子を使用して作成するノードを識別します。Maya ファイル フォーマットでも、この識別子が使用されます。</p>\n\
<p>ノードをローカルでテストする場合は、0x00000000 から 0x0007ffff までの識別子を任意に使用できますが、永続的な目的でノードを使用する場合は、世界で固有な識別子を <a href=\'http://mayaid.autodesk.io/\' title=\'\' target=\'_blank\'>http://mayaid.autodesk.io/</a> から取得してください。ユーザごとに独自で管理できる、固有の範囲が割り当てられます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">};\n\
<a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> sine::id( 0x80000 );\n\
\n\
</pre></div><p>ここでは、ノードの識別子を一意のタグに初期化します。これらのタグは、すべてのノードで一意にする必要があります(タグはノードを再作成するためにファイル フォーマットで使用されます)。タグは Autodesk から API ユーザに割り当てます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> sine::input; \n\
<a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> sine::output; \n\
\n\
</pre></div><p>ノードのアトリビュートは NULL 値に初期化されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">void* sine::creator() {\n\
    return new sine;\n\
}\n\
\n\
</pre></div><p>前に説明したように、<span class=\'code\'>creator()</span> メソッドは、このノードの新しいインスタンスを単に返します。複数のノードを相互に接続する必要がある、より複雑な状況では、接続される複数のノード用に 1 つの creator を定義し、この creator を使って割り当てすべてのノードを相互に接続することができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> sine::initialize() {\n\
\n\
</pre></div><p>initialize メソッドは、ノードを初めて Maya に登録する際、一度だけコールされます。このメソッドでは、ノードのアトリビュート、つまりその他のノードからの接続の対象となる、ノードの入出力データを定義します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnNumericAttribute</a> nAttr;\n\
\n\
</pre></div><p>このサンプルでは数値データしか使用しないので、すべてのアトリビュートは数値であり <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnNumericAttribute</a></span> のみが必要になります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    output = nAttr.create( &quot;output&quot;, &quot;out&quot;,\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html#a1d1cfd8ffb84e947f82999c682b666a7a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnNumericData::kFloat</a>, 0.0 );\n\
    nAttr.setWritable(false);\n\
    nAttr.setStorable(false);\n\
\n\
</pre></div><p>この 3 行の最初の行は、正弦ノードの出力アトリビュートを定義します。アトリビュートを定義する場合は、アトリビュートのロング ネーム(4 文字以上)とショート ネーム(3 文字以下)を指定する必要があります。この名前は、MEL スクリプトと UI エディタで特定アトリビュートを識別するために使用されます。必須ではありませんが、一般的にはロング ネームをアトリビュートの C++ 識別子と同じにします。このサンプルでは、両方とも出力(output)です。</p>\n\
<p>create メソッドではアトリビュートの型も指定します。この場合は float (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html#a1d1cfd8ffb84e947f82999c682b666a7a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnNumericData::kFloat</a></span>) です。また既定値をゼロに設定します。アトリビュートの名前を一意にする必要があるのは同一ノード内のみです。別のノードでは同じ名前のアトリビュートを使用できます。</p>\n\
<p>次の 2 行は、このアトリビュートの特定の特性を設定します。これは正弦ノードの出力であるため、その他のノードからは書き込めません。つまり、別のノードの出力アトリビュートは、このアトリビュートに接続できません。またこれは出力であるため、ファイルの書き込み時に保存する必要はありません。出力は入力から生成できるからです(出力を保存しても問題にはなりませんが、スペースの浪費になります)。</p>\n\
<p>新しいノードをインスタンス化すると、以下の特性は true に設定されます。</p>\n\
<ul>\n\
<li>readable (出力として使用できるか)</li>\n\
<li>writable (入力として使用できるか)</li>\n\
<li>connectable (別のアトリビュートから接続できるか)</li>\n\
<li>storable (ファイルに保存できるか)</li>\n\
<li>settable (値を設定できるか)</li>\n\
</ul>\n\
<p>以下の特性は false に設定されます。</p>\n\
<ul>\n\
<li>multi (配列)</li>\n\
<li>keyable (キーフレーム化できるか)</li>\n\
<li>indeterminant (使用されるかどうかわからないアトリビュート -- 関連するレンダリング)</li>\n\
<li>hidden (アトリビュート エディタ(Attribute Editor)内で可視でない)</li>\n\
</ul>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    input = nAttr.create( &quot;input&quot;, &quot;in&quot;,\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericData::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_data.html#a1d1cfd8ffb84e947f82999c682b666a7a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_data.html#a5acb08282492d2ebdb11c2e7680bb48f&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnNumericData::kFloat</a>, 0.0 );\n\
    nAttr.setStorable(true);\n\
\n\
</pre></div><p>入力アトリビュートの初期化は出力アトリビュートと同じですが、入力の値はノードで計算できないので、ノードを保存する際に保存する必要があります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    addAttribute( input );\n\
    attributeAffects( input, output );\n\
\n\
</pre></div><p>入力アトリビュートが正弦ノードのアトリビュートとして追加されます。<span class=\'code\'>attributeAffects()</span> メソッドは、入力アトリビュートが出力アトリビュートに影響するタイミングを示すために使用されます。これを認識すると、Maya は、複数の入出力がある、より複雑なノードのグラフでディペンデンシーを最適化できるようになりますが、すべての入力がすべての出力に影響するとは限りません。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    addAttribute( output );\n\
\n\
</pre></div><p>出力アトリビュートが正弦ノードに追加されます。出力アトリビュートが生成されても入力アトリビュートは影響されないので、<span class=\'code\'>attributeAffects()</span> メソッドは必要ありません。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    return MS::kSuccess;\n\
\n\
</pre></div><p>成功を返し、ノードが問題なく初期化されたことを Maya に通知します。エラーが返されると初期化は停止します。initialize メソッドは一度しかコールされないので、ノードはこのセッションで使用できなくなります。ノードが必要とするリソースを使用できない場合は、常にエラーが返されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">}\n\
sine::sine() {}\n\
sine::~sine() {}\n\
\n\
</pre></div><p>非常に単純なノードなので、コンストラクタとデストラクタは何も実行しません。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> sine::compute( const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; plug, <a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataBlock</a>&amp; data ) {\n\
\n\
</pre></div><p><span class=\'code\'>compute()</span> メソッドはディペンデンシー グラフ ノードの頭脳で、ノードの実際の作業をすべて実行します。このメソッドは 2 つの引数を取ります。最初の引数は、計算を要求するプラグへの参照で、次の引数はノードのデータ ブロックです。プラグとデータ ブロックについては、後のセクションで詳しく説明します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> returnStatus;\n\
    if( plug == output )\n\
    {\n\
\n\
</pre></div><p><strong>プラグ</strong></p>\n\
<p>プラグは、再計算されたアトリビュートと考えることができます。このテストでは、再計算が要求されている出力アトリビュートがチェックされます。</p>\n\
<p>この単純なサンプルでは出力アトリビュートしか該当しませんが、より複雑なノードでは、任意の出力になることがあります。プラグが認識されているアトリビュートを表しているかどうか、常にテストしてください。たとえば、誰かが接続のあるノードにダイナミック アトリビュートをアタッチしたとします。これにより、入力が変更されていないのに compute メソッドがコールされることがあります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">        <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> inputData = data.inputValue( input,\n\
            &amp;returnStatus );\n\
\n\
</pre></div><p><strong>データ ブロック</strong></p>\n\
<p>データ ブロックには、ノードのこのインスタンスのデータがすべて含まれています。効率上の理由から、このデータは 1 つのブロックとして保存されます。ブロックの一部を参照するには、データ ハンドルを使用します。このケースでは、入力アトリビュートを参照するためにデータ ハンドルが設定されています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">        if( returnStatus != MS::kSuccess )\n\
            cerr &lt;&lt; &quot;ERROR getting data&quot; &lt;&lt; endl;\n\
        else\n\
        {\n\
            float result = sin( inputData.asFloat() );\n\
\n\
</pre></div><p><span class=\'code\'>MFnDataHandle</span> の <span class=\'code\'>as*()</span> メソッドによって、データ ハンドルからデータが取り出されます。<span class=\'code\'>as*()</span> メソッドは必ず、宣言されたアトリビュートの型と一致させる必要があります。入力アトリビュートを <span class=\'code\'>MFnNumericAttribute::kFloat</span> として宣言したので、データは <span class=\'code\'>asFloat()</span> で取り出す必要があります。型と取り出しメソッドが混在すると、重大なエラーの原因となります。たとえばアトリビュートを <span class=\'code\'>MFnNumericAttribute::kDouble</span> として宣言し、<span class=\'code\'>asFloat()</span> で取り出すと重大なエラーとなります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">             <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> outputHandle = data.outputValue(\n\
                output );\n\
\n\
</pre></div><p>出力アトリビュートのデータ ブロックの一部を参照するために、新しいデータ ハンドルを割り当てます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">            outputHandle.set( result );\n\
\n\
</pre></div><p>出力アトリビュートに計算結果が割り当てられます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">            data.setClean(plug);\n\
\n\
</pre></div><p>再計算を引き起こしたデータ ブロックのプラグが clean にマークされ、新しく計算し直されたことが示されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">        }\n\
    }\n\
    return MS::kSuccess;\n\
}\n\
\n\
</pre></div><p>成功ステータスが返ると、計算が適切に終了したことが分かります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> initializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> obj ) { \n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin</a> plugin( obj, &quot;My plug-in&quot;, &quot;1.0&quot;, &quot;Any&quot;);\n\
    status = plugin.registerNode( &quot;sine&quot;, sine::id, sine::creator, sine::initialize );\n\
\n\
</pre></div><p>プラグインでは、コマンド プラグインと同じように <span class=\'code\'>initializePlugin()</span> と <span class=\'code\'>uninitializePlugin()</span> が必要ですが、<span class=\'code\'>registerCommand()</span> の代わりに <span class=\'code\'>registerNode()</span> を使用し、Maya のノードのデータベースにノードを追加します。ノードの initialize メソッドは、<span class=\'code\'>registerNode</span> を呼び出した結果として呼び出されます。initialize メソッドがエラー コードを返すと、<span class=\'code\'>registerNode</span> もエラーになり、ノードはロードされません。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    return status;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> uninitializePlugin( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> obj) {\n\
     <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
     <a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin</a> plugin( obj );\n\
     status = plugin.deregisterNode( sine::id );\n\
     return status;\n\
}\n\
\n\
</pre></div><p>単純なディペンデンシー グラフ ノードが完成しました。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";