var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ディペンデンシー グラフについて</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ディペンデンシー グラフについて</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ディペンデンシー-グラフについて\"></a></div>\n\
<p>このページでは、ディペンデンシー グラフの仕組みを簡単に説明します。</p>\n\
<p>ディペンデンシー グラフ(DG)は、接続された構成要素の集合です。DAG とは異なり、この接続はサイクル可能で、親子リレーションシップを持ちません。その代わりにグラフの接続によって、グラフのある構成要素から別の構成要素にデータを移動できます。グラフ内で入力の受け入れ、計算の実行、新しいデータの出力を行う構成要素は、ディペンデンシー グラフ ノードと呼ばれます。ディペンデンシー グラフ ノードは、モデル作成、デフォメーション、アニメーション、シミュレーション、オーディオ処理など、Maya のほとんどすべてで使用されます。</p>\n\
<p>ノードは、ディペンデンシー グラフを駆動するエンジンです。データがノード内に入り、データに対して操作を実行し、新しいデータを再度使用可能にします。データは入力プラグを通して入り(ノード アトリビュートのインスタンス化)、出力プラグを通して出て行きます。プラグを通して使用できるデータ以外に、ノードが外部データをさらに要求することはありません。</p>\n\
<p>Maya のほとんどのオブジェクトは、ディペンデンシー グラフ ノードか、ノードのネットワーク(複数のノードが接続されたもの)です。たとえば DAG ノードはディペンデンシー グラフ ノードで、シェーダはノードのネットワークです。</p>\n\
<p>ディペンデンシー グラフ ノード同士が接続されると、DAG ノードが影響され、レンダーされるものも影響を受けます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/comp_Transform05.png\' title=\'\' /></div>\n\
<p>この図では、DAG 階層とディペンデンシー グラフを結合しています。Transform1、Transform2、Transform3、球(Sphere)がすべて DAG ノードである一方(ディペンデンシー グラフ ノードでもあります)、時間(Time)は単なるディペンデンシー グラフ ノードです。</p>\n\
<p>Transform3 のスケール X (Scale X)、スケール Y (Scale Y)、スケール Z (Scale Z)パラメータは時間の影響を受けています。あるいは、時間の出力が、Transform3 のスケール X、スケール Y、スケール Z の接続に接続されていると考えることもできます。アニメーションの再生時には、球の 2 つのインスタンスのサイズが大きくなります。</p>\n\
<p>グラフ内を流れるデータは、数値のように単純な場合もあれば、サーフェスのように複雑な場合もあります。完全なユーザ定義オブジェクトである場合もあります。</p>\n\
<p>ディペンデンシー グラフは非常に複雑なアーキテクチャで構成されており、その動作を完全に説明すると、もう 1 冊マニュアルが書けてしまいます。ここでは、簡潔に説明します。</p>\n\
<p>前に説明したように、ディペンデンシー グラフは有向グラフで、グラフのエッジは別のノードのプラグを接続します。データはこのエッジに沿って送信されます。データには、数値、ベクトル、行列などの基本の型、カーブ、サーフェス、ユーザ定義型などの複雑な型が含まれます。</p>\n\
<p>Maya ノードの定義の一部として、どの入力アトリビュートがどの出力アトリビュートに影響するかを指定する必要があります(API では、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::attributeAffects()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#aef755adb241fbe273368fefae14047a4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#adf19fe538d775ac2ec0169e6bc300f1c&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode::attributeAffects()</a></span> メソッドで実行します)。</p>\n\
<p>ノードのアトリビュートが変更されると、ディペンデンシー グラフは、そのアトリビュートが出力に影響するかどうかチェックします。影響する場合は、それぞれの出力がダーティ(dirty)とマークされます。これは、キャッシュされている値が古く、再計算の必要があるということを表します。出力アトリビュートごとに、ディペンデンシー グラフは、それが接続のソースになっているかどうか確認します。ソースになっている場合は接続がたどられ、たどられたアトリビュートもダーティとマークされます。この処理が繰り返され、最終的には、グラフ内の計算し直す必要があるノードのすべてのアトリビュートがダーティとマークされます。この時点では、どのアトリビュートも再計算されないことに注意してください。その代わりに状態が更新され、どのデータが無効であるかを認識できるようになります。無効なアトリビュートの評価と再計算は、別々の手順で実行されます。</p>\n\
<p>画面のリフレッシュやアニメーションの再生など、特定のイベントによって、ディペンデンシー グラフの再評価が引き起こされることがあります。たとえばリフレッシュ中は、システムが DAG を走査し、DAG ノードごとに再評価の必要があるかどうかを確認します(プラグがダーティであるかどうかチェックします)。再評価の必要がある場合は、プラグに影響するノードの compute メソッドがコールされます。この compute メソッドは、ダーティなプラグに依存している可能性があるので、影響するノードの compute メソッドもコールされます。このようにして、DG の関連する部分で、再評価が必要な部分のみが再評価されます。</p>\n\
<p>最適化のために、DG は必要にならないとグラフを再評価しません。たとえば、3 つのノードがある回転サーフェスを考えます。あるカーブ DAG ノードが、カーブを回転してサーフェスを作成する第 2 ノードの入力として使用され、それが第 3 ノード、すなわちサーフェスを DAG に配置する DAG ノードの出力となっている関係です。入力カーブを修正しても、サーフェスはすぐには再作成されません。再作成は画面が次にリフレッシュされるまで行われません。最終的にサーフェスが確実に再作成されるようにするため、カーブを修正すると、カーブの出力プラグに接続されているすべてのプラグがダーティとマークされ、回転ノードの入力もダーティとマークされます(カーブの出力プラグ自体は、再計算されたばかりなのでダーティとマークされません)。アトリビュートを宣言する場合には、相互に影響するアトリビュートを指定する必要があります。回転ノードでは、出力アトリビュートは入力アトリビュートに依存します。このため入力アトリビュートをダーティとマークすると、出力アトリビュートもダーティとマークされます。回転ノードの出力はサーフェス ノードに接続されているので、回転ノードの出力がダーティとマークされると、サーフェスもダーティとマークされます。このため、画面のリフレッシュ中に DAG が走査されると、サーフェスがダーティとマークされているので、ダーティとマークされているものに依存するすべてが再評価される必要があります。</p>\n\
<p>再評価は、ダーティとマークされた入力を含まない最初のノードで停止します。たとえばカーブの回転角度を変更したが、カーブ自体は変更しなかった場合、回転サーフェスの再作成により、回転ノードは再計算されますが、カーブは影響されません。</p>\n\
<p>これは高レベルでの説明です。実際はいろいろ複雑な判断が行われ、必要ない評価は実行されません。</p>\n\
<p>グラフ内を流れるデータは、パイプ内を流れる水にたとえられます。パイプ自体は接続にあたり、流れるデータがなければパイプは何も行いません。</p>\n\
<p>このたとえを拡張すると、ノードは、栓、シャワー、噴水などにあたります。それぞれ独自の方法で水を使用して何らかを行いますが、水がないと動作しません。</p>\n\
<p>DG を使用する場合の興味深い副作用は、オブジェクトに直接影響を与えるのが難しくなることです。</p>\n\
<p>たとえば、前の図の球を考えてください。Transform3 のスケールに DG ノードが接続されていなければ、UI か API で設定した値が新しいスケールになります。しかし図のように 時間が球のスケールに影響する場合、Transform3 のスケールを UI か API でさらに修正しても、結果は異なったものになります。スケールを設定すると、ディペンデンシー グラフが次に再評価されるまで、時間によって設定された値をオーバーライドしますが、再評価と同時に UI または API で設定した値は、時間により再度オーバーライドされます。</p>\n\
<p>回転サーフェスはより複雑な例です。作成されたサーフェス上の CV を移動したら、何が起きるでしょうか。CV は、DG が再評価されるまで新しい位置に移動しますが、再評価された時点で、回転ノードが指示する位置に戻ります。</p>\n\
<p>しかしモデルの微調整は、複雑なモデルやシーンの作成に必要な操作です。そこで Maya では、この調整を処理するメカニズムを設計しました。メッシュ シェイプはアトリビュート pnts を持ちます。ここには、メッシュの頂点に加えたローカルな変更が保存されます。メッシュの頂点の新しいセットを生成するメッシュ シェイプ ノードの上流接続は、pnts アトリビュートに影響しません。pnts アトリビュートの値は、メッシュの座標に追加されます。NURBS サーフェスと、コントロール ポイントに基づくその他のノードでは、controlPoints アトリビュートに調整情報が保存されます。Maya では、コントロール ポイントに基づくノードの調整情報を保存する tweak ノードも実装されています。tweak ノードは、コントロール ポイントに基づくノードとコントロール ポイント上で動作する上流トランスフォーム ノードの間に配置されます。tweak ノードは、調整情報と変形コントロール ポイントを統合し、最終的なコントロール ポイントを生成してシェイプに渡します。調整情報を処理するアトリビュートの詳細については、「tweak ノード」、「mesh シェイプ ノード」、「nurbsSurface シェイプ ノード」のマニュアル ページを参照してください。</p>\n\
<div class=\'section\'><a id=\"ノード状態\"></a><h2 id=\"ノード状態\">ノード状態</h2></div>\n\
<p>各ディペンデンシー グラフ ノードには、評価方法を示す状態値があります。Maya ユーザは、MEL や Python コマンドおよび API を使用して、Maya UI でこの値を取得して設定できます。状態は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::state\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#ab1315838f80fd570104dc41d834d8ff5&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode::state</a></span> アトリビュートに整数として格納されます。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
状態値\n\
</th>\n\
<th class=\"table-heading\">\n\
状態\n\
</th>\n\
<th class=\"table-heading\">\n\
説明\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<a name=\"GUID-B269E42C-C79D-4E1A-8666-A9F9BDB378F3\"></a>\n\
<p class=\"table-body\">\n\
0\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"GUID-95953C77-5DA0-4A33-9099-6DCA9B52B2BC\"></a>\n\
<p class=\"table-body\">\n\
<em class=\"mild\">通常(Normal)</em>\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
これは通常、デフォルトのノードの状態です。この状態のノードは普通に評価されます。\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
<a name=\"GUID-62B73B22-5B43-45A5-A425-2ABAB990349C\"></a>\n\
<p class=\"table-body\">\n\
1\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"GUID-507F955D-9B14-40DD-9871-1731FC578DC1\"></a>\n\
<p class=\"table-body\">\n\
<em class=\"mild\">エフェクトなし(HasNoEffect)</em>\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"GUID-3B16A136-F192-4767-BF34-C603202321C8\"></a>\n\
<p class=\"table-body\">\n\
<em class=\"mild\"></em>エフェクトなし状態または<em class=\"mild\"></em>通過状態は、入力データが未変更のノードを通過できるように、ノードが許可する必要があることを示します。これは、ノードが入力値の計算を実行し、同じタイプの出力を生成する場合に使用します。これにより、周囲のグラフからノードを切断せずに、ノード内の計算を簡単に無効にすることができます。\n\
</p>\n\
<a name=\"GUID-7DA6F259-0F16-4F83-9211-F45DCEC605DA\"></a>\n\
<p class=\"table-body\">\n\
たとえば、ほぼすべてのデフォーマが、入力ジオメトリを変形せずに、出力アトリビュートに直接送信することで、この状態をサポートします。ただし、デフォーマが通常受け入れる入力とは異なるタイプの出力を生成するノードは、この状態をサポートしません。\n\
</p>\n\
<a name=\"GUID-C666459A-1803-4C93-8DDB-A42BE7C184CD\"></a>\n\
<p class=\"table-body\">\n\
カスタム ディペンデンシー ノード クラスを作成する場合、この状態をサポートすることができます。詳細については、「<span class=\"char_link\"><a href=\"#!/url=./dev_help/Dependency-graph-plug-ins/Implementing-the-compute-method.html\">ディペンデンシー グラフ ノードに compute()メソッドを実装する</a></span>」を参照してください。\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<a name=\"GUID-8F35A7DE-2116-466B-9C94-9ABEFC88E5F1\"></a>\n\
<p class=\"table-body\">\n\
2\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"GUID-7649EE46-85AF-4230-9756-A09D375A54B7\"></a>\n\
<p class=\"table-body\">\n\
<em class=\"mild\"></em>ブロッキング\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"GUID-73C70745-28B5-43CF-9EAF-DAFC07BF95AC\"></a>\n\
<p class=\"table-body\">\n\
<em class=\"mild\"></em>ブロッキング状態は、ディペンデンシー ノード ベース クラスで実装され、すべてのノードに適用されます。ブロッキングは、評価フェーズ中の接続に適用されます。ブロックされた接続に対する評価要求が失敗すると、目的プラグが現在の値を保持します。ブロックされた接続はクリーンな状態になることはないため、この状態はダーティな伝播に影響します。\n\
</p>\n\
<a name=\"GUID-CBED54B6-EC79-4A98-90BD-09CFB5ADEC14\"></a>\n\
<p class=\"table-body\">\n\
ノードを<em class=\"mild\"></em>ブロッキングに設定すると、すべての送信接続が解除されたのと同じ動作になる可能性があります。ブロックされたノードの評価を直接要求しない限り、再評価されることはありません。ブロックされたノードは <span class=\"code\">getAttr()</span> 要求に引き続き応答しますが、下流ノードの <span class=\"code\">getAttr()</span> は、ブロックされたノードを再評価しないことに注意してください。\n\
</p>\n\
<a name=\"GUID-5F040A13-4D9F-46AE-B56A-88399C1C75DA\"></a>\n\
<p class=\"table-body\">\n\
<em class=\"mild\">ブロッキング(Blocking)</em>に対して階層のルート変換を設定しても、自動的にはこの階層の子変換に影響しません。その代わり、各子ノードを <span class=\"code\">Blocking</span> 状態に明示的に設定する必要があります。たとえば、次のようなスクリプトを使用します。\n\
</p>\n\
<pre><code>import maya.cmds as cmds\n\
\n\
def blockTree(root):\n\
\n\
    nodesToBlock = []\n\
\n\
    for node in {child:1 for child in cmds.listRelatives( root, path=True, allDescendents=True )}.keys():\n\
\n\
        nodesToBlock += cmds.listConnections(node, source=True, destination=True )\n\
\n\
    for node in {source:1 for source in nodesToBlock}.keys():\n\
\n\
        cmds.setAttr( \'%s.nodeState\' % node, 2 )\n\
\n\
</code></pre>\n\
<a name=\"GUID-DAB96228-28F1-49A4-9C97-C3E35DB3FFE6\"></a>\n\
<p class=\"table-body\">\n\
このスクリプトを適用してオブジェクトの描画を継続できますが、子ノードはアニメートできません。\n\
</p>\n\
<a name=\"GUID-516E6C9D-C104-4C9B-876F-ADEEC6DEA153\"></a>\n\
<p class=\"table-body\">\n\
カスタム ディペンデンシー ノード クラスを作成する場合、<span class=\"code\"><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a></span> ベース クラスをによって自動的に処理されるため、この場合を確認する必要がありません。\n\
</p>\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p>内部使用専用として次の 3 つの状態があります。<strong>待機 - 通常、</strong>待機 - エフェクトなし、および **待機 - ブロッキングです。これらのノードは、ユーザの操作(グラフの操作)中にグラフのパーツを一時的に遮断します。操作が完了したら、Maya はノードの状態を適切にリセットします。これらの状態を心配する必要はありません。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";