var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>アトリビュートとプラグ</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>アトリビュートとプラグ</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"アトリビュートとプラグ\"></a></div>\n\
<p>このページでは、単純なスタティック アトリビュートおよびプラグの処理方法について説明します。</p>\n\
<p>ノード自体は、影響を与える方法がなければ使い道があまりありません。ノードの変更は、アトリビュートとプラグで実行します。</p>\n\
<p>ノードのアトリビュートは、ノードとグラフの他の部分とのデータ インタフェースを定義します。評価中にノードが相互に渡すデータだけは、このインタフェースを介してやり取りされます。このインタフェースは、受け取るデータの型、データの名前(ロング フォームかショート フォームか)、データをリストにできるかどうか、ノードがデータの入出力を行う方法を指定します。データ型には、整数値や浮動小数点値などの単純なデータ型と、ポイント、ポリゴン メッシュ全体、NURBS サーフェスなどの複雑なデータ型が含まれます。</p>\n\
<p>プラグは、特定アトリビュートのデータを含む構造体です。アトリビュートのすべてのデータ アクセスは、プラグを通して実行されます。アトリビュート自体は、データ型とアトリビュートの名前の定義のみを行います。プラグは、ノード間の接続を作成するためのポートでもあります。</p>\n\
<p>アトリビュート名は、ノード階層全体で一意でなければなりません。つまり、派生クラスと親クラスすべてで一意である必要がありますが、関係ないノード間では再利用できます。</p>\n\
<p>アトリビュートには既定値が割り当てられていることがあります。既定値は、値が設定されていない場合に、アトリビュート上のプラグに含まれる値です。たとえば数値アトリビュートの既定値はゼロですが、これはアトリビュートの作成時に変更できます。どのアトリビュートの型でも既定値は、アトリビュートが受け入れるデータ型の既定値になります。数値データの既定値はゼロで、行列データの既定値は単位行列です。</p>\n\
<p>スタティック アトリビュートを設定するためには、主に 2 つのことを実行する必要があります。</p>\n\
<ul>\n\
<li>ノード クラスのアトリビュートで <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> スタティック クラス メンバーを宣言します。アトリビュートを NULL 値に初期化します。</li>\n\
<li><span class=\'code\'>MPxNode::initialize()</span> の実装でアトリビュートを設定し、使用するノードに追加します。これを実行するには、アトリビュートが格納するデータの種類に応じて、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnAttribute</a></span> から派生するクラスの 1 つを使用します。</li>\n\
</ul>\n\
<p>たとえば、単純な数値を格納するアトリビュートを使用するには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnNumericAttribute</a></span> クラスを使用します。「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/A-basic-dependency-node-example.html\' title=\'\'>ディペンデンシー ノードの基本例</a>」を参照してください。</p>\n\
<p>より複雑なデータ型を格納するには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnTypedAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_typed_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_typed_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnTypedAttribute</a></span> などの他のアトリビュート クラスを使用して設定します。「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/A-more-complex-dependency-graph.html\' title=\'\'>より複雑なディペンデンシー グラフの例</a>」を参照してください。</p>\n\
<div class=\'section\'><a id=\"maya-ui-のアトリビュート\"></a><h2 id=\"maya-ui-のアトリビュート\">Maya UI のアトリビュート</h2></div>\n\
<p>既定では、Maya はアトリビュート エディタ(Attribute Editor)内でノードのアトリビュートを自動的に準備します。ノードのアトリビュートを特別に準備する場合は、ノードのアトリビュート エディタ テンプレートを作成します。これは <span class=\'code\'>MAYA_SCRIPT_PATH</span> 上にある、<span class=\'code\'>AE{nodeName}Template.mel</span> という形式の MEL ファイルで、<span class=\'code\'>AE{nodeName}Template</span> という名前の MEL プロシージャが含まれています。このプロシージャには <em>editorTemplate</em> コマンドが含まれており、このコマンドは、ノード内でアトリビュートの既定レイアウトを変更する方法をアトリビュート エディタに指示します。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";