var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ディペンデンシー グラフ ノードに compute()メソッドを実装する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ディペンデンシー グラフ ノードに compute()メソッドを実装する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ディペンデンシー-グラフ-ノードに-computeメソッドを実装する\"></a></div>\n\
<p>このトピックでは、カスタム ディペンデンシー ノード クラスに対して <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#a6e1aa1e50774080d5aee55f20ffa5503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#ae17c4b226f482e2d77c3f99375d1eea0&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode::compute()</a></span> 仮想メソッドを実装する場合に注意すべきいくつかの原理について紹介します。</p>\n\
<p>Maya は、ノードの出力アトリビュートまたはプラグの 1 つが古く、再計算が必要であると判断した場合、使用するノードの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#a6e1aa1e50774080d5aee55f20ffa5503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#ae17c4b226f482e2d77c3f99375d1eea0&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode::compute()</a></span> メソッドを呼び出します。再計算する必要のあるプラグ、および使用するノードの現在のインスタンスに対する入出力アトリビュートの現在の値を含むデータ ブロックが引数として渡されます。<span class=\'code\'>compute()</span> メソッドは、ノードの入力アトリビュートの現在の値に基づいて、要求したプラグの値を再計算し、計算した出力値をデータ ブロックに戻して保存することが求められます。</p>\n\
<div class=\'section\'><a id=\"パフォーマンスの問題\"></a><h2 id=\"パフォーマンスの問題\">パフォーマンスの問題</h2></div>\n\
<p>ノードを頻繁に再評価すると仮定します。できるだけ効率的に計算するように努力します。</p>\n\
<p>たとえば、ノードのレンダリング中、ピクセルごとに複数回評価する必要があるとします。計算をできるだけ高速に処理しないと、ディペンデンシー グラフが簡単にボトルネックとなる可能性があります。</p>\n\
<div class=\'section\'><a id=\"入力アトリビュートのみに依存\"></a><h2 id=\"入力アトリビュートのみに依存\">入力アトリビュートのみに依存</h2></div>\n\
<p>すべてのノードの <span class=\'code\'>compute()</span> メソッドは、パラメータ内に存在するデータ、すなわちそのアトリビュートの現在の値のみを使用して動作する必要があります。</p>\n\
<p>計算でその他のデータを使用する必要がある場合は、そのデータをアトリビュート内に作成します。一時的に情報をキャッシュ化して、計算を高速化するだけだとしても、ファイルの読み出し後の最初のリフレッシュを高速化する非表示アトリビュートとして役に立ちます。</p>\n\
<div class=\'section\'><a id=\"出力アトリビュートのみを変更する\"></a><h2 id=\"出力アトリビュートのみを変更する\">出力アトリビュートのみを変更する</h2></div>\n\
<p>ノードは、その出力アトリビュートとは関係のない値またはオブジェクトに影響を与えてはいけません。たとえば、ノードが、DAG またはその他のディペンデンシー グラフ ノードを直接変更してはいけません。変更すると、無限ループが発生する可能性があります。ディペンデンシー グラフの新しい評価がプロンプト表示されるため、ノードの再計算を迫られます。これにより、DAG またはディペンデンシー グラフを再度変更し、ディペンデンシー グラフ評価を新しくしなければならなくなります。何らかの理由でノードがまわりの状態に変更する必要がある場合は、アトリビュートとしてその知識をカプセル化し、計算されたデータを使用できる別のコンポーネントにアトリビュートを接続する必要があります。外部データに影響を与えると、ほとんどの場合以下のうちいずれかに反することになります。</p>\n\
<ul>\n\
<li>多重処理の使いやすさ</li>\n\
<li>別のコンテキストでの評価(たとえば、時間 T での評価)</li>\n\
<li>ノードのインスタンス化</li>\n\
<li>計算のベクトル化</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"要求したプラグを常に確認する\"></a><h2 id=\"要求したプラグを常に確認する\">要求したプラグを常に確認する</h2></div>\n\
<p>Maya がどのプラグの再計算を要求しているかを常に確認し、<span class=\'code\'>MS::kUnknownParameter</span> を返して認識されていないプラグをすべて処理します。</p>\n\
<p>たとえば、次のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">{\n\
    ...\n\
\n\
    if ( (plug == myOutputPlug) || (plug == myOtherOutputPlug) )\n\
    {\n\
         ... // compute and set the requested output values here.\n\
    }\n\
    else\n\
         return MS::kUnknownParameter;\n\
\n\
    return MS::kSuccess;\n\
}\n\
</pre></div><p>ノードによる出力アトリビュートの不必要な再計算を回避することができます。</p>\n\
<p>さらに、<span class=\'code\'>MS::kUnknownParameter</span> を返すと、Maya は、使用するクラスの派生元となるベース クラスの <span class=\'code\'>compute()</span> メソッドを呼び出します。再計算する必要のあるアトリビュートがベース クラスで初期化され、<span class=\'code\'>compute()</span> メソッドによって計算される場合、値はベース クラスによって自動的に更新されます。したがって、派生クラスに継承されたアトリビュートを処理する必要はありません。ただし、値を更新したり、派生クラスに固有のアトリビュートと同じように <span class=\'code\'>MS::kSuccess</span> を返すことで、ベース クラスが、実装内のアトリビュートのいずれかを処理する方法を <em>オーバーライド</em> できる場合があります。</p>\n\
<div class=\'section\'><a id=\"計算プラグを常にクリーンに設定する\"></a><h2 id=\"計算プラグを常にクリーンに設定する\">計算プラグを常にクリーンに設定する</h2></div>\n\
<p>ノードが、要求したプラグの新しい値を計算し、<span class=\'code\'>compute()</span> メソッドに渡されるデータ ブロック内にその値を保存する場合は、プラグを「clean」としてマークすることにより、プラグの値が新たに計算されたことを Maya に常に通知します。このマーク付けを行うには、</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">data.setClean(plug);\n\
</pre></div><p>を呼び出して、<span class=\'code\'>MS::kSuccess</span> を返します。</p>\n\
<p>プラグにクリーンのマークを付けないと、ノードがディペンデンシー グラフをリフレッシュするたびに、Maya はノードの再評価を複数回要求する場合があります。</p>\n\
<div class=\'section\'><a id=\"データへの参照を保存しない\"></a><h2 id=\"データへの参照を保存しない\">データへの参照を保存しない</h2></div>\n\
<p>ノードには、プラグの <span class=\'code\'>compute()</span> メソッドに渡されるいずれかのデータへの参照を保存しないでください。たとえばサーフェス ジオメトリがプラグで入ってきても、このジオメトリへのポインタを保存しないでください。プラグで入ってくるデータは一時的なもので、気付かないうちに消えることがあります。このデータは、ノードの <span class=\'code\'>compute()</span> メソッドの実行中に限って存在することが保証されています。</p>\n\
<div class=\'section\'><a id=\"必要に応じてエフェクトなしノード状態に返信\"></a><h2 id=\"必要に応じてエフェクトなしノード状態に返信\">必要に応じて、エフェクトなしノード状態に返信</h2></div>\n\
<p>ノードが特定の種類の入力アトリビュートを受け入れ、出力と同じ種類のデータを生成する場合、「エフェクトなし」または通過ノード状態をサポートしたいことがあります。通常、ノードをこの状態に設定すると、何も変更しなくても、入力アトリビュート値が出力アトリビュートに直接割り当てられます。これにより、Maya ユーザは、このディペンデンシー グラフ内の接続を切断することなく、ノードの計算を回避することができます。</p>\n\
<p>たとえば、次の <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"splitUVCmd/splitUVNode.cpp\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/split_u_v_cmd_2split_u_v_node_8cpp-example.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">splitUVCmd/splitUVNode.cpp</a></span> サンプルのスニペットは、状態アトリビュートの値を取得し、この値が、「HasNoEffect」の設定に対応する <span class=\'code\'>1</span> を示すかどうかを確認します。その場合は、入力アトリビュートが返されるだけです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUVNode::compute( const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; plug, <a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataBlock</a>&amp; data )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status = MS::kSuccess;\n\
     \n\
    <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> stateData = data.outputValue( state, &amp;status );\n\
    MCheckStatus( status, &quot;ERROR getting state&quot; );\n\
\n\
    if( stateData.asShort() == 1 )\n\
    {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> inputData = data.inputValue( inMesh, &amp;status );\n\
        MCheckStatus(status,&quot;ERROR getting inMesh&quot;);\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> outputData = data.outputValue( outMesh, &amp;status );\n\
        MCheckStatus(status,&quot;ERROR getting outMesh&quot;);\n\
        // Simply redirect the inMesh to the outMesh for the PassThrough effect\n\
        //\n\
        outputData.set(inputData.asMesh());\n\
    }\n\
    ...\n\
}\n\
</pre></div><p>ノードの状態とその値の詳細については、「<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/About-the-dependency-graph.html\' title=\'\'>ディペンデンシー グラフについて</a>」を参照してください。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";