var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Maya モジュールのパス、フォルダ、およびバージョン</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Maya モジュールのパス、フォルダ、およびバージョン</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maya-モジュールのパスフォルダおよびバージョン\"></a></div>\n\
<p>プラグイン モジュールを作成すれば、ネットワーク上の任意の場所またはローカルに保存できるプラグインの配布可能インストールを作成できるようになります。これにより、場所を管理するために Maya インストールやその他のハードにファイルを書き込む必要がなくなります。モジュール ファイルを使用することで、インストールされている数多くのプラグインの場所を別のスクリプト フォルダに変えるなど、モジュールの配布を簡単に変更できるようになります。</p>\n\
<p>Maya では、複数のバージョンのプラグインをインストールしたり、OS、Maya のバージョン、および言語設定に基づいて異なるバージョンをロードしたりすることができます。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> 拡張子に関係なく、すべてのモジュール ファイルが Maya によって読み取られます。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"モジュール-フォルダの構造\"></a><h2 id=\"モジュール-フォルダの構造\">モジュール フォルダの構造</h2></div>\n\
<p>モジュール ファイルでは、モジュールの場所を指定します。場所は、読み取られる <span class=\'code\'>.mod</span> ファイルの場所を基準としたパス、または絶対パスで指定できます。</p>\n\
<p>モジュール フォルダの構造を上書きするには、次の構文を使用します: <span class=\'code\'>&lt;folder to override&gt;: &lt;new location for this folder&gt;</span>。</p>\n\
<p>たとえば、モジュールのスクリプト フォルダの新しい場所を指定するには、次の行を追加します。</p>\n\
<p><span class=\'code\'>scripts: ../commonModuleFiles/scripts</span></p>\n\
<p>この方法は、モジュール間でスクリプト/アイコン/プリセット ファイルを共有する場合に役に立ちます。</p>\n\
<blockquote>\n\
<p><strong>重要:</strong> スクリプト フォルダのパスを指定する場合は、<span class=\'code\'>scripts:</span> の後にスペースを追加する必要があります(例: <span class=\'code\'>scripts: c:\\myScripts</span>)。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"例\"></a><h3 id=\"例\">例</h3></div>\n\
<p>モジュールおよびスクリプト ファイルの場所</p>\n\
<ul>\n\
<li><span class=\'code\'>C:\\CustomModule\\Modules\\win64</span></li>\n\
<li><span class=\'code\'>C:\\CustomModule\\Modules\\mac</span></li>\n\
<li><span class=\'code\'>C:\\CustomModule\\CommonFiles\\scripts</span></li>\n\
</ul>\n\
<p>.mod ファイルの場所</p>\n\
<ul>\n\
<li><span class=\'code\'>C:\\ModulesMOD\\CustomModule.mod</span></li>\n\
</ul>\n\
<p>モジュールの場所とスクリプトの新しい場所を記述した <span class=\'code\'>.mod</span> ファイルの例を次に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">+ PLATFORM:win64 CustomModule 3.10.5 ..\\CustomModule\\Modules\\win64\n\
scripts: ..\\..\\CommonFiles\\scripts\n\
</pre></div><p>最初の行では、.mod ファイルの場所(<span class=\'code\'>C:\\ModulesMOD\\CustomModule.mod</span>)を基準にしてモジュールの場所を指定する相対パスが使用されています。次の行では、モジュールの場所(<span class=\'code\'>..\\CustomModule\\Modules\\win64</span>)を基準にしてスクリプト フォルダの場所を指定する相対パスが使用されています。</p>\n\
<div class=\'section\'><a id=\"モジュール-フォルダのサブフォルダ\"></a><h2 id=\"モジュール-フォルダのサブフォルダ\">モジュール フォルダのサブフォルダ</h2></div>\n\
<p>既定では、Maya はモジュール内に含まれるすべてのサブフォルダを無視します。Maya がモジュールのサブフォルダを無視しないようにするには、<span class=\'code\'>[r]</span> キーワードを使用してそのフォルダの再帰的動作を要求する必要があります。次のように指定します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">[r] scripts: ..\\..\\CommonFiles\\scripts\n\
</pre></div><p>.フォルダ(すなわちドットで始まるフォルダ、別名隠しフォルダ)は、[r] キーワードが設定されていても無視されます。このフォルダは再帰的にパースされることはなく、検索パスとして Maya に追加されることもありません。</p>\n\
<div class=\'section\'><a id=\"モジュールのロードのための条件を指定する\"></a><h2 id=\"モジュールのロードのための条件を指定する\">モジュールのロードのための条件を指定する</h2></div>\n\
<p>モジュールをロードする条件を指定できます。条件はモジュール説明行に追加する必要があります。</p>\n\
<p><span class=\'code\'>MAYAVERSION</span>、<span class=\'code\'>PLATFORM</span>、および <span class=\'code\'>LOCALE</span> の 3 つの条件を指定できます。</p>\n\
<table class=\'ruled\'>\n\
<tr class=\"header\">\n\
<th align=\"left\">条件</th>\n\
<th align=\"left\">説明</th>\n\
<th align=\"left\">サポートされる値</th>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\"><span class=\'code\'>MAYAVERSION</span></td>\n\
<td align=\"left\">Maya のベース バージョンを指定します。この条件を省略すると、この行の内容が Maya のすべてのバージョンに適用されます。</td>\n\
<td align=\"left\">Maya の任意のベース バージョン(2020 や 2019など)を指定できます。</td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\"><span class=\'code\'>PLATFORM</span></td>\n\
<td align=\"left\">アーキテクチャを指定します。この条件を省略すると、この行の内容がすべてのシステム アーキテクチャに適用されます。</td>\n\
<td align=\"left\"><span class=\'code\'>win64</span>、<span class=\'code\'>mac</span>、または <span class=\'code\'>linux</span></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\"><span class=\'code\'>LOCALE</span></td>\n\
<td align=\"left\">システム ロケールを指定します。この条件を省略すると、この行の内容がすべてのロケールに適用されます。</td>\n\
<td align=\"left\"><span class=\'code\'>en_US</span> (英語)、<span class=\'code\'>ja_JP</span> (日本語)、または <span class=\'code\'>zh_CN</span> (簡体字中国語)</td>\n\
</tr>\n\
</table>\n\
<div class=\'section\'><a id=\"例-1\"></a><h3 id=\"例-1\">例</h3></div>\n\
<p><span class=\'code\'>+ MAYAVERSION:2019 PLATFORM:win64 LOCALE:ja_JP CustomModule 3.10.5 ..\\CustomModule\\Modules\\win64</span></p>\n\
<p>この例では、システム ロケールが日本語に設定されているWindows 上の Maya 2019 にのみ、CustomModule プラグインがロードされます。</p>\n\
<div class=\'section\'><a id=\"環境変数\"></a><h2 id=\"環境変数\">環境変数</h2></div>\n\
<p>カスタム環境変数を設定するには、次の構文を使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">MYVAR=MYVALUE\n\
</pre></div><p>モジュールの場所を基準とした値を使用して環境変数を指定することもできます。その場合は <span class=\'code\'>:=</span> 構文を使用します。</p>\n\
<div class=\'section\'><a id=\"例-2\"></a><h3 id=\"例-2\">例</h3></div>\n\
<p>前述の例で、PYTHONPATH を <span class=\'code\'>C:\\CustomModule\\Modules\\win64\\python</span> に設定する必要がある場合は、次のように設定するだけです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">PYTHONPATH:=python\n\
</pre></div><div class=\'section\'><a id=\"変数の現在値にアペンドする\"></a><h3 id=\"変数の現在値にアペンドする\">変数の現在値にアペンドする</h3></div>\n\
<p>変数の現在値にアペンドするには、+ または : 演算子を使用します。次に例を示します。</p>\n\
<p><span class=\'code\'>PATH += c:/myModule/bin</span> と設定すると、環境変数 PATH の現在値に <span class=\'code\'>;c:/myModule/bin</span> が追加されます。</p>\n\
<p><span class=\'code\'>PATH +:= bin</span> と設定すると、環境変数 PATH の現在値に <span class=\'code\'>;’module location’/bin</span> が追加されます。</p>\n\
<div class=\'section\'><a id=\"モジュール-パスを取得する\"></a><h2 id=\"モジュール-パスを取得する\">モジュール パスを取得する</h2></div>\n\
<p>モジュール パスを照会するには、次のように MEL コマンド <span class=\'code\'>getModulePath</span> を使用します。</p>\n\
<p><span class=\'code\'>getModulePath –moduleName “MyModule”</span></p>\n\
<p>この照会によって次の値が返されます。<span class=\'code\'>c:\\MyModule</span></p>\n\
<div class=\'section\'><a id=\"既知の制限事項\"></a><h2 id=\"既知の制限事項\">既知の制限事項</h2></div>\n\
<p>次のフォルダ タイプは、リーガル モジュール リソース パスとしてサポートされていません。モジュール システムでは、名前に次の拡張子が付いたフォルダは無視されます。</p>\n\
<ul>\n\
<li><span class=\'code\'>.so</span></li>\n\
<li><span class=\'code\'>.mll</span></li>\n\
<li><span class=\'code\'>.bundle</span></li>\n\
<li><span class=\'code\'>.py</span></li>\n\
<li><span class=\'code\'>.dll</span></li>\n\
<li><span class=\'code\'>.framework</span></li>\n\
<li><span class=\'code\'>.plugin</span></li>\n\
<li><span class=\'code\'>.plist</span></li>\n\
<li><span class=\'code\'>.app</span></li>\n\
<li><span class=\'code\'>.pkg</span></li>\n\
<li><span class=\'code\'>.rtfd</span></li>\n\
<li><span class=\'code\'>.download</span></li>\n\
<li><span class=\'code\'>.sparsebundle</span></li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";