var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>非推奨 API 呼び出しを処理する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>非推奨 API 呼び出しを処理する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"非推奨-api-呼び出しを処理する\"></a></div>\n\
<p>非推奨 API 呼び出しを使用すると、次のような警告がコンパイラによって生成されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">warning C4996: &#39;<a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::validateAndSetValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#ace2cd11d9d4eade0bcb57a2e341faedb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform::validateAndSetValue</a>&#39;: Override validateAndSetValue(const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp;, const <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a>&amp;) instead.  If needed, useMDGContext::current() to get the context.\n\
</pre></div><p>コンパイラで <span class=\'code\'>treat warning as error</span> (警告をエラーとして扱う)が有効になっていて、移行中に関連するビルド エラーが発生した場合は、非推奨の警告を無効にすることができます。</p>\n\
<p>非推奨の警告を無視するには、<span class=\'code\'>_OPENMAYA_DEPRECATION_DISABLE_WARNING</span> プリプロセッサ マクロを定義するか、次のコンパイラ スイッチを使用します。</p>\n\
<table class=\'ruled\'>\n\
<tr class=\"odd\">\n\
<td align=\"left\">MSVC</td>\n\
<td align=\"left\">/Wd&quot;4996&quot;</td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">ICC</td>\n\
<td align=\"left\">-diag-disable 1786</td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Clang</td>\n\
<td align=\"left\">-Wno-error=deprecated-declarations</td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">GCC</td>\n\
<td align=\"left\">-Wno-error=deprecated-declarations</td>\n\
</tr>\n\
</table>\n\
<p>非推奨をエラーとして処理するには、<span class=\'code\'>_OPENMAYA_DEPRECATION_ERROR_ALL</span> プリプロセッサ マクロを定義するか、次のコンパイラ スイッチを使用します。</p>\n\
<table class=\'ruled\'>\n\
<tr class=\"odd\">\n\
<td align=\"left\">MSVC</td>\n\
<td align=\"left\">/We&quot;4996&quot; (/D_CRT_NONSTDC_NO_DEPRECATE)</td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">ICC</td>\n\
<td align=\"left\">-diag-error 1786</td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Clang</td>\n\
<td align=\"left\">-Werror=deprecated-declarations</td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">GCC</td>\n\
<td align=\"left\">Werror=deprecated-declarations</td>\n\
</tr>\n\
</table>\n\
<div class=\'section\'><a id=\"廃止されたメソッドの下位互換性\"></a><h2 id=\"廃止されたメソッドの下位互換性\">廃止されたメソッドの下位互換性</h2></div>\n\
<p>非推奨のメソッドは、3 つの主要なリリース内で API から削除される可能性があります。そのため、非推奨のメソッドはプラグインからできるだけ早く削除する必要があります。</p>\n\
<p>ただし、変更の範囲が大きすぎてすべてを一度に処理できない場合、またはサードパーティ製ソフトウェアを使用している場合は、コードに非推奨 API 呼び出しが残っている可能性があります。</p>\n\
<p>非推奨 API 呼び出しはオーバーライドすることができます。ただし、非推奨 API と新しい API の両方を同じ階層または同じクラスでオーバーライドすることはできません。</p>\n\
<p>次の例は、新しい API および非推奨 API をオーバーライドする方法を示します。サンプルでは、<span class=\'code\'>getMatrix()</span> メソッドを使用します。<span class=\'code\'>MMatrix::getMatrix(const <a href=\"javascript:void(0)\" data-symbol=\"MDGContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContext</a>&amp;)</span> は Maya 2018 で廃止され、<span class=\'code\'>MMatrix::getMatrix()</span> に置き換えられました。</p>\n\
<p>新しい API をオーバーライドするには:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">class UserTransform : public <a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a> {\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMatrix</a> getMatrix() override;\n\
};\n\
</pre></div><p>非推奨 API をオーバーライドするには:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">class UserTransform: public <a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a> {\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMatrix</a> getMatrix(const <a href=\"javascript:void(0)\" data-symbol=\"MDGContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContext</a>&amp;) override; // deprecated\n\
};\n\
</pre></div><div class=\'section\'><a id=\"避けるべき一般的な間違い\"></a><h2 id=\"避けるべき一般的な間違い\">避けるべき一般的な間違い</h2></div>\n\
<p>新しい API と非推奨 API を使用する場合は、同じクラスまたは継承階層内で新しい API と非推奨 API の両方をオーバーライドしないでください。また、新しい API のオーバーライドから非推奨 API を呼び出さないでください(その反対も同様)。</p>\n\
<p>次の例では、これらの一般的な間違いを示します。サンプルでは、<span class=\'code\'>getMatrix()</span> メソッドを使用します。<span class=\'code\'>MMatrix::getMatrix(const <a href=\"javascript:void(0)\" data-symbol=\"MDGContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContext</a>&amp;)</span> は Maya 2018 で廃止され、<span class=\'code\'>MMatrix::getMatrix()</span> に置き換えられました。</p>\n\
<p>同じクラス内で新しい API と非推奨 API をオーバーライドしないでください。たとえば、次の操作は行わないでください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">class UserTransform: public <a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a> {\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMatrix</a> getMatrix() override; // new\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMatrix</a> getMatrix(const <a href=\"javascript:void(0)\" data-symbol=\"MDGContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContext</a>&amp;) override; // deprecated\n\
}; // Error, override both API in one class\n\
</pre></div><p>同じ継承階層内で新しい API と非推奨 API の両方をオーバーライドしないでください。</p>\n\
<p>たとえば、次の操作は行わないでください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">class UserTransformBase: public <a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a> {\n\
   <a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMatrix</a> getMatrix(const <a href=\"javascript:void(0)\" data-symbol=\"MDGContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContext</a>&amp;) override; // deprecated\n\
}; // Ok\n\
\n\
class UserTransformDerived: public UserTransformBase {  \n\
    <a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMatrix</a> getMatrix() override; // new\n\
}; // Error, override both API in one inheritance hierarchy\n\
</pre></div><p>新しい API のオーバーライドから非推奨 API を呼び出さないでください(または非推奨 API のオーバーライドから新しい API を呼び出さないでください)。</p>\n\
<p>たとえば、次の操作は行わないでください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">class UserTransform: public <a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a> {\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMatrix</a> getMatrix() override {\n\
        return <a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::getMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#af6e52bdebc5f622b643dfdf60d9e15fb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform::getMatrix</a>(<a href=\"javascript:void(0)\" data-symbol=\"MDGContext::current\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context.html#a11a98edcfc027fb57d3a66fcfbc580a8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContext::current</a>()); // Error, calling deprecated API from new API overridden\n\
    }\n\
};\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";