var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>エラー チェック</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>エラー チェック</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"エラー-チェック\"></a></div>\n\
<p>これまでのサンプルでは、エラー チェックについてあまり触れませんでした。サンプルならこれで構いませんが、実際のプラグインを作成する場合は、エラーをチェックする必要があります。</p>\n\
<p>ほとんどのメソッドは、オプションの最終引数を取ります。この引数は、ステータスの戻り値が保存されている <a href=\'#!/url=./dev_help/Maya-API-introduction/MStatus-class.html\' title=\'\'><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a></span></a> 変数のポインタです。</p>\n\
<p>らせんのサンプルで引数解析コードを以下のコードと置き換えると、ほとんどのエラーのチェックと処理が行われるようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">// Parse the arguments.\n\
for ( i = 0; i &lt; args.length(); i++ )\n\
    if ( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>( &quot;-p&quot; ) == args.asString( i, &amp;stat )\n\
        &amp;&amp; MS::kSuccess == stat )\n\
    {\n\
        double tmp = args.asDouble( ++i, &amp;stat );\n\
        // argument can be retrieved as a double\n\
        if ( MS::kSuccess == stat )\n\
            pitch = tmp;\n\
    }\n\
    else if ( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>( &quot;-r&quot; ) == args.asString( i, &amp;stat )\n\
        &amp;&amp; MS::kSuccess == stat )\n\
    {\n\
        double tmp = args.asDouble( ++i, &amp;stat );\n\
        // argument can be retrieved as a double\n\
        if ( MS::kSuccess == stat )\n\
            radius = tmp;\n\
    }\n\
\n\
</pre></div><p><span class=\'code\'>&amp;stat</span> を asString() メソッドと asDouble() メソッドに追加すると、キャスト操作が成功したかどうかをチェックできます。</p>\n\
<p>たとえばインデックスが引数の数より大きい場合、<span class=\'code\'>args.asString(i, &amp;stat)</span> は <span class=\'code\'>MS::kFailure</span> を返すことがあります。</p>\n\
<p>または</p>\n\
<p>引数を double に変換できない場合、<span class=\'code\'>args.asDouble(++i, &amp;stat)</span> はエラーになることがあります。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";