var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>.NET を使用した Hello World コマンド プラグインの作成</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>.NET を使用した Hello World コマンド プラグインの作成</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"net-を使用した-hello-world-コマンド-プラグインの作成\"></a></div>\n\
<p>次に、必要最小限のカスタム .NET コマンドの例を示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">using System;\n\
\n\
using Autodesk.Maya.Runtime;\n\
using Autodesk.Maya.OpenMaya;\n\
\n\
[assembly: MPxCommandClass(typeof(MayaNetPlugin.helloWorldCmd), &quot;helloWorldCmd&quot;)]\n\
[assembly: ExtensionPlugin(typeof(MayaNetPlugin.helloWorldPlugin), &quot;Autodesk&quot;, &quot;1.0&quot;, &quot;Any&quot;)]\n\
\n\
namespace MayaNetPlugin\n\
{\n\
    public class helloWorldPlugin : IExtensionPlugin\n\
    {\n\
        bool IExtensionPlugin.InitializePlugin()\n\
        {\n\
            return true;\n\
        }\n\
\n\
        bool IExtensionPlugin.UninitializePlugin()\n\
        {\n\
            return true;\n\
        }\n\
        String IExtensionPlugin.GetMayaDotNetSdkBuildVersion()\n\
        {\n\
            String version = &quot;&quot;;\n\
            return version;\n\
        }\n\
\n\
    }\n\
\n\
    public class helloWorldCmd : <a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a>,IMPxCommand\n\
    {\n\
        public override void doIt(<a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a> argl)\n\
        {\n\
            MGlobal.displayInfo(&quot;Hello World\\n&quot;);\n\
        }\n\
    }\n\
}\n\
</pre></div><p>この単純な例では、Maya 出力(Output)ウィンドウに文字列を出力する helloWorld Maya コマンドを C# で作成する方法を例示します。</p>\n\
<p>2 つの <em>using Autodesk.Maya…</em> ディレクティブは、.NET SDK のネームスペースを追加します。このようにすると、これらのネームスペースの型を修飾なしで使用できます。ディレクティブを使用しない場合は、、<span class=\'code\'>Autodesk.Maya.OpenMaya.MPxCommand</span> のように、ファイル内で型の完全な名前を記述する必要があります。</p>\n\
<p>このプラグインは、2 つの論理的な部分で構成されます。<span class=\'code\'>IExtensionPlugin</span> インタフェースの実装と、コマンド自体です。</p>\n\
<p><span class=\'code\'>ExtensionPlugin</span> アセンブリ アトリビュートは、<span class=\'code\'>IExtensionPlugin</span> の実装を指します。</p>\n\
<p><span class=\'code\'>IExtensionPlugin.InitializePlugin()</span> を実装するとき、初期化を続行できる場合は true を返します。プラグインをロードできない場合は、false が返されて、Maya はロード処理を中止します。<span class=\'code\'>IExtensionPlugin.UninitializePlugin()</span> についても同じです。</p>\n\
<p><span class=\'code\'>IExtensionPlugin.GetMayaDotNetSdkBuildVersion()</span> を実装するときは、プラグインのビルドに使用している API のバージョン番号を返すか、または空の文字列を返すことができます。</p>\n\
<p><span class=\'code\'>MPxCommandClass</span> アセンブリのアトリビュートは、プラグインのタイプを .NET SDK に対して示します。<span class=\'code\'>MPxCommandClass</span> アトリビュートは、ユーザ定義コマンドを実装しているクラスの型とコマンドの名前をパラメータとして受け取る必要があります。クラスの型を指定するには、<span class=\'code\'>typeof</span> 演算子を使用します。アトリビュートは<em>MayaNetPlugin</em> ネームスペースの外部にあるので、<span class=\'code\'>typeof</span> 演算子にはネームスペースを含むクラスのフル パスを指定する必要があります。</p>\n\
<p><em>namespace MayaNetPlugin</em>: すべての型は、ネームスペース内で宣言されている必要があります。C# のネームスペースは、クラス、構造体、インタフェース、列挙を含むことができます。ネームスペースは、コードを整理したり、名前の衝突を防ぐのに役立ちます。</p>\n\
<p><em>public class helloWorldCmd : MPxCommand, IMPxCommand</em>: helloWorldCmd クラスは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> クラスから派生し、<span class=\'code\'>IMPxCommand</span> インタフェースを実装します。複数のインタフェースを使用できますが、1 つのクラスからのみ派生できます。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> はユーザ コマンドの基本クラスであり、すべてのコマンドはこのクラスから派生します。</p>\n\
<p><em>public override void doIt(MArgList argl)</em>: コマンドのアクションを実行するには、doIt() を使用します。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";