var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>.NET API のスタートアップ</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>.NET API のスタートアップ</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"net-api-のスタートアップ\"></a></div>\n\
<blockquote>\n\
<p><strong>重要</strong>: .NET API は Visual Studio 2015 でのみサポートされています。</p>\n\
</blockquote>\n\
<p>Maya .NET API は、プラグインの作成を可能にするシステムであり、Microsoft の .NET テクノロジを使用する Maya の拡張機能です。次の機能が含まれています。</p>\n\
<ul>\n\
<li>.NET アセンブリからプラグインのコードをロードするシステム</li>\n\
<li>プラグイン作成者が .NET 言語から Maya SDK にアクセスするためにインポートできる .NET アセンブリ</li>\n\
<li>Maya の QT システムに WPF/XAML ウィンドウを埋め込むためのサービス</li>\n\
<li>システムの使用法を例示するために C# で記述された例</li>\n\
</ul>\n\
<p>Maya .NET API は Maya Python API と同様に、Maya C++ API から生成されます。.NET API のほとんどのクラスには、同じ名前で似たインタフェース(つまり、関数とクラスのセット)を持つ対応するクラスが C++ API にあります。</p>\n\
<p>C# クラスは C++ クラスのプロキシです。</p>\n\
<p>システムには次のような利点があります。</p>\n\
<ul>\n\
<li>C# や .NET SDK などの最新のツールを使用して、プラグインの開発を加速できます。Maya SDK は、.NET プログラマ向けに慣用的なスタイルで提供されます。</li>\n\
<li>開発者は既存のカスタム パイプライン ツールと Maya をよりよく統合でき、アーティストはコンテンツ作成環境内の重要な制作ツールにアクセスできます。</li>\n\
<li>Maya プラグインでアセンブリを参照することにより、.NET コードおよび WPF/XAML ユーザ インタフェースへの既存の投資を再利用できます。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"要件\"></a><h2 id=\"要件\">要件</h2></div>\n\
<p>Extension 2 for Maya 2013 時点では、.NET SDK は Maya とともにインストールされます。.NET バインディングは他のバージョンの Maya(Maya 2013 など)では動作しません。</p>\n\
<p>Maya .NET API は .NET 4.5 Frameworkを使用しており､.NET 4.0 Framework と互換性があります。</p>\n\
<p>このサンプルのコンパイルには .NET Framework 4.5 と Microsoft Visual Studio 2012 を使用することをお勧めします。ですが、.NET Framework 4.0 および Visual Studio 2010 を使用してソリューションを作成し、サンプルをコンパイルすることもできます。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> この章では、パス プリフィックス &lt;...&gt; は Maya インストール フォルダを表します。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"net-sdk-のファイル\"></a><h2 id=\"net-sdk-のファイル\">.NET SDK のファイル</h2></div>\n\
<p>Maya の .NET SDK には、次のファイルが含まれます。</p>\n\
<ul>\n\
<li><span class=\'code\'>&lt;...&gt;\\bin</span> フォルダ:</li>\n\
<li><span class=\'code\'>openmayacs.dll</span> / <span class=\'code\'>swigfiles.dll</span>: .NET SDK クラス ライブラリ</li>\n\
<li><span class=\'code\'>openmayacs.xml</span>: Visual Studio XML のドキュメンテーション</li>\n\
<li><p>Developer Kit インストールの <span class=\'code\'>devkit\\dotnet</span> フォルダ:</p></li>\n\
<li><p>C# サンプル ファイル。提供されているソリューション <span class=\'code\'>examples.sln</span> および <span class=\'code\'>wpfexamples.sln</span> でコンパイルします。</p></li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>注:</strong> Developer Kit は、<a href=\'https://www.autodesk.com/developmaya-jpn\' title=\'\' target=\'_blank\'>オートデスク デベロッパー ネットワーク</a>から入手できます。詳細については、「<a href=\'#!/url=./dev_help/Setting-up-your-build/Windows-environment-64-bit-.html\' title=\'\'>ビルド環境を設定する: Windows 環境(64 ビット)</a>」を参照してください。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"visual-studio-の統合マニュアル\"></a><h2 id=\"visual-studio-の統合マニュアル\">Visual Studio の統合マニュアル</h2></div>\n\
<p>Maya API C++ リファレンス マニュアルの使用に加え、Maya .NET API には、C++ リファレンス マニュアルから生成された Visual Studio の統合マニュアルが含まれます。これは次のものを有効にします。</p>\n\
<ul>\n\
<li>ツールチップ</li>\n\
<li>**定義に移動(F12)を使用するときに自動生成されるコード ファイル内のコメント</li>\n\
<li>オブジェクト ブラウザのヘルプ</li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>注:</strong> また、この .NET リファレンス ドキュメントの <span class=\'code\'>.chm</span> バージョンを、<a href=\'http://www.autodesk.com/me-sdk-docs\' title=\'\' target=\'_blank\'>http://www.autodesk.com/me-sdk-docs</a> から入手することができます。</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";