var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>メタ データ</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>メタ データ</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"メタ-データ\"></a></div>\n\
<p>C++ API の<strong>メタ データ</strong> クラスは、その他すべての Maya API クラスと同様に .NET API に移植されています。さらに、.NET のパワーを活用するため、いくつかの機能強化が行われています。</p>\n\
<p>メタデータは、Maya API の非常に重要な部分であり、クライアントがカスタム データ(ストラクチャ、タイプ、要素ごとのデータにアクセスする方法など)を記述できるようになります。.NET 機能では、C++ の場合よりも処理を大幅に単純化し、強力にすることができます。</p>\n\
<div class=\'section\'><a id=\"net-の例\"></a><h2 id=\"net-の例\">.NET の例</h2></div>\n\
<p>このページに記載した .NET 拡張機能を紹介する興味深い複数の例は、Maya に付属している例にも含まれています(「<a href=\'#!/url=./dev_help/Maya-NET-API/Compiling-examples.html\' title=\'\'>コンパイルの例</a>」を参照)。Microsoft Visual Studio を使用して <span class=\'code\'>examples.sln</span> ソリューション(Developer Kit をインストールした <span class=\'code\'>devkit\\dotnet\\examples</span> フォルダ内、「<a href=\'#!/url=./dev_help/Setting-up-your-build/Windows-environment-64-bit-.html\' title=\'\'>ビルド環境を設定する: Windows 環境(64 ビット)</a>」を参照)を開くと、これらのサンプルを <span class=\'code\'>MetaData</span> フォルダ内で見つけることができます。いくつかの興味深い例を次に示します。</p>\n\
<ul>\n\
<li><span class=\'code\'>CreateMetadataFromTypeCmd.cs</span> (<span class=\'code\'>CreateMetadataXMLCmd.mel</span> を使用してテスト)</li>\n\
</ul>\n\
<p>この例では、新しい <span class=\'code\'>StructureClass</span> アセンブリ アトリビュートと .NET タイプ用の特殊なクラス <span class=\'code\'>StreamForType&lt;T&gt;</span> (つまり、例の MyStructureClass)の使用方法を示します。</p>\n\
<p>これにより、すべてが汎用クラス <span class=\'code\'>StreamForType&lt;T&gt;</span> によって自動的に実行されるため、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Structure</a></span> クラスおよび <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a></span> クラスが不要になります。</p>\n\
<p>この例はまた、LINQ を使用して任意のコレクションでクエリを実行する方法も示します(例では、ストリームの要素を照会します)。</p>\n\
<ul>\n\
<li><span class=\'code\'>WriteMetadataToConsoleCmd.cs</span> (<span class=\'code\'>MetaData</span> フォルダ内のすべての MEL スクリプトでテスト)</li>\n\
</ul>\n\
<p>この例では、Associations、Channel、Stream、および Structure クラスで .NET インタフェース <span class=\'code\'>IEnumerable</span> がサポートされるおかげで、<span class=\'code\'>foreach</span> 構文を使用した場合に列挙チャネル、ストリーム、ストラクチャ メンバーおよびストリーム ハンドルをどれだけシンプルにできるかを示します。</p>\n\
<div class=\'section\'><a id=\"概要\"></a><h2 id=\"概要\">概要</h2></div>\n\
<p>メタデータ API の主なクラスのリストとそれぞれの簡単な概要を、.NET に移植された C++ メソッドのリストとともに次に示します。</p>\n\
<div class=\'section\'><a id=\"associations\"></a><h3 id=\"associations\">Associations</h3></div>\n\
<p>これは、<span class=\'code\'>MFnDependencyNode.metadata</span> プロパティを取得することなどによって Maya オブジェクトからメタ データにアクセスするためのエントリ ポイントです。</p>\n\
<p>基本的に、チャネルの単純なコンテナです。</p>\n\
<p>C++ から移植された興味深いメソッドをいくつか示します。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Channel</a> findChannel(string)</span> は、名前が指定されたチャネルを検索します。</li>\n\
<li><span class=\'code\'>void setChannel(<a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Channel</a>)</span> は、チャネルを追加するか、同じ名前を持つ既存のチャネルを置き換えます。</li>\n\
<li><span class=\'code\'>bool removeChannel(string)</span> は、名前が指定されたチャネルを除去します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"AssociationsIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_associations_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">AssociationsIterator</a> begin()</span> は、C++/STL 形式のイテレータを返し、チャネルを反復します。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"channel\"></a><h3 id=\"channel\">Channel</h3></div>\n\
<p>これは、同じトポロジ(同じストリーム インデックス)を共有しているか、ユーザーが論理的に同じグループになるように決定したため(シミュレーション エフェクトのすべてのストリームが同じチャネルになり、エフェクトの名前であるチャネル名が付けられる場合など)にグループ化されたストリームのコレクションです。</p>\n\
<p>チャネルに名前を付けることができますが、いくつかの名前は予約されています(たとえば、<span class=\'code\'>vertex</span> はストリームが頂点ごとに 1 つの要素を持つことを示すために予約されています)。</p>\n\
<p>C++ から移植された興味深いメソッドをいくつか示します。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a> findDataStream(string)</span> は、名前が指定されたストリームを検索します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a> setDataStream(<a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a>)</span> はストリームを追加します。</li>\n\
<li><span class=\'code\'>void removeDataStream(string)</span> は、名前が指定されたストリームを除去します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"ChannelIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ChannelIterator</a> begin()</span> は、C++/STL 形式のイテレータを返し、ストリームを反復します。</li>\n\
<li><span class=\'code\'>bool removeElement(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Index</a> elementIndex)</span> は、チャネルで検出されたすべてのストリームから指定された要素を除去します。</li>\n\
<li><span class=\'code\'>bool addElement(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Index</a> elementIndex)</span> は、チャネルで検出されたすべてのストリームに指定された要素を追加します。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"stream\"></a><h3 id=\"stream\">Stream</h3></div>\n\
<p>これは、オブジェクト上のデータのコンテナです(たとえば、メッシュ上のチャネル <span class=\'code\'>vertex</span> では、ストリームにある頂点と同じ数のデータ要素があります)。</p>\n\
<p>C++ から移植された興味深いメソッドをいくつか示します。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a>(<a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Structure</a>, string)</span> は、指定されたストラクチャを使用して指定された名前の <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a></span> オブジェクトを作成します。</li>\n\
<li><span class=\'code\'>bool setElement(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Index</a>, <a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a>)</span> は、指定されたインデックスにあるデータを別のデータに置き換えます。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a> element(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Index</a>)</span> は、指定されたインデックスにあるデータのハンドルを取得します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"StreamIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">StreamIterator</a> begin()</span> は、C++/STL 形式のイテレータを返し、ハンドルを反復します。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"structure\"></a><h3 id=\"structure\">Structure</h3></div>\n\
<p>このクラスは、ストリームの各要素で検出されたメタ データについて記述します。</p>\n\
<p>このメソッド <span class=\'code\'>AddMember</span> は、メタ データの各フィールドを定義するために使用されます。</p>\n\
<p>たとえば、1 つの float と 1 つのブール値をすべての要素に格納する場合は、最初にストラクチャを作成し、<span class=\'code\'>AddMember(kFloat,1,”MyFloatField”)</span> と <span class=\'code\'>AddMember(kBoolean,1,”MyBooleanField”)</span> を呼び出します。</p>\n\
<p>C++ から移植された興味深いメソッドをいくつか示します。</p>\n\
<ul>\n\
<li><span class=\'code\'>bool addMember( Member.eDataType, uint arraySize, string memberName )</span> は、指定されたタイプ、サイズ(一般的には 1)、および名前のメンバーをストラクチャに追加します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"StructureIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">StructureIterator</a> begin()</span> は、C++/STL 形式のイテレータを返し、メンバーを反復します。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"ハンドル\"></a><h3 id=\"ハンドル\">ハンドル</h3></div>\n\
<p>このクラスを使用すると、ストリームの指定された要素のデータにアクセスすることができます。</p>\n\
<p>ハンドルを使用すると、ストリーム要素のデータを取得または設定することができます。</p>\n\
<p>C++ から移植された興味深いメソッドをいくつか示します。</p>\n\
<ul>\n\
<li><span class=\'code\'>bool setPositionByMemberIndex(uint)</span> は、このハンドルが関連付けられているストラクチャのメンバーを示します。</li>\n\
<li><span class=\'code\'>int[] asInt32Array</span> は、(整数が 1 つのみの場合でも)整数データを整数の配列として取得または設定します。</li>\n\
<li><span class=\'code\'>float[] asFloatArray</span> は、(float が 1 つのみの場合でも) float データを float の配列として取得または設定します。</li>\n\
<li>など...</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"net-を利用する\"></a><h2 id=\"net-を利用する\">.NET を利用する</h2></div>\n\
<p>.NET では、メタデータ API にいくつかの拡張機能が提供されます。ここでは、.NET の拡張機能がある API の主なクラスを示します。</p>\n\
<div class=\'section\'><a id=\"associations-1\"></a><h3 id=\"associations-1\">Associations</h3></div>\n\
<p>このクラスは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Channel</a></span> オブジェクトのディクショナリとして機能するため、.NET インタフェース <span class=\'code\'>IDictionary&lt;<a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Channel</a>&gt;</span> をサポートします。</p>\n\
<p>このインタフェースを使用すると、.NET のディクショナリから予測される次の標準のメソッド/プロパティを使用することができます。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Channel</a> channel;    if( myAssociations.TryGetValue( “vertex”, out channel ) { ... }</span></li>\n\
</ul>\n\
<p>このメソッドを使用すると名前が指定されたチャネルを検索することができ、同時にその有無がテストされます。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Channel</a> channel =  myAssociations[“vertex”];</span></li>\n\
</ul>\n\
<p>このインデクサも名前が指定されたチャネルを検索しますが、この場合、チャネルは見つかる必要があります(見つからない場合は、<span class=\'code\'>KeyNotFoundException</span> をスローします)。</p>\n\
<ul>\n\
<li><span class=\'code\'>if(myAssociations.ContainsKey( “vertex” ) { ... }</span></li>\n\
</ul>\n\
<p>これは単に、指定された名前のチャネルが存在しているかどうかをテストします。チャネルは返されません。</p>\n\
<ul>\n\
<li><span class=\'code\'>myAssociations.Add( “vertex”, myChannel );</span></li>\n\
</ul>\n\
<p>これはチャネルを追加します。または同じ名前のチャネルが既に存在している場合は <span class=\'code\'>ArgumentException</span> をスローします。</p>\n\
<ul>\n\
<li><span class=\'code\'>foreach( <a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Channel</a> chnl in myAssociations )  { ... }</span></li>\n\
</ul>\n\
<p>これを使用すると、複雑な C++/STL 構文の代わりに非常に単純な構文を使用してすべてのチャネルを列挙することができます。</p>\n\
<p><span class=\'code\'>for( <a href=\"javascript:void(0)\" data-symbol=\"AssociationsIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_associations_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">AssociationsIterator</a> iter = myAssociations.begin(); iter.notEqual( myAssociations.end() ); iter.next() ) {         <a href=\"javascript:void(0)\" data-symbol=\"Channel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Channel</a> chnl = iter.__deref__();        ...     }</span></p>\n\
<div class=\'section\'><a id=\"channel-1\"></a><h3 id=\"channel-1\">Channel</h3></div>\n\
<p>このクラスは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a></span> オブジェクトのディクショナリとして機能するため、.NET インタフェース <span class=\'code\'>IDictionary&lt;<a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a>&gt;</span> をサポートします。</p>\n\
<p>このインタフェースを使用すると、.NET のディクショナリから予測される次の標準のメソッド/プロパティを使用することができます。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a> stream;     if( myChannel.TryGetValue( “myStream”, out stream ) { ... }</span></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"このメソッドを使用すると名前が指定されたストリームを検索することができ同時にその有無がテストされます\"></a><h2 id=\"このメソッドを使用すると名前が指定されたストリームを検索することができ同時にその有無がテストされます\">このメソッドを使用すると名前が指定されたストリームを検索することができ、同時にその有無がテストされます。</h2></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a> stream =  myChannel[“myStream”];</span></p>\n\
<div class=\'section\'><a id=\"このインデクサも名前が指定されたストリームを検索しますがこの場合ストリームは見つかる必要があります見つからない場合はkeynotfoundexception-をスローします\"></a><h2 id=\"このインデクサも名前が指定されたストリームを検索しますがこの場合ストリームは見つかる必要があります見つからない場合はkeynotfoundexception-をスローします\">このインデクサも名前が指定されたストリームを検索しますが、この場合、ストリームは見つかる必要があります(見つからない場合は、<span class=\'code\'>KeyNotFoundException</span> をスローします)。</h2></div>\n\
<p><span class=\'code\'>if( myChannel.ContainsKey( “myStream” ) { ... }</span></p>\n\
<div class=\'section\'><a id=\"これは単に指定された名前のストリームが存在しているかどうかをテストしますストリームは返されません\"></a><h2 id=\"これは単に指定された名前のストリームが存在しているかどうかをテストしますストリームは返されません\">これは単に、指定された名前のストリームが存在しているかどうかをテストします。ストリームは返されません。</h2></div>\n\
<p><span class=\'code\'>myChannel.Add( “myStream”, myStream );</span></p>\n\
<div class=\'section\'><a id=\"これはストリームを追加しますまたは同じ名前のストリームが既に存在している場合は-argumentexception-をスローします\"></a><h2 id=\"これはストリームを追加しますまたは同じ名前のストリームが既に存在している場合は-argumentexception-をスローします\">これはストリームを追加します。または同じ名前のストリームが既に存在している場合は <span class=\'code\'>ArgumentException</span> をスローします。</h2></div>\n\
<p><span class=\'code\'>foreach( <a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a> stream in myChannel )  { ... }</span></p>\n\
<p>これを使用すると、複雑な C++/STL 構文の代わりに非常に単純な構文を使用してすべてのストリームを列挙することができます。</p>\n\
<p><span class=\'code\'>for( <a href=\"javascript:void(0)\" data-symbol=\"ChannelIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_channel_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">ChannelIterator</a> iter = myChannel.begin(); iter.notEqual( myChannel.end() ); iter.next() ) {         <a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a> stream = iter.__deref__();        ...     }</span></p>\n\
<div class=\'section\'><a id=\"stream-1\"></a><h3 id=\"stream-1\">Stream</h3></div>\n\
<p>このクラスは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a></span> オブジェクトのディクショナリとして機能するため、.NET インタフェース <span class=\'code\'>IDictionary&lt;<a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a>&gt;</span> をサポートします。</p>\n\
<p>これを使用すると、.NET のディクショナリから予測される次の標準のメソッド/プロパティを使用することができます。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a> handle;     if( myStream.TryGetValue( 18, out handle ) { ... }</span></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"このメソッドを使用するとインデックスが指定されたハンドルを検索することができ同時にその有無がテストされます\"></a><h2 id=\"このメソッドを使用するとインデックスが指定されたハンドルを検索することができ同時にその有無がテストされます\">このメソッドを使用するとインデックスが指定されたハンドルを検索することができ、同時にその有無がテストされます。</h2></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a> handle = myStream[18];</span></p>\n\
<div class=\'section\'><a id=\"このインデクサもインデックスが指定されたハンドルを検索しますがこの場合ハンドルは見つかる必要があります見つからない場合はkeynotfoundexception-をスローします\"></a><h2 id=\"このインデクサもインデックスが指定されたハンドルを検索しますがこの場合ハンドルは見つかる必要があります見つからない場合はkeynotfoundexception-をスローします\">このインデクサもインデックスが指定されたハンドルを検索しますが、この場合、ハンドルは見つかる必要があります(見つからない場合は、<span class=\'code\'>KeyNotFoundException</span> をスローします)。</h2></div>\n\
<p><span class=\'code\'>if( myStream.ContainsKey(18) { ... }</span></p>\n\
<div class=\'section\'><a id=\"これは単に指定されたインデックスのハンドルが存在しているかどうかをテストしますハンドルは返されません\"></a><h2 id=\"これは単に指定されたインデックスのハンドルが存在しているかどうかをテストしますハンドルは返されません\">これは単に、指定されたインデックスのハンドルが存在しているかどうかをテストします。ハンドルは返されません。</h2></div>\n\
<p><span class=\'code\'>myStream.Add( 18, myHandle );</span></p>\n\
<div class=\'section\'><a id=\"これはハンドルを追加しますまたは同じインデックスのハンドルが既に存在している場合は-argumentexception-をスローします\"></a><h2 id=\"これはハンドルを追加しますまたは同じインデックスのハンドルが既に存在している場合は-argumentexception-をスローします\">これはハンドルを追加します。または同じインデックスのハンドルが既に存在している場合は <span class=\'code\'>ArgumentException</span> をスローします。</h2></div>\n\
<p><span class=\'code\'>foreach( <a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a> handle in myStream )  { ... }</span></p>\n\
<p>これを使用すると、複雑な C++/STL 構文の代わりに非常に単純な構文を使用してすべてのハンドルを列挙することができます。</p>\n\
<p><span class=\'code\'>for( <a href=\"javascript:void(0)\" data-symbol=\"StreamIterator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream_iterator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">StreamIterator</a> iter = myStream.begin(); iter.notEqual( myStream.end() ); iter.next() ) {         <a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a> handle = iter.__deref__();        ...     }</span></p>\n\
<div class=\'section\'><a id=\"structure-1\"></a><h3 id=\"structure-1\">Structure</h3></div>\n\
<p>この構文を有効にするために <span class=\'code\'>IEnumerable&lt;Member&gt;</span> が追加されました。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">foreach( Member member in myStructure )  { ... }\n\
</pre></div><p>これを使用すると、複雑な C++/STL 構文の代わりに非常に単純な構文を使用してすべてのメンバーを列挙することができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">for( StructureIterator iter = myStream.begin(); iter.notEqual( myStream.end() ); iter.next() ) { \n\
    Member member = iter.__deref__();\n\
    ... \n\
}\n\
</pre></div><div class=\'section\'><a id=\"ハンドル-1\"></a><h3 id=\"ハンドル-1\">ハンドル</h3></div>\n\
<p>C++ API はポインタを使用する単一メソッド(例: <span class=\'code\'>int *asInt32()</span>)を使用するため、特定のタイプのデータにアクセスすることができます。単一の整数に対するポインタとして使用できます(例: <span class=\'code\'>myInteger = *asInt32()</span>)。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Structure</a></span> オブジェクトに対応するメンバーを作成するときに 1 より大きいサイズを指定した場合は、整数値の配列に対するポインタとして使用できます(例: <span class=\'code\'>asInt32()[6]</span>)。</p>\n\
<p>.NET の場合、API でポインタを使用することはできなかったため、タイプごとに 2 つのプロパティが提供されています。</p>\n\
<ul>\n\
<li><span class=\'code\'>int[] asInt32Array</span> は、整数の配列として整数データを取得または設定します。</li>\n\
<li><span class=\'code\'>int asInt32</span> は、単一の整数を取得または設定します(対応するストラクチャ メンバーで検出されたサイズが 1 より大きい場合は <span class=\'code\'>ApplicationException</span> をスローします)。</li>\n\
<li><span class=\'code\'>float[] asFloatArray</span> は、float の配列として float データを取得または設定します。</li>\n\
<li><span class=\'code\'>float asFloat</span> は、単一の float を取得または設定します(対応するストラクチャ メンバーで検出されたサイズが 1 より大きい場合は <span class=\'code\'>ApplicationException</span> をスローします)。</li>\n\
<li>など...</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"クライアントの-.net-タイプと一致-データの記述とアクセスを簡略化するための最終テクニック\"></a><h2 id=\"クライアントの-.net-タイプと一致-データの記述とアクセスを簡略化するための最終テクニック\">クライアントの .NET タイプと一致: データの記述とアクセスを簡略化するための最終テクニック</h2></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Structure</a></span> クラスを使用して要素のデータを記述すると、データにアクセスする <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a></span> クラスは次のようにかなり低レベルになり、C++ のようになります。</p>\n\
<ul>\n\
<li><span class=\'code\'>Structure.AddMember( kInt32, 1, “myIntMember”)</span> は、int メンバーを追加します。</li>\n\
<li><span class=\'code\'>Handle.setPositionByMemberIndex(uint)</span> は、アクセスするハンドルのメンバーを指定します。</li>\n\
<li><span class=\'code\'>Handle.asInt</span> は、メンバーの整数データを取得または設定します。</li>\n\
<li>など...</li>\n\
</ul>\n\
<p>使用しているタイプの各メンバーが予想される <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Structure</a></span> オブジェクトのメンバーとなっているデータを、クラスまたはストラクチャ内で記述している場合は、.NET によってプロセス全体が単純化されます。</p>\n\
<div class=\'section\'><a id=\"新しい-structureclass-アセンブリ-アトリビュート\"></a><h3 id=\"新しい-structureclass-アセンブリ-アトリビュート\">新しい StructureClass アセンブリ アトリビュート</h3></div>\n\
<p>プラグインで新しい <span class=\'code\'>StructureClass</span> アセンブリ アトリビュートを使用し、メタデータのストラクチャを記述するタイプを指定している場合は、.NET によって <strong>Structure</strong> オブジェクトを自動的に作成することができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">[assembly: StructureClass(typeof(MyNameSpace.MyStructureClass))]\n\
\n\
namespace MyNameSpace\n\
{\n\
   public class MyStructureClass\n\
   {\n\
      public int a;\n\
      public int b { get; set; }\n\
      public float[] c = new float[3];\n\
   }\n\
}\n\
</pre></div><p>イントロスペクションのおかげで、.NET はクラス(またはストラクチャ)ですべてのパブリック フィールドおよびプロパティを検索し、<span class=\'code\'>Structure.registerStructure</span> を使用して登録されている <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Structure</a></span> オブジェクトを自動的に作成することができます。</p>\n\
<p>ストラクチャの名前は、タイプのフル ネームです(<span class=\'code\'>MyNameSpace.MyStructureClass</span> など)。各ストラクチャ メンバーの名前は、タイプの対応するメンバーの名前です。</p>\n\
<div class=\'section\'><a id=\"handle-から-.net-オブジェクトまたはその逆に変換する\"></a><h3 id=\"handle-から-.net-オブジェクトまたはその逆に変換する\">Handle から .NET オブジェクト(またはその逆)に変換する</h3></div>\n\
<p>.NET オブジェクト タイプの新しい <strong>StructureClass</strong> アセンブリ アトリビュート(前のセクションを参照)を使用する場合は、次に示す <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a></span> クラスの新しいメソッドを使用することができます。</p>\n\
<ul>\n\
<li><span class=\'code\'>public void SetFromDotNetObject( Object dotNetObj, <a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Structure</a> structure );</span></li>\n\
</ul>\n\
<p>これにより、メンバーは .NET オブジェクトから <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a></span> オブジェクトに高レベルでコピーされます。</p>\n\
<p>これは、次の疑似コードと同等です。</p>\n\
<p><span class=\'code\'>for each public member in the type of dotNetObj         find corresponding member in <a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Structure</a> object        call this.setPositionByMemberIndex( index of member found )         if type is int32            this.asInt = get value of member in dotNetObj        else if type is float            this.asFloat = get value of member in dotNetObj        …    next</span></p>\n\
<ul>\n\
<li><span class=\'code\'>public void CopyToDotNetObject(Object dotNetObj, <a href=\"javascript:void(0)\" data-symbol=\"Structure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_structure.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Structure</a> structure);</span></li>\n\
</ul>\n\
<p>これにより、メンバーは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a></span> オブジェクトから .NET オブジェクトに高レベルでコピーされます。</p>\n\
<p>これは、次の疑似コードと同等です。</p>\n\
<p>``` for each public member in the type of dotNetObj find corresponding member in Structure object call this.setPositionByMemberIndex( index of member found ) if type is int32 dotNetObj.SetValue( this.asInt ) else if type is float dotNetObj.SetValue( this.asFloat ) … next</p>\n\
<p>```</p>\n\
<p>ただし、次のセクションで説明する新しい汎用クラス <span class=\'code\'>StreamForType&lt;T&gt;</span> を使用する場合、これらのメソッドは不要になります。</p>\n\
<div class=\'section\'><a id=\"streamfortype-.net-タイプに合わせた-stream-クラスの特殊なバージョン\"></a><h3 id=\"streamfortype-.net-タイプに合わせた-stream-クラスの特殊なバージョン\">StreamForType<t>: .NET タイプに合わせた Stream クラスの特殊なバージョン</t></h3></div>\n\
<p>Stream は Structure を記述する .NET タイプを提供できない場合に使用するクラスですが、新しい StructureClass アセンブリ アトリビュートを使用してタイプを提供した場合は、クラス <span class=\'code\'>StreamForType&lt;T&gt;</span> を使用する必要があります。</p>\n\
<p>この汎用クラスの T パラメータに同じタイプを使用すると、タイプに合わせて完全にカスタマイズされた Stream のようなクラスが提供されます。</p>\n\
<p>この汎用クラスは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a></span> オブジェクトのラッパーであり、2 つの方法で作成することができます。2 つのコンストラクタを次に示します。</p>\n\
<ul>\n\
<li><span class=\'code\'>StreamForType&lt;T&gt;(string streamName)</span></li>\n\
</ul>\n\
<p>このコンストラクタは、タイプ T のフル ネームで呼び出された既存の Structure を検索します(StructureClass アセンブリ アトリビュートを使用した場合に検索する必要があります)。コンストラクタは、指定された名前と検出されたストラクチャを使用して新しい <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a></span> オブジェクトを作成し、この新しい <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a></span> オブジェクトをラップします。</p>\n\
<ul>\n\
<li><span class=\'code\'>StreamForType&lt;T&gt;(<a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a> baseStream)</span></li>\n\
</ul>\n\
<p>このコンストラクタは、指定されたストリームをラップするだけでなく、このベース ストリームのストラクチャがタイプと互換性のあることを保証します(StructureClass アセンブリ アトリビュートを使用した場合にその必要があります)。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Stream\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_stream.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Stream</a></span> クラスは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a></span> オブジェクトのディクショナリとみなすことができますが、<span class=\'code\'>StreamForType&lt;T&gt;</span> 汎用クラスは T が .NET クラス(またはストラクチャ)である T オブジェクトのディクショナリとみなすことができます。これは、汎用クラスによってサポートされた <span class=\'code\'>IDictionary&lt;T&gt;</span> を使用して実行されます。</p>\n\
<p>いくつかの興味深いメソッドを次に示します。</p>\n\
<ul>\n\
<li><span class=\'code\'>bool TryGetValue(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Index</a>, out T value)</span></li>\n\
</ul>\n\
<p>指定されたインデックスを持つ <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"Handle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Handle</a></span> オブジェクトを検索し、T の新しいインスタンスで <span class=\'code\'>handle.CopyToDotNetObject()</span> を呼び出します。新しいインスタンスを返すか、ハンドルが見つからない場合は false を返します。</p>\n\
<ul>\n\
<li><span class=\'code\'>void Add(<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Index</a>, T value)</span></li>\n\
</ul>\n\
<p>指定したインデックスで新しいハンドルを作成し、指定された T の値を使用して <span class=\'code\'>handle.SetFromDotNetObject()</span> を呼び出します。</p>\n\
<ul>\n\
<li><span class=\'code\'>T this[<a href=\"javascript:void(0)\" data-symbol=\"Index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/classadsk_1_1_data_1_1_index.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">Index</a> key]</span></li>\n\
</ul>\n\
<p>これにより、次の構文が有効になります(<span class=\'code\'>MyStructureClass</span> は T パラメータに使用される .NET タイプです)。</p>\n\
<p><span class=\'code\'>MyStructureClass myDotNetObj ;    myDotNetObj.myInt = 3;    myStream[18] = myDotNetObj;</span></p>\n\
<p>上記の例では、指定されたインデックスに .NET オブジェクトを追加するか、既にそのインデックスにオブジェクトが存在する場合は現在のオブジェクトを置き換えます。</p>\n\
<p><span class=\'code\'>MyStructureClass myDotNetObj = myStream[18];</span></p>\n\
<p>上記の例では、指定されたインデックスで検出されたオブジェクトが返されるか、オブジェクトがそのインデックスに存在しない場合は <span class=\'code\'>KeyNotFoundException</span> をスローします。</p>\n\
<p>次の構文はコンパイルを実行しますが、ベース ストリーム内の要素は変更されないため、予測どおりに動作しないことに注意してください。</p>\n\
<p><span class=\'code\'>myStream[18].myInt = 1.6;</span></p>\n\
<p>上記の例では代わりにインデクサで返された「コピー」の <span class=\'code\'>myInt</span> フィールドが変更されるため、まったく意味がありません。**</p>\n\
<p>目的の結果を出力するには、次のコードを実行します。</p>\n\
<p>``` MyStructureClass temp = myStream[18]; temp.myInt = 1.6; myStream[18] = temp;</p>\n\
<p>```</p>\n\
<ul>\n\
<li><span class=\'code\'>IEnumerator&lt;T&gt; GetEnumerator()</span></li>\n\
</ul>\n\
<p>これにより、この単純な構文を使用してすべての要素が列挙されます。</p>\n\
<p><span class=\'code\'>foreach( MyStructureClass myDotNetObj in myStream ) { … }</span></p>\n\
<div class=\'section\'><a id=\"強力な-linq-を使用して-sql-のような照会を実行する\"></a><h3 id=\"強力な-linq-を使用して-sql-のような照会を実行する\">強力な LINQ を使用して SQL のような照会を実行する</h3></div>\n\
<p><span class=\'code\'>IEnumerable</span> はほとんどのクラスでサポートされているため、データで非常に強力な照会を実行することができます。</p>\n\
<p>たとえば、クラスに振幅というフィールドがあり、振幅が 0.5 よりも大きいメッシュの頂点のチャネルでメタデータを検索する場合、次のようにしてこれを簡単に行うことができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"> Channel chn = myAssociations[&quot;vertex&quot;];\n\
 Stream chnStream = chn[“myStream”];\n\
 var strm = new StreamForType&lt;MyStructureClass&gt;(chnStream);\n\
 var list = strm.Where( ( MyStructureClass obj ) =&gt;obj.amplitude &gt;0.5 );\n\
 foreach( MyStructureClass obj in list ) { … }\n\
</pre></div><p>頂点インデックスを照会するには、次のように実行できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">var list = strm.Where( ( KeyValuePair&lt;Index,MyStructureClass&gt; keyvalue ) =&gt; keyvalue.Value.amplitude &gt; 0.5 );\n\
foreach (var keyvalue in list ) {  \n\
   Index index = keyvalue.Key;\n\
   MyStructureClass obj = keyvalue.Value;\n\
   …   \n\
}\n\
</pre></div><p>このタイプの照会は、Associations、Channel、Stream、および Structure のいずれかのクラスで実行できます。これらはすべて、LINQ が必要とする唯一のインタフェースである <span class=\'code\'>IEnumerable</span> を実装しているためです。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";