var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Maya .NET API で IEnumerable および LINQ を使用する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Maya .NET API で IEnumerable および LINQ を使用する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maya-.net-api-で-ienumerable-および-linq-を使用する\"></a></div>\n\
<p>Maya .NET API の多くのクラスに <span class=\'code\'>IEnumerable&lt;T&gt;</span> インタフェースが実装されています。一部の例には、<span class=\'code\'>MCGeometry</span>、<span class=\'code\'>MCDag</span>、<span class=\'code\'>MCDependencyGraph</span> などのヘルパー クラスに加えて、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MColorArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_color_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_color_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MColorArray</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_point_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatPointArray</a></span> などのさまざまな Maya 配列クラスも含まれています。<span class=\'code\'>IEnumerable&lt;T&gt;</span> を実装しているすべてのクラスを表示するには、オブジェクト ブラウザを使用して <span class=\'code\'>GetEnumerator()</span> を検索します。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/API_dotNet_IEnumerable_ObjBrowser_search.png\' title=\'\' /></div>\n\
<p><span class=\'code\'>GetEnumerator()</span> 関数(<span class=\'code\'>IEnumerable</span> を実装する関数を含む)を実装し、<span class=\'code\'>IEnumerator</span> インタフェースに準拠しているクラスを返す任意のクラスで、<span class=\'code\'>foreach</span> キーワードを使用できます。たとえば、シーン内で選択したオブジェクトを使用して、次のコードを実行すると、選択したすべてのオブジェクトのパス名が表示されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">foreach (var s in MGlobal.activeSelectionList)\n\
           MGlobal.displayInfo(s.partialPathName);\n\
</pre></div><p><span class=\'code\'>System.Linq</span> ネームスペースを読み込むと、<span class=\'code\'>IEnumerable&lt;T&gt;</span> を実装しているすべてのコレクションで LINQ 拡張メソッドを使用できます。たとえば、次のコードでは、選択したすべてのメッシュが返されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">var meshes = MGlobal.activeSelectionList.Where(p =&gt; p.hasFn(MFn.Type.kMesh)).Select(p =&gt; new <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnMesh</a>(p)); \n\
</pre></div><p>これは、「メソッド構文」と呼ばれます。LINQ でサポートされるその他の構文は、「クエリー構文」と呼ばれます。次のコードは、前のコードと同じです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">var meshes = from p in MGlobal.activeSelectionList where p.hasFn(MFn.Type.kMesh) select new <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnMesh</a>(p);\n\
</pre></div><p>その他の LINQ の使用例については、Developer Kit インストールの <span class=\'code\'>devkit\\dotnet\\wpfexamples</span> フォルダにある DAGExplorer のサンプルを参照してください。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";