var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>.NET アセンブリ アトリビュートを使用する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>.NET アセンブリ アトリビュートを使用する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"net-アセンブリ-アトリビュートを使用する\"></a></div>\n\
<p>Maya の .NET SDK では、.NET アセンブリ アトリビュートを使用して、プラグイン、コマンド、ノードなどを自動登録します。これは、Maya の C++ SDK とは異なる方法です。C++ の場合は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin</a></span> クラスに、Maya の MPx プリフィックスが付いたすべてのクラスに対する登録メソッドが用意されています(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a></span> など)。.NET では、代わりにクラスをアトリビュートで修飾すると、アトリビュートがプラグイン ローダによって解釈されて、ローダが Maya への登録を行います。</p>\n\
<p>詳細については、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin</a></span> クラスのリファレンス マニュアルを参照してください。</p>\n\
<div class=\'section\'><a id=\"拡張プラグイン\"></a><h2 id=\"拡張プラグイン\">拡張プラグイン</h2></div>\n\
<p>プラグインで <span class=\'code\'>ExtensionPlugin</span> アセンブリ アトリビュートを指定します。</p>\n\
<p>通常、プラグインを定義するクラスの先頭にこのアセンブリ アトリビュートを追加します。</p>\n\
<p><span class=\'code\'>[assembly: ExtensionPlugin(typeof(PluginClass), &quot;Name1&quot;, &quot;Name2&quot;,…)]</span></p>\n\
<p>ここで:</p>\n\
<ul>\n\
<li><span class=\'code\'>ExtensionPlugin</span>: このアトリビュートは、特定の PluginClass がロードされることを保証します。</li>\n\
<li><span class=\'code\'>PluginClass</span>: プラグイン(IExtensionPlugin インタフェースを実装)を宣言している C# クラスの完全な名前。</li>\n\
<li><span class=\'code\'>Name1, Name2, …</span>: 無視されます。内部での使用のために予約されています。</li>\n\
</ul>\n\
<p>このアトリビュートは必須ではありませんが、指定すると、プラグインのロードが高速化します。指定しないと、<span class=\'code\'>IExtensionPlugin</span> インタフェースを実装している最初の C# クラスが検索されます。このインタフェースには次のメソッドが含まれます。</p>\n\
<p><span class=\'code\'>bool InitializePlugin () ; // called when the plug-in is loaded</span></p>\n\
<p><span class=\'code\'>bool UninitializePlugin () ; // called when the plug-in is unloaded</span></p>\n\
<p><span class=\'code\'>System::String^ GetMayaDotNetSdkBuildVersion(); //Returns a string representation of the integer version of Maya (for example, “20135002”)</span></p>\n\
<div class=\'section\'><a id=\"コマンド\"></a><h2 id=\"コマンド\">コマンド</h2></div>\n\
<div class=\'section\'><a id=\"コマンドの定義\"></a><h3 id=\"コマンドの定義\">コマンドの定義</h3></div>\n\
<p>[assembly: MPxCommandClass(typeof(MPxCommandDerivedClass), &quot;CommandName&quot;)]</p>\n\
<p>ここで:</p>\n\
<ul>\n\
<li><span class=\'code\'>MPxCommandClass</span>: このアトリビュートは、コマンド クラスが Maya に登録されることを保証します。</li>\n\
<li><span class=\'code\'>MPxCommandDerivedClass</span>: <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span>から派生する C# クラスの名前です。</li>\n\
</ul>\n\
<p>クラスのネームスペースを含むフル パスを指定する必要があります。</p>\n\
<ul>\n\
<li><span class=\'code\'>CommandName</span>: Maya のスクリプト エディタに表示されるコマンドの名前です。</li>\n\
</ul>\n\
<p>例:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">[assembly: MPxCommandClass(typeof(MayaNetTest.WhatIsCmd), &quot;netWhatIs&quot;)]\n\
namespace MayaNetTest \n\
{\n\
    public class WhatIsCmd : <a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a>, IMPxCommand \n\
    {\n\
        override public void doIt(<a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a> args)\n\
        {\n\
            …\n\
        }\n\
    }\n\
}\n\
</pre></div><div class=\'section\'><a id=\"コマンド構文\"></a><h3 id=\"コマンド構文\">コマンド構文</h3></div>\n\
<p>コマンド構文を記述するには、いくつかのクラス アトリビュート(コマンド クラスの定義の上にあります)が必要な場合もあります。</p>\n\
<p>指定できるアトリビュートを次に示します。</p>\n\
<div class=\'section\'><a id=\"コマンド引数\"></a><h4 id=\"コマンド引数\">コマンド引数</h4></div>\n\
<p>コマンドが引数を受け取る場合は、各引数に対して次のアトリビュートを追加する必要があります。</p>\n\
<p><span class=\'code\'>[MPxCommandSyntaxArg(typeof(ArgType))]</span></p>\n\
<ul>\n\
<li><p><span class=\'code\'>MPxCommandSyntaxArg</span>: このアトリビュートにより、この引数は構文に追加されます。</p></li>\n\
<li><p><span class=\'code\'>ArgType</span>: 引数の型(例: System.String)。</p></li>\n\
</ul>\n\
<p>次に例を示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">[MPxCommandSyntaxArg(typeof(System.String))] // a string argument\n\
[MPxCommandSyntaxArg(typeof(System.Int32))] // an integer argument\n\
\n\
</pre></div><p>引数がオブジェクトである場合は、さらに多くのコントロールでこのクラス アトリビュートを使用する必要があります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">[MPxCommandSyntaxSelection( UseSelectionAsDefault = UseSelection,  MinObjectCount = min, MaxObjectCount = max, ObjectsType = typeof(ObjType))]\n\
</pre></div><p>ここで:</p>\n\
<ul>\n\
<li><span class=\'code\'>MPxCommandSyntaxSelection</span>: このアトリビュートにより、この引数は構文に追加されます。</li>\n\
<li><span class=\'code\'>UseSelection</span>: オブジェクトが指定されていない場合に、コマンドが選択を使用するかどうか。</li>\n\
<li><span class=\'code\'>min</span>: ユーザが指定できるオブジェクトの最小数です。</li>\n\
<li><span class=\'code\'>max</span>: ユーザが指定できるオブジェクトの最大数です。</li>\n\
</ul>\n\
<p><span class=\'code\'>ObjType</span> には、以下を指定できます。</p>\n\
<ul>\n\
<li><span class=\'code\'>typeof(<a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSelectionList</a>)</span>: 常に選択を使用します。</li>\n\
<li><span class=\'code\'>typeof(System.String</span>: ユーザが名前を使用してオブジェクトを指定します。</li>\n\
</ul>\n\
<p>次に例を示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">[MPxCommandSyntaxSelection(UseSelectionAsDefault = true, MinObjectCount = 1, \n\
MaxObjectCount = 2, ObjectsType = typeof(System.String))]\n\
</pre></div><p>このコマンドは、1 つまたは 2 つのオブジェクトを受け取り、オブジェクトが指定されていない場合は選択を使用します。</p>\n\
<div class=\'section\'><a id=\"コマンド-フラグ\"></a><h4 id=\"コマンド-フラグ\">コマンド フラグ</h4></div>\n\
<p>コマンドが 1 つまたは複数のフラグを受け取る場合は、各フラグに次のクラス アトリビュートを追加する必要があります。</p>\n\
<p><span class=\'code\'>[MPxCommandSyntaxFlag( “flag’s short name“, “flag’s long name”, Arg1 = typeof(ArgType), Arg2 = typeof(ArgType), ... ]</span></p>\n\
<p>ここで:</p>\n\
<ul>\n\
<li><span class=\'code\'>MPxCommandSyntaxFlag</span>: このアトリビュートにより、フラグがコマンドの構文に追加されます。</li>\n\
<li><span class=\'code\'>flag’s short name</span>: フラグの短い名前です(例: -i)。</li>\n\
<li><span class=\'code\'>flag’s long name</span>: フラグの長い名前です(例: -index)。</li>\n\
<li><span class=\'code\'>ArgType</span>: フラグ引数がある場合、その型(例: System.Double)。</li>\n\
</ul>\n\
<p>次に例を示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">[MPxCommandSyntaxFlag(&quot;-na&quot;, &quot;-name&quot;, Arg1=typeof(System.String))]\n\
[MPxCommandSyntaxFlag(&quot;-ip&quot;, &quot;-inPosition&quot;, \n\
Arg1 = typeof(System.Double), \n\
Arg2 = typeof(System.Double), \n\
Arg3 = typeof(System.Double))]\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>注:</strong> フラグ -c、-q、-e は、コマンド モード用に予約されています(「<a href=\'#!/url=./dev_help/Maya-NET-API/Using-NET-assembly-attributes.html#command-mode\' title=\'\'>コマンド モード</a>」を参照)。</p>\n\
\n\
<div class=\'section\'><a id=\"コマンド-モード\"></a><h4 id=\"コマンド-モード\">コマンド モード</h4></div>\n\
<p>Maya コマンドは、作成、照会、編集という 3 つのモードで使用できます。</p>\n\
<ul>\n\
<li>作成: コマンドは要素の作成に使用されます(既定)。</li>\n\
<li>照会: –q フラグを指定したコマンドは、既に作成されている要素の照会に使用されます。</li>\n\
<li>編集: –e フラグを指定したコマンドは、既に作成されている要素の修正に使用されます。</li>\n\
</ul>\n\
<p>作成モードは常にサポートされ、既定のモードです。作成モードに加えて、コマンドは照会モードと編集モードの一方または両方をサポートできます。</p>\n\
<p>次のクラス アトリビュートを使用して、異なるモードを指定できます。</p>\n\
<p><span class=\'code\'>[MPxCommandSyntaxMode(CommandMode)]</span></p>\n\
<p>ここで:</p>\n\
<ul>\n\
<li><span class=\'code\'>MPxCommandSyntaxMode</span>: このアトリビュートにより、コマンド構文でモードが正しく設定されます。</li>\n\
<li><span class=\'code\'>CommandMode</span>:</li>\n\
<li><span class=\'code\'>MPxCommandSyntaxModeAttribute.CommandMode.kNone</span>: コマンドは作成モードのみをサポートします。</li>\n\
<li><span class=\'code\'>MPxCommandSyntaxModeAttribute.CommandMode.kQuery</span>: コマンドは作成モードと照会モードのみをサポートします。</li>\n\
<li><span class=\'code\'>MPxCommandSyntaxModeAttribute.CommandMode.kEdit</span>: コマンドは作成モードと編集モードのみをサポートします。</li>\n\
<li><span class=\'code\'>MPxCommandSyntaxModeAttribute.CommandMode.kBoth</span>: コマンドは 3 つのモードすべてをサポートします。</li>\n\
</ul>\n\
<p>例:</p>\n\
<p><span class=\'code\'>[MPxCommandSyntaxMode(MPxCommandSyntaxModeAttribute.CommandMode.kQuery)]</span></p>\n\
<p>このコマンドは、作成(既定)と照会モード(-q)をサポートします。</p>\n\
<div class=\'section\'><a id=\"コマンドからの引数とフラグの取得\"></a><h2 id=\"コマンドからの引数とフラグの取得\">コマンドからの引数とフラグの取得</h2></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MArgDatabase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_database.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_database.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgDatabase</a></span> クラスを使用して、引数とフラグを取得するには、コマンドの <span class=\'code\'>syntax()</span> メソッドを使用します。</p>\n\
<p>次のような構文アトリビュートのあるコマンドについて考えます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">[MPxCommandSyntaxFlag(&quot;-i&quot;, &quot;-index&quot;)]\n\
[MPxCommandSyntaxSelection(MinObjectCount = 1, MaxObjectCount = 1, ObjectsType = typeof(<a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSelectionList</a>))]\n\
[MPxCommandSyntaxModeAttribute(MPxCommandSyntaxModeAttribute.CommandMode.kNone)]\n\
</pre></div><p>次のようにして引数を取得できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">bool isIndex;\n\
MxPlug fPlug;\n\
               \n\
const string kIndexFlag = &quot;-i&quot; ;\n\
const string kIndexFlagLong = &quot;-index&quot; ;\n\
\n\
// the following transfers all the class attributes information \n\
var argData = new <a href=\"javascript:void(0)\" data-symbol=\"MArgDatabase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_database.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_database.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgDatabase</a>( syntax, args);\n\
\n\
if ( argData.isFlagSet (kIndexFlag) )\n\
    isIndex =true ;\n\
\n\
// Get the plug specified on the command line.\n\
var slist = argData.getObjects() as <a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSelectionList</a>;\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";