var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ユーザ独自の .NET プラグインの作成</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ユーザ独自の .NET プラグインの作成</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ユーザ独自の-.net-プラグインの作成\"></a></div>\n\
<p>Maya .NET SDK は 64 ビットのみで使用できます。Maya .NET プラグイン プロジェクトも x64 でコンパイルされていることを確認してください。</p>\n\
<p>プラグインは、<span class=\'code\'>Autodesk.Maya.OpenMaya.IExtensionPlugin</span> インタフェースを実装する必要があります。何も行わない既定の実装でもかまいません。</p>\n\
<p>SDK はこのインタフェースを実装する最初のクラスを検索しますが、<span class=\'code\'>IExtensionPlugin</span> の実装の検出を速くするため、.NET プラグインには次のように 1 つの <span class=\'code\'>ExtensionPlugin</span> アセンブリ アトリビュートをオプションで含めることもできます。</p>\n\
<p><span class=\'code\'>[assembly: ExtensionPlugin(typeof(MayaNetPlugin.helloWorldPlugin), &quot;Autodesk&quot;, &quot;1.0&quot;, &quot;Any&quot;)]</span></p>\n\
<p>アセンブリ アトリビュートの詳細については、「<a href=\'#!/url=./dev_help/Maya-NET-API/Using-NET-assembly-attributes.html\' title=\'\'>.NET アセンブリ アトリビュートを使用する</a>」を参照してください。</p>\n\
<p>このアセンブリ アトリビュートは、通常は宣言を使用した後に、ネームスペース外部のライブラリの任意のソース ファイル内で出現できます。</p>\n\
<p>プラグイン ライブラリは、任意の数のカスタム .NET コマンド、または .NET ノードを含むことができます。</p>\n\
<p>Maya .NET SDK メソッドのマニュアルは IntelliSense をサポートし、コードを入力するとポップアップ表示されます。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> - 独自のカスタム .NET プラグイン プロジェクトを作成する場合には、Maya アセンブリ リファレンスの<strong><a href=\'#!/url=./dev_help/Maya-NET-API/Copy%20Local/\' title=\'\'>ローカル コピー</a></strong>プロパティを false に設定する必要があります。</p>\n\
<p><em>ローカル コピー(Copy Local)</em>プロパティが有効になっていると(既定)、Visual Studio はコードを実行するのに必要なリファレンスを .NET プロジェクトの出力フォルダ <span class=\'code\'>\\bin</span> にコピーし、それらを毎回ロードします。しかし、そのプラグインは Maya で実行されるので、リファレンスは既に Maya にインストールおよびロードされており、使用可能になっています。</p>\n\
<p>結果として、そのプラグインは初期化に失敗することがあります。</p>\n\
<p><em><a href=\'#!/url=./dev_help/Maya-NET-API/Copy%20Local/\' title=\'\'>ローカル コピー</a></em>を false に設定するには、Visual Studio の<a href=\'#!/url=./dev_help/Maya-NET-API/Solution%20Explorer/\' title=\'\'>ソリューション エクスプローラ</a>で、リファレンスを右クリックします。そして<a href=\'#!/url=./dev_help/Maya-NET-API/Properties/\' title=\'\'>プロパティ</a>を選択し、表示された<a href=\'#!/url=./dev_help/Maya-NET-API/Properties/\' title=\'\'>プロパティ</a>ウィンドウで、<a href=\'#!/url=./dev_help/Maya-NET-API/Copy%20Local/\' title=\'\'>ローカル コピー</a>を false に設定します。 - Maya の <span class=\'code\'>bin</span> フォルダ内にないアセンブリをプラグインが参照している場合、Maya がプラグインをロードするように、PATH 環境変数にこれらのアセンブリのパスを追加する必要があります。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"オブジェクト-インスタンスの比較\"></a><h2 id=\"オブジェクト-インスタンスの比較\">オブジェクト インスタンスの比較</h2></div>\n\
<p><strong>==</strong> または <strong>!=</strong> を使用した 2 つのオブジェクト参照の比較は、常に、意図したように動作しない可能性があります。たとえば、.NET ベース クラスから<em>派生される</em>オブジェクトが新しいメモリ インスタンスに移動することがあります。Maya オブジェクトを比較するには、メンバ関数 <span class=\'code\'>MObject.equalEqual</span> および <span class=\'code\'>MObject.notEqual</span> を代わりに使用します。</p>\n\
<div class=\'section\'><a id=\"内部-swig-型について\"></a><h2 id=\"内部-swig-型について\">内部 SWIG 型について</h2></div>\n\
<p>API で公開される一部の型の名前には、<strong>swig</strong> が含まれています。これは内部使用専用であり、サポートされていません。</p>\n\
<div class=\'section\'><a id=\"ドッキング可能な-wpf-コントロールの作成\"></a><h2 id=\"ドッキング可能な-wpf-コントロールの作成\">ドッキング可能な WPF コントロールの作成</h2></div>\n\
<p><span class=\'code\'>MDockStation</span> クラスは、Windows コントロールで WPF コントロールをドッキングするための機能を提供します。Developer Kit をインストールしたフォルダの <span class=\'code\'>devkit\\dotnet\\wpfexamples</span> フォルダにある DAGExplorer のサンプルを参照してください。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";