var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Maya Python API を使用する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Maya Python API を使用する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maya-python-api-を使用する\"></a></div>\n\
<p>Maya API のラッパ(wrapper)、イテレータ、関数セット クラスを使用する基本的なスクリプトを作成できます。これらのスクリプトは、Maya モデルを照会し操作することはできますが、Maya に完全に統合されているわけではありません。スクリプト プラグインは、Maya に強固に統合された、より複雑なソリューションを提供します。このセクションでは、基本のスクリプト、スクリプト プラグイン、そしてスタンドアローン型スクリプトを作成する方法について説明します。</p>\n\
<p>Maya Python API は Python ベースの API なので、Python の知識が必要です。</p>\n\
<div class=\'section\'><a id=\"モジュールを読み込む\"></a><h2 id=\"モジュールを読み込む\">モジュールを読み込む</h2></div>\n\
<p>Maya Python API は、いくつかの Python モジュールに内蔵されています。作成するスクリプトで使用する機能を読み込む必要があります。また、Maya Python API は Maya ネームスペース内に存在します。したがって、追加のプリフィックスが必要です。OpenMaya モジュールを読み込むには次を実行します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.OpenMaya\n\
\n\
</pre></div><div class=\'section\'><a id=\"モジュールまたはクラスのヘルプ\"></a><h2 id=\"モジュールまたはクラスのヘルプ\">モジュールまたはクラスのヘルプ</h2></div>\n\
<p><span class=\'code\'>help</span> コマンドを使用して、任意のモジュールまたはクラスについての情報を表示できます。たとえば、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MVector</a></span> についてのクラス情報を表示する場合は、次を使用します。</p>\n\
<p><span class=\'code\'>help(maya.OpenMaya.MVector)</span></p>\n\
<p>また、モジュール全体についての情報を表示することもできます。</p>\n\
<p><span class=\'code\'>help(maya.OpenMaya)</span></p>\n\
<p>OpenMaya モジュールは非常に大きいので、この操作が値を返すには時間がかかります。</p>\n\
<div class=\'section\'><a id=\"スクリプトを作成する\"></a><h2 id=\"スクリプトを作成する\">スクリプトを作成する</h2></div>\n\
<p>Maya Python API モジュールには、Python プログラミングで使用可能なクラスが含まれています。これらのクラスは異なるカテゴリに分類され、その関連を示すための適切な命名規則を持っています。クラスには次のような種類があります。</p>\n\
<div class=\'section\'><a id=\"mfn\"></a><h3 id=\"mfn\">MFn</h3></div>\n\
<p>このプリフィックスを含むクラスは、特定タイプの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MObject</a></span> に対して演算を行う関数セットです。</p>\n\
<div class=\'section\'><a id=\"mitmit\"></a><h3 id=\"mitmit\">MIt<so>MIt</so></h3></div>\n\
<p>このクラスはイテレータで、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MObject</a></span> に対する動作は関数セットの場合とほぼ同じになります。たとえば <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItCurveCV\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_curve_c_v.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MItCurveCV</a></span> は、個々の NURBS カーブ CV に演算を行う場合や(<span class=\'code\'>MFnNurbsCurveCV</span> はありません)、カーブのすべての CV に演算を繰り返し行う場合に使用します。</p>\n\
<div class=\'section\'><a id=\"mpx\"></a><h3 id=\"mpx\">MPx</h3></div>\n\
<p>このプリフィックスを含むクラスはすべて「プロキシ」です。これは、ユーザ独自のオブジェクト型を作成したり、そこから派生させたりするために設計された API クラスです。</p>\n\
<div class=\'section\'><a id=\"m-クラス\"></a><h3 id=\"m-クラス\">M クラス</h3></div>\n\
<p>これらのクラスのほとんどは「ラッパ（wrapper）」ですが、それ以外もあります。このクラスの例には、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_vector.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MVector</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_int_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MIntArray</a></span> などがあります。</p>\n\
<p>ラッパ クラスと関数セット クラスを使用して、次のようなスクリプトを作成できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.OpenMaya\n\
vector1 = maya.OpenMaya.MVector(0,1,0)\n\
vector2 = maya.OpenMaya.MVector(1,0,0)\n\
vector3 = maya.OpenMaya.MVector(0,0,2)\n\
newVector = vector1 + vector2 + vector3\n\
print &quot;newVector %f, %f, %f &quot; % (newVector.x, newVector.y, newVector.z)\n\
\n\
</pre></div><p>import コマンドを修正して、使用されているシンボル名を短くすることが可能です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.OpenMaya as OpenMaya\n\
vector1 = OpenMaya.MVector(0,1,0)\n\
\n\
</pre></div><p>スクリプトは、Maya Python API クラスを使用してディペンデンシー グラフの情報にアクセスすることができます。次のスクリプトでは、persp ノードを検索し、その <span class=\'code\'>translateX</span> アトリビュート値を出力します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># import the OpenMaya module\n\
import maya.OpenMaya as OpenMaya\n\
\n\
# function that returns a node object given a name\n\
def nameToNode( name ):\n\
    selectionList = OpenMaya.MSelectionList()\n\
    selectionList.add( name )\n\
    node = OpenMaya.MObject()\n\
    selectionList.getDependNode( 0, node )\n\
    return node\n\
\n\
# function that finds a plug given a node object and plug name\n\
def nameToNodePlug( attrName, nodeObject ):\n\
    depNodeFn = OpenMaya.MFnDependencyNode( nodeObject )\n\
    attrObject = depNodeFn.attribute( attrName )\n\
    plug = OpenMaya.MPlug( nodeObject, attrObject )\n\
    return plug\n\
\n\
# Find the persp camera node\n\
print &quot;Find the persp camera&quot;\n\
perspNode = nameToNode( &quot;persp&quot; )\n\
print &quot;APItype %d&quot; % perspNode.apiType()\n\
print &quot;APItype string %s&quot; % perspNode.apiTypeStr()\n\
\n\
# Print the translateX value\n\
translatePlug = nameToNodePlug( &quot;translateX&quot;, perspNode )\n\
print &quot;Plug name: %s&quot; % translatePlug.name()\n\
print &quot;Plug value %g&quot; % translatePlug.asDouble())\n\
\n\
</pre></div><p>上の例は次のことを示します。</p>\n\
<ul>\n\
<li>クラスのインスタンス化には、<span class=\'code\'>fn = OpenMaya.MFnFunctionSet()</span> 表記を使用します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MObject</a></span> は <span class=\'code\'>node = OpenMaya.MObject()</span> メソッドを使用して作成できます。</li>\n\
<li>Python は型のない言語ですが、クラスのパラメータとして型を渡すには、正しい型をインスタンス化する必要があります。</li>\n\
<li>Python 文字列は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a></span> ラッパ クラスの代わりに渡され、返されます。</li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>注:</strong>わかりやすくするため、上の例ではエラー チェックを省略しています。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"スクリプト-プラグイン\"></a><h2 id=\"スクリプト-プラグイン\">スクリプト プラグイン</h2></div>\n\
<p>スクリプト プラグインは、Maya に強固に統合されたソリューションの作成を可能にします。スクリプト プラグインにより開発者はコマンドのアンドゥ、Maya シーン ファイルへの適切な requires 行の構築などの機能をサポートすることができます。スクリプト プラグインを使用するもう 1 つの利点は、MEL と Python の両方で機能を使用きることです。</p>\n\
<div class=\'section\'><a id=\"スクリプト-プラグインを使用する\"></a><h3 id=\"スクリプト-プラグインを使用する\">スクリプト プラグインを使用する</h3></div>\n\
<p>Maya プラグイン マネージャ(Plug-in Manager)が拡張され、スクリプト プラグインのロードとアンロードがサポートされるようになりました。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/plugin_manager_python_QT.png\' title=\'\' /></div>\n\
<p><span class=\'code\'>MAYA_PLUG_IN_PATH</span> 上にあり、<span class=\'code\'>.py</span> 拡張子で終わるファイルが、プラグイン マネージャ(Plug-in Manager)に表示されます。ロード（Loaded）チェック ボックスまたは自動ロード（Auto Load）チェック ボックスのどちらかを選択して、スクリプト プラグインをロードまたは自動ロードします。</p>\n\
<blockquote>\n\
<p><strong>注:</strong><span class=\'code\'>.py</span> にプラグイン スクリプトではない <span class=\'code\'>MAYA_PLUG_IN_PATH</span> スクリプトがあっても構いませんが、これらの項目はロードされません。エントリ ポイントが見つからないという内容の警告メッセージが発行されます。</p>\n\
</blockquote>\n\
<p>プラグインは、プラグイン マネージャから、または MEL あるいは Python のコマンド タブからロードできます。 MEL では、<span class=\'code\'>loadPlugin()</span> コマンドを使用します。Python では、<span class=\'code\'>maya.cmds.loadPlugin()</span> コマンドを使用します。</p>\n\
<p><span class=\'code\'>helixCmd.py</span> などのサンプルを実行するには、プラグインをロードし、Python エディタ(Python Editor)のタブに次を入力します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya\n\
maya.cmds.spHelix().\n\
\n\
</pre></div><p>この Python スクリプトを起動すると、次が実行されます。</p>\n\
<ul>\n\
<li>Maya モジュールがインポートされ、<span class=\'code\'>cmds</span> モジュールが使用可能になります。</li>\n\
<li>カスタム コマンド <span class=\'code\'>spHelix()</span> が起動されます。</li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>注:</strong> - <span class=\'code\'>sp</span> プリフィックスは、「スクリプト プラグイン」に使用します。 - スクリプト プラグインは、loadPlugin コマンドを使用してロードする必要があります。スクリプト プラグインのソースを実行してもロードされません。</p>\n\
</blockquote>\n\
<p>このプラグインは、Python コマンド <span class=\'code\'>maya.cmds.unloadPlugin(&quot;helixCmd.py&quot;)</span> を使用してアンロードすることもできます。</p>\n\
<p>ロードと実行の手順は、MEL エディタ内でも次を使用して起動できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">loadPlugin helixCmd.py;\n\
spHelix();\n\
\n\
</pre></div><div class=\'section\'><a id=\"スクリプト-プラグインを作成する\"></a><h3 id=\"スクリプト-プラグインを作成する\">スクリプト プラグインを作成する</h3></div>\n\
<p>スクリプト プラグインの作成には、プラグイン内で専用の関数を定義することが必要です。スクリプト プラグインは次を行う必要があります。</p>\n\
<ul>\n\
<li><span class=\'code\'>initializePlugin</span> および <span class=\'code\'>uninitializePlugin</span> エントリ ポイントを定義します。</li>\n\
<li>これらのエントリ ポイント内で、プロキシ クラスを登録および登録解除します。</li>\n\
<li>必要に応じて、プロキシ クラス構築のためにコールされる creator メソッドと initialize メソッドを実装します。</li>\n\
<li>プロキシ クラスで必要な機能を実装します。これには、必要なモジュールの読み込みが必須です。</li>\n\
</ul>\n\
<p>以下のセクションで、これらの項目についてサンプルとともに詳しく説明します。</p>\n\
<div class=\'section\'><a id=\"読み込み\"></a><h4 id=\"読み込み\">読み込み</h4></div>\n\
<p>Python は import キーワードを使用して、機能をモジュールからスクリプトにインクルードします。例:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import sys\n\
\n\
</pre></div><p>スクリプト プラグインが複数のファイルに分割されていてもかまいません。import コマンドは、2 次ファイルの機能をスクリプト プラグインにロードするために使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import polyModifier\n\
\n\
</pre></div><p>すべての 2 次スクリプトは、スクリプト プラグインと同じディレクトリに配置する必要があります。</p>\n\
<div class=\'section\'><a id=\"スクリプト-プラグインを初期化する\"></a><h4 id=\"スクリプト-プラグインを初期化する\">スクリプト プラグインを初期化する</h4></div>\n\
<p>スクリプト プラグインがロードされると、Maya は定義内の <span class=\'code\'>initializePlugin()</span> 関数を検索します。この関数にすべてのプロキシ ノードが登録されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># Initialize the script plug-in\n\
def initializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to register command: %s\\n&quot; % kPluginCmdName )\n\
        raise\n\
\n\
</pre></div><p><span class=\'code\'>initializePlugin()</span> 関数が見つからない場合は、スクリプト プラグインのロードが失敗します。また、Maya はロード時に <span class=\'code\'>uninitializePlugin()</span> 関数も検索します。これが見つからない場合、スクリプト プラグインのロードは失敗します。</p>\n\
<div class=\'section\'><a id=\"スクリプト-プラグインの初期化を解除する\"></a><h4 id=\"スクリプト-プラグインの初期化を解除する\">スクリプト プラグインの初期化を解除する</h4></div>\n\
<p>Maya は、プラグインのアンロード試行時に、あらかじめ見つけておいた <span class=\'code\'>uninitializePlugin()</span> 関数を呼び出して、プラグインのリソースをアンロードします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def uninitializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to unregister command: %s\\n&quot; % kPluginCmdName )\n\
        raise\n\
\n\
</pre></div><div class=\'section\'><a id=\"クリエータ関数\"></a><h4 id=\"クリエータ関数\">クリエータ関数</h4></div>\n\
<p>クリエータ関数は、派生したバージョンのプロキシ クラスを Maya に返すために使用します。バーチャル メソッドが Maya からコールする派生クラスに実装されます。以下は、クラス定義とクリエータ関数の例です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class scriptedCommand(OpenMayaMPx.MPxCommand):\n\
    # ...\n\
def cmdCreator():\n\
    return OpenMayaMPx.asMPxPtr( scriptedCommand() )\n\
\n\
</pre></div><p>新しく作成したプロキシ オブジェクト上で <span class=\'code\'>OpenMayaMPx.asMPxPtr()</span> を呼び出すことが非常に重要です。このコールにより、オブジェクトの所有権が Python から Maya に移行します。このコールを行わなければ、Python でこのオブジェクトの参照が解除され破棄されることがあるため、プログラム エラーが発生します。これにより、Maya にダングリング ポインタが残ります。</p>\n\
<div class=\'section\'><a id=\"クラスの実装\"></a><h4 id=\"クラスの実装\">クラスの実装</h4></div>\n\
<p>プロキシ クラスの実装には、Maya Python API オブジェクトからの派生が必要です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class scriptedCommand(OpenMayaMPx.MPxCommand):\n\
    def __init__(self):\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    def doIt(self,argList):\n\
        print &quot;Hello World!&quot;\n\
\n\
</pre></div><p><span class=\'code\'>scriptedCommand</span> クラスは <span class=\'code\'>OpenMayaMPx.MPxCommand</span> から派生しています。コンストラクタまたは <span class=\'code\'>__init__</span> メソッドは、親クラスの <span class=\'code\'>__init__</span> メソッドを呼び出す必要があります。すべてのクラス メソッドには、1 番目のパラメータとして <span class=\'code\'>self</span> が必要です。この後、通常の引数リストが続きます。このコマンドの <span class=\'code\'>doIt()</span> メソッドは「Hello World!」を出力します。</p>\n\
<div class=\'section\'><a id=\"初期化関数\"></a><h4 id=\"初期化関数\">初期化関数</h4></div>\n\
<p>初期化関数は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPxNode</a></span> クラスを使用して新しいプロキシ ノードを定義するスクリプト プラグイン内で使用します。次は、その出力がサイン関数である単純なスクリプト プラグイン ノードを作成する方法を示すサンプルです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import math, sys\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
kPluginNodeTypeName = &quot;spSineNode&quot;\n\
sineNodeId = OpenMaya.MTypeId(0x8700)\n\
\n\
# Node definition\n\
class sineNode(OpenMayaMPx.MPxNode):\n\
    # class variables\n\
    input = OpenMaya.MObject()\n\
    output = OpenMaya.MObject()\n\
    \n\
    def __init__(self):\n\
        OpenMayaMPx.MPxNode.__init__(self)\n\
        \n\
    def compute(self,plug,dataBlock):\n\
        if ( plug == sineNode.output ):\n\
            dataHandle = dataBlock.inputValue( sineNode.input )\n\
            \n\
            inputFloat = dataHandle.asFloat()\n\
            result = math.sin( inputFloat ) * 10.0\n\
            outputHandle = dataBlock.outputValue( sineNode.output )\n\
            outputHandle.setFloat( result )\n\
            dataBlock.setClean( plug )\n\
# creator\n\
def nodeCreator():\n\
    return OpenMayaMPx.asMPxPtr( sineNode() )\n\
    \n\
# initializer\n\
def nodeInitializer():\n\
    # input\n\
    nAttr = OpenMaya.MFnNumericAttribute()\n\
    sineNode.input = nAttr.create( &quot;input&quot;, &quot;in&quot;, OpenMaya.MFnNumericData.kFloat, 0.0 )\n\
    nAttr.setStorable(1)\n\
    # output\n\
    nAttr = OpenMaya.MFnNumericAttribute()\n\
    sineNode.output = nAttr.create( &quot;output&quot;, &quot;out&quot;, OpenMaya.MFnNumericData.kFloat, 0.0 )\n\
    nAttr.setStorable(1)\n\
    nAttr.setWritable(1)\n\
    # add attributes\n\
    sineNode.addAttribute( sineNode.input )\n\
    sineNode.addAttribute( sineNode.output )\n\
    sineNode.attributeAffects( sineNode.input, sineNode.output )\n\
    \n\
# initialize the script plug-in\n\
def initializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.registerNode( kPluginNodeTypeName, sineNodeId, nodeCreator, nodeInitializer )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to register node: %s&quot; % kPluginNodeTypeName )\n\
        raise\n\
        \n\
# uninitialize the script plug-in\n\
def uninitializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.deregisterNode( sineNodeId )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to register node: %s&quot; % kPluginNodeTypeName )\n\
        raise\n\
\n\
</pre></div><p><span class=\'code\'>nodeInitializer()</span> 関数は、<span class=\'code\'>initializePlugin()</span> 関数内の <span class=\'code\'>registerNode()</span> に渡されます。Maya はプラグインのロード時に <span class=\'code\'>nodeInitializer()</span> 関数を呼び出して、ノードのアトリビュートを作成します。</p>\n\
<div class=\'section\'><a id=\"エラー条件\"></a><h4 id=\"エラー条件\">エラー条件</h4></div>\n\
<p>Maya Python APIでは、スクリプトの状態の照会と設定に Python の例外を使用します。ほとんとのケースでは、あるメソッドに戻り値があるとクラスのマニュアルに示されていても、例外が使用されます。例外が発生しうる状況にはいろいろあります。</p>\n\
<ol>\n\
<li>コールが失敗し、失敗の状態を保持する必要がある場合。</li>\n\
</ol>\n\
<p>``` def uninitializePlugin(mobject): mplugin = OpenMayaMPx.MFnPlugin(mobject) try: mplugin.deregisterNode( sineNodeId ) except: sys.stderr.write( &quot;Failed to deregister node: %s&quot; % kPluginNodeTypeName ) raise</p>\n\
<p>```</p>\n\
<p>この例では、<span class=\'code\'>deregisterNode()</span> 呼び出しが失敗した場合、<span class=\'code\'>uninitializePlugin()</span> 呼び出しは Maya に例外を返してプラグインのアンロードが失敗します。</p>\n\
<ol>\n\
<li>コールが失敗し、失敗の状態をクリアする必要がある場合。</li>\n\
</ol>\n\
<p>このコードを修正してエラーをキャッチし、<span class=\'code\'>deregisterNode()</span> 呼び出しが失敗した場合でもプラグインのアンロードを許可することができます。</p>\n\
<p>``` def uninitializePlugin(mobject): mplugin = OpenMayaMPx.MFnPlugin(mobject) try: mplugin.deregisterNode( sineNodeId ) except: sys.stderr.write( &quot;Failed to deregister node: %s&quot; % kPluginNodeTypeName ) pass</p>\n\
<p>```</p>\n\
<p>唯一の違いは、<span class=\'code\'>raise</span> キーワードが <span class=\'code\'>pass</span> に変更されたことです。この技法は、正しくないオブジェクトを審査した場合に失敗するイテレータ コードを作成する場合に便利です。</p>\n\
<p>3. 不明なパラメータ戻り値。</p>\n\
<p>Maya Python API では、不明なパラメータ戻り値を使用してメソッドが特定のケースを処理できないことを示します。この操作を処理するかどうかは、コール元が決定します。このようなメソッドの 1 つに <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#a6e1aa1e50774080d5aee55f20ffa5503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#ae17c4b226f482e2d77c3f99375d1eea0&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPxNode::compute()</a></span> があります。この状況では、Python コードは <span class=\'code\'>OpenMaya.kUnknownParameter.</span> を返します。</p>\n\
<div class=\'section\'><a id=\"例外と-mstatus\"></a><h4 id=\"例外と-mstatus\">例外と MStatus</h4></div>\n\
<p>前のセクションで説明したとおり、Maya Python API では、ステータス情報をやり取りするために、MStatus の値ではなく例外が使用されます。C++ ドキュメントから API メソッドの Python 的な動作を推測する場合、下記のルールが適用されます。</p>\n\
<p>C++ API メソッドが MStatus 値を返す方法には、メソッドの返り値として返す方法と、</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a> someMethod(Type arg1, Type arg2, ...) \n\
\n\
</pre></div><p>パラメータ リストの MStatus 変数(通常、最後のパラメータ)へのオプション ポインタとして返す方法の 2 通りがあります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">Type someMethod(Type arg1, Type arg2, ..., <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a>* ReturnStatus = NULL) \n\
\n\
</pre></div><div class=\'section\'><a id=\"メソッドが関数値として-mstatus-を返す場合\"></a><h5 id=\"メソッドが関数値として-mstatus-を返す場合\">メソッドが関数値として MStatus を返す場合</h5></div>\n\
<p>メソッドが関数値として <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a></span> を返す場合、この戻り値は Python で次のように処理されます。</p>\n\
<ul>\n\
<li>ステータスが <span class=\'code\'>MS::kUnknownParameter</span> である場合は、文字列 <span class=\'code\'>unknown</span> が Python に返されます。</li>\n\
<li>ステータスが <span class=\'code\'>MS::kSuccess</span> である場合は、何も返されず、例外も発生しません。</li>\n\
<li>それ以外のステータスの場合は、何も返されませんが、<span class=\'code\'>RuntimeError</span> 例外が発生します。</li>\n\
</ul>\n\
<p><span class=\'code\'>MS::kUnknownParameter</span> を特別に処理するのは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#a6e1aa1e50774080d5aee55f20ffa5503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#ae17c4b226f482e2d77c3f99375d1eea0&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPxNode::compute()</a></span> に対応するためです。</p>\n\
<p>API 固有の特別な例外はありません。Maya は単に Python の標準 <span class=\'code\'>RuntimeError</span> を使用し、エラー文字列を引数として渡します。</p>\n\
<div class=\'section\'><a id=\"メソッドがポインタ変数を通じて-mstatus-を返す場合\"></a><h5 id=\"メソッドがポインタ変数を通じて-mstatus-を返す場合\">メソッドがポインタ変数を通じて MStatus を返す場合</h5></div>\n\
<p>API メソッドがパラメータ リストのポインタ変数を通じて <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a></span> を返す場合、この <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a></span> は次のように処理されます。</p>\n\
<ul>\n\
<li>ステータスが <span class=\'code\'>MS::kSuccess</span> である場合、例外は発生しません。</li>\n\
<li>それ以外のステータスの場合は、何も返されませんが、<span class=\'code\'>RuntimeError</span> 例外が発生します。</li>\n\
</ul>\n\
<p>つまり、C++ 言語でプラグインを記述する場合に、コードを呼び出しているのが C++ であるか Python であるかに関係なく、これまでどおり <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a></span> コードを返すことができます。Maya は必要に応じて、これらのコードを Python 例外に変換します。</p>\n\
<p>Python でプラグインを記述する場合は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a></span> 値を返すのではなく、例外を発生させる必要があります。ただし、<span class=\'code\'>compute()</span> メソッドでプラグを処理しないことを指示する場合を除きます。この場合、このメソッドは <span class=\'code\'>maya.OpenMaya.kUnknownParameter</span> を返します。</p>\n\
<div class=\'section\'><a id=\"クラスでスライスをサポートする\"></a><h4 id=\"クラスでスライスをサポートする\">クラスでスライスをサポートする</h4></div>\n\
<p>すべての数値配列(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_int_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MIntArray</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUintArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uint_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_uint_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MUintArray</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUint64Array\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_uint64_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_uint64_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MUint64Array</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFloatArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_float_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MFloatArray</a></span>、および <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_double_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MDoubleArray</a></span>)は、Python スタイルのスライスをサポートします。たとえば、次のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.OpenMaya as OpenMaya \n\
array = OpenMaya.MUintArray() \n\
for i in range(0,9):\n\
   array.append( i )\n\
array[2:8:2]\n\
\n\
</pre></div><p><span class=\'code\'># Result:[2, 4, 6] #</span></p>\n\
<div class=\'section\'><a id=\"mpx-クラスのスタティック-mobject-にアクセスする\"></a><h4 id=\"mpx-クラスのスタティック-mobject-にアクセスする\">MPx クラスのスタティック MObject にアクセスする</h4></div>\n\
<p>プロキシ クラスは、開発者に対し、使用されているノードについての標準的な情報を提供します。これには、ノードの定義に使用するアトリビュート オブジェクトが含まれます。Maya Python API でスタティック クラス <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MObject</a></span> にアクセスするために、類似のコードを使用できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">envelope = OpenMayaMPx.cvar.MPxDeformerNode_envelope\n\
\n\
</pre></div><p>この呼び出し後、エンベロープは <span class=\'code\'>MPxDeformerNode::envelope</span> の <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MObject</a></span> になります。</p>\n\
<div class=\'section\'><a id=\"メッセージ\"></a><h4 id=\"メッセージ\">メッセージ</h4></div>\n\
<p>Maya Python API では、メッセージ クラスをサポートしています。Python の関数が、コールバック用に渡されます。この関数は、コールバック メッセージが必要とするのとちょうど同じ数のパラメータを持つ必要があります。そうでない場合、メッセージ起動時に例外が発生し、コンソールに情報が書き出されます。ほとんどのメッセージと一緒に、Python オブジェクトの形式のクライアント データを渡すことができます。次はメッセージのサンプルです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># Message callback\n\
def dagParentAddedCallback( child, parent, clientData ):\n\
    print &quot;dagParentAddedCallback...&quot;\n\
    print &quot;\\tchild %s&quot; % child.fullPathName()\n\
    print &quot;\\tparent %s&quot; % parent.fullPathName()\n\
    print &quot;\\tclient data %s&quot; % clientData\n\
\n\
# Create the mesage\n\
def createParentAddedCallback(stringData):\n\
    try:\n\
        id = OpenMaya.MDagMessage.addParentAddedCallback( dagParentAddedCallback, stringData )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to install dag parent added callback\\n&quot; )\n\
        messageIdSet = False\n\
    else:\n\
        messageIdSet = True\n\
    return id\n\
# Call the message creator\n\
messageId = createParentAddedCallback( &quot;_noData_&quot; )\n\
\n\
</pre></div><div class=\'section\'><a id=\"割り当てを使用する代わりにパラメータ値を修正する\"></a><h4 id=\"割り当てを使用する代わりにパラメータ値を修正する\">割り当てを使用する代わりにパラメータ値を修正する</h4></div>\n\
<p>Python では、割り当てを使用する代わりにパラメータを修正するほうが適切です。 次のコードには割り当てが含まれており、その場合にどのようにエラーが発生しうるかを示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.OpenMaya as OpenMaya \n\
def vectorTest(v): \n\
    lv = OpenMaya.MVector(1,5,9) \n\
    v = lv \n\
    print &quot;%g %g %g&quot; % (v.x,v.y,v.z) \n\
v = OpenMaya.MVector() \n\
vectorTest(v) \n\
print &quot;%g %g %g&quot; % (v.x,v.y,v.z)\n\
\n\
</pre></div><p>2 番目の print コマンドは(0,0,0)を出力します。Python で、パラメータ値を修正するかコードを作成して、新しい値が返されるようにします。次のように <span class=\'code\'>vectorTest()</span> 関数を書き換えます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def vectorTest(v): \n\
    lv = OpenMaya.MVector(1,5,9) \n\
    v.x = lv.x\n\
    v.y = lv.y\n\
    v.z = lv.z\n\
    print &quot;%g %g %g&quot; % (v.x,v.y,v.z) \n\
\n\
</pre></div><div class=\'section\'><a id=\"基本型へのリファレンス\"></a><h4 id=\"基本型へのリファレンス\">基本型へのリファレンス</h4></div>\n\
<p>Maya Python API には、int&amp;、char&amp;、float&amp; など、基本型へのリファレンスとなる値またはパラメータを返すコールがたくさんあります。Maya Python API では、すべてのリファレンスはポインタとして扱われます。結果として、これらの項目の値を作成、設定、アクセスするには、特別なコールが必要になります。</p>\n\
<p>OpenMaya.py モジュールにある <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MScriptUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_script_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MScriptUtil</a></span> というユーティリティ クラスは、これらのタイプのパラメータおよび戻り値を使用するための手段を提供します。このクラスでは、データを作成してからそのデータへのポインタを取得してリファレンスを必要とするクラス メソッドに情報を渡すことができます。API リファレンス マニュアルの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MScriptUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_script_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MScriptUtil</a></span> を参照してください。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MScriptUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_script_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MScriptUtil</a></span> の使用法については、以下の例を参考にしてください。<span class=\'code\'>MFnLattice.getDivisions()</span> への呼び出しから x、y、z の値を取得する方法を示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaAnim as Anim\n\
xutil = OpenMaya.MScriptUtil()\n\
xutil.createFromInt(0)\n\
xptr = xutil.asUintPtr()\n\
yutil = OpenMaya.MScriptUtil()\n\
yutil.createFromInt(0)\n\
yptr = yutil.asUintPtr()\n\
zutil = OpenMaya.MScriptUtil()\n\
zutil.createFromInt(0)\n\
zptr = zutil.asUintPtr()\n\
it = OpenMaya.MItDependencyNodes(OpenMaya.MFn.kFFD)\n\
while not it.isDone():\n\
    latDefFn = Anim.MFnLatticeDeformer( it.thisNode() )\n\
    latFn = Anim.MFnLattice( latDefFn.deformLattice() )\n\
    latFn.getDivisions(xptr, yptr, zptr)\n\
    x = xutil.getUint(xptr)\n\
    y = yutil.getUint(yptr)\n\
    z = zutil.getUint(zptr)\n\
    doSomethingUseful(x, y, z)\n\
    it.next()\n\
\n\
</pre></div><p><span class=\'code\'>getUint()</span> は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MScriptUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_script_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MScriptUtil</a></span> のスタティック メソッドであるため、クラスから直接呼び出して最終値を取得することもできます。たとえば、次のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">x = OpenMaya.MScriptUtil.getUint(xptr)\n\
\n\
</pre></div><p>列挙型へのリファレンスは short int へのリファレンスとして扱う必要があります。</p>\n\
<div class=\'section\'><a id=\"フラグ付きコマンド\"></a><h4 id=\"フラグ付きコマンド\">フラグ付きコマンド</h4></div>\n\
<p>フラグ付きコマンドは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MSyntax</a></span> オブジェクトを使用して構文を指定し、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MArgParser</a></span> クラスまたは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MArgDatabase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_database.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_database.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MArgDatabase</a></span> クラスを使用してフラグを解析する必要があります。そうしないと、Python からコマンドを使用するときにフラグにアクセスできません。これは、Python と C++ のどちらで記述されたかに関係なく同じです。次は、フラグ付きコマンドを実装したプラグインの記述例です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import sys, math\n\
kPluginCmdName=&quot;spHelix&quot;\n\
kPitchFlag = &quot;-p&quot;\n\
kPitchLongFlag = &quot;-pitch&quot;\n\
kRadiusFlag = &quot;-r&quot;\n\
kRadiusLongFlag = &quot;-radius&quot;\n\
\n\
# command\n\
class scriptedCommand(OpenMayaMPx.MPxCommand):\n\
    def __init__(self):\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        deg = 3\n\
        ncvs = 20\n\
        spans = ncvs - deg\n\
        nknots = spans+2*deg-1\n\
        radius = 4.0\n\
        pitch = 0.5\n\
        \n\
        # Parse the arguments.\n\
        argData = OpenMaya.MArgDatabase(self.syntax(), args)\n\
        if argData.isFlagSet(kPitchFlag):\n\
            pitch = argData.flagArgumentDouble(kPitchFlag, 0)\n\
        if argData.isFlagSet(kRadiusFlag):\n\
            radius = argData.flagArgumentDouble(kRadiusFlag, 0)\n\
        controlVertices = OpenMaya.MPointArray()\n\
        knotSequences = OpenMaya.MDoubleArray()\n\
        \n\
        # Set up cvs and knots for the helix\n\
        for i in range(0, ncvs):\n\
            controlVertices.append( OpenMaya.MPoint( radius * math.cos(i),\n\
                pitch * i, radius * math.sin(i) ) )\n\
        for i in range(0, nknots):\n\
            knotSequences.append( i )\n\
        \n\
        # Now create the curve\n\
        curveFn = OpenMaya.MFnNurbsCurve()\n\
        \n\
        nullObj = OpenMaya.MObject()\n\
        try:\n\
            # This plugin normally creates the curve by passing in the\n\
            # cv&#39;s. A function to create curves by passing in the ep&#39;s\n\
            # has been added. Set this to False to get that behaviour.\n\
            if True:\n\
                curveFn.create( controlVertices, knotSequences, deg, OpenMaya.MFnNurbsCurve.kOpen, 0, 0, nullObj )\n\
            else:\n\
                curveFn.createWithEditPoints(controlVertices, 3, OpenMaya.MFnNurbsCurve.kOpen, False, False, False)\n\
        except:\n\
            sys.stderr.write( &quot;Error creating curve.\\n&quot; )\n\
            raise\n\
# Creator\n\
def cmdCreator():\n\
    # Create the command\n\
    return OpenMayaMPx.asMPxPtr( scriptedCommand() )\n\
\n\
# Syntax creator\n\
def syntaxCreator():\n\
    syntax = OpenMaya.MSyntax()\n\
    syntax.addFlag(kPitchFlag, kPitchLongFlag, OpenMaya.MSyntax.kDouble)\n\
    syntax.addFlag(kRadiusFlag, kRadiusLongFlag, OpenMaya.MSyntax.kDouble)\n\
    return syntax\n\
\n\
# Initialize the script plug-in\n\
def initializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject, &quot;Autodesk&quot;, &quot;1.0&quot;, &quot;Any&quot;)\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to register command: %s\\n&quot; % kPluginCmdName )\n\
        raise\n\
        \n\
# Uninitialize the script plug-in\n\
def uninitializePlugin(mobject):\n\
    mplugin = OpenMayaMPx.MFnPlugin(mobject)\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to unregister command: %s\\n&quot; % kPluginCmdName )\n\
        raise\n\
\n\
</pre></div><p>このサンプルでは、クラスの <span class=\'code\'>doIt()</span> メソッドに、シンタックス クリエータ関数とパース処理が含まれています。</p>\n\
<div class=\'section\'><a id=\"保護されたメソッド\"></a><h4 id=\"保護されたメソッド\">保護されたメソッド</h4></div>\n\
<p>Maya Python API には、メソッドが所属するクラスからのみコールされるメソッドがいくつか含まれています。Maya では、この保護がメソッドに適用されることを示すため、Python の指定に従って _ を付加しています。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPxNode</a></span> クラスに、このようなメソッドのサンプルがいくつかあります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">_forceCache()\n\
_setMPSafe()\n\
\n\
</pre></div><p>Maya Python API 内では、保護されたメソッドの使用の要件を守ってください。</p>\n\
<div class=\'section\'><a id=\"mpx-ベースのオブジェクトから派生したオブジェクトを取得する\"></a><h4 id=\"mpx-ベースのオブジェクトから派生したオブジェクトを取得する\">MPx ベースのオブジェクトから派生したオブジェクトを取得する</h4></div>\n\
<p>API メソッドによっては、カスタム オブジェクトを派生クラスのインスタンスではなく、<span class=\'code\'>MPx</span> ベース クラスのインスタンスとして返します。たとえば、<span class=\'code\'>MPxContext._newToolCommand()</span> はカスタム ツール コマンドを <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxToolCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_tool_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_tool_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPxToolCommand</a></span> オブジェクトとして返し、<span class=\'code\'>MPxSurfaceShapeUI.surfaceShape()</span> はカスタム サーフェス シェイプを <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPxSurfaceShape</a></span> オブジェクトとして返します。これらのベース インスタンスはオリジナルの派生インスタンスと同じ内部 Maya オブジェクトを参照しますが、派生インスタンスに設定されたメンバー変数の値をまったく保持しない個別の Python オブジェクトです。このため、返されたオブジェクトのメンバー変数をコールまたはアクセスすると、不正な結果が生じることがあります。</p>\n\
<p>この問題は、<span class=\'code\'>OpenMayaMPx.asHashable()</span> 関数のプロパティを利用して解決できます。<span class=\'code\'>OpenMayaMPx.asHashable()</span> は <span class=\'code\'>MPx</span> オブジェクトを取り、Maya の基本オブジェクトを一意に識別するハッシュ値を返します。これは、オブジェクトが <span class=\'code\'>MPx</span> ベース クラスのインスタンスであるか、派生クラスのインスタンスであるかには関係ありません。両方が Maya の同じ基本オブジェクトを参照していれば、同じハッシュ値を返します。これにより、ベース インスタンスを該当する派生インスタンスに翻訳できる辞書を設定することができます。</p>\n\
<p>これにはまず、空の辞書をクラスに追加します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class MoveToolCmd(OpenMayaMPx.MPxToolCommand):\n\
    kTrackingDictionary = {}\n\
\n\
</pre></div><p>このクラスの <span class=\'code\'>__init__</span> メソッド内で、ディクショナリにエントリを追加し、新しいオブジェクトのハッシュ値をオブジェクト自体にマッピングします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def __init__(self): \n\
    OpenMayaMPx.MPxToolCommand.__init__(self)\n\
    MoveToolCmd.kTrackingDictionary[OpenMayaMPx.asHashable(self)] = self \n\
\n\
\n\
</pre></div><p>クラスの <span class=\'code\'>__del__</span> メソッド内で、ディクショナリから削除されたオブジェクトを除去します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def __del__(self): \n\
    del MoveToolCmd.kTrackingDictionary[OpenMayaMPx.asHashable(self)] \n\
\n\
\n\
</pre></div><p>これでトラッキング ディクショナリができたので、これを利用して該当するベース オブジェクトから派生したオブジェクトを読み出すことができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class MoveContext(OpenMayaMPx.MPxSelectionContext): \n\
    ... \n\
    \n\
    def doPress(self, event): \n\
\n\
        # Create an instance of the move tool command. \n\
        baseCmd = self._newToolCommand() \n\
        derivedCmd = MoveToolCmd.kTrackingDictionary.get( \n\
                        OpenMayaMPx.asHashable(baseCmd), None \n\
                     ) \n\
\n\
        # Call its methods.\n\
        derivedCmd.setVector(0.0, 0.0, 0.0) \n\
\n\
\n\
</pre></div><p>カスタム ノード タイプ(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPxNode</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShape\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_surface_shape.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPxSurfaceShape</a></span> など)の定義には、追加作業が必要です。Maya でファイルを開く、または新規ファイルの操作を行うときに、各ノードで __del__ method を実行しなければシーンが破損します。つまり、これらのノードのエントリはトラッキング ディクショナリからは削除されないということです。これを回避するには、initializePlugin メソッドでコールバックをセットアップし、ファイルのオープンと新規ファイルの作成のトラッキング ディクショナリをクリアする必要があります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">fileOpenCB = 0\n\
fileNewCB = 0\n\
\n\
def clearTrackingDictionaries(unused):\n\
    MyNode.kTrackingDictionary = {} \n\
    MySurfaceShape.kTrackingDictionary = {}\n\
\n\
def initializePlugin(plugin): \n\
    ... \n\
    fileOpenCB = OpenMaya.MSceneMessage.addCallback(\n\
                     OpenMaya.MSceneMessage.kBeforeOpen, \n\
                     clearTrackingDictionaries \n\
                 )\n\
    fileNewCB  = OpenMaya.MSceneMessage.addCallback(\n\
                     OpenMaya.MSceneMessage.kBeforeNew, \n\
                     clearTrackingDictionaries \n\
                 )\n\
    ...\n\
}\n\
\n\
def uninitializePlugin(plugin): \n\
    ... \n\
    if fileOpenCB != 0:\n\
        OpenMaya.MSceneMessage.removeCallback(fileOpenCB) \n\
        fileOpenCB = 0 \n\
\n\
    if fileNewCB != 0: \n\
        OpenMaya.MSceneMessage.removeCallback(fileNewCB)\n\
        fileNewCB = 0\n\
\n\
</pre></div><div class=\'section\'><a id=\"オペレーティング-システム-タイプ\"></a><h4 id=\"オペレーティング-システム-タイプ\">オペレーティング システム タイプ</h4></div>\n\
<p>Maya Python API の一部のメソッドでは、<span class=\'code\'>&lt;iosteam&gt;</span> オペレーティング システム タイプが必要です。これらは Python に含まれていないので、このようなタイプのオブジェクトを作成して使用するための <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStreamUtils\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_stream_utils.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStreamUtils</a></span> クラスが用意されています。このクラスの使用法を示すサンプルについては、Developer Kit を参照してください。</p>\n\
<div class=\'section\'><a id=\"親クラスへのコール\"></a><h4 id=\"親クラスへのコール\">親クラスへのコール</h4></div>\n\
<p>MPx プロキシ クラスを作成する場合、スクリプトで親クラスへのコールが必要になることがあります。これは次のような表記法で行います。</p>\n\
<p><span class=\'code\'>matrix = OpenMayaMPx.MPxTransformationMatrix.asMatrix(self)</span></p>\n\
<div class=\'section\'><a id=\"enum-値\"></a><h4 id=\"enum-値\">Enum 値</h4></div>\n\
<p>Enum 値は、次のように moduleName.className.value 表記法でアクセスすることができます。</p>\n\
<p><span class=\'code\'>OpenMaya.MSyntax.kDouble</span></p>\n\
<div class=\'section\'><a id=\"opengl-を使用する\"></a><h4 id=\"opengl-を使用する\">OpenGL を使用する</h4></div>\n\
<p>サポートするすべてのプラットフォームで、OpenGL 機能をスクリプトで使用するためのラッパ(wrapper)クラス <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGLFunctionTable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_l_function_table.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MGLFunctionTable</a></span> を提供しています。このクラスへのリファレンスを取得するには、次のコードを使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">glRenderer = OpenMayaRender.MHardwareRenderer.theRenderer()\n\
glFT = glRenderer.glFunctionTable()\n\
\n\
</pre></div><div class=\'section\'><a id=\"ネストされたイテレータとガベージ-コレクション\"></a><h4 id=\"ネストされたイテレータとガベージ-コレクション\">ネストされたイテレータとガベージ コレクション</h4></div>\n\
<p>ネストされたイテレータを記述する場合、通常、外側のループで現在選択されている項目は、内側のループに渡されます。たとえば、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MItSelectionList</a></span> で現在選択されている項目は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItSurfaceCV\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_surface_c_v.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_surface_c_v.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MItSurfaceCV</a></span> イテレータに渡されます。内側のイテレータに、無効になった情報が保持されている場合には、ガベージ コレクションの問題が発生する可能性があります。この問題を回避するには、内側のループが完了したら、内側のイテレータをなし(None)にリセットします。この結果、外側のループを継続する前に、内側のイテレータの情報がリリースされます。現在選択されている項目をリビルドまたは更新している場合にはこれが重要です。</p>\n\
<div class=\'section\'><a id=\"スタンドアローン型スクリプト\"></a><h2 id=\"スタンドアローン型スクリプト\">スタンドアローン型スクリプト</h2></div>\n\
<p>ラッパ クラスと関数セットを使用して Maya モデルを修正するためのスタンドアローン型スクリプトを作成できます。このスクリプトはコマンドラインから実行します。単純なスタンドアローン型「hello world」スクリプトは次のとおりです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.standalone\n\
import maya.OpenMaya as OpenMaya\n\
import sys\n\
def main( argv = None ):\n\
    try:\n\
        maya.standalone.initialize( name=&#39;python&#39; )\n\
    except:\n\
        sys.stderr.write( &quot;Failed in initialize standalone application&quot; )\n\
        raise\n\
    sys.stderr.write( &quot;Hello world! (script output)\\n&quot; )\n\
    OpenMaya.MGlobal().executeCommand( &quot;print \\&quot;Hello world! (command script output)\\\\n\\&quot;&quot; )\n\
    maya.standalone.uninitialize()\n\
    \n\
if __name__ == &quot;__main__&quot;:\n\
    main()\n\
\n\
</pre></div><p>スタンドアローン型スクリプトが初期化された後、Maya コマンドと API クラスを使用して Maya モデルの作成や修正をすることができます。終了後、スタンドアローンは非初期化され、その後に Maya がクリーンアップできるようになります。<span class=\'code\'>initialize()</span> を呼び出す前、または <span class=\'code\'>uninitialize()</span> を呼び出した後に Maya コマンドまたは API クラスを使用しないでください。動作が不安定になる可能性があります。</p>\n\
<p>スタンドアローン スクリプトの実行では、Maya と共に提供される Python 実行可能ファイルを使用する必要があります。たとえば、次のようになります。</p>\n\
<p><span class=\'code\'>$MAYA_LOCATION/bin/mayapy helloWorld.py</span></p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";