var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>初めての Maya Python プラグイン</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>初めての Maya Python プラグイン</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"初めての-maya-python-プラグイン\"></a></div>\n\
<p>このトピックは、初めて Maya Python プラグインを作成して実行する場合の手順について説明します。</p>\n\
<div class=\'section\'><a id=\"オプション-maya-プラグイン環境変数を設定する\"></a><h2 id=\"オプション-maya-プラグイン環境変数を設定する\">(オプション) Maya プラグイン環境変数を設定する</h2></div>\n\
<p>既定では、Maya は 次のディレクトリに配置されたプラグインをロードしようとします。</p>\n\
<ul>\n\
<li>(Windows)<span class=\'code\'>C:/Users/&lt;username&gt;/Documents/maya/&lt;version&gt;/plug-ins</span></li>\n\
<li>(Mac OS X)<span class=\'code\'>Library/Preferences/Autodesk/maya/&lt;version&gt;/plug-ins</span></li>\n\
<li>(Linux) <span class=\'code\'>$MAYA_APP_DIR/maya/&lt;version&gt;/plug-ins</span></li>\n\
</ul>\n\
<p />この詳細は、次の通りになります。<version>は Maya のバージョンを表します(<em>Maya2016</em> など)。<p />\n\
<p>Maya がプラグインをロードする既定の場所は複数存在する場合があります。詳細については、Maya ユーザ ガイドの「<strong>環境変数」セクションの「</strong>ファイル パス変数」を参照してください。また、この環境変数を設定するフォルダのリストのコマンド ラインに <span class=\'code\'>getenv MAYA_PLUG_IN_PATH</span> と入力することもできます。</p>\n\
<p>オプションで、<span class=\'code\'>MAYA_PLUG_IN_PATH</span> 環境変数の追加フォルダを定義し、これらのフォルダからプラグインをロードすることができます。</p>\n\
<p>Windows 7 の場合は、スタートメニューを開き、検索ボックスに「<span class=\'code\'>env</span>」と入力し、[Enter]キーを押します。<span class=\'code\'>User variables</span> セクションで「新規(New)」ボタンをクリックし、変数名として「<span class=\'code\'>MAYA_PLUG_IN_PATH</span>」を入力します。選択するパスに変数値を設定します。後でこのパスにスクリプトを格納します。たとえば、変数値「<span class=\'code\'>%USERPROFILE%\\Documents\\scripts</span>」は、現在のユーザの My Documents\\scripts フォルダに対応します。複数のパスを指定するには、変数値をセミコロン「<span class=\'code\'>;</span>」で区切ります。</p>\n\
<p>Maya を起動すると、<span class=\'code\'>MAYA_PLUG_IN_PATH</span> に含まれるフォルダが<strong>ウィンドウ &gt; 設定/プリファレンス &gt; プラグイン マネージャ(Window &gt; Settings/Preferences &gt; Plug-in Manager)</strong>に別のセクションとして表示されます。</p>\n\
<p>スクリプト エディタを使用して Python プラグインを作成する</p>\n\
<p>Python および MEL Script Editor (Python and MEL Script Editor)ウィンドウは、<strong>ウィンドウ &gt; 一般エディタ &gt; スクリプト エディタ(Window &gt; General Editors &gt; Script Editor)</strong>にあります。Python プラグインは任意の外部テキスト エディタを使用して作成することもできますが、このトピックでは Maya にビルトインされた対話型スクリプト エディタを使用した手順を説明します。</p>\n\
<p>スクリプト エディタの Python タブに、以下のプラグイン コードをペーストしてください。このコードは、呼び出されると「Hello World!」をスクリプト エディタに出力する単純なコマンドを作成します。その他の Python プラグインのサンプル(以下を含む)は、Developer Kit インストールの devkit/plug-ins/scripted フォルダにあります(「<a href=\'#!/url=./dev_help/Setting-up-your-build/Windows-environment-64-bit-.html\' title=\'\'>ビルド環境を設定する: Windows 環境(64 ビット)</a>」を参照してください)。2.0 API を使用するプラグインの名前は、pyHelloWorldCmd.py などのように、&#39;py&#39; ではじまります。 次のトピックでは、プラグインのプログラム構造を説明します。ここでは、最初のプラグインの実行に焦点を置きます。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import sys\n\
import maya.api.OpenMaya as om\n\
\n\
def maya_useNewAPI():\n\
    &quot;&quot;&quot;\n\
    The presence of this function tells Maya that the plugin produces, and\n\
    expects to be passed, objects created using the Maya Python API 2.0.\n\
    &quot;&quot;&quot;\n\
    pass\n\
\n\
\n\
# command\n\
class PyHelloWorldCmd(om.MPxCommand):\n\
    kPluginCmdName = &quot;pyHelloWorld&quot;\n\
\n\
    def __init__(self):\n\
        om.MPxCommand.__init__(self)\n\
\n\
    @staticmethod\n\
    def cmdCreator():\n\
        return PyHelloWorldCmd()\n\
\n\
    def doIt(self, args):\n\
        print &quot;Hello World!&quot;\n\
\n\
\n\
# Initialize the plug-in\n\
def initializePlugin(plugin):\n\
    pluginFn = om.MFnPlugin(plugin)\n\
    try:\n\
        pluginFn.registerCommand(\n\
            PyHelloWorldCmd.kPluginCmdName, PyHelloWorldCmd.cmdCreator\n\
        )\n\
    except:\n\
        sys.stderr.write(\n\
            &quot;Failed to register command: %s\\n&quot; % PyHelloWorldCmd.kPluginCmdName\n\
        )\n\
        raise\n\
\n\
\n\
# Uninitialize the plug-in\n\
def uninitializePlugin(plugin):\n\
    pluginFn = om.MFnPlugin(plugin)\n\
    try:\n\
        pluginFn.deregisterCommand(PyHelloWorldCmd.kPluginCmdName)\n\
    except:\n\
        sys.stderr.write(\n\
            &quot;Failed to unregister command: %s\\n&quot; % PyHelloWorldCmd.kPluginCmdName\n\
        )\n\
        raise\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import sys\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
\n\
# command\n\
class HelloWorldCmd(OpenMayaMPx.MPxCommand):\n\
    kPluginCmdName = &quot;spHelloWorld&quot;\n\
\n\
    def __init__(self):\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
\n\
    @staticmethod\n\
    def cmdCreator():\n\
        return OpenMayaMPx.asMPxPtr( HelloWorldCmd() )\n\
\n\
    def doIt(self,argList):\n\
        print &quot;Hello World!&quot;\n\
\n\
\n\
# Initialize the script plug-in\n\
def initializePlugin(plugin):\n\
    pluginFn = OpenMayaMPx.MFnPlugin(plugin)\n\
    try:\n\
        pluginFn.registerCommand(\n\
            HelloWorldCmd.kPluginCmdName, HelloWorldCmd.cmdCreator\n\
        )\n\
    except:\n\
        sys.stderr.write(\n\
            &quot;Failed to register command: %s\\n&quot; % HelloWorldCmd.kPluginCmdName\n\
        )\n\
        raise\n\
\n\
# Uninitialize the script plug-in\n\
def uninitializePlugin(plugin):\n\
    pluginFn = OpenMayaMPx.MFnPlugin(plugin)\n\
    try:\n\
        pluginFn.deregisterCommand(HelloWorldCmd.kPluginCmdName)\n\
    except:\n\
        sys.stderr.write(\n\
            &quot;Failed to unregister command: %s\\n&quot; % HelloWorldCmd.kPluginCmdName\n\
        )\n\
        raise\n\
</pre></div><p>スクリプト エディタ(Script Editor)ウィンドウで、<strong>ファイル &gt; スクリプトの保存(File &gt; Save Script)</strong>を選択します。ファイル名を <span class=\'code\'>myFirstPlugin.py</span> (拡張子 .py は省略可能。自動的に追加されます)に設定し、スクリプトを <span class=\'code\'>C:\\Users\\&lt;username&gt;\\Documents\\maya\\&lt;version&gt;\\plug-ins</span> フォルダまたは <span class=\'code\'>MAYA_PLUG_IN_PATH</span> 環境変数で定義したフォルダの 1 つに保存します。</p>\n\
<p>新規保存したスクリプトを Maya が認識しているか確認するには、プラグイン マネージャ(Plug-in Manager)ウィンドウに、<strong>ウィンドウ &gt; 設定/プリファレンス &gt; プラグイン マネージャ(Window &gt; Settings/Preferences &gt; Plug-in Manager)</strong>でアクセスし、更新(Refresh)ボタンを押します。プラグイン ファイルはここに表示されます。ロード(Loaded)または自動ロード(Auto load)チェックボックスはここではオンにしないでください。</p>\n\
<div class=\'section\'><a id=\"python-プラグインをロードする\"></a><h2 id=\"python-プラグインをロードする\">Python プラグインをロードする</h2></div>\n\
<p>新規作成されたプラグインを Maya にロードするには、2 つの方法があります。</p>\n\
<ul>\n\
<li><strong>プログラムを使用</strong>: スクリプト エディタで、以前の Python コードを削除します。ここで次のコード行を書き、スクリプト エディタのツールバー上の青色の実行(Play)ボタンを使用してコードを実行します。</li>\n\
</ul>\n\
<p><span class=\'code\'>import maya.cmds    maya.cmds.loadPlugin(&quot;myFirstPlugin.py&quot;)</span></p>\n\
<p>プラグイン マネージャ(Plug-in Manager)ウィンドウを表示したときに、プラグインのロード(Loaded)チェックボックスがオンになっていることを確認します。 - <strong>手動</strong>: プラグイン マネージャ(Plug-in Manager)ウィンドウ内で、ロード(Loaded)および自動ロード(Auto load)チェックボックスをオンにすることができます。ロード(Loaded)チェックボックスをオンにするとプラグインがロードされ、自動ロード(Auto load)チェックボックスをオンにすると、Maya を起動したときに自動的にプラグインがロードされるようになります。ロード(Loaded)チェックボックスを一度オフにしてから再度オンにするとプラグインがリロードされます。これは、コードのテストやデバッグの際に便利です。</p>\n\
<div class=\'section\'><a id=\"python-プラグインを起動する\"></a><h2 id=\"python-プラグインを起動する\">Python プラグインを起動する</h2></div>\n\
<p>ここで作成したのは、「Command」プラグインです。つまり、このプラグインは、呼び出されたときに「Hello World!」を出力する新しいコマンドを定義します。プラグインが適切にロードされると、新しい MEL コマンドとして表示されます。また、Python モジュール <span class=\'code\'>maya.cmds</span> 内の新しい関数として表示されます。このモジュールはすべての利用可能な Maya Python コマンド(利用可能な MEL コマンドのサブセット)を定義します。コマンドを実行するには、スクリプト エディタ内で次のコードを実行します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.spHelloWorld()\n\
</pre></div><p>スクリプト エディタには次の行が表示されます。ここには、「Hello World!」という出力とともにコマンドがエコーされます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.spHelloWorld()\n\
Hello World!\n\
</pre></div><p>これで 初めての Maya Python プラグインが実行されました。</p>\n\
</version>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";