var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Python API 2.0 を使用する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Python API 2.0 を使用する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"python-api-2.0-を使用する\"></a></div>\n\
<div class=\'section\'><a id=\"python-api-2.0-を使用する-1\"></a><h2 id=\"python-api-2.0-を使用する-1\">Python API 2.0 を使用する</h2></div>\n\
<p>新しい Python API モジュールは、<span class=\'code\'>maya.api</span> 内にあります。例:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya as om\n\
</pre></div><p>モジュール名は古い API と同じですが、プロキシ クラス(<em>MPx</em> で始まるクラス)は、それ自身のモジュールを持たず、他の関連クラスと同じモジュールに常駐します。これは、より C++ API に似た構造になっています。</p>\n\
<p>クラス名は、古い Python API および C++ API の場合と同じです。 メソッド名はほとんど同じで、ワークフローに影響する場合にいくつかの違いがあります。 単にオブジェクト上で値を取得または設定するメソッドのいくつかは、Python オブジェクト アトリビュートに置き換えられました。</p>\n\
<p>新しい API クラスと古い API クラスを同じスクリプト内で使用することができますが、それらのオブジェクトには相互運用性はありません。 したがって、以下は実行可能です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya as newOM\n\
import maya.OpenMaya as oldOM\n\
\n\
newAttrObj = newOM.MObject()\n\
oldNodeObj = oldOM.MObject()\n\
\n\
#...\n\
\n\
newAttrFn = newOM.MFnAttribute(newAttrObj)\n\
oldNodeFn = oldOM.MFnDependencyNode(oldNodeObj)\n\
    \n\
# OKAY: Print names from old and new function sets.\n\
print(&quot;Attribute name is %s.%s&quot; % (oldNodeFn.name(), newAttrFn.name))\n\
</pre></div><p>しかし、以下は実行できません。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.api.OpenMaya as newOM\n\
import maya.OpenMaya as oldOM\n\
\n\
newAttrObj = newOM.MObject()\n\
oldNodeObj = oldOM.MObject()\n\
\n\
#...\n\
\n\
# BAD: Passing an old API <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MObject</a> to a new API method.\n\
newPlug = newOM.MPlug(oldNodeObj, newAttrObj)\n\
</pre></div><p>クラスとメソッド名が 2 つの API 間でまったく同一の場合、混乱の可能性が高くなります。したがって、可能であればそれらを混用しないでください。</p>\n\
<p>新しい API を使用するプラグインを記述する場合、プラグインは maya_useNewAPI と呼ばれる関数を定義しなければなりません。これによって、Maya は、古い API からではなく新しい API からオブジェクトをプラグインに渡すことができます。 次に例を示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def maya_useNewAPI():\n\
    pass\n\
</pre></div><p>Maya のヘルプ メニューから利用可能なオンラインのコメント送付サイト、および Autodesk Developer Network を利用し、この新しい Python API についてのフィードバックをぜひお寄せください。</p>\n\
<p>Python 2.0 クラスのリストについては、「Maya Python API 2.0 リファレンス」を参照してください。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";