var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>コマンド引数とフラグ</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>コマンド引数とフラグ</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"コマンド引数とフラグ\"></a></div>\n\
<p>このトピックでは、コマンドの引数とフラグの使用について説明します。</p>\n\
<div class=\'section\'><a id=\"フラグとコマンド引数\"></a><h2 id=\"フラグとコマンド引数\">「フラグ」と「コマンド引数」</h2></div>\n\
<p>Maya API マニュアルのコンテキストでは、「フラグ」と「コマンド引数」という用語が特定の意味を持っています。これらの用語の意味を次に説明します。</p>\n\
<ul>\n\
<li><strong>「フラグ」</strong>:フラグは、コマンドの通常の動作のオプションです。各フラグには、ロング ネームとショート ネームがあります。MEL コマンドで使用する場合は、フラグの前にハイフン(「<span class=\'code\'>-</span>」)が付加されます。Python の場合、フラグは、ハイフンのない名前付き関数引数として表示されます。次の例では、「<span class=\'code\'>sx</span>」、「<span class=\'code\'>sy</span>」、「<span class=\'code\'>sz</span>」、「<span class=\'code\'>h</span>」フラグが、各軸のサブディビジョンの数と <span class=\'code\'>cmds.polyCube()</span> で作成した立方体の高さを指定しています。</li>\n\
</ul>\n\
<p><span class=\'code\'>import maya.cmds as cmds    cmds.polyCube( sx=10, sy=15, sz=5, h=20 )</span></p>\n\
<blockquote>\n\
<p><strong>注:</strong> 単一のフラグは、値のタプル(たとえば、カラーの <span class=\'code\'>(r,g,b)</span> 値)も受け入れることができます。タプルの各項目は、フラグ パラメータと呼ばれます。**<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Command-Arguments-and-Flags.html#parsing-flags-with-multiple-parameters\' title=\'\'>以下の</a>、複数のフラグ パラメータの解析で詳しく説明します。</p>\n\
</blockquote>\n\
<ul>\n\
<li><strong>「コマンド引数」</strong>: コマンド引数には、関連付けられた名前がありません。MEL コマンドでコマンド引数を使用する場合は、呼び出しの最後に表示されます。対照的に、Python の言語設計のため、コマンド引数は、<span class=\'code\'>maya.cmds</span> 関数呼び出しの最初に表示されます。以下の例は、コマンド引数とフラグの違いを示しています。****</li>\n\
</ul>\n\
<p><span class=\'code\'>import maya.cmds as cmds    cmds.group( &#39;circle1&#39;, &#39;sphere1&#39;, n=&#39;group1&#39; )</span></p>\n\
<p>ここで、<span class=\'code\'>&#39;circle1&#39;</span> および <span class=\'code\'>&#39;sphere1&#39;</span>は、<span class=\'code\'>cmds.group()</span> のコマンド引数です。これらは、オブションの「<span class=\'code\'>n</span>」フラグの前に配置されます。このフラグを使用して、結果として生じるグループの名前を指定します。</p>\n\
<p>現在選択されている Maya オブジェクトをコマンドの引数として使用することもできます。<strong>この場合、コマンド引数とオブジェクトに互換性がなく、コマンドの構文定義で結合できません。</strong>**詳細については、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSyntax</a></span> クラスのマニュアルを参照してください。</p>\n\
<div class=\'section\'><a id=\"コマンド-プラグインのサンプル-フラグを作成する\"></a><h2 id=\"コマンド-プラグインのサンプル-フラグを作成する\">コマンド プラグインのサンプル: フラグを作成する</h2></div>\n\
<p>以下のプラグイン コードでは、渡されれたフラグに関連付けられている値を出力するコマンドを作成します。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSyntax</a></span> および <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgParser</a></span> クラスのマニュアルには、コマンドでフラグ、引数、選択したオブジェクトを使用する方法についての追加情報が含まれています。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleCommandFlag.py\n\
\n\
import sys\n\
\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = &#39;myCommandWithFlag&#39;\n\
\n\
kShortFlagName = &#39;-mf&#39;\n\
kLongFlagName = &#39;-myFlag&#39;\n\
\n\
def maya_useNewAPI():\n\
    &quot;&quot;&quot;\n\
    The presence of this function tells Maya that the plugin produces, and\n\
    expects to be passed, objects created using the Maya Python API 2.0.\n\
    &quot;&quot;&quot;\n\
    pass\n\
    \n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagClass( OpenMaya.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMaya.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; Command execution. &#39;&#39;&#39;\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following &#39;pass&#39; keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        &#39;&#39;&#39; \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        &#39;&#39;&#39;\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = OpenMaya.MArgParser( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flag&#39;s value as an integer.\n\
            # We use the &#39;0&#39; to index the flag&#39;s first and only parameter.\n\
            flagValue = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            print kLongFlagName + &#39;: &#39; + str( flagValue )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
    return MyCommandWithFlagClass() \n\
\n\
def syntaxCreator():\n\
    &#39;&#39;&#39; Defines the argument and flag syntax for this command. &#39;&#39;&#39;\n\
    syntax = OpenMaya.MSyntax()\n\
    \n\
    # In this example, our flag will be expecting a numeric value, denoted by OpenMaya.MSyntax.kDouble. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, OpenMaya.MSyntax.kDouble )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;sampleCommandFlag.py&#39; )\n\
cmds.myCommandWithFlag( myFlag = 4 )\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommandFlag.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = &#39;myCommandWithFlag&#39;\n\
\n\
kShortFlagName = &#39;-mf&#39;\n\
kLongFlagName = &#39;-myFlag&#39;\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; Command execution. &#39;&#39;&#39;\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following &#39;pass&#39; keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        &#39;&#39;&#39; \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        &#39;&#39;&#39;\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = OpenMaya.MArgParser( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flag&#39;s value as an integer.\n\
            # We use the &#39;0&#39; to index the flag&#39;s first and only parameter.\n\
            flagValue = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            print kLongFlagName + &#39;: &#39; + str( flagValue )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( MyCommandWithFlagClass() )\n\
\n\
def syntaxCreator():\n\
    &#39;&#39;&#39; Defines the argument and flag syntax for this command. &#39;&#39;&#39;\n\
    syntax = OpenMaya.MSyntax()\n\
    \n\
    # In this example, our flag will be expecting a numeric value, denoted by OpenMaya.MSyntax.kDouble. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, OpenMaya.MSyntax.kDouble )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;sampleCommandFlag.py&#39; )\n\
cmds.myCommandWithFlag( myFlag = 4 )\n\
\n\
&#39;&#39;&#39;\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>注:</strong> コマンド引数を使用する実用的な例については、「<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Example-Creating-an-IK-Joint.html\' title=\'\'>例: IK ジョイント チェーンを作成する</a>」を参照してください。</p>\n\
\n\
<div class=\'section\'><a id=\"maya-プラグイン-エントリエグジット-ポイント-引数構文を登録する\"></a><h2 id=\"maya-プラグイン-エントリエグジット-ポイント-引数構文を登録する\">Maya プラグイン エントリ/エグジット ポイント: 引数構文を登録する</h2></div>\n\
<p>引数またはフラグを処理しないコマンドと比較すると、<span class=\'code\'>initializePlugin()</span> エントリ ポイントは、コマンドの引数構文を含むように修正する必要があります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    \n\
</pre></div><p>特に、<span class=\'code\'>MFnPlugin.registerCommand()</span> への呼び出しに 3 番目のパラメータ <span class=\'code\'>syntaxCreator</span> を含める必要があります。<span class=\'code\'>MFnPlugin.registerCommand()</span> の関数パラメータを次に示します。</p>\n\
<ol>\n\
<li><strong>コマンド名</strong>: コマンド <span class=\'code\'>&#39;myCommandWithFlag&#39;</span> の名前です。これにより、MEL または Python の <span class=\'code\'>maya.cmds</span> モジュールを使用してコマンドを実行する方法が決定されます。</li>\n\
<li><strong>コマンド作成関数リファレンス</strong>: コマンド <span class=\'code\'>cmdCreator</span> のインスタンスを作成する関数へのリファレンスです。</li>\n\
<li><strong>構文作成関数</strong>: <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSyntax</a></span> オブジェクト <span class=\'code\'>syntaxCreator</span> を返す関数へのリファレンスです。この返された <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSyntax</a></span> オブジェクトは、各フラグの必要なタイプのほか、各フラグのロング ネームとショート ネームを定義します。フラグのショート ネーム(<span class=\'code\'>kShortFlagName</span>)は、ハイフンが前に付加された 1 または 2 文字の文字列にする必要があります(<span class=\'code\'>&#39;-mf&#39;</span>)。一般的に、フラグのロング ネーム(<span class=\'code\'>kLongFlagName</span>)はより説明的であり、ハイフンを前に付加する必要があります(<span class=\'code\'>&#39;-myFlag&#39;</span>)。</li>\n\
</ol>\n\
<p>``` kShortFlagName = &#39;-mf&#39; kLongFlagName = &#39;-myFlag&#39;</p>\n\
<p># ...</p>\n\
<p>def syntaxCreator(): &#39;&#39;&#39; Defines the argument and flag syntax for this command. &#39;&#39;&#39; syntax = OpenMaya.MSyntax()</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   # In this example, our flag will be expecting a numeric value, denoted by OpenMaya.MSyntax.kDouble. \n\
   syntax.addFlag( kShortFlagName, kLongFlagName, OpenMaya.MSyntax.kDouble )\n\
\n\
   # ... Add more flags here ...\n\
\n\
   return syntax\n\
</pre></div><p>```</p>\n\
<blockquote>\n\
<p><strong>注:</strong> <em>コマンド引数</em> を追加するには、<span class=\'code\'>MSyntax.addArg()</span> 関数を使用します。詳細については、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSyntax</a></span> クラスのマニュアルを参照してください。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"コマンドの動作-フラグを解析する\"></a><h2 id=\"コマンドの動作-フラグを解析する\">コマンドの動作: フラグを解析する</h2></div>\n\
<p>コマンドの <span class=\'code\'>doIt()</span> メソッドでは、渡された引数とフラグを解析する専用のコードが必要です。<span class=\'code\'>parseArguments()</span> で、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSyntax\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_syntax.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_syntax.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSyntax</a></span> オブジェクト(<span class=\'code\'>self.syntax()</span> から取得)を使用して <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgParser</a></span> オブジェクトと <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgList</a></span> オブジェクト (<span class=\'code\'>args</span>)をインスタンス化します。<span class=\'code\'>MArgParser.isFlagSet()</span> を使用して特定のフラグが存在するかどうかをチェックします。<span class=\'code\'>MArgParser.flagArgumentInt()</span> を呼び出すと、特定のフラグに整数として関連付けられている値が抽出されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    def doIt(self, args):\n\
        &#39;&#39;&#39; Command execution. &#39;&#39;&#39;\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following &#39;pass&#39; keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        &#39;&#39;&#39; \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        &#39;&#39;&#39;\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = OpenMaya.MArgParser( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flag&#39;s value as an integer.\n\
            # We use the &#39;0&#39; to index the flag&#39;s first and only parameter.\n\
            flagValue = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            print kLongFlagName + &#39;: &#39; + str( flagValue )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>注:</strong> <em>コマンド引数</em> を解析するには、<span class=\'code\'>MArgParser.commandArgument*()</span> 関数を使用します。詳細については、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgParser</a></span> クラスのマニュアルを参照してください。</p>\n\
\n\
<div class=\'section\'><a id=\"複数のパラメータを使用してフラグを解析する\"></a><h2 id=\"複数のパラメータを使用してフラグを解析する\">複数のパラメータを使用してフラグを解析する</h2></div>\n\
<p>次の使用事例のように、複数のパラメータ(たとえば、3 次元ベクトル)が含まれているフラグを解析する必要があると仮定します。**</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;sampleCommandFlagTuple.py&#39; )\n\
cmds.myCommandWithTupleFlag( myTupleFlag = (10, 20, 30) )\n\
</pre></div><p>これを実現するには、コードの 2 つのセクションを修正する必要があります。</p>\n\
<ol>\n\
<li><strong>構文作成関数</strong>: 構文作成関数では、<span class=\'code\'>MSyntax.addFlag()</span> への呼び出しに 3 つの <span class=\'code\'>OpenMaya.MSyntax.kDouble</span> パラメータのタプルが必要です。この新しいフラグ構文定義により、このフラグの単一の数値ではなく、3 つの数値のタプルが Maya で認識されます。</li>\n\
</ol>\n\
<p>``` def syntaxCreator(): &#39;&#39;&#39; Defines the argument and flag syntax for this command. &#39;&#39;&#39; syntax = OpenMaya.MSyntax()</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   # In this example, our flag will be expecting three OpenMaya.MSyntax.kDouble parameters. \n\
   syntax.addFlag( kShortFlagName, kLongFlagName, (OpenMaya.MSyntax.kDouble, OpenMaya.MSyntax.kDouble, OpenMaya.MSyntax.kDouble) )\n\
\n\
   # ... Add more flags here ...\n\
\n\
   return syntax\n\
</pre></div><p>```</p>\n\
<blockquote>\n\
<p><strong>注:</strong> Python API 1.0 では、パラメータはタプル形式で渡されません。</p>\n\
</blockquote>\n\
<ol>\n\
<li><strong>引数の解析</strong>: <span class=\'code\'>parseArguments()</span> のメソッド本体で、<span class=\'code\'>MArgParser.flagArgumentInt()</span> への 3 つの個別の呼び出しに対してインデックス <span class=\'code\'>0</span> ～ <span class=\'code\'>2</span> を使用して、フラグの 3 つのパラメータを解析します。</li>\n\
</ol>\n\
<p>``` def doIt(self, args): &#39;&#39;&#39; Command execution. &#39;&#39;&#39;</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">       # We recommend parsing your arguments first.\n\
       self.parseArguments( args )\n\
\n\
       # Remove the following &#39;pass&#39; keyword and replace it with the code you want to run. \n\
       pass\n\
\n\
   def parseArguments(self, args):\n\
       &#39;&#39;&#39; \n\
       The presence of this function is not enforced,\n\
       but helps separate argument parsing code from other\n\
       command code. \n\
       &#39;&#39;&#39;\n\
\n\
       # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
       argData = OpenMaya.MArgParser( self.syntax(), args )\n\
\n\
       if argData.isFlagSet( kShortFlagName ):\n\
\n\
           # In this case, we print the passed flags&#39;s three parameters, indexed from 0 to 2.\n\
           flagParam0 = argData.flagArgumentInt( kShortFlagName, 0 )\n\
           flagParam1 = argData.flagArgumentInt( kShortFlagName, 1 )\n\
           flagParam2 = argData.flagArgumentInt( kShortFlagName, 2 )\n\
\n\
           print kLongFlagName + &#39;[0]: &#39; + str( flagParam0 )\n\
           print kLongFlagName + &#39;[1]: &#39; + str( flagParam1 )\n\
           print kLongFlagName + &#39;[2]: &#39; + str( flagParam2 )\n\
</pre></div><p>```</p>\n\
<div class=\'section\'><a id=\"サンプル-コマンド-プラグイン-複数のパラメータを持つ-1-つのフラグ\"></a><h2 id=\"サンプル-コマンド-プラグイン-複数のパラメータを持つ-1-つのフラグ\">サンプル コマンド プラグイン: 複数のパラメータを持つ 1 つのフラグ</h2></div>\n\
<p>次の Python コードは、指定したフラグで渡される 3 つのパラメータを出力するコマンドを作成します。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleCommandFlagTuple.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = &#39;myCommandWithTupleFlag&#39;\n\
\n\
kShortFlagName = &#39;-tf&#39;\n\
kLongFlagName = &#39;-myTupleFlag&#39;\n\
\n\
def maya_useNewAPI():\n\
    &quot;&quot;&quot;\n\
    The presence of this function tells Maya that the plugin produces, and\n\
    expects to be passed, objects created using the Maya Python API 2.0.\n\
    &quot;&quot;&quot;\n\
    pass\n\
    \n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagTupleClass( OpenMaya.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMaya.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; Command execution. &#39;&#39;&#39;\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following &#39;pass&#39; keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        &#39;&#39;&#39; \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        &#39;&#39;&#39;\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = OpenMaya.MArgParser( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flags&#39;s three parameters, indexed from 0 to 2.\n\
            flagParam0 = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            flagParam1 = argData.flagArgumentInt( kShortFlagName, 1 )\n\
            flagParam2 = argData.flagArgumentInt( kShortFlagName, 2 )\n\
            \n\
            print kLongFlagName + &#39;[0]: &#39; + str( flagParam0 )\n\
            print kLongFlagName + &#39;[1]: &#39; + str( flagParam1 )\n\
            print kLongFlagName + &#39;[2]: &#39; + str( flagParam2 )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
    return MyCommandWithFlagTupleClass()\n\
\n\
def syntaxCreator():\n\
    &#39;&#39;&#39; Defines the argument and flag syntax for this command. &#39;&#39;&#39;\n\
    syntax = OpenMaya.MSyntax()\n\
    \n\
    # In this example, our flag will be expecting three OpenMaya.MSyntax.kDouble parameters. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, (OpenMaya.MSyntax.kDouble, OpenMaya.MSyntax.kDouble, OpenMaya.MSyntax.kDouble) )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;sampleCommandFlagTuple.py&#39; )\n\
cmds.myCommandWithTupleFlag( myTupleFlag = (10, 20, 30) )\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommandFlagTuple.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = &#39;myCommandWithTupleFlag&#39;\n\
\n\
kShortFlagName = &#39;-tf&#39;\n\
kLongFlagName = &#39;-myTupleFlag&#39;\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandWithFlagTupleClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; Command execution. &#39;&#39;&#39;\n\
        \n\
        # We recommend parsing your arguments first.\n\
        self.parseArguments( args )\n\
\n\
        # Remove the following &#39;pass&#39; keyword and replace it with the code you want to run. \n\
        pass\n\
    \n\
    def parseArguments(self, args):\n\
        &#39;&#39;&#39; \n\
        The presence of this function is not enforced,\n\
        but helps separate argument parsing code from other\n\
        command code. \n\
        &#39;&#39;&#39;\n\
        \n\
        # The following <a href=\"javascript:void(0)\" data-symbol=\"MArgParser\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_parser.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_arg_parser.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MArgParser</a> object allows you to check if specific flags are set.\n\
        argData = OpenMaya.MArgParser( self.syntax(), args )\n\
        \n\
        if argData.isFlagSet( kShortFlagName ):\n\
                \n\
            # In this case, we print the passed flags&#39;s three parameters, indexed from 0 to 2.\n\
            flagParam0 = argData.flagArgumentInt( kShortFlagName, 0 )\n\
            flagParam1 = argData.flagArgumentInt( kShortFlagName, 1 )\n\
            flagParam2 = argData.flagArgumentInt( kShortFlagName, 2 )\n\
            \n\
            print kLongFlagName + &#39;[0]: &#39; + str( flagParam0 )\n\
            print kLongFlagName + &#39;[1]: &#39; + str( flagParam1 )\n\
            print kLongFlagName + &#39;[2]: &#39; + str( flagParam2 )\n\
            \n\
        \n\
        # ... If there are more flags, process them here ...\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( MyCommandWithFlagTupleClass() )\n\
\n\
def syntaxCreator():\n\
    &#39;&#39;&#39; Defines the argument and flag syntax for this command. &#39;&#39;&#39;\n\
    syntax = OpenMaya.MSyntax()\n\
    \n\
    # In this example, our flag will be expecting three OpenMaya.MSyntax.kDouble parameters. \n\
    syntax.addFlag( kShortFlagName, kLongFlagName, OpenMaya.MSyntax.kDouble, OpenMaya.MSyntax.kDouble, OpenMaya.MSyntax.kDouble )\n\
    \n\
    # ... Add more flags here ...\n\
        \n\
    return syntax\n\
    \n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator, syntaxCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;sampleCommandFlagTuple.py&#39; )\n\
cmds.myCommandWithTupleFlag( myTupleFlag = (10, 20, 30) )\n\
\n\
&#39;&#39;&#39;\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";