var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>コマンド プラグイン</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>コマンド プラグイン</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"コマンド-プラグイン\"></a></div>\n\
<p>次のトピックでは、コマンド プラグインの基本的なコード構造を示します。</p>\n\
<div class=\'section\'><a id=\"サンプル-コマンド-プラグイン\"></a><h2 id=\"サンプル-コマンド-プラグイン\">サンプル コマンド プラグイン</h2></div>\n\
<p>次の Python コードは、コマンド プラグインのサンプルです。このサンプル コマンド プラグインについては、後の関連するセクションで説明します。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommand.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandClass( OpenMaya.MPxCommand ):\n\
    kPluginCmdName = &#39;myCommandName&#39;\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMaya.MPxCommand.__init__(self)\n\
    \n\
    @staticmethod \n\
    def cmdCreator():\n\
        &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
        return MyCommandClass() \n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; Command execution. &#39;&#39;&#39;        \n\
        # Remove the following &#39;pass&#39; keyword and replace it with \n\
        # the code you want to run.\n\
        pass\n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
\n\
def maya_useNewAPI():\n\
    &quot;&quot;&quot;\n\
    The presence of this function tells Maya that the plugin produces, and\n\
    expects to be passed, objects created using the Maya Python API 2.0.\n\
    &quot;&quot;&quot;\n\
    pass\n\
\n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( MyCommandClass.kPluginCmdName, \n\
            MyCommandClass.cmdCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + MyCommandClass.kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( MyCommandClass.kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + MyCommandClass.kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin(&#39;sampleCommand.py&#39;)\n\
cmds.myCommandName()\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCommand.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = &#39;myCommandName&#39;\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCommandClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; Command execution. &#39;&#39;&#39;\n\
        \n\
        # Remove the following &#39;pass&#39; keyword and replace it with \n\
        # the code you want to run.\n\
        pass\n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( MyCommandClass() )\n\
\n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin(&#39;sampleCommand.py&#39;)\n\
cmds.myCommandName()\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><div class=\'section\'><a id=\"maya-プラグイン-エントリエグジット-ポイント\"></a><h2 id=\"maya-プラグイン-エントリエグジット-ポイント\">Maya プラグイン エントリ/エグジット ポイント</h2></div>\n\
<p>Maya プラグインには <span class=\'code\'>initializePlugin()</span> および <span class=\'code\'>uninitializePlugin()</span> という 2 つの関数が必要であり、それぞれ Maya がプラグインのロードおよびアンロードを試みるときに呼び出されます。これら 2 つの関数がファイル内に存在しない場合、プラグインはロードに失敗します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    ...\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    ...\n\
</pre></div><p>これらの関数のコードはプラグインのタイプに依存します。現在、プラグインのクラスは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxCommand</a></span> から派生するので、<span class=\'code\'>MFnPlugin.registerCommand()</span> を呼び出して登録する必要があります。この関数には次の 2 つのパラメータがあります。</p>\n\
<ol>\n\
<li><strong>コマンド名</strong>: この変数(便宜的に <span class=\'code\'>kPluginCmdName</span> という名前にしてあります)は、コマンドの名前を含みます。値には <span class=\'code\'>&#39;myCommandName&#39;</span> を代入してあり、これは <span class=\'code\'>MFnPlugin.dergisterCommand()</span> の中、および <span class=\'code\'>sys.stderr.write()</span> に対するエラー レポート呼び出しで再利用されます。<span class=\'code\'>&#39;myCommandName&#39;</span> というコマンド名を登録してあるので、Maya のスクリプト エディタでは次の Python 命令を使用してコマンドを実行できます。</li>\n\
</ol>\n\
<p><span class=\'code\'>import maya.cmds as cmds    cmds.myCommandName()</span></p>\n\
<ol>\n\
<li><strong>コマンド作成関数リファレンス</strong>: 2 番目のパラメータは、コマンドのインスタンスを作成する関数へのリファレンスです。ここでは、<span class=\'code\'>cmdCreator</span> がこのコマンド クラスのインスタンスを作成し、有効な Maya オブジェクト ポインタとして返します。</li>\n\
</ol>\n\
<p>Python API 1.0 では、<span class=\'code\'>OpenMayaMPx.asMPxPtr()</span> を使用してポインタを有効な Maya オブジェクトにキャストする必要があります。このキャストは、Python API 2.0 では必要ありません。ただし、渡されるオブジェクトのタイプを示すように <span class=\'code\'>maya_useNewAPI()</span> 関数を定義する必要があります。</p>\n\
<p><span class=\'code\'>def cmdCreator():        &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;        ...</span></p>\n\
<div class=\'section\'><a id=\"コマンドの動作\"></a><h2 id=\"コマンドの動作\">コマンドの動作</h2></div>\n\
<p>コマンドの動作は、<span class=\'code\'>MyCommandClass</span> クラスで定義されています。このクラスは、すべてのカスタム Maya コマンドの基本クラスである <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxCommand</a></span> から派生します。<span class=\'code\'>MPx</span> というプリフィックスが付けられたクラスは<em>プロキシ クラス</em>と呼ばれ、さまざまなプラグイン タイプを作成するために使用されます。「<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Dependency-Graph-Plug-in-Basics.html\' title=\'\'>ディペンデンシー グラフ プラグインの基本</a>」セクションでは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxNode</a></span> から派生したクラスを使用して、カスタム デフォーマ、コンストレイント、ソフトウェアおよびハードウェアのシェーディング ノード、サーフェスなどの他のプラグイン タイプを作成する方法が説明されています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class MyCommandClass( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        ...\n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; Command execution. &#39;&#39;&#39;\n\
        \n\
        # Remove the following &#39;pass&#39; keyword and replace it with \n\
        # the code you want to run.\n\
        pass\n\
</pre></div><p>クラス名(<span class=\'code\'>MyCommandClass</span>)には任意の名前を付けることができますが、特定の 2 つの関数が含まれている必要があります。</p>\n\
<ul>\n\
<li><strong>__init__(self)</strong>: これはコマンドのコンストラクタです。その本体では、派生元の基本クラスのコンストラクタを呼び出す必要があります。</li>\n\
<li><strong>doIt(self, args)</strong>: これはコマンド実行関数です。コマンドが呼び出されたときに実行するすべてのコードは、ここに記述する必要があります。コマンドが MEL または <span class=\'code\'>maya.cmds</span> Python モジュールから実行されると、コマンドはインスタンス化され、<span class=\'code\'>args</span> パラメータで指定した引数が <span class=\'code\'>doIt()</span> メソッドに渡されます。</li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>注:</strong> コマンドの引数とフラグの定義の詳細については、「<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Command-Arguments-and-Flags.html\' title=\'\'>コマンド引数とフラグ</a>」を参照してください。</p>\n\
</blockquote>\n\
<blockquote>\n\
<p><strong>注:</strong> コマンドは <span class=\'code\'>undoIt()</span> および <span class=\'code\'>redoIt()</span> 関数をサポートしていて、元に戻したり、やり直しに対応することもできます。詳細については、「<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Creating-and-Manipulating.html\' title=\'\'>オブジェクトの作成と操作</a>」を参照してください。</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";