var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>オブジェクトの作成と操作</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>オブジェクトの作成と操作</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"オブジェクトの作成と操作\"></a></div>\n\
<p>コマンド プラグインのコンテキストでは、オブジェクトの作成と操作は Maya の元に戻す/やり直しシステムに密接に関連付けられています。実際には、<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Dependency-Graph-Plug-in-Basics.html\' title=\'\'>ディペンデンシー グラフ</a>とそのノードの状態を操作するコマンドは(<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Querying-the-Scene-Graph.html\' title=\'\'>DAG</a> を含みます)、「元に戻す」操作を実装してアクションを元に戻し、Maya の内部状態が「元に戻す」スタックと同期するようにする必要があります。このトピックでは、元に戻すことが可能なコマンド内でオブジェクトを作成して操作する方法を例示します。</p>\n\
<div class=\'section\'><a id=\"元に戻すことが可能なコマンドのサンプル\"></a><h2 id=\"元に戻すことが可能なコマンドのサンプル\">元に戻すことが可能なコマンドのサンプル</h2></div>\n\
<p>最初に、元に戻すことが可能なコマンドの構造を示します。後で、カメラを作成して操作する、元に戻すことが可能なコマンドを示します。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleUndoableCommand.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
def maya_useNewAPI():\n\
    &quot;&quot;&quot;\n\
    The presence of this function tells Maya that the plugin produces, and\n\
    expects to be passed, objects created using the Maya Python API 2.0.\n\
    &quot;&quot;&quot;\n\
    pass\n\
\n\
kPluginCmdName = &#39;myUndoableCommandName&#39;\n\
\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyUndoableCommand( OpenMaya.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMaya.MPxCommand.__init__(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; doIt() is called once when the command is first executed. &#39;&#39;&#39;\n\
        \n\
        # ... Perform any object creation here, since doIt() is only called once per command instance ...\n\
        \n\
        # Call self.redoIt() to perform the command&#39;s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        &#39;&#39;&#39; redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. &#39;&#39;&#39;\n\
        \n\
        # ... Perform any object manipulation here ...\n\
        pass\n\
    \n\
    \n\
    def undoIt(self):\n\
        &#39;&#39;&#39; undoIt() is called every time the instance of this command is undone. &#39;&#39;&#39;\n\
        \n\
        # ... Reverse any object creation or manipulations here ...\n\
        pass\n\
    \n\
    \n\
    def isUndoable(self):\n\
        &#39;&#39;&#39; This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. &#39;&#39;&#39;\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
    return MyUndoableCommand() \n\
\n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;pySampleUndoableCommand.py&#39; )\n\
cmds.myUndoableCommandName()\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleUndoableCommand.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
# ... additional imports here ...\n\
\n\
kPluginCmdName = &#39;myUndoableCommandName&#39;\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyUndoableCommand( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; doIt() is called once when the command is first executed. &#39;&#39;&#39;\n\
        \n\
        # ... Perform any object creation here, since doIt() is only called once per command instance ...\n\
        \n\
        # Call self.redoIt() to perform the command&#39;s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        &#39;&#39;&#39; redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. &#39;&#39;&#39;\n\
        \n\
        # ... Perform any object manipulation here ...\n\
        pass\n\
    \n\
    \n\
    def undoIt(self):\n\
        &#39;&#39;&#39; undoIt() is called every time the instance of this command is undone. &#39;&#39;&#39;\n\
        \n\
        # ... Reverse any object creation or manipulations here ...\n\
        pass\n\
    \n\
    \n\
    def isUndoable(self):\n\
        &#39;&#39;&#39; This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. &#39;&#39;&#39;\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( MyUndoableCommand() )\n\
\n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;sampleUndoableCommand.py&#39; )\n\
cmds.myUndoableCommandName()\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>前述のコマンド プラグインには、コマンド実行プロセス中に Maya によって呼び出される 4 つの重要な関数が含まれます。</p>\n\
<ul>\n\
<li><strong>isUndoable()</strong>: コマンドの <span class=\'code\'>isUndoable()</span> 関数が <span class=\'code\'>True</span> を返す場合、そのコマンドのインスタンスは Maya の「元に戻す」スタックに追加されます。</li>\n\
</ul>\n\
<p>``` def isUndoable(self): &#39;&#39;&#39; This function indicates whether or not the command is undoable. If the command is undoable, each executed instance of that command is added to the undo queue. &#39;&#39;&#39;</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">       # We must return True to specify that this command is undoable.\n\
       return True\n\
</pre></div><p>```</p>\n\
<ul>\n\
<li><strong>doIt()</strong>: 各コマンド インスタンスの <span class=\'code\'>doIt()</span> 関数は、コマンドが最初に実行されるときに <em>1 回</em>呼び出されます。コードを最大限に再利用するには、コマンド インスタンスで必要なすべてのオブジェクトと変数を <span class=\'code\'>doIt()</span> 関数でインスタンス化し、その後で <span class=\'code\'>doIt()</span> 関数本体内から <span class=\'code\'>redoIt()</span> を呼び出すことをお勧めします。</li>\n\
</ul>\n\
<p>``` def doIt(self, args): &#39;&#39;&#39; doIt() is called once when the command is first executed. &#39;&#39;&#39;</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">       # Parse any arguments when doIt() is invoked.\n\
       self.parseArgs( args )\n\
\n\
       # ... Perform any object creation here, since doIt() is only called once per command instance ...\n\
\n\
       # Call self.redoIt() to perform the command&#39;s actual work. This function call flow\n\
       # is useful for code re-use.\n\
       self.redoIt()\n\
</pre></div><p>```</p>\n\
<ul>\n\
<li><strong>redoIt()</strong>: <span class=\'code\'>redoIt()</span> 関数は、コマンドが再実行されるたびに Maya によって呼び出されます。したがって、コマンドで使用されているオブジェクトの状態を操作するには、<span class=\'code\'>redoIt()</span> を使用する必要があります。この状態操作は、<span class=\'code\'>undoIt()</span> 関数で元に戻す必要があることに留意してください。</li>\n\
</ul>\n\
<p>``` def redoIt(self): &#39;&#39;&#39; redoIt() is called every time the instance of this command is re-done from the undo queue. &#39;&#39;&#39;</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">       # ... Perform any object manipulation here ...\n\
       pass\n\
</pre></div><p>```</p>\n\
<ul>\n\
<li><strong>undoIt()</strong>: <span class=\'code\'>undoIt()</span> 関数は、コマンドが元に戻されると呼び出されます。<span class=\'code\'>undoIt()</span> 関数の目的は、コマンドによって操作される各オブジェクトが、コマンドの実行前に戻った状態を保持することです。コマンドのインスタンスが操作を正しく元に戻さない場合、Maya の内部状態が、元に戻す/やり直しスタックと矛盾します。</li>\n\
</ul>\n\
<p>``` def undoIt(self): &#39;&#39;&#39; undoIt() is called every time the instance of this command is undone. &#39;&#39;&#39;</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">       # ... Reverse any object creation or manipulations here ...\n\
       pass\n\
</pre></div><p>```</p>\n\
<div class=\'section\'><a id=\"mdagmodifier-でオブジェクトを作成する\"></a><h2 id=\"mdagmodifier-でオブジェクトを作成する\">MDagModifier でオブジェクトを作成する</h2></div>\n\
<p>DAG ノードの作成および DAG ノードの操作を元に戻すことを容易にするため、Maya API には <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a></span> クラスが用意されています。このクラスの派生元は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDGModifier</a></span> であり、ディペンデンシー グラフ ノードの作成と操作に使用されます。DAG はディペンデンシー グラフのサブセットなので、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDGModifier</a></span> によって提供される関数は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a></span> よっても提供されます。これを覚えておくと、このトピックの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a></span> に対して行われる関数呼び出しのクラス マニュアルを参照するときに役立つ場合があります。</p>\n\
<p>次の元に戻すことができるコマンドでは、カメラを作成して操作し、この新しく作成したカメラに現在のビューを設定しています。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleCameraCommand.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
import maya.api.OpenMayaUI as OpenMayaUI\n\
\n\
def maya_useNewAPI():\n\
    &quot;&quot;&quot;\n\
    The presence of this function tells Maya that the plugin produces, and\n\
    expects to be passed, objects created using the Maya Python API 2.0.\n\
    &quot;&quot;&quot;\n\
    pass\n\
    \n\
kPluginCmdName = &#39;myCameraCommand&#39;\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCameraCommand( OpenMaya.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMaya.MPxCommand.__init__(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; doIt() is called once when the command is first executed. &#39;&#39;&#39; \n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = OpenMaya.MDagModifier()\n\
        \n\
        # Create the camera transform node.\n\
        self.cameraTransformObj = self.dagModifier.createNode( &#39;transform&#39; )\n\
        self.dagModifier.renameNode( self.cameraTransformObj, &#39;myCameraTransform&#39; )\n\
        \n\
        # Create the camera shape node as a child of the camera transform node.\n\
        self.cameraShapeObj = self.dagModifier.createNode( &#39;camera&#39;, self.cameraTransformObj )\n\
        self.dagModifier.renameNode( self.cameraShapeObj, &#39;myCameraShape&#39; )\n\
        \n\
        # Call self.redoIt() to perform the command&#39;s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        &#39;&#39;&#39; redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. &#39;&#39;&#39;\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier. This effectively\n\
        # creates the DAG nodes specified using self.dagModifier.createNode().\n\
        self.dagModifier.doIt()\n\
        \n\
        # Set the translation value of the camera&#39;s transform node. \n\
        transformFn = OpenMaya.MFnTransform( self.cameraTransformObj )\n\
        transformFn.setTranslation( OpenMaya.MVector( 0, 5, 30 ), OpenMaya.MSpace.kTransform )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = OpenMaya.MDagPath()\n\
        currentView = OpenMayaUI.M3dView.active3dView()\n\
        self.previousCamera=currentView.getCamera() # self.previousCamera is now populated with the current camera before we switch.\n\
        \n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = OpenMaya.MDagPath()\n\
        dagNodeFn = OpenMaya.MFnDagNode( self.cameraShapeObj )\n\
        cameraDagPath = dagNodeFn.getPath()\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
    \n\
    \n\
    def undoIt(self):\n\
        &#39;&#39;&#39; undoIt() is called every time the instance of this command is undone. &#39;&#39;&#39;\n\
        \n\
        # Switch back to the previous camera. We do not have to reverse the translation of \n\
        # self.cameraTransformObj because it will be excluded from the DAG once \n\
        # self.dagModifier.undoIt() is called below.\n\
        currentView = OpenMayaUI.M3dView.active3dView()\n\
        self.previousCamera = currentView.getCamera()\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        self.dagModifier.undoIt()\n\
    \n\
    \n\
    def isUndoable(self):\n\
        &#39;&#39;&#39; This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. &#39;&#39;&#39;\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
    return  MyCameraCommand() \n\
\n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;pySampleCameraCommand.py&#39; )\n\
cmds.myCameraCommand()\n\
cmds.undo()\n\
cmds.redo()\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleCameraCommand.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaUI as OpenMayaUI\n\
\n\
kPluginCmdName = &#39;myCameraCommand&#39;\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class MyCameraCommand( OpenMayaMPx.MPxCommand ):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
    \n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; doIt() is called once when the command is first executed. &#39;&#39;&#39; \n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = OpenMaya.MDagModifier()\n\
        \n\
        # Create the camera transform node.\n\
        self.cameraTransformObj = self.dagModifier.createNode( &#39;transform&#39; )\n\
        self.dagModifier.renameNode( self.cameraTransformObj, &#39;myCameraTransform&#39; )\n\
        \n\
        # Create the camera shape node as a child of the camera transform node.\n\
        self.cameraShapeObj = self.dagModifier.createNode( &#39;camera&#39;, self.cameraTransformObj )\n\
        self.dagModifier.renameNode( self.cameraShapeObj, &#39;myCameraShape&#39; )\n\
        \n\
        # Call self.redoIt() to perform the command&#39;s actual work. This function call flow\n\
        # is useful for code re-use.\n\
        self.redoIt()\n\
        \n\
        \n\
    def redoIt(self):\n\
        &#39;&#39;&#39; redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. &#39;&#39;&#39;\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier. This effectively\n\
        # creates the DAG nodes specified using self.dagModifier.createNode().\n\
        self.dagModifier.doIt()\n\
        \n\
        # Set the translation value of the camera&#39;s transform node. \n\
        transformFn = OpenMaya.MFnTransform( self.cameraTransformObj )\n\
        transformFn.setTranslation( OpenMaya.MVector( 0, 5, 30 ), OpenMaya.MSpace.kTransform )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = OpenMaya.MDagPath()\n\
        currentView = OpenMayaUI.M3dView.active3dView()\n\
        currentView.getCamera( self.previousCamera ) # self.previousCamera is now populated with the current camera before we switch.\n\
        \n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = OpenMaya.MDagPath()\n\
        dagNodeFn = OpenMaya.MFnDagNode( self.cameraShapeObj )\n\
        dagNodeFn.getPath( cameraDagPath )\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
    \n\
    \n\
    def undoIt(self):\n\
        &#39;&#39;&#39; undoIt() is called every time the instance of this command is undone. &#39;&#39;&#39;\n\
        \n\
        # Switch back to the previous camera. We do not have to reverse the translation of \n\
        # self.cameraTransformObj because it will be excluded from the DAG once \n\
        # self.dagModifier.undoIt() is called below.\n\
        currentView = OpenMayaUI.M3dView.active3dView()\n\
        currentView.setCamera( self.previousCamera )\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        self.dagModifier.undoIt()\n\
    \n\
    \n\
    def isUndoable(self):\n\
        &#39;&#39;&#39; This function indicates whether or not the command is undoable. If the\n\
        command is undoable, each executed instance of that command is added to the\n\
        undo queue. &#39;&#39;&#39;\n\
        \n\
        # We must return True to specify that this command is undoable.\n\
        return True\n\
    \n\
    \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def cmdCreator():\n\
    &#39;&#39;&#39; Create an instance of our command. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( MyCameraCommand() )\n\
\n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in when Maya loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register command: &#39; + kPluginCmdName )\n\
\n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitialize the plug-in when Maya un-loads it. &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to unregister command: &#39; + kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;sampleCameraCommand.py&#39; )\n\
cmds.myCameraCommand()\n\
cmds.undo()\n\
cmds.redo()\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>上の例では、主要な関数は <span class=\'code\'>MDagModifer.createNode()</span>、<span class=\'code\'>MDagModifier.doIt()</span>、<span class=\'code\'>MDagModifier.undoIt()</span> です。これらの関数は、それぞれコマンドの <span class=\'code\'>doIt()</span> メソッド、<span class=\'code\'>redoIt()</span> メソッド、<span class=\'code\'>undoIt()</span> メソッドで使用されています。</p>\n\
<ol>\n\
<li><strong>MDagModifier.createNode()</strong>: <span class=\'code\'>MDagModifier.createNode()</span> が呼び出されると、操作が <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a></span> 内でキューに入れられて、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> のインスタンスが返されます。この <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> は、DAG に<em>まだ含まれていない</em>、新しく作成された Maya DAG ノードへのハンドルです。1 番目のパラメータとして文字列を受け取る <span class=\'code\'>MDagModifier.createNode()</span> のメソッド シグネチャを呼び出していることに注意してください。この文字列は、作成されたノード タイプの名前を示します。有効なノード タイプ名は、<strong>『Maya ユーザ ガイド』 &gt; 「テクニカル ドキュメント」 &gt; 「ノード」</strong>に列記されています。<span class=\'code\'>&#39;transform&#39;</span> や <span class=\'code\'>&#39;camera&#39;</span> などです。<span class=\'code\'>MDagModifier.renameNode()</span> の呼び出しも <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a></span> 内でキューに入れられ、ノードの名前変更を実行する/元に戻すために使用されます。</li>\n\
</ol>\n\
<p>``` def doIt(self, args): &#39;&#39;&#39; doIt() is called once when the command is first executed. &#39;&#39;&#39;</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">       # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
       self.dagModifier = OpenMaya.MDagModifier()\n\
\n\
       # Create the camera transform node.\n\
       self.cameraTransformObj = self.dagModifier.createNode( &#39;transform&#39; )\n\
       self.dagModifier.renameNode( self.cameraTransformObj, &#39;myCameraTransform&#39; )\n\
\n\
       # Create the camera shape node as a child of the camera transform node.\n\
       self.cameraShapeObj = self.dagModifier.createNode( &#39;camera&#39;, self.cameraTransformObj )\n\
       self.dagModifier.renameNode( self.cameraShapeObj, &#39;myCameraShape&#39; )\n\
\n\
       # Call self.redoIt() to perform the command&#39;s actual work. This function call flow\n\
       # is useful for code re-use.\n\
       self.redoIt()\n\
</pre></div><p>```</p>\n\
<ol>\n\
<li><strong>MDagModifier.doIt()</strong>: <span class=\'code\'>MDagModifier.doIt()</span> が呼び出されると、前にキューに入れられた操作が効果的に実行されます。キューに入れられた <span class=\'code\'>MDagModifier.createNode()</span> 操作は、作成されたノードを DAG に追加することによって完了します。コマンドの <span class=\'code\'>redoIt()</span> メソッドの <span class=\'code\'>MDagModifier.doIt()</span> を呼び出すと、コマンドの <span class=\'code\'>doIt()</span> メソッドで定義されている、作成されたノードの同じセットを操作できます。コマンドの <span class=\'code\'>redoIt()</span> メソッドを呼び出すときに新しいノードを繰り返し作成していないことに注意してください。</li>\n\
</ol>\n\
<p>``` def redoIt(self): &#39;&#39;&#39; redoIt() is called every time the instance of this command is re-done from the undo queue. &#39;&#39;&#39;</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">       # Perform the operations enqueued within our reference to MDagModifier.\n\
       self.dagModifier.doIt()\n\
\n\
       # ... object manipulations ...\n\
</pre></div><p>```</p>\n\
<blockquote>\n\
<p><strong>注:</strong> <span class=\'code\'>MDagModifier.doIt()</span> は同じコマンドで何回でも呼び出すことができます。これはノードを切断して削除する必要がある場合に必要になります。詳細については、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDGModifier</a></span> クラスのマニュアルを参照してください。</p>\n\
</blockquote>\n\
<ol>\n\
<li><strong>MDagModifier.undoIt()</strong>: <span class=\'code\'>MDagModifier.undoIt()</span> を呼び出すと、<span class=\'code\'>MDagModifier.doIt()</span> の呼び出しで完了しているすべてのキューに入れられた操作が元に戻されます。</li>\n\
</ol>\n\
<p>``` def undoIt(self): &#39;&#39;&#39; undoIt() is called every time the instance of this command is undone. &#39;&#39;&#39;</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">       # ... revert object manipulations ...\n\
\n\
       # This call to MDagModifier.undoIt() undoes all the operations queued within the MDagModifier.\n\
       self.dagModifier.undoIt()\n\
</pre></div><p>```</p>\n\
<blockquote>\n\
<p><strong>注:</strong> コマンド内での <span class=\'code\'>MDagModifier.doIt()</span> の呼び出し回数に関係なく、<span class=\'code\'>MDagModifier.undoIt()</span> の呼び出しは 1 回だけで十分です。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"オブジェクトの操作\"></a><h2 id=\"オブジェクトの操作\">オブジェクトの操作</h2></div>\n\
<p>このコマンドの <span class=\'code\'>redoIt()</span> メソッドの本体では、<span class=\'code\'>MFnCamera.setTranslation()</span> を呼び出してカメラのトランスフォーム ノードの位置を変更します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    def redoIt(self):\n\
        &#39;&#39;&#39; redoIt() is called every time the instance of this command is re-done from\n\
        the undo queue. &#39;&#39;&#39;\n\
        \n\
        # ...\n\
        \n\
        # Set the translation value of the camera&#39;s transform node. \n\
        transformFn = OpenMaya.MFnTransform( self.cameraTransformObj )\n\
        transformFn.setTranslation( OpenMaya.MVector( 0, 5, 30 ), OpenMaya.MSpace.kTransform )\n\
        \n\
        # ...\n\
</pre></div><p>これにより、Maya API で <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> および関数セットを使用できるようになります。**</p>\n\
<ul>\n\
<li><p><strong>Maya オブジェクト(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span>)</strong>: Maya API は、Maya オブジェクトへのアクセスを <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> ラッパ クラスのインスタンスとして提供します。したがって、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> のインスタンスは、カメラ、ライト、メッシュ、変換、およびディペンデンシー グラフ ノードを表すことができます。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> の内部状態は、互換性のある<em>関数セット</em>(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnBase</a></span> から派生されるクラス)を使用して操作します。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> のすべてのインスタンスは、ただ 1 つの Maya オブジェクト タイプ(<span class=\'code\'>MObject.apiType()</span>)を持つか(例: <span class=\'code\'>MFn.kTransform</span>)、または<em>関数セット</em>の複数のタイプと互換性がある場合がある <span class=\'code\'>MFn.kCamera</span> を持ちます。<span class=\'code\'>MObject.hasFn()</span> メソッドは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> のインスタンスと特定の関数セットとの間に互換性があるかどうかを判定します。</p></li>\n\
<li><p><strong>関数セット(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnBase</a></span> およびサブクラス)</strong>: <em>関数セット</em>は、互換性のある <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> の状態を操作するために Maya API で提供されています。シングルトンとして存在します。つまり、Maya の内部には各タイプの<em>関数セット</em>が 1 つだけ含まれます。<em>関数セット</em>は一度に 1 つの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> だけを操作できますが、このオブジェクトは <span class=\'code\'>MFnBase.setObject()</span> を使用して変更できます。特定の<em>関数セット</em>のリファレンスは、そのコンストラクタを使用して取得します。コンストラクタは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> を受け入れて現在の作業オブジェクトを設定できます。</p></li>\n\
</ul>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> の関数セットの互換性は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnBase</a></span> クラスまでのクラス階層に従います。したがって、<span class=\'code\'>MFn.kCamera</span> の Maya オブジェクト タイプを持つ <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> のインスタンスは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnDependencyNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDependencyNode</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnBase\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_base.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_base.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnBase</a></span> との互換性があります。</p>\n\
<p>次のコード サンプルと図は、互換性のある <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> (<span class=\'code\'>Mfn.kTransform</span> タイプ)の移動を設定するための <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnTransform</a></span> 関数セットの使用を示しています。つまり、以前に <span class=\'code\'>self.cameraTransformObj</span> に割り当てて <span class=\'code\'>&#39;myCameraTransform&#39;</span> という名前を設定したトランスフォーム ノードです。**</p>\n\
<p><span class=\'code\'># Set the translation value of the camera&#39;s transform node.     transformFn = OpenMaya.MFnTransform( self.cameraTransformObj )    transformFn.setTranslation( OpenMaya.MVector( 0, 5, 30 ), OpenMaya.MSpace.kTransform )</span></p>\n\
<div class=\'figure\'><img src=\'dev_help/images/Maya_Camera_MFnTransform_75%.png\' title=\'\' /></div>\n\
<blockquote>\n\
<p><strong>注:</strong> <span class=\'code\'>MFnTransform.setTranslation()</span> の呼び出しの 2 番目のパラメータ(<span class=\'code\'>OpenMaya.MSpace.kTransform</span>)は、移動をトランスフォーム ノードのローカル座標空間内で適用する必要があることを指定しています。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"警告-mdagmodifier-を使用しないノードを作成操作する\"></a><h2 id=\"警告-mdagmodifier-を使用しないノードを作成操作する\">警告: MDagModifier を使用しないノードを作成、操作する</h2></div>\n\
<p>関数セットの多くでは、<span class=\'code\'>create()</span> 関数(例: <span class=\'code\'>MFnCamera.create()</span>)も提供されており、これは自動的に適切なシェープとトランスフォーム ノードをインスタンス化します。**これらの関数は、シーンを初期化など、1 回だけ使用する、元に戻せないコマンド内でのみ使用することをお勧めします。このガイドラインの例外は <span class=\'code\'>MFnMesh.create()</span> で、コマンド内での使用は「<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Example-Creating-a-Scene.html\' title=\'\'>例: シーンの作成</a>」で示されています。この例では、<span class=\'code\'>MDagModifier.createNode()</span> で親トランスフォーム ノードを作成し、<span class=\'code\'>MFnMesh.create()</span> を使用してその下のメッシュ データを子ノードとして定義する必要があります。</p>\n\
<p>同様に、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a></span> 関数セットには、<span class=\'code\'>MFnDagNode.addChild()</span>、<span class=\'code\'>MFnDagNode.removeChild()</span>、その他の DAG 階層操作関数が含まれています。**1 回だけ使用される元に戻せないコマンドを作成している場合や、コマンドの <span class=\'code\'>undoIt()</span> ロジックを手動で実装してこれらのアクションを元に戻す場合以外は、<span class=\'code\'>MDagModifier.reparentNode()</span> 関数を使用してから <span class=\'code\'>MDagModifier.doIt()</span> を呼び出すことをお勧めします。</p>\n\
<div class=\'section\'><a id=\"警告-mglobal.deletenode-でのノード削除\"></a><h2 id=\"警告-mglobal.deletenode-でのノード削除\">警告: MGlobal.deleteNode() でのノード削除</h2></div>\n\
<p>また、コマンドの <span class=\'code\'>undoIt()</span> メソッドの中で <span class=\'code\'>MGlobal.deleteNode()</span> を呼び出してコマンドのノード作成を元に戻すことがあります。これはお勧めできません。<span class=\'code\'>MGlobal.deleteNode()</span> を呼び出すと、実際は MEL ノード削除コマンドが内部的に実行され、それによってコマンドを元に戻すプロセスの実行中に「元に戻す」スタックにコマンドが追加されるからです。これにより Maya の「元に戻す」スタック内に矛盾が発生し、クラッシュが発生することがあります。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> 同じ理由で、コマンド プラグイン内で <span class=\'code\'>maya.cmds</span> 関数を呼び出すことをお勧めしません。代わりの安全な方法としては、<span class=\'code\'>MDagModifier.commandToExecute()</span> 関数を使用して MEL コマンドをキューに加えると、<span class=\'code\'>MDagModifier.doIt()</span> が呼び出されたときに安全に実行されます。同じ MEL コマンドは <span class=\'code\'>MDagModifier.undoIt()</span> を呼び出すと安全に元に戻るので、Maya 内の「元に戻す」スタックの不整合を避けることができます。詳細は、「<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Example-Creating-an-IK-Joint.html\' title=\'\'>例: IK ジョイント チェーンを作成する</a>」を参照してください。</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";