var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>例: シーンの作成</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>例: シーンの作成</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"例-シーンの作成\"></a></div>\n\
<div class=\'section\'><a id=\"例-シーンの作成-1\"></a><h2 id=\"例-シーンの作成-1\">例: シーンの作成</h2></div>\n\
<p><strong>ファイル名:</strong> <span class=\'code\'>sampleScene.py</span></p>\n\
<p><strong>出力例:</strong></p>\n\
<div class=\'figure\'><img src=\'dev_help/images/sampleScene_75%.png\' title=\'\' /></div>\n\
<p><strong>プログラムの概要:</strong> 次のプラグイン コードは、<span class=\'code\'>OpenMayaMPx.MPxCommand</span> クラスを継承することによって、新しいコマンド <span class=\'code\'>cmds.mySampleScene()</span> を作成します。このコマンドを実行すると、簡単な家のようなポリゴンを持つ赤いシェードのメッシュ、照準が家の方向にコンストレイントされたスポットライト、新しいビュー ポイントを定義するための新しいカメラが作成されます。最後に、シーン グラフ(DAG)がトラバースされて、スクリプト エディタの出力ウィンドウに表示されます。上のサンプル出力と一致するように、ビューアの「スムーズ シェーディング(smooth shading)」、「ワイヤフレーム付きシェード(wireframe on shaded)」、「すべてのライトの使用(use all lights)」の各ボタンをアクティブ化します。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleScene.py\n\
\n\
import sys\n\
import maya.api.OpenMaya as OpenMaya\n\
import maya.api.OpenMayaUI as OpenMayaUI\n\
\n\
def maya_useNewAPI():\n\
    &quot;&quot;&quot;\n\
    The presence of this function tells Maya that the plugin produces, and\n\
    expects to be passed, objects created using the Maya Python API 2.0.\n\
    &quot;&quot;&quot;\n\
    pass\n\
\n\
kPluginCmdName = &quot;pySampleScene&quot;\n\
\n\
# Vertices used to define a planar house shape within a single <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnMesh</a> object:\n\
#\n\
#              [4]\n\
#             /   \\\n\
#            /     \\\n\
#          [3]-----[2]        where the bracketed numbers correspond\n\
#           |       |         to the vertex index.\n\
#           |       |\n\
#          [0]-----[1]\n\
#\n\
vertices = [ # Square plane:\n\
             OpenMaya.MPoint( -2, -2, 0), # index 0: bottom left corner\n\
             OpenMaya.MPoint(  2, -2, 0), # index 1: bottom right corner\n\
             OpenMaya.MPoint(  2,  2, 0), # index 2: top right corner\n\
             OpenMaya.MPoint( -2,  2, 0), # index 3: top left corner\n\
             # Vertex used to define the roof:\n\
             OpenMaya.MPoint(  0,  5, 0)  # index 4: tip of the roof.\n\
            ]\n\
   \n\
\n\
# Count the number of times this command has been instantiated.\n\
commandInstanceCounter = 1\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class SampleSceneCommand(OpenMaya.MPxCommand):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMaya.MPxCommand.__init__(self)\n\
        \n\
        # We keep track of the number of times the command was instantiated, and we label this particular\n\
        # instance of the command with it. This will help us name the objects manipulated by this particular instance \n\
        # of the command.\n\
        global commandInstanceCounter\n\
        self.commandExecution = commandInstanceCounter\n\
        commandInstanceCounter = commandInstanceCounter + 1\n\
    \n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; Set up the objects which the command will use. &#39;&#39;&#39;\n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = OpenMaya.MDagModifier()\n\
        \n\
        # We first create the required MObjects using the MDagModifer assigned to self.dagModifier.\n\
        #   (!) The &#39;transform&#39;, &#39;spotLight&#39; and &#39;camera&#39; strings are recognized by the <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a> as valid node type names. \n\
        #       For a complete list of node type names, consult the Maya User Guide  &gt; Technical Documentation &gt; Nodes section.\n\
        self.meshTransformObj = self.dagModifier.createNode( &#39;transform&#39; )\n\
        self.meshShapeObj = self.createHouseMesh() # This function will create a mesh under the self.meshTransformObj node.\n\
        \n\
        self.lightTransformObj = self.dagModifier.createNode( &#39;transform&#39; )\n\
        self.lightShapeObj = self.dagModifier.createNode( &#39;spotLight&#39;, self.lightTransformObj )\n\
        \n\
        self.cameraTransformObj = self.dagModifier.createNode( &#39;transform&#39; )\n\
        self.cameraShapeObj = self.dagModifier.createNode( &#39;camera&#39;, self.cameraTransformObj )\n\
        \n\
        # Create the shading node.\n\
        self.shadingNodeName = &#39;myMaterial&#39; + str( self.commandExecution )\n\
        self.dagModifier.commandToExecute( &#39;shadingNode -asShader -name &#39; + self.shadingNodeName + &#39; phong;&#39; )\n\
        self.dagModifier.commandToExecute( &#39;setAttr &quot;&#39; + self.shadingNodeName + &#39;.color&quot; -type double3 0.7 0.2 0.15;&#39;)\n\
        \n\
        # Create the shading group.\n\
        self.shadingGroupName = &#39;myShadingGroup&#39; + str( self.commandExecution )\n\
        self.dagModifier.commandToExecute( &#39;sets -renderable true -noSurfaceShader true -empty -name &#39; + self.shadingGroupName + &#39;;&#39;)\n\
        self.dagModifier.commandToExecute( &#39;connectAttr -f &#39; + self.shadingNodeName + &#39;.outColor &#39; + self.shadingGroupName + &#39;.surfaceShader;&#39; )\n\
        \n\
        # Invoke the command&#39;s redoIt() function to actually create and manipulate these objects.\n\
        self.redoIt()\n\
    \n\
    \n\
    def createHouseMesh(self):\n\
        &#39;&#39;&#39; Create a house mesh. &#39;&#39;&#39;\n\
        global vertices # we want to access the list of vertices defined as a static variable  \n\
\n\
        # Create the function set for operating on the mesh\n\
        meshFn = OpenMaya.MFnMesh( )\n\
\n\
        # Create a mesh and set this function set to operate on it.\n\
        # The mesh consists of 2 polygons: a square plane and a triangle roof. The second parameter gives the number of vertices for each.\n\
        # The third parameter is the sequence of vertices, partitioned according to the second parameter.\n\
        # Therefore, the 4 vertices numbered 0, 1, 2, 3 are used for the square, and the 3 vertices 2, 4, 3 for the triangle.\n\
        # The mesh is parented under the transform node.\n\
        meshShapeObj = meshFn.create(vertices, (4,3), (0,1,2,3,2,4,3), parent=self.meshTransformObj)\n\
                \n\
        # Set the name of the mesh.\n\
        meshFn.setName( &#39;myMeshShape&#39; + str( self.commandExecution ) )\n\
        \n\
        return meshShapeObj\n\
        \n\
    \n\
    def redoIt(self):\n\
        &#39;&#39;&#39; \n\
        Manipulate the objects created in doIt(). This function is also called by Maya when\n\
        the user re-does the operation after undoing it.\n\
        &#39;&#39;&#39;\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier.\n\
        self.dagModifier.doIt()\n\
        \n\
        #=======================================\n\
        # MESH MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the mesh&#39;s transform node, as well as its name.\n\
        transformFn = OpenMaya.MFnTransform( self.meshTransformObj )\n\
        transformFn.setTranslation( OpenMaya.MVector( 0, 2, 0 ), OpenMaya.MSpace.kTransform )\n\
        transformFn.setName( &#39;myMeshTransform&#39; + str( self.commandExecution ) )\n\
        \n\
        # Obtain the DAG path of the mesh transform node. This will be used to create\n\
        # an aiming constraint between the light and the mesh.\n\
        \n\
        meshTransformDagPath = OpenMaya.MDagPath()\n\
        dagmeshNodeFn = OpenMaya.MFnDagNode( self.meshTransformObj )\n\
        meshTransformDagPath = dagmeshNodeFn.getPath()\n\
\n\
        # The DAG path of the mesh shape node will be used to apply a material.\n\
\n\
        meshShapeDagPath = OpenMaya.MDagPath()\n\
        dagshapeNodeFn = OpenMaya.MFnDagNode( self.meshShapeObj )\n\
        meshShapeDagPath = dagshapeNodeFn.getPath( )    \n\
                \n\
        #=======================================\n\
        # LIGHT MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the light&#39;s transform node, as well as its name.\n\
        transformFn = OpenMaya.MFnTransform( self.lightTransformObj )\n\
        transformFn.setTranslation( OpenMaya.MVector( 4, 9.5, 12 ), OpenMaya.MSpace.kTransform )\n\
        transformFn.setName( &#39;myLightTransform&#39; + str( self.commandExecution ) )\n\
        \n\
        # Obtain the DAG path of the light transform node. This will be used to create\n\
        # an aiming constraint between the light and the mesh.\n\
\n\
        lightTransformDagPath = OpenMaya.MDagPath()\n\
        daglightNodeFn = OpenMaya.MFnDagNode( self.lightTransformObj  )\n\
        lightTransformDagPath = daglightNodeFn.getPath()\n\
        \n\
        # Change the name of the light shape\n\
        spotLightFn = OpenMaya.MFnDependencyNode( self.lightShapeObj )\n\
        spotLightFn.setName( &#39;myLightShape&#39; + str( self.commandExecution ) )\n\
\n\
        #=======================================\n\
        # CAMERA MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the camera&#39;s transform node, as well as its name. \n\
        transformFn = OpenMaya.MFnTransform( self.cameraTransformObj )\n\
        transformFn.setTranslation( OpenMaya.MVector( 0, 5, 30 ), OpenMaya.MSpace.kTransform )\n\
        transformFn.setName( &#39;myCameraTransform&#39; + str( self.commandExecution ) )\n\
        \n\
        # Change the name of the camera shape.\n\
        cameraFn = OpenMaya.MFnCamera( self.cameraShapeObj )\n\
        cameraFn.setName( &#39;myCameraShape&#39; + str( self.commandExecution ) )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = OpenMaya.MDagPath()\n\
        currentView = OpenMayaUI.M3dView.active3dView()\n\
        self.previousCamera=currentView.getCamera()    # self.previousCamera is now populated with the current camera before we switch.\n\
\n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = OpenMaya.MDagPath()\n\
        dagNodeFn = OpenMaya.MFnDagNode( self.cameraShapeObj )\n\
        # dagNodeFn.getPath( cameraDagPath )\n\
        cameraDagPath = dagNodeFn.getPath()\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
        \n\
        #=======================================\n\
        # AIM CONSTRAINT\n\
        #=======================================\n\
        # Enqueue a MEL command to aim the light to the mesh&#39;s transform node. We must use MEL\n\
        # because there is currently no way to enqueue calls to the maya.cmds Python module.\n\
        self.dagModifier.commandToExecute( &#39;aimConstraint -aimVector 0.0 0.0 -1.0 &#39; \n\
                                           + meshTransformDagPath.fullPathName() + &#39; &#39; \n\
                                           + lightTransformDagPath.fullPathName() )\n\
        \n\
        # Execute the MEL command we just added to the MDagModifier. By adding this command to the <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a>,\n\
        # we are able to undo it using MDagModifier.undoIt() in our command&#39;s undoIt() method. \n\
        self.dagModifier.doIt()\n\
        \n\
        #=======================================\n\
        # PHONG MATERIAL\n\
        #=======================================\n\
        # Include our mesh shape in the shading group we have defined in this command&#39;s doIt() function.\n\
        self.dagModifier.commandToExecute( &#39;sets -e -forceElement &#39; + self.shadingGroupName + &#39; &#39; + meshShapeDagPath.fullPathName() )\n\
        \n\
        # Execute the queued MEL command.\n\
        self.dagModifier.doIt()\n\
        \n\
        \n\
        # Print the contents of the scene.\n\
        self.printScene()\n\
        \n\
    \n\
    def undoIt(self):\n\
        &#39;&#39;&#39; Undo the command. &#39;&#39;&#39;\n\
        \n\
        # Switch back to the previous camera\n\
        currentView = OpenMayaUI.M3dView.active3dView()\n\
        currentView.setCamera( self.previousCamera )\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        # Observe that the number of calls to MDagModifier.undoIt() does not need to match the number of calls to MDagModifier.doIt().\n\
        self.dagModifier.undoIt()\n\
        \n\
    \n\
    def isUndoable(self):\n\
        &#39;&#39;&#39; This command must be undoable because it affects the structure of the DAG. &#39;&#39;&#39;\n\
        return True\n\
    \n\
        \n\
    def printScene(self):\n\
        &#39;&#39;&#39; Traverse and print the elements in the scene graph (DAG)  &#39;&#39;&#39;\n\
        # Create a function set which we will re-use throughout our scene graph traversal.\n\
        dagNodeFn = OpenMaya.MFnDagNode()\n\
        \n\
        # Create an iterator to traverse the scene graph starting at the world node\n\
        # (the scene&#39;s origin). We use a depth-first traversal, and we do not filter for\n\
        # any scene elements, as indicated by the &#39;OpenMaya.MFn.kInvalid&#39; parameter.\n\
        dagIterator = OpenMaya.MItDag( OpenMaya.MItDag.kDepthFirst,\n\
                                       OpenMaya.MFn.kInvalid )\n\
\n\
        print &#39;=====================&#39;\n\
        print &#39; SCENE GRAPH (DAG):  &#39;\n\
        print &#39;=====================&#39;\n\
        \n\
        # Traverse the scene.\n\
        while( not dagIterator.isDone() ):\n\
            \n\
            # Obtain the current item.\n\
            currentObj = dagIterator.currentItem()\n\
            depth = dagIterator.depth()\n\
            \n\
            # Make our dag node function set operate on the current object.\n\
            dagNodeFn.setObject( currentObj )\n\
                       \n\
            # Extract the dag node information to print.\n\
            name = dagNodeFn.name()\n\
            type = currentObj.apiTypeStr\n\
            path = dagNodeFn.fullPathName()\n\
            \n\
            # generate our output by first incrementing the tabs based on the depth\n\
            # of the current object. This formats our output nicely.\n\
            output = &#39;&#39;\n\
            for i in range( 0, depth ):\n\
                output += &#39;\\t&#39;\n\
                \n\
            output += name + &#39;: &#39; + type + &#39; [&#39; + path + &#39;]&#39;\n\
            print output\n\
            \n\
            # Increment to the next item.\n\
            dagIterator.next()\n\
        \n\
        print &#39;=====================&#39;\n\
                \n\
        \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################       \n\
def cmdCreator():\n\
    &#39;&#39;&#39; Creates an instance of the scripted command. &#39;&#39;&#39;\n\
    return SampleSceneCommand()\n\
    \n\
def initializePlugin(mobject):\n\
    &#39;&#39;&#39; Initializes the plug-in.&#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to register command: %s\\n&quot; % kPluginCmdName )\n\
\n\
def uninitializePlugin(mobject):\n\
    &#39;&#39;&#39; Uninitializes the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to unregister command: %s\\n&quot; % kPluginCmdName )\n\
\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin(&#39;pySampleScene.py&#39;)\n\
cmds.pySampleScene()\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleScene.py\n\
\n\
import sys\n\
import maya.OpenMaya as OpenMaya\n\
import maya.OpenMayaUI as OpenMayaUI\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
\n\
kPluginCmdName = &quot;mySampleScene&quot;\n\
\n\
# Vertices used to define a planar house shape within a single <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnMesh</a> object:\n\
#\n\
#              [4]\n\
#             /   \\\n\
#            /     \\\n\
#          [3]-----[2]        where the bracketed numbers correspond\n\
#           |       |         to the vertex index.\n\
#           |       |\n\
#          [0]-----[1]\n\
#\n\
vertices = [ # Square plane:\n\
             OpenMaya.MPoint( -2, -2, 0), # index 0: bottom left corner\n\
             OpenMaya.MPoint(  2, -2, 0), # index 1: bottom right corner\n\
             OpenMaya.MPoint(  2,  2, 0), # index 2: top right corner\n\
             OpenMaya.MPoint( -2,  2, 0), # index 3: top left corner\n\
             # Vertex used to define the roof:\n\
             OpenMaya.MPoint(  0,  5, 0)  # index 4: tip of the roof.\n\
           ]\n\
\n\
# Count the number of times this command has been instantiated.\n\
commandInstanceCounter = 1\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class SampleSceneCommand(OpenMayaMPx.MPxCommand):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
        \n\
        # We keep track of the number of times the command was instantiated, and we label this particular\n\
        # instance of the command with it. This will help us name the objects manipulated by this particular instance \n\
        # of the command.\n\
        global commandInstanceCounter\n\
        self.commandExecution = commandInstanceCounter\n\
        commandInstanceCounter = commandInstanceCounter + 1\n\
    \n\
    \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; Set up the objects which the command will use. &#39;&#39;&#39;\n\
        \n\
        # This <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a> object will allow us to undo and redo the creation of DAG nodes in our command.\n\
        self.dagModifier = OpenMaya.MDagModifier()\n\
        \n\
        # We first create the required MObjects using the MDagModifer assigned to self.dagModifier.\n\
        #   (!) The &#39;transform&#39;, &#39;spotLight&#39; and &#39;camera&#39; strings are recognized by the <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a> as valid node type names. \n\
        #       For a complete list of node type names, consult the Maya User Guide  &gt; Technical Documentation &gt; Nodes section.\n\
        self.meshTransformObj = self.dagModifier.createNode( &#39;transform&#39; )\n\
        self.meshShapeObj = self.createHouseMesh() # This function will create a mesh under the self.meshTransformObj node.\n\
        \n\
        self.lightTransformObj = self.dagModifier.createNode( &#39;transform&#39; )\n\
        self.lightShapeObj = self.dagModifier.createNode( &#39;spotLight&#39;, self.lightTransformObj )\n\
        \n\
        self.cameraTransformObj = self.dagModifier.createNode( &#39;transform&#39; )\n\
        self.cameraShapeObj = self.dagModifier.createNode( &#39;camera&#39;, self.cameraTransformObj )\n\
        \n\
        # Create the shading node.\n\
        self.shadingNodeName = &#39;myMaterial&#39; + str( self.commandExecution )\n\
        self.dagModifier.commandToExecute( &#39;shadingNode -asShader -name &#39; + self.shadingNodeName + &#39; phong;&#39; )\n\
        self.dagModifier.commandToExecute( &#39;setAttr &quot;&#39; + self.shadingNodeName + &#39;.color&quot; -type double3 0.7 0.2 0.15;&#39;)\n\
        \n\
        # Create the shading group.\n\
        self.shadingGroupName = &#39;myShadingGroup&#39; + str( self.commandExecution )\n\
        self.dagModifier.commandToExecute( &#39;sets -renderable true -noSurfaceShader true -empty -name &#39; + self.shadingGroupName + &#39;;&#39;)\n\
        self.dagModifier.commandToExecute( &#39;connectAttr -f &#39; + self.shadingNodeName + &#39;.outColor &#39; + self.shadingGroupName + &#39;.surfaceShader;&#39; )\n\
        \n\
        # Invoke the command&#39;s redoIt() function to actually create and manipulate these objects.\n\
        self.redoIt()\n\
    \n\
    \n\
    def createHouseMesh(self):\n\
        &#39;&#39;&#39; Create a house mesh. &#39;&#39;&#39;\n\
        global vertices # we want to access the list of vertices defined as a static variable  \n\
        \n\
        meshFn = OpenMaya.MFnMesh()\n\
        mergeVertices = True   # a parameter indicating whether or not nearby vertices will be merged.\n\
        pointTolerance = 0.001 # the distance which determines if any two nearby vertices will be merged.\n\
        \n\
        # Create the base of the house.\n\
        squareVertexArray = OpenMaya.MPointArray()\n\
        squareVertexArray.setLength( 4 )\n\
        squareVertexArray.set( vertices[0], 0 )\n\
        squareVertexArray.set( vertices[1], 1 )\n\
        squareVertexArray.set( vertices[2], 2 )\n\
        squareVertexArray.set( vertices[3], 3 )\n\
        \n\
        # Add the square polygon to the mesh whose parent is self.meshTransformObj.\n\
        meshFn.addPolygon( squareVertexArray, mergeVertices, pointTolerance, self.meshTransformObj)\n\
        \n\
        # Create the roof of the house.\n\
        triangleVertexArray = OpenMaya.MPointArray()\n\
        triangleVertexArray.setLength( 3 )\n\
        triangleVertexArray.set( vertices[3], 0 )\n\
        triangleVertexArray.set( vertices[2], 1 )\n\
        triangleVertexArray.set( vertices[4], 2 ) \n\
        \n\
        # Add a triangular polygon to the mesh whose parent is self.meshTransformObj. The returned meshShapeObj is\n\
        # a reference to the mesh geometry object.\n\
        meshShapeObj = meshFn.addPolygon( triangleVertexArray, mergeVertices, pointTolerance, self.meshTransformObj)\n\
        \n\
        # Set the name of the mesh.\n\
        meshFn.setName( &#39;myMeshShape&#39; + str( self.commandExecution ) )\n\
        \n\
        return meshShapeObj\n\
        \n\
    \n\
    def redoIt(self):\n\
        &#39;&#39;&#39; \n\
        Manipulate the objects created in doIt(). This function is also called by Maya when\n\
        the user re-does the operation after undoing it.\n\
        &#39;&#39;&#39;\n\
        \n\
        # Perform the operations enqueued within our reference to MDagModifier.\n\
        self.dagModifier.doIt()\n\
        \n\
        #=======================================\n\
        # MESH MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the mesh&#39;s transform node, as well as its name.\n\
        transformFn = OpenMaya.MFnTransform( self.meshTransformObj )\n\
        transformFn.setTranslation( OpenMaya.MVector( 0, 2, 0 ), OpenMaya.MSpace.kTransform )\n\
        transformFn.setName( &#39;myMeshTransform&#39; + str( self.commandExecution ) )\n\
        \n\
        # Obtain the DAG path of the mesh transform node. This will be used to create\n\
        # an aiming constraint between the light and the mesh.\n\
        meshTransformDagPath = OpenMaya.MDagPath()\n\
        transformFn.getPath( meshTransformDagPath )\n\
        \n\
        # The DAG path of the mesh shape node will be used to apply a material.\n\
        meshShapeDagPath = OpenMaya.MDagPath()\n\
        meshFn = OpenMaya.MFnMesh( self.meshShapeObj )\n\
        meshFn.getPath( meshShapeDagPath )\n\
                \n\
        #=======================================\n\
        # LIGHT MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the light&#39;s transform node, as well as its name.\n\
        transformFn = OpenMaya.MFnTransform( self.lightTransformObj )\n\
        transformFn.setTranslation( OpenMaya.MVector( 4, 9.5, 12 ), OpenMaya.MSpace.kTransform )\n\
        transformFn.setName( &#39;myLightTransform&#39; + str( self.commandExecution ) )\n\
        \n\
        # Obtain the DAG path of the light transform node. This will be used to create\n\
        # an aiming constraint between the light and the mesh.\n\
        lightTransformDagPath = OpenMaya.MDagPath()\n\
        transformFn.getPath( lightTransformDagPath )\n\
        \n\
        # Change the name of the light shape\n\
        spotLightFn = OpenMaya.MFnSpotLight( self.lightShapeObj )\n\
        spotLightFn.setName( &#39;myLightShape&#39; + str( self.commandExecution ) )\n\
\n\
        #=======================================\n\
        # CAMERA MANIPULATION\n\
        #=======================================\n\
        # Set the translation value of the camera&#39;s transform node, as well as its name. \n\
        transformFn = OpenMaya.MFnTransform( self.cameraTransformObj )\n\
        transformFn.setTranslation( OpenMaya.MVector( 0, 5, 30 ), OpenMaya.MSpace.kTransform )\n\
        transformFn.setName( &#39;myCameraTransform&#39; + str( self.commandExecution ) )\n\
        \n\
        # Change the name of the camera shape.\n\
        cameraFn = OpenMaya.MFnCamera( self.cameraShapeObj )\n\
        cameraFn.setName( &#39;myCameraShape&#39; + str( self.commandExecution ) )\n\
        \n\
        # Store the previous camera before we switch to the camera created within this command.\n\
        # In undo() we will revert to this previous camera.\n\
        self.previousCamera = OpenMaya.MDagPath()\n\
        currentView = OpenMayaUI.M3dView.active3dView()\n\
        currentView.getCamera( self.previousCamera ) # self.previousCamera is now populated with the current camera before we switch.\n\
        \n\
        # Get the DAG path of our camera shape node.\n\
        cameraDagPath = OpenMaya.MDagPath()\n\
        dagNodeFn = OpenMaya.MFnDagNode( self.cameraShapeObj )\n\
        dagNodeFn.getPath( cameraDagPath )\n\
        \n\
        # Set the camera view to the one we switched\n\
        currentView.setCamera( cameraDagPath )\n\
        \n\
        #=======================================\n\
        # AIM CONSTRAINT\n\
        #=======================================\n\
        # Enqueue a MEL command to aim the light to the mesh&#39;s transform node. We must use MEL\n\
        # because there is currently no way to enqueue calls to the maya.cmds Python module.\n\
        self.dagModifier.commandToExecute( &#39;aimConstraint -aimVector 0.0 0.0 -1.0 &#39; \n\
                                           + meshTransformDagPath.fullPathName() + &#39; &#39; \n\
                                           + lightTransformDagPath.fullPathName() )\n\
        \n\
        # Execute the MEL command we just added to the MDagModifier. By adding this command to the <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagModifier</a>,\n\
        # we are able to undo it using MDagModifier.undoIt() in our command&#39;s undoIt() method. \n\
        self.dagModifier.doIt()\n\
        \n\
        #=======================================\n\
        # PHONG MATERIAL\n\
        #=======================================\n\
        # Include our mesh shape in the shading group we have defined in this command&#39;s doIt() function.\n\
        self.dagModifier.commandToExecute( &#39;sets -e -forceElement &#39; + self.shadingGroupName + &#39; &#39; + meshShapeDagPath.fullPathName() )\n\
        \n\
        # Execute the queued MEL command.\n\
        self.dagModifier.doIt()\n\
        \n\
        \n\
        # Print the contents of the scene.\n\
        self.printScene()\n\
        \n\
    \n\
    def undoIt(self):\n\
        &#39;&#39;&#39; Undo the command. &#39;&#39;&#39;\n\
        \n\
        # Switch back to the previous camera\n\
        currentView = OpenMayaUI.M3dView.active3dView()\n\
        currentView.setCamera( self.previousCamera )\n\
        \n\
        # This call to MDagModifier.undoIt() undoes all the operations within the MDagModifier.\n\
        # Observe that the number of calls to MDagModifier.undoIt() does not need to match the number of calls to MDagModifier.doIt().\n\
        self.dagModifier.undoIt()\n\
        \n\
    \n\
    def isUndoable(self):\n\
        &#39;&#39;&#39; This command must be undoable because it affects the structure of the DAG. &#39;&#39;&#39;\n\
        return True\n\
    \n\
        \n\
    def printScene(self):\n\
        &#39;&#39;&#39; Traverse and print the elements in the scene graph (DAG)  &#39;&#39;&#39;\n\
        # Create a function set which we will re-use throughout our scene graph traversal.\n\
        dagNodeFn = OpenMaya.MFnDagNode()\n\
        \n\
        # Create an iterator to traverse the scene graph starting at the world node\n\
        # (the scene&#39;s origin). We use a depth-first traversal, and we do not filter for\n\
        # any scene elements, as indicated by the &#39;OpenMaya.MFn.kInvalid&#39; parameter.\n\
        dagIterator = OpenMaya.MItDag( OpenMaya.MItDag.kDepthFirst,\n\
                                       OpenMaya.MFn.kInvalid )\n\
\n\
        print &#39;=====================&#39;\n\
        print &#39; SCENE GRAPH (DAG):  &#39;\n\
        print &#39;=====================&#39;\n\
        \n\
        # Traverse the scene.\n\
        while( not dagIterator.isDone() ):\n\
            \n\
            # Obtain the current item.\n\
            currentObj = dagIterator.currentItem()\n\
            depth = dagIterator.depth()\n\
            \n\
            # Make our dag node function set operate on the current object.\n\
            dagNodeFn.setObject( currentObj )\n\
                       \n\
            # Extract the dag node information to print.\n\
            name = dagNodeFn.name()\n\
            type = currentObj.apiTypeStr()\n\
            path = dagNodeFn.fullPathName()\n\
            \n\
            # generate our output by first incrementing the tabs based on the depth\n\
            # of the current object. This formats our output nicely.\n\
            output = &#39;&#39;\n\
            for i in range( 0, depth ):\n\
                output += &#39;\\t&#39;\n\
                \n\
            output += name + &#39;: &#39; + type + &#39; [&#39; + path + &#39;]&#39;\n\
            print output\n\
            \n\
            # Increment to the next item.\n\
            dagIterator.next()\n\
        \n\
        print &#39;=====================&#39;\n\
                \n\
        \n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################       \n\
def cmdCreator():\n\
    &#39;&#39;&#39; Creates an instance of the scripted command. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( SampleSceneCommand() )\n\
    \n\
def initializePlugin(mobject):\n\
    &#39;&#39;&#39; Initializes the plug-in.&#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to register command: %s\\n&quot; % kPluginCmdName )\n\
\n\
def uninitializePlugin(mobject):\n\
    &#39;&#39;&#39; Uninitializes the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to unregister command: %s\\n&quot; % kPluginCmdName )\n\
\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin(&#39;sampleScene.py&#39;)\n\
cmds.mySampleScene()\n\
\n\
&#39;&#39;&#39;\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";