var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ディペンデンシー グラフ プラグイン</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ディペンデンシー グラフ プラグイン</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ディペンデンシー-グラフ-プラグイン\"></a></div>\n\
<p>次のトピックでは、ディペンデンシー グラフ プラグインの基本的なコード構造を示します。</p>\n\
<div class=\'section\'><a id=\"ディペンデンシー-グラフ-プラグインのサンプル\"></a><h2 id=\"ディペンデンシー-グラフ-プラグインのサンプル\">ディペンデンシー グラフ プラグインのサンプル</h2></div>\n\
<p>次の Python コードは、ディペンデンシー グラフ プラグインのサンプルです。このサンプルは、<span class=\'code\'>myNodeName</span> というユーティリティ(<span class=\'code\'>utility/general</span>)ハイパーシェード ノードを定義します。このノードには、浮動小数点数(十進数)を受け取る 1 つの入力アトリビュートと、入力された浮動小数点数を出力する 1 つの出力アトリビュートがあります。このノードは、<span class=\'code\'>cmds.createNode( &#39;myNodeName&#39; )</span> または <span class=\'code\'>cmds.shadingNode( &#39;myNodeName&#39;, asUtility=True )</span> 使用して作成されます。このノードが後者のコマンドで作成された場合、または Maya ハイパーシェード ユーザ インタフェース(テキスト ボックスに「<span class=\'code\'>My Node Name</span>」と入力してフィルタ)を介して手動で作成された場合は、ノードのインスタンスが<strong>ウィンドウ &gt; レンダリング エディタ &gt; ハイパーシェード &gt; &#39;ユーティリティ&#39; タブ(Window &gt; Rendering Editors &gt; Hypershade &gt; &#39;Utilities&#39; Tab)</strong>に表示されます。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># pySampleDGNode.py\n\
\n\
import sys\n\
\n\
import maya.api.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
def maya_useNewAPI():\n\
    &quot;&quot;&quot;\n\
    The presence of this function tells Maya that the plugin produces, and\n\
    expects to be passed, objects created using the Maya Python API 2.0.\n\
    &quot;&quot;&quot;\n\
    pass\n\
\n\
# Plug-in information:\n\
kPluginNodeName = &#39;myNodeName&#39;              # The name of the node.\n\
kPluginNodeClassify = &#39;utility/general&#39;     # Where this node will be found in the Maya UI.\n\
kPluginNodeId = OpenMaya.MTypeId( 0x87EFE ) # A unique ID associated to this node type.\n\
\n\
# Default attribute values\n\
sampleDefaultValue = 1\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class myNode(OpenMaya.MPxNode):\n\
    # Static variables which will later be replaced by the node&#39;s attributes.\n\
    sampleInAttribute = OpenMaya.MObject()\n\
    sampleOutAttribute = OpenMaya.MObject()\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMaya.MPxNode.__init__(self)\n\
        \n\
    def compute(self, pPlug, pDataBlock):\n\
        &#39;&#39;&#39;\n\
        Node computation method.\n\
            - pPlug: A connection point related to one of our node attributes (could be an input or an output)\n\
            - pDataBlock: Contains the data on which we will base our computations.\n\
        &#39;&#39;&#39;\n\
        \n\
        if( pPlug == myNode.sampleOutAttribute ):\n\
            \n\
            # Obtain the data handles for each attribute\n\
            sampleInDataHandle = pDataBlock.inputValue( myNode.sampleInAttribute )\n\
            sampleOutDataHandle = pDataBlock.outputValue( myNode.sampleOutAttribute )\n\
            \n\
            # Extract the actual value associated to our sample input attribute (we have defined it as a float)\n\
            sampleInValue = sampleInDataHandle.asFloat()\n\
            \n\
            \n\
            # ... perform the desired computation ...\n\
            \n\
            # Set the output value.\n\
            sampleOutDataHandle.setFloat( sampleInValue ) #  As an example, we just set the output value to be equal to the input value.\n\
            \n\
            # Mark the output data handle as being clean; it need not be computed given its input.\n\
            sampleOutDataHandle.setClean()\n\
             \n\
        else:\n\
            return OpenMaya.kUnknownParameter\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def nodeCreator():\n\
    &#39;&#39;&#39; Creates an instance of our node class and delivers it to Maya as a pointer. &#39;&#39;&#39;\n\
    return  myNode() \n\
\n\
def nodeInitializer():\n\
    &#39;&#39;&#39; Defines the input and output attributes as static variables in our plug-in class. &#39;&#39;&#39;\n\
    \n\
    # The following <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnNumericAttribute</a> function set will allow us to create our attributes.\n\
    numericAttributeFn = OpenMaya.MFnNumericAttribute()\n\
    \n\
    #==================================\n\
    # INPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    global sampleDefaultValue\n\
    myNode.sampleInAttribute = numericAttributeFn.create( &#39;myInputAttribute&#39;, &#39;i&#39;, \n\
                                                          OpenMaya.MFnNumericData.kFloat,\n\
                                                          sampleDefaultValue )\n\
    numericAttributeFn.writable = True \n\
    numericAttributeFn.storable = True \n\
    numericAttributeFn.hidden = False \n\
    myNode.addAttribute( myNode.sampleInAttribute ) # Calls the MPxNode.addAttribute function.\n\
    \n\
    #==================================\n\
    # OUTPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    myNode.sampleOutAttribute = numericAttributeFn.create( &#39;myOutputAttribute&#39;, &#39;o&#39;,\n\
                                                           OpenMaya.MFnNumericData.kFloat )\n\
    numericAttributeFn.storable = False \n\
    numericAttributeFn.writable = False\n\
    numericAttributeFn.readable = True \n\
    numericAttributeFn.hidden = False \n\
    myNode.addAttribute( myNode.sampleOutAttribute )\n\
    \n\
    #==================================\n\
    # NODE ATTRIBUTE DEPENDENCIES\n\
    #==================================\n\
    # If sampleInAttribute changes, the sampleOutAttribute data must be recomputed.\n\
    myNode.attributeAffects( myNode.sampleInAttribute, myNode.sampleOutAttribute )\n\
    \n\
    \n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator,\n\
                              nodeInitializer, OpenMaya.MPxNode.kDependNode, kPluginNodeClassify )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register node: &#39; + kPluginNodeName )\n\
        raise\n\
    \n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitializes the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMaya.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to deregister node: &#39; + kPluginNodeName )\n\
        raise\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
\n\
cmds.loadPlugin( &#39;pySampleDGNode.py&#39; )\n\
cmds.createNode( &#39;myNodeName&#39; )\n\
# ...\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># sampleDGNode.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
# ... additional imports here ...\n\
\n\
# Plug-in information:\n\
kPluginNodeName = &#39;myNodeName&#39;              # The name of the node.\n\
kPluginNodeClassify = &#39;utility/general&#39;     # Where this node will be found in the Maya UI.\n\
kPluginNodeId = OpenMaya.MTypeId( 0x87EFE ) # A unique ID associated to this node type.\n\
\n\
# Default attribute values\n\
sampleDefaultValue = 1\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class myNode(OpenMayaMPx.MPxNode):\n\
    # Static variables which will later be replaced by the node&#39;s attributes.\n\
    sampleInAttribute = OpenMaya.MObject()\n\
    sampleOutAttribute = OpenMaya.MObject()\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMayaMPx.MPxNode.__init__(self)\n\
        \n\
    def compute(self, pPlug, pDataBlock):\n\
        &#39;&#39;&#39;\n\
        Node computation method.\n\
            - pPlug: A connection point related to one of our node attributes (could be an input or an output)\n\
            - pDataBlock: Contains the data on which we will base our computations.\n\
        &#39;&#39;&#39;\n\
        \n\
        if( pPlug == myNode.sampleOutAttribute ):\n\
            \n\
            # Obtain the data handles for each attribute\n\
            sampleInDataHandle = pDataBlock.inputValue( myNode.sampleInAttribute )\n\
            sampleOutDataHandle = pDataBlock.outputValue( myNode.sampleOutAttribute )\n\
            \n\
            # Extract the actual value associated to our sample input attribute (we have defined it as a float)\n\
            sampleInValue = sampleInDataHandle.asFloat()\n\
            \n\
            \n\
            # ... perform the desired computation ...\n\
            \n\
            # Set the output value.\n\
            sampleOutDataHandle.setFloat( sampleInValue ) #  As an example, we just set the output value to be equal to the input value.\n\
            \n\
            # Mark the output data handle as being clean; it need not be computed given its input.\n\
            sampleOutDataHandle.setClean()\n\
             \n\
        else:\n\
            return OpenMaya.kUnknownParameter\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################\n\
def nodeCreator():\n\
    &#39;&#39;&#39; Creates an instance of our node class and delivers it to Maya as a pointer. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( myNode() )\n\
\n\
def nodeInitializer():\n\
    &#39;&#39;&#39; Defines the input and output attributes as static variables in our plug-in class. &#39;&#39;&#39;\n\
    \n\
    # The following <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnNumericAttribute</a> function set will allow us to create our attributes.\n\
    numericAttributeFn = OpenMaya.MFnNumericAttribute()\n\
    \n\
    #==================================\n\
    # INPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    global sampleDefaultValue\n\
    myNode.sampleInAttribute = numericAttributeFn.create( &#39;myInputAttribute&#39;, &#39;i&#39;, \n\
                                                          OpenMaya.MFnNumericData.kFloat,\n\
                                                          sampleDefaultValue )\n\
    numericAttributeFn.setWritable( True )\n\
    numericAttributeFn.setStorable( True ) \n\
    numericAttributeFn.setHidden( False )\n\
    myNode.addAttribute( myNode.sampleInAttribute ) # Calls the MPxNode.addAttribute function.\n\
    \n\
    #==================================\n\
    # OUTPUT NODE ATTRIBUTE(S)\n\
    #==================================\n\
    myNode.sampleOutAttribute = numericAttributeFn.create( &#39;myOutputAttribute&#39;, &#39;o&#39;,\n\
                                                           OpenMaya.MFnNumericData.kFloat )\n\
    numericAttributeFn.setStorable( False )\n\
    numericAttributeFn.setWritable( False )\n\
    numericAttributeFn.setReadable( True )\n\
    numericAttributeFn.setHidden( False )\n\
    myNode.addAttribute( myNode.sampleOutAttribute )\n\
    \n\
    #==================================\n\
    # NODE ATTRIBUTE DEPENDENCIES\n\
    #==================================\n\
    # If sampleInAttribute changes, the sampleOutAttribute data must be recomputed.\n\
    myNode.attributeAffects( myNode.sampleInAttribute, myNode.sampleOutAttribute )\n\
    \n\
    \n\
def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator,\n\
                              nodeInitializer, OpenMayaMPx.MPxNode.kDependNode, kPluginNodeClassify )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register node: &#39; + kPluginNodeName )\n\
        raise\n\
    \n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitializes the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to deregister node: &#39; + kPluginNodeName )\n\
        raise\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39; \n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
\n\
cmds.loadPlugin( &#39;sampleDGNode.py&#39; )\n\
cmds.createNode( &#39;myNodeName&#39; )\n\
# ...\n\
\n\
&#39;&#39;&#39;\n\
</pre></div><div class=\'section\'><a id=\"maya-プラグイン-エントリエグジット-ポイント\"></a><h2 id=\"maya-プラグイン-エントリエグジット-ポイント\">Maya プラグイン エントリ/エグジット ポイント</h2></div>\n\
<p>ディペンデンシー グラフ プラグインは、<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Command-Plug-ins.html\' title=\'\'>コマンド プラグイン</a>と同じエントリ/エグジット ポイント関数を必要とします。すなわち、<span class=\'code\'>initializePlugin()</span> と <span class=\'code\'>uninitializePlugin()</span> です。Maya がプラグインをロード/アンロードするときに、これらの 2 つの関数がそれぞれ呼び出されます。これらの 2 つの関数がファイルにない場合は、プラグインはロードに失敗します。ディペンデンシー グラフ プラグインを使用して、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxNode</a></span> またはその多くのサブクラスのいずれかを継承し、新しいノード タイプを作成します。このトピックに含まれるサンプルでは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxNode</a></span> を直接継承しているので、<span class=\'code\'>MFnPlugin.registerNode()</span> を介してノードを登録する必要があります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def initializePlugin( mobject ):\n\
    &#39;&#39;&#39; Initialize the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerNode( kPluginNodeName, kPluginNodeId, nodeCreator,\n\
                              nodeInitializer, OpenMayaMPx.MPxNode.kDependNode, kPluginNodeClassify )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to register node: &#39; + kPluginNodeName )\n\
        raise\n\
    \n\
def uninitializePlugin( mobject ):\n\
    &#39;&#39;&#39; Uninitializes the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterNode( kPluginNodeId )\n\
    except:\n\
        sys.stderr.write( &#39;Failed to deregister node: &#39; + kPluginNodeName )\n\
</pre></div><p><span class=\'code\'>MFnPlugin.registerNode()</span> への呼び出しに 6 つのパラメータが含まれていることが分かります。これらのパラメータの説明は次のとおりです。</p>\n\
<ol>\n\
<li><strong>ノード名</strong>: ノードの名前です。任意の名前の付いた変数 <span class=\'code\'>kPluginNodeName</span> でこの値を指定します。この変数は、<span class=\'code\'>uninitializePlugin()</span> の他に、<span class=\'code\'>sys.stderr.write()</span> へのエラー レポート呼び出しでも使用されます。</li>\n\
</ol>\n\
<p><span class=\'code\'>kPluginNodeName = &#39;myNodeName&#39;              # The name of the node.</span></p>\n\
<p>このノードの名前を登録することにより、次の Python コマンドを使用してノードのインスタンスを作成することができます。</p>\n\
<p><span class=\'code\'>import maya.cmds as cmds    cmds.createNode( &#39;myNodeName&#39; )</span></p>\n\
<ol>\n\
<li><strong>ノード ID</strong>: Maya で登録されている他のすべてのノード タイプからノードのタイプ(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MTypeId</a></span>)を識別する一意の数値です。任意の名前の付いた変数 <span class=\'code\'>kPluginNodeId</span> でこの値を指定します。</li>\n\
</ol>\n\
<p><span class=\'code\'>kPluginNodeId = OpenMaya.MTypeId( 0x87EFE ) # A unique ID associated to this node type.</span></p>\n\
<p>この <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MTypeId</a></span> 値は一意である必要があります。Maya がノードを含むファイルを保存およびロードしようとするときは、この一意の ID を使用して、ノードがラベル付けされます。ロードされたノードの一意の ID が Maya に登録されていない場合(プラグインがロードされていない可能性がある場合)は、これらのノードがディペンデンシー グラフに表示されません。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MTypeId</a></span> API ドキュメントで詳細に説明したように、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MTypeId</a></span> の特定の数値範囲は別の目的のために予約されています。次の表に、これらの範囲の概要を示します。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col width=\"23.076923076923077%\" />\n\
<col width=\"76.92307692307692%\" />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
予約済み <span class=\"code\"><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MTypeId</a></span> 範囲\n\
</th>\n\
<th class=\"table-heading\">\n\
修正される問題\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">0x00000 - 0x7ffff</span>\n\
</td>\n\
<td class=\"table-body\">\n\
広く分配するように意図されていないプラグインです。この範囲は内部で開発されたプラグインに適しています。\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">0x80000 - 0xfffff</span>\n\
</td>\n\
<td class=\"table-body\">\n\
Maya および API ドキュメントで提供されるサンプル プラグインです。\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<blockquote>\n\
<p><strong>注:</strong> 作成したディペンデンシー グラフ プラグインをパブリックに分配する場合は、グローバルに一意の ID が必要になります。<a href=\'http://www.autodesk.com/developmaya\' title=\'\' target=\'_blank\'>オートデスク デベロッパー ネットワーク</a>では、こうした ID を 64、128、256、または 512 のブロックで提供します。1 つまたは複数の 24 ビットのプリフィックスが割り当てられます。これを取得したら、2 つの <span class=\'code\'>unsigned int</span> パラメータを受け取る <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_type_id.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MTypeId</a></span> コンストラクタを使用します。プリフィックスが最初のパラメータになりますが、2 番目のパラメータになる ID の割り当てを管理する必要があります。</p>\n\
</blockquote>\n\
<ol>\n\
<li><strong>ノードの作成関数リファレンス</strong>: 任意の名前が付けられた <span class=\'code\'>nodeCreator()</span> 関数へのリファレンスです。この関数は、ノードのインスタンスを作成し、有効な Maya オブジェクト ポインタとしてそのインスタンスを返します。</li>\n\
</ol>\n\
<p>``` def nodeCreator(): &#39;&#39;&#39; Creates an instance of our node class and delivers it to Maya as a pointer. &#39;&#39;&#39; return OpenMayaMPx.asMPxPtr( myNode() )</p>\n\
<p>```</p>\n\
<ol>\n\
<li><strong>ノードのアトリビュートの初期化関数リファレンス</strong>: 任意の名前が付けられた <span class=\'code\'>nodeInitializer()</span> 関数へのリファレンスです。この関数は、ノードの入力/出力アトリビュートのセットを作成します。</li>\n\
</ol>\n\
<p>``` def nodeInitializer(): &#39;&#39;&#39; Defines the input and output attributes as static variables in our plug-in class. &#39;&#39;&#39;</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   # The following <a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnNumericAttribute</a> function set will allow us to create our attributes.\n\
   numericAttributeFn = OpenMaya.MFnNumericAttribute()\n\
\n\
   #==================================\n\
   # INPUT NODE ATTRIBUTE(S)\n\
   #==================================\n\
   global sampleDefaultValue\n\
   myNode.sampleInAttribute = numericAttributeFn.create( &#39;myInputAttribute&#39;, &#39;i&#39;, \n\
                                                         OpenMaya.MFnNumericData.kFloat,\n\
                                                         sampleDefaultValue )\n\
   numericAttributeFn.setWritable( True )\n\
   numericAttributeFn.setStorable( True ) \n\
   numericAttributeFn.setHidden( False )\n\
   myNode.addAttribute( myNode.sampleInAttribute ) # Calls the MPxNode.addAttribute function.\n\
\n\
   #==================================\n\
   # OUTPUT NODE ATTRIBUTE(S)\n\
   #==================================\n\
   myNode.sampleOutAttribute = numericAttributeFn.create( &#39;myOutputAttribute&#39;, &#39;o&#39;,\n\
                                                          OpenMaya.MFnNumericData.kFloat )\n\
   numericAttributeFn.setStorable( False )\n\
   numericAttributeFn.setWritable( False )\n\
   numericAttributeFn.setReadable( True )\n\
   numericAttributeFn.setHidden( False )\n\
   myNode.addAttribute( myNode.sampleOutAttribute )\n\
\n\
   #==================================\n\
   # NODE ATTRIBUTE DEPENDENCIES\n\
   #==================================\n\
   # If sampleInAttribute changes, the sampleOutAttribute data must be recomputed.\n\
   myNode.attributeAffects( myNode.sampleInAttribute, myNode.sampleOutAttribute )\n\
</pre></div><p>```</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnNumericAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_numeric_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnNumericAttribute</a></span> 関数セットを使用して、数値アトリビュートをカプセル化する <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> のインスタンスを作成します。これらのアトリビュートには、ロング ネームとショート ネームの他、タイプおよびオプションの既定値が必要です。作成したアトリビュートを <span class=\'code\'>myNode</span> クラスのスタティック変数、たとえば、<span class=\'code\'>myNode.sampleInAttribute</span> として割り当てます。これらのオブジェクトをスタティック変数として割り当てると、<span class=\'code\'>myNode.compute()</span> メソッドでオブジェクトを参照することができます。</p>\n\
<p>作成したアトリビュートは、<span class=\'code\'>MPxNode.addAttribute()</span> によってノードのベース クラスに追加されます。これにより、ディペンデンシー グラフでノードのアトリビュートにアクセスできるようになります。</p>\n\
<p><span class=\'code\'>MFnNumericAttribute.setWritable()</span> 関数を使用すると、入力ソースの宛先としてアトリビュートに接続することができます。<span class=\'code\'>MFnNumericAttribute.setStorable()</span> を使用すると、アトリビュートに関連付けられた値をファイルに保存することができます。<span class=\'code\'>MFnNumeric.setReadable()</span> 関数を使用すると、このアトリビュートに関連付けられた値を他のノードの書き込み可能なアトリビュートに対する入力として使用することができます。<span class=\'code\'>MFnNumeric.setHidden()</span> アトリビュートは、ユーザ インタフェースのアトリビュートを非表示にするので、このアトリビュートが誤って接続されることはありません。</p>\n\
<p><span class=\'code\'>MPxNode.attributeAffects()</span> 関数は、指定された入力に関連付けられた値が変更された場合に、ノードの <span class=\'code\'>compute()</span> 関数が呼び出され、出力アトリビュートの値が再計算されるようにします。詳細については、「<a href=\'#!/url=./dev_help/Maya-Python-API/Maya-Python-Plug-in-Learning/Dependency-Graph-Plug-in-Basics/The-Dependency-Graph.html#defining-a-custom-node\' title=\'\'>ディペンデンシー グラフ</a>」を参照してください。</p>\n\
<ol>\n\
<li><p><strong>ノード タイプ</strong>: プラグインによって定義されているノード タイプです。既定では、<span class=\'code\'>MPxNode.kDependNode</span> に設定されていますが、<span class=\'code\'>MPxNode.kLocatorNode</span>、<span class=\'code\'>MPxNode.kDeformerNode</span>、<span class=\'code\'>MPxNode.kSurfaceShape</span> などの他のタイプを指定して、ディペンデンシー グラフのさまざまな動作を定義できます。</p></li>\n\
<li><p><strong>ノードの分類</strong>: ノードの分類は、レンダー ノードの作成(Create Render Node)やハイパーシェード ウィンドウなどのさまざまなレンダリング関連のユーザ インタフェースでノードが分類される方法を決定する文字列です。文字列が提供されていない場合、ノードはレンダリング ノードとみなされないので、これらのユーザ インタフェースに表示されません。</p></li>\n\
</ol>\n\
<p><span class=\'code\'>kPluginNodeClassify = &#39;utility/general&#39;     # Where this node will be found in the Maya UI.</span></p>\n\
<p>次の表は、有効なレンダリング ノード分類のセットを示しています。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col width=\"23.076923076923077%\" />\n\
<col width=\"76.92307692307692%\" />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
カテゴリ\n\
</th>\n\
<th class=\"table-heading\">\n\
区分文字列\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
2D テクスチャ\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;texture/2d&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
3D テクスチャ\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;texture/3d&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
環境テクスチャ\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;texture/environment&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
サーフェス マテリアル\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;shader/surface&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
ボリューム マテリアル\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;shader/volume&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
ディスプレイスメント マテリアル\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;shader/displacement&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
ライト\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;light&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
一般ユーティリティ\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;utility/general&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
カラー ユーティリティ\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;utlity/color&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
パーティクル ユーティリティ\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;utility/particle&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
イメージ プレーン\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;imageplane&#39;</span>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
グロー\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">&#39;postprocess/opticalFX&#39;</span>\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<div class=\'section\'><a id=\"ノードの動作node-behavior\"></a><h2 id=\"ノードの動作node-behavior\">ノードの動作(Node Behavior)</h2></div>\n\
<p>ディペンデンシー グラフ ノード(<span class=\'code\'>myNode</span>)の動作は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxNode</a></span> を継承するクラスで定義されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class myNode(OpenMayaMPx.MPxNode):\n\
    # Static variables which will later be replaced by the node&#39;s attributes.\n\
    sampleInAttribute = OpenMaya.MObject()\n\
    sampleOutAttribute = OpenMaya.MObject()\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMayaMPx.MPxNode.__init__(self)\n\
        \n\
    def compute(self, pPlug, pDataBlock):\n\
        &#39;&#39;&#39;\n\
        Node computation method.\n\
            - pPlug: A connection point related to one of our node attributes (could be an input or an output)\n\
            - pDataBlock: Contains the data on which we will base our computations.\n\
        &#39;&#39;&#39;\n\
        \n\
        if( pPlug == myNode.sampleOutAttribute ):\n\
            \n\
            # Obtain the data handles for each attribute\n\
            sampleInDataHandle = pDataBlock.inputValue( myNode.sampleInAttribute )\n\
            sampleOutDataHandle = pDataBlock.outputValue( myNode.sampleOutAttribute )\n\
            \n\
            # Extract the actual value associated to our sample input attribute (we have defined it as a float)\n\
            sampleInValue = sampleInDataHandle.asFloat()\n\
            \n\
            \n\
            # ... perform the desired computation ...\n\
            \n\
            # Set the output value.\n\
            sampleOutDataHandle.setFloat( sampleInValue ) #  As an example, we just set the output value to be equal to the input value.\n\
            \n\
            # Mark the output data handle as being clean; it need not be computed given its input.\n\
            sampleOutDataHandle.setClean()\n\
             \n\
        else:\n\
            return OpenMaya.kUnknownParameter\n\
</pre></div><p>Maya は、<span class=\'code\'>nodeInitializer()</span> の <span class=\'code\'>MPxNode.addAttribute()</span> で追加されたノード アトリビュートを使用して、ノードがディペンデンシー グラフでインスタンス化されたときにノードの入力/出力接続ポイントを定義します。</p>\n\
<p>これらの接続ポイントはプラグと呼ばれ、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPlug</a></span> のインスタンスによって表されます。<strong><span class=\'code\'>nodeInitializer()</span> の <span class=\'code\'>MPxNode.attributeAffects()</span> への呼び出しは、これらのプラグ間の原因となる入力 &gt; 出力リンクを決定します。最終的に、ディペンデンシー グラフは、すべてのノード間で接続されているプラグの有向エッジを追跡します。Maya のディペンデンシー グラフの継続している評価プロセス中に、プラグに関連付けられたデータが変更された場合は、このプラグがダーティとしてマークされます。つまり、キャッシュされた値が古いので、値を再計算する必要があります。</strong>プラグ階層が再帰的にトラバースされ、残りの影響を受けるプラグがダーティとしてマークされます。</p>\n\
<p>次に、Maya は、ダーティなプラグを含む各ノードで <span class=\'code\'>compute()</span> メソッドを呼び出し、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPlug</a></span> と <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDataBlock</a></span> のインスタンスを渡します。渡された <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPlug</a></span> の関連するアトリビュートをチェックし、何を計算するか決定する必要があります。これは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPlug</a></span> のオーバーロードされた等価演算子「<span class=\'code\'>==</span>」を使用して行います。</p>\n\
<p>渡された <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDataBlock</a></span> インスタンスには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDataHandle</a></span> オブジェクトが含まれます。このオブジェクトには、それぞれのアトリビュートに関連付けられた値が格納されます。<span class=\'code\'>float</span>入力値は、次のように取得されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">sampleInDataHandle = pDataBlock.inputValue( myNode.sampleInAttribute )\n\
sampleInValue = sampleInDataHandle.asFloat()\n\
</pre></div><p><span class=\'code\'>compute()</span> メソッドは、新たに計算された値を正しい出力 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDataHandle</a></span> に設定することによって終了する必要があります。<span class=\'code\'>MDataHandle.setClean()</span> への呼び出しによって、対応するプラグからダーティなフラグが除去されます。</p>\n\
<p><span class=\'code\'>compute()</span> 関数に渡されたプラグが計算可能な出力アトリビュートに関連していない場合は、関数が <span class=\'code\'>OpenMaya.kUnknownParameter</span> を返す必要があります。これにより、ベース クラスのいずれかの <span class=\'code\'>compute()</span> 関数を使用してプラグの値を計算する必要があることが Maya に通知されます。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";