var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Python 構文に関するヒント</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Python 構文に関するヒント</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"python-構文に関するヒント\"></a></div>\n\
<p>Python プログラミングの初心者ユーザ向けに、この学習パスで使用される Python コードの構文をすばやく理解するためのいくつかの基本的なヒントをここに示します。詳細な説明が必要な場合は、<a href=\'https://docs.python.org/ja/3/tutorial/introduction.html\' title=\'\' target=\'_blank\'>The Informal Introduction to Python (英語)</a>を参照してください。</p>\n\
<div class=\'section\'><a id=\"コメント\"></a><h2 id=\"コメント\">コメント</h2></div>\n\
<p>1 行のコメントは、シャープ記号(<span class=\'code\'>#</span>)から始まり、改行文字で終了します。複数行のコメントは、3 つの一重引用符(または二重引用符)で囲みます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">someVariable = 4 # This assigns 4 to someVariable.\n\
\n\
&#39;&#39;&#39; There are multiple lines \n\
in this comment. &#39;&#39;&#39;\n\
\n\
&quot;&quot;&quot; \n\
Another\n\
multiple\n\
line\n\
comment. \n\
&quot;&quot;&quot; \n\
<blockquote>\n\
</blockquote></pre></div><p><strong>注:</strong> 3 つの一重引用符(または二重引用符)は、改行または通常の引用符が含まれる文字列を作成するために使用することもできます。</p>\n\
\n\
<div class=\'section\'><a id=\"文字列\"></a><h2 id=\"文字列\">文字列</h2></div>\n\
<p>文字列を一重引用符または二重引用符のペアで囲み、さらに「<span class=\'code\'>+</span>」演算子を使用して連結することができます。<span class=\'code\'>str()</span> 関数は、入力した文字を文字列表現に変換することを試みます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">myString1 = &#39;some&#39; + &#39; string&#39;\n\
myString2 = &quot;another &quot; + &quot;string&quot;\n\
\n\
print &#39;four: &#39; + str(4) \n\
# &#39;four: 4&#39;\n\
</pre></div><div class=\'section\'><a id=\"リスト\"></a><h2 id=\"リスト\">リスト</h2></div>\n\
<p>リストは角括弧のペアで示され、ダイナミック配列と等価です。 リスト内の開始インデックスは <span class=\'code\'>0</span> です。リストに追加するには、<span class=\'code\'>append()</span> 関数を使用します。<span class=\'code\'>len()</span> 関数は、リストの長さを返します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">myList = []\n\
myList.append(&#39;apples&#39;)\n\
myList.append(&#39;oranges&#39;)\n\
\n\
print myList[1] \n\
# &#39;oranges&#39;\n\
\n\
print str( len( myList ) ) \n\
# &#39;2&#39;\n\
</pre></div><div class=\'section\'><a id=\"ディクショナリ\"></a><h2 id=\"ディクショナリ\">ディクショナリ</h2></div>\n\
<p>ディクショナリは中括弧のペアで示され、キー値のペアが含まれています(ここで、キーは文字列と同様に Hashable オブジェクト)。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">myDictionary = {}\n\
myDictionary[&#39;myKey&#39;] = &#39;myValue&#39;\n\
myDictionary[&#39;myOtherKey&#39;] = 17\n\
\n\
print str( myDictionary[&#39;myOtherKey&#39;] ) \n\
# &#39;17&#39;\n\
\n\
print str( myDictionary ) \n\
# &#39;{&#39;myKey&#39;: &#39;myValue&#39;, &#39;myOtherKey&#39;: 17}&#39;\n\
</pre></div><div class=\'section\'><a id=\"タプル\"></a><h2 id=\"タプル\">タプル</h2></div>\n\
<p>タプルは固定シーケンスで、括弧のペアによって表されます。タプル内の要素は、そのインデックスに応じて参照されます。タプルの先頭要素のインデックスは、ゼロ <span class=\'code\'>[0]</span> になります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">myTuple = (&#39;pants&#39;, &#39;shirt&#39;, 1987)\n\
\n\
print str( myTuple[1] )\n\
# &#39;shirt&#39;\n\
\n\
print str( myTuple )\n\
# (&#39;pants&#39;, &#39;shirt&#39;, 1987)\n\
\n\
</pre></div><div class=\'section\'><a id=\"セットsets\"></a><h2 id=\"セットsets\">セット(Sets)</h2></div>\n\
<p>セットは一意の(hashable)オブジェクトの不規則なコレクションです。セットは中括弧で示されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">mySet = {&quot;cat&quot;, &quot;dog&quot;, &quot;lizard&quot;, &quot;emu&quot;}\n\
\n\
# Print set.\n\
print(mySet)\n\
# set([&#39;emu&#39;, &#39;lizard&#39;, &#39;dog&#39;, &#39;cat&#39;])\n\
\n\
print(len(mySet))\n\
# 4\n\
\n\
# Use in-keyword.\n\
if &quot;lizard&quot; in mySet:\n\
    print(&quot;Lizard exists&quot;)\n\
# Lizard exists\n\
\n\
</pre></div><div class=\'section\'><a id=\"クラス関数およびインデント\"></a><h2 id=\"クラス関数およびインデント\">クラス、関数、およびインデント</h2></div>\n\
<p>クラスや関数、あるいは If/Else 条件やループなどのステートメント本体を識別するために、一貫したインデントを使用してください。下記のサンプル コードでは、4 つのスペース(&#39; &#39;)文字によって 1 つのインデントのレベルを示しています。 クラスはキーワード「<span class=\'code\'>class</span>」を使用して宣言され、メソッドおよびグローバル関数はキーワード「<span class=\'code\'>def</span>」を使用して宣言されます。クラス メソッドの最初のパラメータ(通常は「<span class=\'code\'>self</span>」という名前)は現在のインスタンスを参照することに注意してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class myClass:\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; \n\
        __init__ identifies the class constructor. \n\
        &#39;&#39;&#39;\n\
        pass # The &#39;pass&#39; keyword indicates that we do nothing.\n\
\n\
    def doIt(self, myParameter):\n\
        &#39;&#39;&#39;\n\
        This is a method which we have defined as having one\n\
        parameter whose name is myParameter.\n\
        &#39;&#39;&#39;\n\
        for i in range(0, 9): # This will loop 10 times.\n\
            if (i == 0):\n\
                # Print &#39;Hello World!&#39; on the first iteration\n\
                print &#39;Hello World!&#39;\n\
            else:\n\
                # Print a string representation of myParameter the rest of the time.\n\
                print str( myParameter )\n\
\n\
# This code will be executed once the myClass definition is read.\n\
myClassInstance = myClass()\n\
myClassInstance.doIt( &#39;some string&#39; )\n\
</pre></div><div class=\'section\'><a id=\"例外処理\"></a><h2 id=\"例外処理\">例外処理</h2></div>\n\
<p>従来の try/catch/finally 例外処理は、「<span class=\'code\'>try</span>」および「<span class=\'code\'>except</span>」キーワード シーケンスを使用して実行されます。「<span class=\'code\'>else</span>」と「<span class=\'code\'>finally</span>」キーワードは省略可能です。キーワード「<span class=\'code\'>else</span>」に続くコードは、キーワード「<span class=\'code\'>try</span>」に続くコードが例外なく実行された場合に実行されます。キーワード「<span class=\'code\'>finally</span>」に続くコードは、例外の発生にかかわらず実行されます。キーワード「<span class=\'code\'>raise</span>」を使用して、独自の例外を発生させることができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># This code sample can be found at: http://docs.python.org/tutorial/errors.html\n\
def divide(x, y):\n\
    try:\n\
        result = x / y\n\
    except ZeroDivisionError:\n\
        print &quot;division by zero!&quot;\n\
    else:\n\
        print &quot;result is&quot; + result\n\
    finally:\n\
        print &quot;executing finally clause&quot;\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";