var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Maya で PySide を使用する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Maya で PySide を使用する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maya-で-pyside-を使用する\"></a></div>\n\
<p>PyQt と PySide は非常に似ており、2 つはほぼ同じ API を使用します。</p>\n\
<p>また、PySide は Qt ディストリビューションに含まれているので、各 Maya バージョンのソースから手動でビルドする必要はありません。</p>\n\
<div class=\'section\'><a id=\"pyqt-と-pyside-の違い\"></a><h2 id=\"pyqt-と-pyside-の違い\">PyQt と PySide の違い</h2></div>\n\
<p>読み込みの方法、クラス名、ツール名にいくつかの違いがあります。次に例を示します。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> Maya 2017 では、PySide バージョン 2.0 が Maya と共に使用されます。</p>\n\
</blockquote>\n\
<p>読み込み:</p>\n\
<ul>\n\
<li>(PyQt) <span class=\'code\'>from PyQt4.QtCore import *</span></li>\n\
<li>(PySide) <span class=\'code\'>from PySide2.QtCore import *</span></li>\n\
</ul>\n\
<p>クラス名の違い:</p>\n\
<ul>\n\
<li>(PyQt) <span class=\'code\'>QtCore.pyqtSignal</span> v (PySide) <span class=\'code\'>QtCore.Signal</span></li>\n\
<li>(PyQt) <span class=\'code\'>QtCore.pyqtSlot</span> v (PySide) <span class=\'code\'>QtCore.Slot</span></li>\n\
<li>(PyQt) <span class=\'code\'>QtCore.pyqtProperty</span> v (PySide) <span class=\'code\'>QtCore.Property</span></li>\n\
</ul>\n\
<p>ツール名の違い:</p>\n\
<ul>\n\
<li>(PyQt) <span class=\'code\'>pyuic4</span> v (PySide) <span class=\'code\'>pyside-uic</span></li>\n\
<li>(PyQt) <span class=\'code\'>pyrcc4</span> v (PySide) <span class=\'code\'>pyside-rcc</span></li>\n\
<li>(PyQt) <span class=\'code\'>pylupdate4</span> v (PySide) <span class=\'code\'>pyside-lupdate</span></li>\n\
<li>(PyQt) <span class=\'code\'>sip</span> v (PySide) <span class=\'code\'>shiboken2</span></li>\n\
</ul>\n\
<p>信号</p>\n\
<p>PySide:</p>\n\
<ul>\n\
<li>旧形式の信号には括弧が必要です。</li>\n\
<li>引数を指定しない信号のみが QAction などのコンストラクタに自動接続されます。</li>\n\
</ul>\n\
<p>その他の違い</p>\n\
<ul>\n\
<li>Qt 4.5 より前に廃止された関数は PySide にはありません。</li>\n\
<li>PySide のみで PyQt の API2 がサポートされます。</li>\n\
<li>Python コードについて、PySide のほうが PyQt より厳密です。</li>\n\
</ul>\n\
<p>__init__ では、リラックスされた(正しくない) <span class=\'code\'>super(&lt;QtGui.QWidget&gt;,self).__init__(parent)</span> の代わりに、<span class=\'code\'>super(&lt;yourClassName&gt;,self).__init__(parent)</span> を呼び出す必要があります。</p>\n\
<div class=\'section\'><a id=\"maya-の-pyside-について\"></a><h2 id=\"maya-の-pyside-について\">Maya の PySide について</h2></div>\n\
<p>次に Maya 固有の PySide についていくつかの事実を示します。</p>\n\
<ul>\n\
<li>「<a href=\'#!/url=./dev_help/Maya-Python-API/Working-with-PySide-in-Maya/PyQt-and-PySide-Widget-Best.html#maintain-a-reference-to-your-widget\' title=\'\'>ウィジェットへのリファレンスの維持</a>」で説明されているように、Python インタプリタのガベージ コレクターによってウィジェットが破棄されないように、既存の Maya ウィンドウに対して Qt ウィジェットをペアレント化する必要があります。Maya のメイン ウィンドウまたはドッキング コントロールに対して PySide ウィジェットをペアレント化することができます。これは、「<a href=\'#!/url=./dev_help/Maya-Python-API/Working-with-PySide-in-Maya/PyQt-and-PySide-Widget-Best.html#use-the-maya-app-general-mayamixin-classes\' title=\'\'>maya.app.general.mayaMixin クラスの使用</a>」の説明に従って、ミックスイン クラスを使用しても、簡単に行うことができます。</li>\n\
<li>ウィジェットを使用し、<span class=\'code\'>maya.OpenMayaUI.MQtUtil.findControl()</span> からルックアップできるようにするには、ウィジェットに一意の <span class=\'code\'>objectName()</span>が必要です。</li>\n\
<li>PySide ウィジェットにネイティブのサイズ変更プリファレンスはありません。サイズ変更プリファレンスは、<span class=\'code\'>windowPref</span> コマンドを直接使用して設定することができます。</li>\n\
<li>ウィンドウをドッキングしたときにウィジェットのサイズが保持され、同じ領域に複数のウィンドウをドッキングすることができるため、Maya と同様にタブを使用してウィンドウを切り替えることができます。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"pyside-サンプル-スクリプト\"></a><h2 id=\"pyside-サンプル-スクリプト\">PySide サンプル スクリプト</h2></div>\n\
<p>Developer Kit インストール フォルダ <span class=\'code\'>devkit/pythonScripts</span> に基本的な PySide スクリプトの基本概念を例示するいくつかのサンプル スクリプトがあります。「<a href=\'#!/url=./dev_help/Setting-up-your-build/Windows-environment-64-bit-.html\' title=\'\'>ビルド環境を設定する: Windows 環境(64 ビット)</a>」を参照してください。</p>\n\
<div class=\'section\'><a id=\"サンプル-スクリプトを実行する\"></a><h3 id=\"サンプル-スクリプトを実行する\">サンプル スクリプトを実行する</h3></div>\n\
<p>サンプル スクリプトは、スクリプト エディタ(Script Editor)の Python タブで次のように <span class=\'code\'>execfile</span> コマンドを使用して実行することができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">execfile(&#39;C:/Program Files/Autodesk/Maya2017/devkit/pythonScripts/widgetHierarchy.py&#39;)\n\
\n\
</pre></div><p>または、スクリプトを読み込むことで、サンプル スクリプトを実行することもできます。次は、<span class=\'code\'>createNodeUI.py</span> サンプルを実行するための推奨方法です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">import sys\n\
import os.path\n\
sys.path.insert(0,  os.path.join(os.environ[&#39;MAYA_LOCATION&#39;], &#39;devkit&#39;, &#39;pythonScripts&#39; ) )\n\
\n\
import createNodeUI\n\
w = createNodeUI.main()\n\
w.close()\n\
</pre></div><div class=\'section\'><a id=\"maya-ウィジェットのカラーをカスタマイズする\"></a><h3 id=\"maya-ウィジェットのカラーをカスタマイズする\">Maya ウィジェットのカラーをカスタマイズする</h3></div>\n\
<p>以下の <span class=\'code\'>editMayaWidgets.py</span> スクリプトで、Maya のメイン ウィンドウのカラーとメニューをカスタマイズする方法を例示します。</p>\n\
<p>Maya の標準的な読み込みは次のとおりです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">from maya import cmds\n\
from maya import mel\n\
from maya import OpenMayaUI as omui \n\
</pre></div><p>さらに、次の PySide の読み込みを含めます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">from PySide2.QtCore import * \n\
from PySide2.QtGui import *\n\
from PySide2.QtWidgets import *\n\
from shiboken2 import wrapInstance \n\
<blockquote>\n\
</blockquote></pre></div><p><strong>注:</strong> スクリプトが Maya 2017 よりも古いバージョンの Maya とも互換性があると便利です。そのための方法の 1 つとして、次の手順のようにして PySide から読み込む方法があります。</p>\n\
\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">try:\n\
  from PySide2.QtCore import * \n\
  from PySide2.QtGui import * \n\
  from PySide2.QtWidgets import *\n\
  from PySide2 import __version__\n\
  from shiboken2 import wrapInstance \n\
except ImportError:\n\
  from PySide.QtCore import * \n\
  from PySide.QtGui import * \n\
  from PySide import __version__\n\
  from shiboken import wrapInstance \n\
</pre></div><p>Maya のメイン ウィンドウ ウィジェットを PySide ウィジェットとして取得するには、次のようにします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">omui.MQtUtil.mainWindow()    \n\
ptr = omui.MQtUtil.mainWindow()    \n\
widget = wrapInstance(long(ptr), QWidget)\n\
</pre></div><p>このスクリプトでは、スタイルシートを編集して Maya の背景色を変更する方法を例示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def changeMayaBackgroundColor(background=&#39;black&#39;, color=&#39;yellow&#39;):\n\
    ....\n\
    widget.setStyleSheet(\n\
        &#39;background-color:%s;&#39;%background +\n\
        &#39;color:%s;&#39;%color\n\
        )\n\
</pre></div><p>このスクリプトでは、はじめに Python で MEL 文字列を評価し、次に <span class=\'code\'>maya.OpenMayaUI.MQtUtil.findControl()</span> を使用することで、PySide ウィジェットとして Maya のコントロール(この場合は作成(Create)メニュー)を取得する方法も例示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">widgetStr = mel.eval( &#39;string $tempString = $gMainCreateMenu&#39; )    \n\
ptr = omui.MQtUtil.findControl( widgetStr )    \n\
widget = wrapInstance(long(ptr), QWidget)\n\
</pre></div><p>次のように、Qt スタイルシートを編集することで、メニュー(この場合は作成(Create)メニュー)のフォント スタイルとウェイトを変更することができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def changeMayaMenuColors(fontStyle=&#39;italic&#39;, fontWeight=&#39;bold&#39;, fontColor=&#39;cyan&#39;):\n\
    ....\n\
    widget.setStyleSheet(\n\
        &#39;font-style:%s;&#39;%fontStyle +\n\
        &#39;font-weight:%s;&#39;%fontWeight +\n\
        &#39;color:%s;&#39;%fontColor\n\
        )\n\
<div class=\'figure\'><img src=\'dev_help/images/EditMayaWidgets_PySide.png\' title=\'\'></div>\n\
</pre></div><div class=\'section\'><a id=\"単純な-qt-ウィジェットを作成する\"></a><h3 id=\"単純な-qt-ウィジェットを作成する\">単純な Qt ウィジェットを作成する</h3></div>\n\
<p><span class=\'code\'>createPolygonUI.py</span> スクリプトでは、ドロップダウン メニュー(コンボ ボックス)と作成(Create)ボタンを使用して Qt ウィジェットを作成します。ドロップダウン メニューのいくつかのポリゴン プリミティブの中から選択し、作成(Create)をクリックして、選択したポリゴンを作成します。</p>\n\
<p>このスクリプトでは、QT ウィジェット UI の作成に <span class=\'code\'>QComboBox</span> と <span class=\'code\'>QPushButton</span> を使用する方法を例示します。</p>\n\
<p>このスクリプトでは、作成する QT ウィジェットの親ウィジェットとして設定することができるように、最初に PySide ウィジェットとして Maya のメイン ウィンドウ ウィジェットを取得します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">mayaMainWindowPtr = omui.MQtUtil.mainWindow()\n\
mayaMainWindow = wrapInstance(long(mayaMainWindowPtr), QWidget) \n\
</pre></div><p><span class=\'code\'>QWidget</span> から派生させることでポリゴンを作成(Create Polygon)ウィンドウを作成し、次に <span class=\'code\'>OpenMayaUI.QtUtils.findWidget()</span> 使用して取得できるようオブジェクト名を設定します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class CreatePolygonUI(QWidget):    \n\
    def __init__(self, *args, **kwargs):        \n\
        super(CreatePolygonUI, self).__init__(*args, **kwargs)\n\
        \n\
        #Parent widget under Maya main window        \n\
        self.setParent(mayaMainWindow)        \n\
        self.setWindowFlags(Qt.Window)   \n\
        \n\
        #Set the object name     \n\
        self.setObjectName(&#39;CreatePolygonUI_uniqueId&#39;)        \n\
        self.setWindowTitle(&#39;Create polygon&#39;)        \n\
        self.setGeometry(50, 50, 250, 150)        \n\
        self.initUI()        \n\
        self.cmd = &#39;polyCone&#39;\n\
</pre></div><p>このスクリプトでは、ドロップダウン メニューを作成するために <span class=\'code\'>QComboBox</span> を使用する方法、コンボ ボックス(ドロップダウン メニュー)変更時にコマンド文字列を変更する方法を例示します。</p>\n\
<p><span class=\'code\'>QPushButton</span> は、ボタンを作成するために使用し、クリックすると次の MEL コマンドが実行されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def initUI(self):        \n\
    #Create combo box (drop-down menu) and add menu items \n\
    self.combo = QComboBox(self)        \n\
    self.combo.addItem( &#39;Cone&#39; )        \n\
    self.combo.addItem( &#39;Cube&#39; )        \n\
    self.combo.addItem( &#39;Sphere&#39; )        \n\
    self.combo.addItem( &#39;Torus&#39; )        \n\
    self.combo.setCurrentIndex(0)        \n\
    self.combo.move(20, 20)        \n\
    self.combo.activated[str].connect(self.combo_onActivated)        \n\
\n\
    #Create &#39;Create&#39; button\n\
    self.button = QPushButton(&#39;Create&#39;, self)        \n\
    self.button.move(20, 50)        \n\
    self.button.clicked.connect(self.button_onClicked)                    \n\
\n\
#Change commmand string when combo box changes\n\
def combo_onActivated(self, text):        \n\
    self.cmd = &#39;poly&#39; + text + &#39;()&#39;            \n\
\n\
#Execute MEL command when button is clicked\n\
def button_onClicked(self):        \n\
    mel.eval( self.cmd )            \n\
<div class=\'figure\'><img src=\'dev_help/images/Create_Polygon_PySide.png\' title=\'\'></div>\n\
</pre></div><div class=\'section\'><a id=\"qt-designer-の-ui-ファイルをロードしてロードしたウィジェットを編集する\"></a><h3 id=\"qt-designer-の-ui-ファイルをロードしてロードしたウィジェットを編集する\">Qt Designer の UI ファイルをロードしてロードしたウィジェットを編集する</h3></div>\n\
<p><span class=\'code\'>createNodeUI.py</span> スクリプトでは、Qt Designer の UI ファイルをロードし、ロードしたウィジェットを編集する方法を例示します。まず、Qt Designer を使用して、ウィジェット ツリーを表す <span class=\'code\'>.ui</span> ファイルを作成する必要があります。</p>\n\
<p>これらのコマンドは、<span class=\'code\'>.ui</span> ファイルをロードします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def initUI(self):        \n\
    loader = QUiLoader()        \n\
    currentDir = os.path.dirname(__file__)        \n\
    file = QFile(currentDir+&quot;/createNode.ui&quot;)        \n\
    file.open(QFile.ReadOnly)        \n\
    self.ui = loader.load(file, parentWidget=self)        \n\
    file.close()\n\
</pre></div><p>次に、サンプル スクリプトは、コンボ ボックスに項目を追加することでファイルからロードされた Qt ウィジェットを編集し、OK ボタンとキャンセル ボタンを押すと実行されるようにコマンドを設定します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># Add items to combo box\n\
self.ui.typeComboBox.addItem( &#39;locator&#39; )        \n\
self.ui.typeComboBox.addItem( &#39;camera&#39; )        \n\
self.ui.typeComboBox.addItem( &#39;joint&#39; )                \n\
\n\
# Call doOK if user clicks OK button\n\
self.ui.okButton.clicked.connect( self.doOK )\n\
\n\
# Call doCancel if user clicks Cancel button        \n\
self.ui.cancelButton.clicked.connect( self.doCancel )\n\
</pre></div><p>OK ボタンを押すと、コンボ ボックスによって指定されたタイプの(該当する場合は、指定された名前を持つ)ノードが作成されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def doOK(self):        \n\
    nName = self.ui.nameLineEdit.text()        \n\
    nType = self.ui.typeComboBox.currentText()        \n\
    if len(nName) &gt; 0:            \n\
        cmds.createNode( nType, n=nName )        \n\
    else:            \n\
        cmds.createNode( nType )        \n\
    self.close()\n\
</pre></div><p>それ以外の場合は、ユーザがキャンセルをクリックすると、Qt ウィジェットを閉じます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def doCancel(self):        \n\
    self.close()\n\
<div class=\'figure\'><img src=\'dev_help/images/createNode_PySide.png\' title=\'\'></div>\n\
</pre></div><div class=\'section\'><a id=\"基本的なアトリビュート-エディタを作成する\"></a><h3 id=\"基本的なアトリビュート-エディタを作成する\">基本的なアトリビュート エディタを作成する</h3></div>\n\
<p><span class=\'code\'>connectAttr.py</span> スクリプトでは、基本的なアトリビュート エディタ(Attribute Editor)を作成する方法を例示します。このエディタはアトリビュート値を更新し、アトリビュート変更時に更新されます。この方法で、アトリビュート値とコントロールの値は同期されます。</p>\n\
<p>そのドッキング可能な関数で <span class=\'code\'>mayaMixin</span> が使用され、<span class=\'code\'>QFormLayout</span> と <span class=\'code\'>QScrollLayout</span> を使用して Qt UI が作成されます。</p>\n\
<p>次のように <span class=\'code\'>mayaMixin</span> モジュールを読み込みます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">from maya.app.general.mayaMixin import MayaQWidgetBaseMixin, MayaQWidgetDockableMixin\n\
</pre></div><p>この例では、<span class=\'code\'>MayaQWidgetDockableMixin</span> クラスと <span class=\'code\'>QScrollArea</span> クラスから派生し、コンテナ ウィジェットとアトリビュート ウィジェットを作成します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class Example_connectAttr(MayaQWidgetDockableMixin, QScrollArea):\n\
    def __init__(self, node=None, *args, **kwargs):\n\
        super(Example_connectAttr, self).__init__(*args, **kwargs)\n\
        # Member Variables\n\
        self.nodeName = node               # Node name for the UI\n\
        self.attrUI = None                 # Container widget for the attr UI widgets\n\
        self.attrWidgets = {}              # Dict key=attrName, value=widget\n\
        .....\n\
</pre></div><p>次に、<span class=\'code\'>MayaQWidgetDockableMixin</span> クラスの <span class=\'code\'>show()</span> メソッドを使用して、ウィジェットを表示し、ドッキング可能なフロートするウィンドウとして設定します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">ui = Example_connectAttr(node=obj)\n\
ui.show(dockable=True, floating=True)\n\
</pre></div><p>次に、<span class=\'code\'>QFormLayout</span> を使用し、アトリビュート名の文字列とアトリビュート ウィジェットを指定して 2 列フォームのウィジェットを作成します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def attachToNode(self, nodeName):\n\
    &#39;&#39;&#39;Connect UI to the specified node\n\
    &#39;&#39;&#39;\n\
    self.nodeName = nodeName\n\
    self.attrs = None\n\
    self.nodeCallbacks = []\n\
    self._deferredUpdateRequest.clear()\n\
    self.attrWidgets.clear()\n\
\n\
    # Get a sorted list of the attributes\n\
    attrs = cmds.listAttr(self.nodeName)\n\
    attrs.sort() # in-place sort the attributes\n\
\n\
    # Create container for attribute widgets\n\
    self.setWindowTitle(&#39;ConnectAttrs: %s&#39;%self.nodeName)\n\
    self.attrUI = QWidget(parent=self)\n\
    layout = QFormLayout()\n\
\n\
    # Loop over the attributes and construct widgets\n\
    acceptedAttrTypes = set([&#39;doubleLinear&#39;, &#39;string&#39;, &#39;double&#39;, &#39;float&#39;, &#39;long&#39;, &#39;short&#39;, &#39;bool&#39;, &#39;time&#39;, &#39;doubleAngle&#39;, &#39;byte&#39;, &#39;enum&#39;])\n\
    for attr in attrs:\n\
        # Get the attr value (and skip if invalid)\n\
        try:\n\
            attrType = cmds.getAttr(&#39;%s.%s&#39;%(self.nodeName, attr), type=True)\n\
            if attrType not in acceptedAttrTypes:\n\
                continue # skip attr\n\
            v = cmds.getAttr(&#39;%s.%s&#39;%(self.nodeName, attr))\n\
        except Exception, e:\n\
            continue  # skip attr\n\
\n\
        # Create the widget and bind the function\n\
        attrValueWidget = QLineEdit(parent=self.attrUI)\n\
        attrValueWidget.setText(str(v))\n\
\n\
        ....\n\
\n\
        # Add to layout\n\
        layout.addRow(attr, attrValueWidget)\n\
\n\
        # Track the widget associated with a particular attribute\n\
        self.attrWidgets[attr] = attrValueWidget\n\
\n\
    # Attach the QFormLayout to the root attrUI widget\n\
    self.attrUI.setLayout(layout)\n\
</pre></div><p>このメソッドは <span class=\'code\'>functools.partial()</span>を使用して <span class=\'code\'>setAttr</span> にメタデータを追加してから、<span class=\'code\'>attrValueWidget.editingFinished</span> 信号に接続します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># Use functools.partial() to dynamically construct a function with additional parameters\n\
onSetAttrFunc =  functools.partial(self.onSetAttr, widget=attrValueWidget, attrName=attr)\n\
attrValueWidget.editingFinished.connect( onSetAttrFunc )\n\
\n\
def onSetAttr(self, widget, attrName, *args, **kwargs):\n\
    &#39;&#39;&#39;Handle setting the attribute when the UI widget edits the value for it.\n\
    If it fails to set the value, then restore the original value to the UI widget\n\
    &#39;&#39;&#39;\n\
    print &quot;onSetAttr&quot;, attrName, widget, args, kwargs\n\
        \n\
    try:\n\
        attrType = cmds.getAttr(&#39;%s.%s&#39;%(self.nodeName, attrName), type=True)\n\
        if attrType == &#39;string&#39;:\n\
            cmds.setAttr(&#39;%s.%s&#39;%(self.nodeName, attrName), widget.text(), type=attrType)\n\
        else:\n\
            cmds.setAttr(&#39;%s.%s&#39;%(self.nodeName, attrName), eval(widget.text()))\n\
    except Exception, e:\n\
        print e\n\
        curVal = cmds.getAttr(&#39;%s.%s&#39;%(self.nodeName, attrName))\n\
        widget.setText( str(curVal) )\n\
</pre></div><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MMessage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_message.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_message.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMessage</a></span> コールバックを削除するためにラッパークラスが作成されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class MCallbackIdWrapper(object):\n\
    &#39;&#39;&#39;Wrapper class to handle cleaning up of MCallbackIds from registered <a href=\"javascript:void(0)\" data-symbol=\"MMessage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_message.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_message.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMessage</a>\n\
    &#39;&#39;&#39;\n\
    def __init__(self, callbackId):\n\
        super(MCallbackIdWrapper, self).__init__()\n\
        self.callbackId = callbackId\n\
\n\
    def __del__(self):\n\
        om.MMessage.removeCallback(self.callbackId)\n\
\n\
    def __repr__(self):\n\
        return &#39;MCallbackIdWrapper(%r)&#39;%self.callbackId\n\
</pre></div><p>アトリビュートの値のリフレッシュをトリガするために <span class=\'code\'>addNodeDirtyPlugCallback</span> を使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">nodeObj = getDependNode(nodeName)\n\
cb = om.MNodeMessage.addNodeDirtyPlugCallback(nodeObj, self.onDirtyPlug, None)\n\
self.nodeCallbacks.append( MCallbackIdWrapper(cb) )\n\
</pre></div><p>またこの例では、UI の更新を保留するために <span class=\'code\'>evalDeferred</span> も使用します。評価は、次に Maya がアイドル状態になるまで保留されます。詳細については、以下の <span class=\'code\'>onDirtyPlug()</span> 関数と<span class=\'code\'>_processDeferredUpdateRequest()</span> 関数の定義を参照してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def onDirtyPlug(self, node, plug, *args, **kwargs):\n\
    &#39;&#39;&#39;Add to the self._deferredUpdateRequest member variable that is then\n\
    deferred processed by self._processDeferredUpdateRequest().\n\
    &#39;&#39;&#39;\n\
\n\
    # get long name of the attr, to use as the dict key\n\
    attrName = plug.partialName(False, False, False, False, False, True)\n\
\n\
    # get widget associated with the attr\n\
    widget = self.attrWidgets.get(attrName, None)\n\
    if widget != None:\n\
        # get node.attr string\n\
        nodeAttrName = plug.partialName(True, False, False, False, False, True)\n\
        \n\
        # Add to the dict of widgets to defer update\n\
        self._deferredUpdateRequest[widget] = nodeAttrName\n\
        \n\
        # Trigger an evalDeferred action if not already done\n\
        if len(self._deferredUpdateRequest) == 1:\n\
            cmds.evalDeferred(self._processDeferredUpdateRequest, low=True)\n\
\n\
def _processDeferredUpdateRequest(self):\n\
    &#39;&#39;&#39;Retrieve the attribute value and set the widget value\n\
    &#39;&#39;&#39;\n\
    for widget,nodeAttrName in self._deferredUpdateRequest.items():\n\
        v = cmds.getAttr(nodeAttrName)\n\
        widget.setText(str(v))\n\
        print &quot;_processDeferredUpdateRequest &quot;, widget, nodeAttrName, v\n\
    self._deferredUpdateRequest.clear()\n\
<div class=\'figure\'><img src=\'dev_help/images/ConnectAttrs_PySide.png\' title=\'\'></div>\n\
</pre></div><div class=\'section\'><a id=\"ツリーのリスト-ビューを持つ-qt-ウィジェットを作成する\"></a><h3 id=\"ツリーのリスト-ビューを持つ-qt-ウィジェットを作成する\">ツリーのリスト ビューを持つ Qt ウィジェットを作成する</h3></div>\n\
<p><span class=\'code\'>widgetHierarchy.py</span> スクリプトでは、Maya で使用されるすべての QT ウィジェットを一覧表示する Qt ウィジェットを作成する方法を例示します。</p>\n\
<p>ツリー リストは、<span class=\'code\'>MayaQWidgetBaseMixin</span> と <span class=\'code\'>QTreeView</span> から派生させて作成します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class WidgetHierarchyTree(MayaQWidgetBaseMixin, QTreeView):\n\
    def __init__(self, rootWidget=None, *args, **kwargs):\n\
        super(WidgetHierarchyTree, self).__init__(*args, **kwargs)\n\
</pre></div><p>この例では、ウィジェットが閉じているときに、そのウィジェットを削除する方法を例示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">self.setAttribute(Qt.WA_DeleteOnClose, True)\n\
</pre></div><p>ルート ウィジェットを設定することで階層ツリーを作成するように設定します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># Determine root widget to scan\n\
if rootWidget != None:\n\
    self.rootWidget = rootWidget\n\
else:\n\
    mayaMainWindowPtr = omui.MQtUtil.mainWindow() \n\
    self.rootWidget = wrapInstance(long(mayaMainWindowPtr), QWidget)\n\
</pre></div><p>ツリー ビューを作成するために、例では各列で <span class=\'code\'>QStandardItem</span> を呼び出し、子ウィジェットを再帰的に処理しています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def populateModel(self):\n\
    # Create the headers\n\
    self.columnHeaders = [&#39;Class&#39;, &#39;ObjectName&#39;, &#39;Children&#39;]\n\
    myModel = QStandardItemModel(0,len(self.columnHeaders))\n\
    for col,colName in enumerate(self.columnHeaders):\n\
        myModel.setHeaderData(col, Qt.Horizontal, colName)\n\
\n\
    # Recurse through child widgets\n\
    parentItem = myModel.invisibleRootItem();\n\
    self.populateModel_recurseChildren(parentItem, self.rootWidget)\n\
    self.setModel( myModel )\n\
\n\
def populateModel_recurseChildren(self, parentItem, widget):\n\
    # Construct the item data and append the row\n\
    classNameStr = str(widget.__class__).split(&quot;&#39;&quot;)[1]\n\
    if pysideVersion == &#39;1.2.0&#39; :\n\
      classNameStr = classNameStr.replace(&#39;PySide.&#39;,&#39;&#39;).replace(&#39;QtGui.&#39;, &#39;&#39;).replace(&#39;QtCore.&#39;, &#39;&#39;)\n\
    else:\n\
      classNameStr = classNameStr.replace(&#39;PySide2.&#39;,&#39;&#39;).replace(&#39;QtGui.&#39;, &#39;&#39;).replace(&#39;QtCore.&#39;, &#39;&#39;).replace(&#39;QtWidgets.&#39;, &#39;&#39;)\n\
\n\
    items = [QStandardItem(classNameStr), \n\
             QStandardItem(widget.objectName()),\n\
             QStandardItem(str(len(widget.children()))),\n\
             ]\n\
    parentItem.appendRow(items)\n\
\n\
\n\
    # Recurse children and perform the same action\n\
    for childWidget in widget.children():\n\
        self.populateModel_recurseChildren(items[0], childWidget)\n\
<div class=\'figure\'><img src=\'dev_help/images/WidgetHierarchy_PySide.png\' title=\'\'></div>\n\
</pre></div><div class=\'section\'><a id=\"既定のウィジェットまたは既定のウィジェットから派生するウィジェットを作成する\"></a><h3 id=\"既定のウィジェットまたは既定のウィジェットから派生するウィジェットを作成する\">既定のウィジェットまたは既定のウィジェットから派生するウィジェットを作成する</h3></div>\n\
<p><span class=\'code\'>defaultWidget.py</span> スクリプトでは、既定のウィジェット(<span class=\'code\'>QPushButton</span> を使用して作成される押しボタン)と派生ウィジェットを作成するためのフレームワークを設定します。このフレームワークは、既定のウィジェットまたはユーザ独自のオーバーライド ウィジェットの作成に使用することができます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/DefaultButton_PySide.png\' title=\'\' /></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/DerivedButton_PySide.png\' title=\'\' /></div>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";