var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>PyQt および PySide ウィジェットのベスト プラクティス</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>PyQt および PySide ウィジェットのベスト プラクティス</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"pyqt-および-pyside-ウィジェットのベスト-プラクティス\"></a></div>\n\
<div class=\'section\'><a id=\"ウィジェットへのリファレンスの維持\"></a><h2 id=\"ウィジェットへのリファレンスの維持\">ウィジェットへのリファレンスの維持</h2></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/Updated%20_Odd-to-Even.png\' title=\'\' /></div>\n\
<p>PyQt5 または PySide2 を使用して Maya のユーザ インタフェースをカスタマイズする場合は、Maya のメイン ウィンドウなど、既存の Maya ウィジェットの下に自分のウィジェットをペアレント化してください。ウィジェットがペアレント化されていないと、ウィジェットへのリファレンスが維持されていない場合、Python インタプリタのガベージ コレクターによってウィジェットが破棄される場合があります。</p>\n\
<p>このベスト プラクティスのコード例を次に示します。PySide2 の代わりに、PyQt5 モジュールを読み込んだ場合も、このコードは機能することに注意してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">from maya import OpenMayaUI as omui \n\
\n\
from PySide2.QtCore import * \n\
from PySide2.QtGui import * \n\
from PySide2.QtWidgets import *\n\
from PySide2 import __version__\n\
from shiboken2 import wrapInstance \n\
\n\
mayaMainWindowPtr = omui.MQtUtil.mainWindow() \n\
mayaMainWindow= wrapInstance(long(mayaMainWindowPtr), QWidget) \n\
\n\
# WORKS: Widget is fine \n\
hello = QLabel(&quot;Hello, World&quot;, parent=mayaMainWindow) \n\
hello.setObjectName(&#39;MyLabel&#39;) \n\
hello.setWindowFlags(Qt.Window) # Make this widget a standalone window even though it is parented \n\
hello.show() \n\
hello = None # the &quot;hello&quot; widget is parented, so it will not be destroyed. \n\
\n\
# BROKEN: Widget is destroyed \n\
hello = QLabel(&quot;Hello, World&quot;, parent=None) \n\
hello.setObjectName(&#39;MyLabel&#39;) \n\
hello.show() \n\
hello = None # the &quot;hello&quot; widget is not parented, so it will be destroyed.\n\
</pre></div><div class=\'section\'><a id=\"maya.app.general.mayamixin-クラスの使用\"></a><h2 id=\"maya.app.general.mayamixin-クラスの使用\">maya.app.general.mayaMixin クラスの使用</h2></div>\n\
<p>Maya ワークスペースと互換性のある PyQt ウィジェットおよび PySide ウィジェットの記述方法の詳細については、「<a href=\'#!/url=./dev_help/Writing-Workspace-controls.html\' title=\'\'>ワークスペース コントロールを記述する</a>」を参照してください。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";