var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>polyModifierCmd の例</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>polyModifierCmd の例</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"polymodifiercmd-の例\"></a></div>\n\
<p>polyModifierCmd のソース コードは、Developer Kit の <span class=\'code\'>\\plug-ins</span> ディレクトリにあります。</p>\n\
<p>polyModifierCmd には、ポリゴン メッシュを修正するコマンドを作成する一般プロセスと Maya アーキテクチャとインタフェースがカプセル化されています。完全にポリゴンを処理しますが、DG 概念で結合される、Maya のその他のオブジェクト タイプに拡張できます。</p>\n\
<p>このプロセスは以下のとおりです。</p>\n\
<ol>\n\
<li>データを修正します。</li>\n\
</ol>\n\
<p>プロセスのこの部分は、ジオメトリ データかメッシュ データのみを処理します。</p>\n\
<ol>\n\
<li>polyShape ノードに修正データを適用します。</li>\n\
</ol>\n\
<p>すべてのポリゴン修正コマンドに共通していますが、プロセスのこの部分には、コンストラクション ヒストリ、微調整、polyShape ノードに関連する、Maya アーキテクチャとのすべてのやり取りが含まれます。</p>\n\
<p>これは単一アクションなので、polyShape ノードにモディファイアを適用するには、<span class=\'code\'>doIt()</span>、<span class=\'code\'>undoIt()</span>、および <span class=\'code\'>redoIt()</span> クラス構造を使用してクラスを利用します。ただし、polyModifierCmd は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> のサブセットなので、派生したすべての polyModifierCmd クラスがフル コマンド アーキテクチャを継承するように、polyModifierCmd 自身を <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> から派生させることができます。このため、<span class=\'code\'>doIt()</span>、<span class=\'code\'>undoIt()</span>、および <span class=\'code\'>redoIt()</span> メソッドは、操作を実行するために実際のコマンド クラスで必要になるので、オーバーライドすることができません。その代わりに、<span class=\'code\'>doModifyPoly()</span>、<span class=\'code\'>undoModifyPoly()</span>、および <span class=\'code\'>redoModifyPoly()</span> という、類似メソッドの独自のグループを定義します。</p>\n\
<p>派生クラスでは、polyModifierCmd を初期化して <span class=\'code\'>doIt()</span> 内で <span class=\'code\'>doModifyPoly()</span> を呼び出して、元に戻すとやり直しの機能を拡張できます。<a href=\'#!/url=./dev_help/Polygon-API/splitUVCmd-example.html\' title=\'\'>splitUVCmd の例</a>は、派生した polyModifierCmd コマンドの実装例です。以下は、polyModifierCmd のクラス インタフェースです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class polyModifierCmd : <a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a>\n\
{\n\
    public:\n\
        polyModifierCmd();\n\
        virtual ~polyModifierCmd();\n\
        // Restrict access to derived classes only\n\
        //\n\
    protected:\n\
        ////////////////////////////////////\n\
        // polyModifierCmd Initialization //\n\
        ////////////////////////////////////\n\
        // Target polyMesh to modify\n\
        //\n\
        void setMeshNode( <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> mesh );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> getMeshNode() const;\n\
        // Modifier node type\n\
        //\n\
        void setModifierNodeType( <a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> type );\n\
        void setModifierNodeName( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> name );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> getModifierNodeType() const;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> getModifierNodeName() const;\n\
        ///////////////////////////////\n\
        // polyModifierCmd Execution //\n\
        ///////////////////////////////\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> initModifierNode( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNode );\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> directModifier( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> mesh );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> doModifyPoly();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> redoModifyPoly();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> undoModifyPoly();\n\
    private:\n\
        //////////////////////////////////////////////\n\
        // polyModifierCmd Internal Processing Data //\n\
        //////////////////////////////////////////////\n\
        struct modifyPolyData\n\
        {\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> meshNodeTransform;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> meshNodeShape;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> meshNodeDestPlug;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> meshNodeDestAttr;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> upstreamNodeTransform;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> upstreamNodeShape;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> upstreamNodeSrcPlug;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> upstreamNodeSrcAttr;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNodeSrcAttr;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNodeDestAttr;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> tweakNode;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> tweakNodeSrcAttr;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> tweakNodeDestAttr;\n\
        };\n\
        //////////////////////////////////////\n\
        // polyModifierCmd Internal Methods //\n\
        //////////////////////////////////////\n\
        // Preprocessing methods\n\
        //\n\
        bool isCommandDataValid();\n\
        void collectNodeState();\n\
        // Modifier node methods\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> createModifierNode( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a>&amp; modifierNode );\n\
        // Node processing methods (need to be executed in this order)\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> processMeshNode( modifyPolyData&amp; data );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> processUpstreamNode( modifyPolyData&amp; data );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> processModifierNode( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNode,\n\
            modifyPolyData&amp; data );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> processTweaks( modifyPolyData&amp; data );\n\
        // Node connection methods\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> connectNodes( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNode );\n\
        // Mesh caching methods\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> cacheMeshData();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> cacheMeshTweaks();\n\
        // Undo methods\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> undoCachedMesh();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> undoTweakProcessing();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> undoDirectModifier();\n\
        /////////////////////////////////////\n\
        // polyModifierCmd Utility Methods //\n\
        /////////////////////////////////////\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> getFloat3PlugValue( <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> plug,\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a>&amp; value );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> getFloat3asMObject( <a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a> value,\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a>&amp; object );\n\
        //////////////////////////\n\
        // polyModifierCmd Data //\n\
        //////////////////////////\n\
        // polyMesh\n\
        //\n\
        bool fDagPathInitialized;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> fDagPath;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> fDuplicateDagPath;\n\
        // Modifier node type\n\
        //\n\
        bool fModifierNodeTypeInitialized;\n\
        bool fModifierNodeNameInitialized;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> fModifierNodeType;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> fModifierNodeName;\n\
        // Node State Information\n\
        //\n\
        bool fHasHistory;\n\
        bool fHasTweaks;\n\
        bool fHasRecordHistory;\n\
        // Cached Tweak Data\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> fTweakIndexArray;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MFloatVectorArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVectorArray</a> fTweakVectorArray;\n\
        // Cached Mesh Data\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> fMeshData;\n\
        // DG and DAG Modifier\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDGModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGModifier</a> fDGModifier;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDagModifier\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_modifier.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagModifier</a> fDagModifier;\n\
};\n\
\n\
</pre></div><p>// polyModifierCmd Execution // というラベルが付いたクラス インタフェースのセクションでは、対応する <span class=\'code\'>doModifyPoly()</span>、<span class=\'code\'>undoModifyPoly()</span>、および <span class=\'code\'>redoModifyPoly()</span> メソッドの定義に注意してください。この 3 つのメソッドは、派生コマンドがインタフェースを取るインタフェースの中核を表します。</p>\n\
<p>polyModifierCmd には、以下の 3 つの基本ステージがあります。</p>\n\
<ul>\n\
<li>polyModifierCmd の初期化</li>\n\
</ul>\n\
<p><a href=\'#!/url=./dev_help/Polygon-API/polyModifierCmd-example.html#polymodifiercmd-initialization\' title=\'\'>polyModifierCmd の初期化</a>を参照してください。</p>\n\
<ul>\n\
<li>polyModifierCmd の前処理</li>\n\
</ul>\n\
<p><a href=\'#!/url=./dev_help/Polygon-API/polyModifierCmd-example.html#polymodifiercmd-preprocessing\' title=\'\'>polyModifierCmd の前処理</a>を参照してください。</p>\n\
<ul>\n\
<li>polyModifierCmd の処理</li>\n\
</ul>\n\
<p><a href=\'#!/url=./dev_help/Polygon-API/polyModifierCmd-example.html#polymodifiercmd-processing\' title=\'\'>polyModifierCmd の処理</a>を参照してください。</p>\n\
<p>しかし最も重要なことは、polyModipfierCmd(<span class=\'code\'>doModifyPoly()</span>、<span class=\'code\'>undoModifyPoly()</span>、<span class=\'code\'>redoModifyPoly()</span>)の基本クラス インタフェースを理解することです。</p>\n\
<div class=\'section\'><a id=\"polymodifiercmd-の初期化\"></a><h2 id=\"polymodifiercmd-の初期化\">polyModifierCmd の初期化</h2></div>\n\
<p>モディファイアを polyShape ノードに適用する前に、polyModifierCmd では、プロセスのガイドをする初期化データが必要です。これは、前処理データとは異なります。このデータは処理を開始するために必要な入力であるのに対し、前処理データは初期データから抽出されたデータです。操作の実行には、2 つの初期化データが必要です。このデータから、その他のすべてのデータが抽出されます。</p>\n\
<ul>\n\
<li>polyShape ノード: モディファイアを適用するメッシュが必要。</li>\n\
<li>モディファイア: メッシュに適用するモディファイアが必要。</li>\n\
</ul>\n\
<p>メッシュ データに加える実際の修正を、その適用方法にかかわらず「モディファイア」と呼びます。たとえばコンストラクション ヒストリが存在する場合のモディファイアは、モディファイア ノードとして適用されます。</p>\n\
<p>polyShape ノードは、DAG パスの形式で格納できます。DAG パスは絶対パスであり、適切なオブジェクトを指すことが保証されますが、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> は Maya が所有するオブジェクトのハンドルで、プラグインの呼び出し中に変化することがあるので、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> ではなく DAG パスを使用してください。polyShape 入力は、以下のようにクラス インタフェースで表現されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Prototypes\n\
//\n\
void setMeshNode( <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> mesh );\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> getMeshNode() const;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> fDagPath;\n\
// Implementations\n\
//\n\
void polyModifierCmd::setMeshNode( <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> mesh )\n\
{\n\
    fDagPath = mesh;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> polyModifierCmd::getMeshNode() const\n\
{\n\
    return fDagPath;\n\
}\n\
\n\
</pre></div><p>修正は、以下の 2 つの形式で適用できます。</p>\n\
<ul>\n\
<li>モディファイア ノードを通して</li>\n\
<li>メッシュ上に直接</li>\n\
</ul>\n\
<p>モディファイア ノードを通した修正の適用には、作成して polyShape に接続できる DG ノード タイプが必要です。これにより、作業する明確なものが提供され、以下のように、ノード タイプかノード名で polyModifierCmd を初期化するインタフェースが提供されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Prototypes\n\
//\n\
void setModifierNodeType( <a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> type );\n\
void setModifierNodeName( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> name );\n\
<a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> getModifierNodeType() const;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> getModifierNodeName() const;\n\
virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> initModifierNode( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNode );\n\
bool fModifierNodeTypeInitialized;\n\
bool fModifierNodeNameInitialized;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> fModifierNodeType;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> fModifierNodeName;\n\
// Implementations\n\
//\n\
void polyModifierCmd::setModifierNodeType( <a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> type )\n\
{\n\
    fModifierNodeType = type;\n\
    fModifierNodeTypeInitialized = true;\n\
}\n\
void polyModifierCmd::setModifierNodeName( <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> name )\n\
{\n\
    fModifierNodeName = name;\n\
    fModifierNodeNameInitialized = true;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> polyModifierCmd::getModifierNodeType() const\n\
{\n\
    return fModifierNodeType;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> polyModifierCmd::getModifierNodeName() const\n\
{\n\
    return fModifierNodeName;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> polyModifierCmd::initModifierNode( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNode )\n\
{\n\
    return MS::kSuccess;\n\
}\n\
\n\
</pre></div><p><span class=\'code\'>initModifierNode()</span> メソッドは、作成されるノード タイプでは何の役割も果たしませんが、ノードの作成時に役割を果たします。多くの場合、モディファイア ノードでは、ノードにデータの修正方法を指示する入力が必要です。たとえば splitUVNode では、分割する UV のリストが必要です。ここでは、polyModifierCmd がノードを作成した場合に、polyModifierCmd 側のコマンドがモディファイア ノードのその他のデータをどのように初期化するか、という問題が発生します。polyModifierCmd では初期化できません。モディファイアに関係なく、接続方法のみを認識しているためです。この問題を解決するため、仮想メソッドという形式でコールバックが提供されています。この仮想メソッドによりコマンドがモディファイア ノードにオーバーライドし、またそれがモディファイア ノードの使用前に実行されることが期待されます。</p>\n\
<p>モディファイア ノードとは対照的に、直接的な方法で修正を適用する場合は、格納と適用を行う明確なものが提供されません。つまり、モディファイア ノードにはオブジェクト内部に修正が含まれているため、修正と polyShape ノードが分離していますが、ダイレクト モディファイアではそうではありません。ダイレクト モディファイアは polyShape ノードに直接作用して polyModifierCmd は修正プロセスから独立している必要があるので、派生コマンドのコールバックが提供されます。このコールバックは、ダイレクト モディファイアが必要な場合に実行されます。つまりコンストラクション ヒストリが存在せず、コンストラクション ヒストリがオフになっている場合に実行されます。以下の <span class=\'code\'>directModifier</span> コールバックのコードは仮想メソッドの形式で存在し、polyModifierCmd が適切であるとみなした場合に呼び出されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Prototypes\n\
//\n\
virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> directModifier( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> mesh );\n\
// Implementations\n\
//\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> polyModifierCmd::directModifier( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> /* mesh */ )\n\
{\n\
    return MS::kSuccess;\n\
}\n\
\n\
</pre></div><div class=\'section\'><a id=\"polymodifiercmd-の前処理\"></a><h2 id=\"polymodifiercmd-の前処理\">polyModifierCmd の前処理</h2></div>\n\
<p>データを初期化したら、修正の適用に必要な残りのデータを抽出できます。初期化データの他に、以下も把握しておく必要があります。</p>\n\
<ul>\n\
<li>初期化データが有効であるかどうか。</li>\n\
<li>コンストラクション ヒストリが存在するかどうか。</li>\n\
<li>微調整が存在するかどうか。</li>\n\
<li>コンストラクション ヒストリがオンになっているかどうか。</li>\n\
</ul>\n\
<p>上記の最初の項目では、与えられた(初期化)データで処理の連続実行が可能かどうかをチェックします。ここでは、polyShape ノード情報とモディファイア ノード情報の初期化をチェックします。データが無効である場合、polyModifierCmd は実行を継続できず、エラーを返します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Prototypes\n\
//\n\
bool isCommandDataValid()\n\
// Implementations\n\
//\n\
bool polyModifierCmd::isCommandDataValid()\n\
{\n\
    bool valid = true;\n\
    // Check the validity of the DAG path\n\
    //\n\
    if( fDagPathInitialized )\n\
    {\n\
        // Ensure we are pointing to a shape node\n\
        //\n\
        fDagPath.extendToShape();\n\
        if( !fDagPath.isValid() || fDagPath.apiType != <a href=\"javascript:void(0)\" data-symbol=\"MFn::kMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a19fd562fc0900a60162e6073df36cb62&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kMesh</a> )\n\
        {\n\
            valid = false;\n\
        }\n\
    }\n\
    else\n\
    {\n\
        valid = false;\n\
    }\n\
    // Check the validity of the modifier node type/name.\n\
    // Can only check that it has been set.\n\
    //\n\
    if( !fModifierNodeTypeInitialized &amp;&amp;\n\
    !fModifierNodeNameInitialized )\n\
    {\n\
        valid = false;\n\
    }\n\
}\n\
\n\
</pre></div><p>後の 3 つの項目は、polyShape ノードのノード状態に関連します。この 3 つのデータでは、データの抽出には polyShape ノードが必要なので、polyShape ノードの妥当性が必要です。データ抽出は効率的に行われ、1 つのメソッド <span class=\'code\'>collectNodeState</span> にまとめられています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Prototypes\n\
//\n\
void collectNodeState();\n\
// Implementations\n\
//\n\
void polyModifierCmd::collectNodeState()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    // Collect the node state information on the given mesh\n\
    //\n\
    // -HasHistory\n\
    // -HasTweaks\n\
    // -HasRecordHistory\n\
    //\n\
    fDagPath.extendToShape();\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> meshNodeShape = fDagPath.node();\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnDependencyNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnDependencyNode</a> depNodeFn( meshNodeShape );\n\
    // If the inMesh is connected, we have history\n\
    //\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> inMeshPlug = depNodeFn.findPlug( &quot;inMesh&quot; );\n\
    fHasHistory = inMeshPlug.isConnected();\n\
    // Tweaks exist only if the multi &quot;pnts&quot; attribute contains\n\
    // plugs that contain non-zero tweak values. Use false,\n\
    // until proven true search pattern.\n\
    //\n\
    fHasTweaks = false;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> tweakPlug = depNodeFn.findPlug( &quot;pnts&quot; );\n\
    if( !tweakPlug.isNull() )\n\
    {\n\
        // ASSERT : tweakPlug should be an array plug\n\
        //\n\
        MAssert( tweakPlug.isArray(), &quot;tweakPlug.isArray()&quot; );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> tweak;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MFloatVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_float_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFloatVector</a> tweakData;\n\
        int i;\n\
        int numElements = tweakPlug.numElements;\n\
        for( i = 0; i &lt; numElements; i++ )\n\
        {\n\
            tweak = tweakPlug.elementByPhysicalIndex( i, &amp;status );\n\
            if( status == MS::kSuccess &amp;&amp; !tweak.isNull() )\n\
            {\n\
                // Retrieve the float vector from the plug\n\
                //\n\
                getFloat3PlugValue( tweak, tweakData );\n\
                if( 0 != tweakData.x ||\n\
                    0 != tweakData.y ||\n\
                    0 != tweakData.z )\n\
                {\n\
                    fHasTweaks = true;\n\
                    break;\n\
                }\n\
            }\n\
        }\n\
    }\n\
    // Query the constructionHistory command for the preference\n\
    // of recording history\n\
    //\n\
    int result;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::executeCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a09e405631e7cf680f8ac9d934ad73434&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::executeCommand</a>( &quot;constructionHistory –q –tgl&quot;,\n\
        result );\n\
    fHasRecordHistory = (0 != result );\n\
}\n\
\n\
</pre></div><div class=\'section\'><a id=\"polymodifiercmd-の処理\"></a><h2 id=\"polymodifiercmd-の処理\">polyModifierCmd の処理</h2></div>\n\
<p>エントリのポイントは以下のとおりです。</p>\n\
<ul>\n\
<li><span class=\'code\'>doModifyPoly()</span></li>\n\
<li><span class=\'code\'>redoModifyPoly()</span></li>\n\
<li><span class=\'code\'>undoModifyPoly()</span></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"domodifypoly\"></a><h3 id=\"domodifypoly\">doModifyPoly()</h3></div>\n\
<p><span class=\'code\'>doModifyPoly()</span> は最も複雑で、polyModifierCmd の中核といえるものです。ここですべてのデータが分析され、適切な処理が実行されます。<span class=\'code\'>doModifyPoly()</span> では、プロセス全体を 1 つのメソッドで実装するのではなく、ノード状態を迅速にスキャンして、状態に基づいて適切なメソッドに制御を渡すことのみを行います。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> polyModifierCmd::doModifyPoly()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status = MS::kFailure;\n\
    if( isCommandDataValid() )\n\
    {\n\
        // Get the state of the polyMesh\n\
        //\n\
        collectNodeState();\n\
        if( !fHasHistory &amp;&amp; !fHasRecordHistory )\n\
        {\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> meshNode = fDagPath.node();\n\
            // Pre-process the mesh – Cache the old mesh\n\
            //\n\
            cacheMeshData();\n\
            cacheMeshTweaks();\n\
            // Call the directModifier\n\
            //\n\
            status = directModifier( meshNode );\n\
        }\n\
        else\n\
        {\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNode;\n\
            createModifierNode( modifierNode );\n\
            initModifierNode( modifierNode );\n\
            connectNodes( modifierNode );\n\
        }\n\
    }\n\
}\n\
\n\
</pre></div><p><span class=\'code\'>doModifyPoly()</span> のスケルトンでは、ある状態での polyShape ノードとのインタフェースを取る方法の概念がわかります。ヒストリが存在せず、ヒストリの記録がオフになっている場合は、元に戻す操作に備えてメッシュ データをキャッシュし(<a href=\'#!/url=./dev_help/Polygon-API/polyModifierCmd-example.html#undomodifypoly--\' title=\'\'>undoModifyPoly()</a> を参照)、<span class=\'code\'>directModifier</span> コールバックを呼び出します。その他の場合は <span class=\'code\'>modifierNode</span> を介する方法が取られます。モディファイア ノードを作成し、(コールバックによって)初期化するための呼び出しが行われます。それ以降は、ノードの接続を試行する際に呼び出しが渡されます。</p>\n\
<p><span class=\'code\'>doModifyPoly()</span> プロセスでは、コンストラクション ヒストリの状態のみが処理されることに注意してください。一連の処理の中では微調整が大きな役割を果たしますが、微調整はコンストラクション ヒストリから独立しているので、このプロセス以降の別プロセスでは別個に考慮されます。以下の表は、ノードのコンストラクション ヒストリの状態に基づいて何が呼ばれるかを示しています。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
<col width=\"33.333333333333336%\" />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
 \n\
</th>\n\
<th class=\"table-heading\">\n\
ヒストリ記録: オン\n\
</th>\n\
<th class=\"table-heading\">\n\
ヒストリ記録: オフ\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2A8\"></a>\n\
<p class=\"table-body\">\n\
ヒストリ: あり\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2A7\"></a>\n\
<p class=\"table-body\">\n\
connectNodes()\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2A6\"></a>\n\
<p class=\"table-body\">\n\
connectNodes()\n\
</p>\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2A5\"></a>\n\
<p class=\"table-body\">\n\
ヒストリ: なし\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2A4\"></a>\n\
<p class=\"table-body\">\n\
connectNodes()\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<a name=\"WS73099CC142F48755-3D114B7511841AEFA9F-2A3\"></a>\n\
<p class=\"table-body\">\n\
directModifier()\n\
</p>\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p><span class=\'code\'>directModifier</span> のコード行は、派生したコマンドによって実装されており、注意すべき複雑な側面はありません。コマンドはメッシュ ノードに渡され、そこで直接動作します。すべての制御は、コマンドに残ります。</p>\n\
<p>これとは対照的に、コンストラクション ヒストリに関するその他 3 つのケースはより複雑です。<span class=\'code\'>modifierNode</span> の作成から説明します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> polyModifierCmd::createModifierNode( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a>&amp; modifier )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status = MS::kFailure;\n\
    if( fModifierNodeTypeInitialized ||\n\
        fModifierNodeNameInitialized )\n\
    {\n\
        if( fModifierNodeTypeInitialized )\n\
        {\n\
            modifier = fDGModifier.createNode(fModifierNodeType,\n\
                &amp;status);\n\
        }\n\
        else if( fModifierNodeNameInitialized )\n\
        {\n\
            modifier = fDGModifier.createNode(fModifierNodeName,\n\
                &amp;status);\n\
        }\n\
        // Check to make sure that we have a modifier node of the\n\
        // appropriate type. Requires an inMesh and outMesh\n\
        // attribute.\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MFnDependencyNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnDependencyNode</a> depNodeFn( modifier );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> inMeshAttr;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> outMeshAttr;\n\
        inMeshAttr = depNodeFn.attribute( &quot;inMesh&quot; );\n\
        outMeshAttr = depNodeFn.attribute( &quot;outMesh&quot; );\n\
        if( inMeshAttr.isNull() || outMeshAttr.isNull() )\n\
        {\n\
            displayError(&quot;Invalid Modifier: inMesh/outMesh needed&quot;);\n\
            status = MS::kFailure;\n\
        }\n\
    }\n\
    return status;\n\
}\n\
\n\
</pre></div><p><span class=\'code\'>createModifierNode()</span> では、モディファイア ノード タイプかモディファイア ノード名の初期化済みデータを使用し、ローカル DG モディファイアを通してモディファイア ノードを作成します。元に戻すとやり直しを比較的単純にするには、DG モディファイアの使用が不可欠です。DG モディファイアはノードを作成していませんが、接続などそのノードのアクションを待ち行列に入れられるため、DG モディファイアの <span class=\'code\'>doIt()</span> が呼び出されるとすべてが順番に実行されます。これによって、エラーが発生した場合のロールバックの問題が緩和されます。また、<span class=\'code\'>createModifierNode()</span> では、<span class=\'code\'>inMesh</span> アトリビュートと <span class=\'code\'>outMesh</span> アトリビュートがノードに存在するかどうかを確認するためのチェックが行われます。名前だけで判断すると限定的に思えますが、モディファイア ノードのチェーン内では標準的です。<span class=\'code\'>polyModifierNode</span> というヘルパー クラス(後のセクションで説明)では、この 2 つの主要アトリビュートが自動的に生成されます。</p>\n\
<p><span class=\'code\'>createModifierNode()</span> の後で <span class=\'code\'>initModifierNode()</span> のコールバックが行われ、派生クラスでは、これによってノード データが初期化されます。これも、派生コマンドのコントロール下で行われます。そこから、最終ステージの <span class=\'code\'>connectNodes()</span> に入ります。</p>\n\
<div class=\'section\'><a id=\"connectnodes\"></a><h3 id=\"connectnodes\">connectNodes()</h3></div>\n\
<p><span class=\'code\'>connectNodes()</span> は大きなメソッドで、polyShape ノードとモディファイア ノードのすべての変数を処理し、polyShape とモディファイアを接続します。<span class=\'code\'>connectNodes()</span> の実装を調べて、コントロール内容の概要を確認してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> polyModifierCmd::connectNodes( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a>&amp; modifierNode )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    // Declare our internal processing data structure\n\
    //\n\
    modifyPolyData data;\n\
    // Get the mesh node attrs and plugs\n\
    //\n\
    status = processMeshNode( data );\n\
    MCheckStatus( status, &quot;processMeshNode&quot; );\n\
    // Get the upstream node attrs and plugs\n\
    //\n\
    status = processUpstreamNode( data );\n\
    MCheckStatus( status, &quot;processUpstreamNode&quot; );\n\
    // Get the modifierNode attributes\n\
    //\n\
    status = processModifierNode( modifierNode, data );\n\
    MCheckStatus( status, &quot;processModifierNode&quot; );\n\
    // Process the tweaks on the meshNode\n\
    //\n\
    status = processTweaks( data );\n\
    MCheckStatus( status, &quot;processTweaks&quot; );\n\
    // Connect the nodes\n\
    //\n\
    if( fHasTweaks )\n\
    {\n\
        status = fDGModifier.connect( data.upstreamNodeShape,\n\
            data.upstreamNodeSrcAttr,\n\
            data.tweakNode,\n\
            data.tweakNodeDestAttr );\n\
        MCheckStatus( status, &quot;upstream-tweak connect&quot; );\n\
        status = fDGModifier.connect( data.tweakNode,\n\
            data.tweakNodeSrcAttr,\n\
            modifierNode,\n\
            data.modifierNodeDestAttr );\n\
        MCheckStatus( status, &quot;tweak-modifier connect&quot; );\n\
    }\n\
    else\n\
    {\n\
        status = fDGModifier.connect( data.upstreamNodeShape,\n\
            data.upstreamNodeSrcAttr,\n\
            modifierNode,\n\
            data.modifierNodeDestAttr );\n\
        MCheckStatus( status, &quot;upstream-modifier connect&quot; );\n\
    }\n\
    status = fDGModifier.connect( modifierNode,\n\
        data.modifierNodeSrcAttr,\n\
        data.meshNodeShape,\n\
        data.meshNodeDestAttr );\n\
    MCheckStatus( status, &quot;modifier-mesh connect&quot; );\n\
    status = fDGModifier.doIt();\n\
    return status;\n\
}\n\
\n\
</pre></div><p><span class=\'code\'>connectNodes()</span> は複数のサブセクションに分かれます。最初のサブセクションでは、一般的な処理データの構造が構築されます。この構造には、それぞれの処理メソッド間で必要となる、すべての処理変数が含まれます。この構造は、処理メソッド間で渡される引数の数を減らすために作成されます。そこから処理メソッドのセットがコールされ、ノードの接続に必要なデータが収集されて、ノード stat が処理されます。その後で、収集されたデータを使用してノードを接続します。</p>\n\
<p>これに続く各処理メソッドの詳細については、完全に文書化された polyModifierCmd.cpp のソース コードを参照してください。</p>\n\
<div class=\'section\'><a id=\"processmeshnode\"></a><h3 id=\"processmeshnode\">processMeshNode()</h3></div>\n\
<p><span class=\'code\'>connectNodes()</span> が実行する最初の処理メソッドは <span class=\'code\'>processMeshNode()</span> です。この処理メソッドでは、ノード シェイプ、ノード トランスフォーム、接続データ(<span class=\'code\'>inMesh</span> プラグとアトリビュート)など、polyShape ノードで必要なものがすべて処理されます。このデータは、渡された <span class=\'code\'>modifyPolyData</span> データ構造に格納され、その他の処理メソッドでさらに使用されます。重要なことは、この処理メソッドが実行される順序です。</p>\n\
<div class=\'section\'><a id=\"processupstreamnode\"></a><h3 id=\"processupstreamnode\">processUpstreamNode()</h3></div>\n\
<p>次の処理メソッド <span class=\'code\'>processUpstreamNode()</span> では、ヒストリが存在するケースとヒストリが存在しないケースで違いがあります。<span class=\'code\'>connectNodes()</span> は、ヒストリが存在するケース、またはヒストリは存在しないがヒストリの記録がオンになっているケースでのみ呼び出されます。これらのケースでは、いずれもヒストリの追加が許可され、より安定して柔軟に処理できるためです。</p>\n\
<p>ヒストリが既に存在する場合、<span class=\'code\'>processUpstreamNode()</span> は <span class=\'code\'>processMeshNode()</span> で取得した <span class=\'code\'>inMesh</span> プラグを使用し、polyShape ノードのすぐ上流のノードを取得します。すぐ上流のノードを取得したら、polyShape ノードからそのノードを切断し、後でモディファイア ノードを挿入するための準備を行います。すべての DG 接続は、メッシュ ノードと上流ノードの間で行われるので、後で接続するために <span class=\'code\'>outMesh</span> プラグとアトリビュートのみを取得します。</p>\n\
<p>コンストラクション ヒストリが存在しない場合は、コンストラクション ヒストリ チェーンを作成する必要があります。各コンストラクション ヒストリ チェーンの最初には、コンストラクション ヒストリが作成された時点での polyShape ノードの初期状態を表す非表示の中間(Intermediate)ノードがあります。<span class=\'code\'>processUpstreamNode()</span> は polyShape ノードで <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode::duplicate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html#ac1abc89bd329c4b2d1794cc8b971ea7b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html#a7c1ad96bede4dccc84533168081d7481&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnDagNode::duplicate()</a></span> を呼び出すことで、この処理を行います。<span class=\'code\'>duplicate()</span> メソッドによって複製シェイプ ノードのための新しいトランスフォーム ノードも作成されるため、このシェイプ ノードを複製元のシェイプ ノードと同じトランスフォーム ノードでリペアレント化し、DAG モディファイアを使用してこのトランス フォーム ノードを削除します。DG に対しては、この複製シェイプ ノードは、ヒストリが存在する場合に処理される上流ノードと同じように動作します。つまりすべての接続は、この複製シェイプ ノードと元のシェイプ ノードの間で実行されます。したがって、複製シェイプ ノードに上流ノードの情報を設定し、後で接続するために <span class=\'code\'>outMesh</span> プラグとアトリビュートを取得します。</p>\n\
<div class=\'section\'><a id=\"processmodifiernode\"></a><h3 id=\"processmodifiernode\">processModifierNode()</h3></div>\n\
<p><span class=\'code\'>processMeshNode()</span> と同じように、3 番目の処理メソッドである <span class=\'code\'>processModifierNode()</span> は、<span class=\'code\'>connectNodes()</span> のベースでノードを接続するために、モディファイア ノードの <span class=\'code\'>inMesh</span> と <span class=\'code\'>outMesh</span> アトリビュートを取得します。</p>\n\
<div class=\'section\'><a id=\"processtweaks\"></a><h3 id=\"processtweaks\">processTweaks()</h3></div>\n\
<p>コンストラクション ヒストリのため、微調整は、操作順序を維持するためにモディファイア ノードを追加する前に抽出する必要があります。このため、微調整が存在する場合は、以下の 2 つのステージが実行されます。</p>\n\
<ul>\n\
<li>微調整抽出</li>\n\
<li>微調整適用</li>\n\
</ul>\n\
<p>tweak ノードの作成(polyTweak)から始まり、微調整を格納して、<span class=\'code\'>pnts</span> アトリビュートで微調整が解析されます。微調整は元に戻す操作に備えてクラスの配列メンバに個別にキャッシュされ、微調整ノードに転送するためにローカルの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> 配列にキャッシュされます。微調整は、抽出したベクトル配列で構成されますが、抽出中に考慮すべきことはほかにもあります。微調整は <span class=\'code\'>pnts</span> アトリビュートに格納されます。DG のアトリビュートとして、接続も含まれることがあります。DG 構造を維持するため、この接続は保存して微調整ノードに転送する必要があります。</p>\n\
<p>それぞれのベクトル配列の他に、<span class=\'code\'>pnts</span> アトリビュートに接続されているそれぞれのノードのプラグ配列と、接続されている <span class=\'code\'>pnts</span> アトリビュート内のそれぞれのプラグを抽出します。<span class=\'code\'>pnts</span> 配列アトリビュートのそれぞれの配列が、複合アトリビュートであることに注意してください。複合アトリビュートのそれぞれのアトリビュートは、特定の頂点微調整ベクトル(x、y、z)の 1 つの軸移動に関連します。</p>\n\
<p>データを抽出したら、polyTweak ノード上で微調整ベクトルを適用し、それぞれの微調整ベクトル上で再接続します。これで微調整ノードができ、ヒストリ ストリームに接続する準備が整いました。しかし現状のままで接続すると、結果としてメッシュでは微調整の重複が予想されます。これは、メッシュ ノードから微調整が除去されていないためです。このため、微調整ノードから 1 回、メッシュ ノードから 1 回、合計 2 回の微調整が適用されます。しかし、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> 配列を使用してプラグを取り出したことに注意してください。配列アトリビュートに含まれる複合プラグへの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> 参照を取得しました。これを微調整ノードに設定し直すことで、それらは微調整ノード上に移動されます。<span class=\'code\'>processTweaks()</span> には、メッシュ ノードから微調整を削除するための大きなコード セグメントがあり、そのセグメントはコメント化されています。このコードを実行しても結果は同じですが、明らかな利点もなく、パフォーマンスも低下します。</p>\n\
<p>その他の処理メソッドと同じように、<span class=\'code\'>processTweaks()</span> は微調整ノードの接続データを取得し、<span class=\'code\'>connectNodes()</span> がすべてのノードを接続できるようにします。</p>\n\
<div class=\'section\'><a id=\"connectnodes-の見直し\"></a><h3 id=\"connectnodes-の見直し\">connectNodes() の見直し</h3></div>\n\
<p>必要なすべてのノードがセットアップされ、接続データが抽出されました。ノード接続は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier::connect()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html#afbd18f066f70fcd1864ddb4af91f3c7b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html#a320660acebd0d2cbda2d438e076c5628&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGModifier::connect()</a></span> 呼び出しでセットアップされます。すべての操作は、最後の <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier::doIt()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html#a984345cd272bc1a32a9fc2e93a6678b2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html#a5c9d3d3edfc669fc8fcf31b71fe14e4c&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGModifier::doIt()</a></span> 呼び出しで実行されます。そこから、DG モディファイアを実行した反対の順序で <span class=\'code\'>undoIt()</span> を呼び出して元に戻すをサポートし、前と同じ順序で <span class=\'code\'>doIt()</span> を呼び出してやり直しをサポートできます。これを実現できるのは、DG モディファイアが、行ったすべての実行をキャッシュしているためです。同じように polyModifierCmd は、<span class=\'code\'>doModifyPoly()</span> を呼び出して、必要なすべてのデータをキャッシュします。このため、<span class=\'code\'>undoModifyPoly()</span> および <span class=\'code\'>redoModifyPoly()</span> は比較的単純になります。</p>\n\
<div class=\'section\'><a id=\"undomodifypoly\"></a><h3 id=\"undomodifypoly\">undoModifyPoly()</h3></div>\n\
<p>undoModifyPoly の構造と抽象化レベルは、<span class=\'code\'>doModifyPoly()</span> メソッドに非常によく似ています。これは、コールされたノード状態を調べて、適切なメソッドに制御を渡します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> polyModifierCmd::undoModifyPoly()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    if( !fHasHistory &amp;&amp; !fHasRecordHistory )\n\
    {\n\
        status = undoDirectModifier();\n\
    }\n\
    else\n\
    {\n\
        fDGModifier.undoIt();\n\
        // undoCachedMesh() must be called prior to\n\
        // undoTweakProcessing() because undoCachedMesh()\n\
        // copies the original mesh without tweaks back\n\
        // onto the existing mesh. Any changes made before\n\
        // the copy will be lost.\n\
        //\n\
        if( !fHasHistory )\n\
        {\n\
            status = undoCachedMesh();\n\
            fDagModifier.undoIt();\n\
        }\n\
        status = undoTweakProcessing();\n\
    }\n\
    return status;\n\
}\n\
\n\
</pre></div><div class=\'section\'><a id=\"undodirectmodifier\"></a><h3 id=\"undodirectmodifier\">undoDirectModifier()</h3></div>\n\
<p>undoDirectModifier は、directModifier のように単純ではありません。polyModifierCmd は directModifier が実行する内容を認識しないので、undoDirectModifier がメッシュ全体を元の状態に戻す必要があります。そのために、undoDirectModifier は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> ハンドルを独自に使用して、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> の動作方法に関する情報を利用します。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> は、Maya が所有する内部オブジェクトのハンドルであると言われています。しかしこれは部分的にしか合っていません。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> はハンドルですが、Maya が常にこれを所有しているわけではありません。Maya には、参照をカウントするオブジェクトがあります。つまり、オブジェクトの参照ごとにカウントに 1 が加算されます。参照が削除されるたびに、ゼロに達してオブジェクトが削除されるまで、カウントから 1 が差し引かれます。これは、使用されている場合に限って有効であるオブジェクトのようなものです。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> は、参照数が加算される、このような参照カウント オブジェクトを参照することがあります。このため、Maya がこれらのオブジェクトを所有していても、オブジェクトの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> ハンドルを維持して、オブジェクトの存続期間をコントロールできます。その他のタイプのオブジェクトでは、プラグインの呼び出し間にデータが変更される可能性があるため(ノードの削除など)、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> を維持しないという一般的なヒントが有効となり、強く推奨されます。</p>\n\
<p>参照がカウントされるタイプのデータは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnData</a></span> クラスと <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_component.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnComponent</a></span> クラスの階層に分類されるオブジェクトです。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnData</a></span> オブジェクト タイプには、メッシュの内容全体が組み込まれています。メッシュのバックアップの基礎としてこの概念を使用すると、ダイレクト モディファイアを適切に元に戻すことができます。</p>\n\
<div class=\'section\'><a id=\"cachemeshdata\"></a><h3 id=\"cachemeshdata\">cacheMeshData()</h3></div>\n\
<p><span class=\'code\'>cacheMeshData()</span> は、<span class=\'code\'>directModifier()</span> の前に、メッシュの使用に関するデータをキャッシュします。メッシュ データのキャッシュには、<span class=\'code\'>undoDirectModifier()</span> の概念が使用されます(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span>を参照)。データをバックアップする場合は、現行オブジェクトの参照を取得しないように注意してください。dirty になっている可能性があるデータの参照を維持することになってしまいます。これを避けるには、現行メッシュを複製し、複製メッシュの <span class=\'code\'>outMesh</span> アトリビュートから <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> を抽出して <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnData</a></span> オブジェクトを取得します。取得した <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> は、元のメッシュ データの参照なので、参照カウントに 1 が加算されます。ユーザにこれを意識させないようにするには、複製で作成したノードを削除して仕上げます。ノードを削除しても、参照があるので、メッシュ データは削除されません。</p>\n\
<div class=\'section\'><a id=\"cachemesh-tweaks\"></a><h3 id=\"cachemesh-tweaks\">cacheMesh Tweaks()</h3></div>\n\
<p>このメソッドは、微調整ノードを処理しないことを除けば、<span class=\'code\'>processTweaks()</span> メソッドと同じです。<span class=\'code\'>pnts</span> アトリビュートを分析し、微調整キャッシュ データ メンバーに微調整ベクトルを抽出します。</p>\n\
<div class=\'section\'><a id=\"undodirectmodifier-の見直し\"></a><h3 id=\"undodirectmodifier-の見直し\">undoDirectModifier() の見直し</h3></div>\n\
<p>メッシュのバックアップに必要なデータをキャッシュして <span class=\'code\'>undoDirectModifier()</span> で使用できます。微調整がある場合とない場合では、polyShape ノードのデータ フローが異なります。これは、バックアップ メッシュを再適用する方法に直接的な影響を与えます。</p>\n\
<p>微調整は、ノード内のデータ フローのため、バックアップ メッシュの再適用に影響します。微調整がないノードでは、outMesh の値をバックアップ メッシュに設定できます。</p>\n\
<p>微調整があるノードでは、バックアップ メッシュを <span class=\'code\'>cachedInMesh</span> に強制的にコピーしてノードの同期を維持する必要があります。この場合は、polyShape ノードを複製して複製シェイプの <span class=\'code\'>outMesh</span> をバックアップ メッシュに設定し、複製シェイプ ノードを元のノードに接続します。評価を強制実行した後で、複製シェイプ ノードを切断して削除します。これで、<span class=\'code\'>outMesh</span> にバックアップ メッシュが維持されるようになります。次に <span class=\'code\'>undoTweaksProcessing</span> で初期微調整をノードに再適用し、<span class=\'code\'>cachedInMesh</span> にバックアップ メッシュをコピーして、内部ノードの同期化を実行するようにノードを設定します。</p>\n\
<div class=\'section\'><a id=\"undomodifypoly-の見直し\"></a><h3 id=\"undomodifypoly-の見直し\">undoModifyPoly() の見直し</h3></div>\n\
<p><span class=\'code\'>connectNodes()</span> を元に戻す必要がある場合、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier::undoIt()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html#a0789a8d51244cad0495abb2b811c39db&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html#abba728d9d3cbf35ff4713b231eba1bef&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGModifier::undoIt()</a></span> メソッドは、<span class=\'code\'>connectNodes()</span> によって作成されたすべての接続とノードを元に戻します。最初にヒストリがなかった場合は、<span class=\'code\'>processUpstreamNode()</span> も DAG モディファイアを使用したことに注意してください。この場合は、<span class=\'code\'>MDagModifier::undoIt()</span> を呼び出す前に別の操作を実行する必要があります。</p>\n\
<p>これは、ヒストリを作成して操作を元に戻すため、ヒストリを除去する必要があるからです。削除は単純ですが、ノードの <span class=\'code\'>outMesh</span> アトリビュートには最終のノード評価が維持されます。つまり、モディファイアが引き続き含まれます。このため、ノードで「キャッシュされている」メッシュを元に戻す必要があります。これには、メソッド <span class=\'code\'>undoCachedMesh()</span> を呼び出します。メッシュ データの復元に続けて微調整を復元し、元のメッシュを残します。</p>\n\
<div class=\'section\'><a id=\"undocachedmesh\"></a><h3 id=\"undocachedmesh\">undoCachedMesh()</h3></div>\n\
<p><span class=\'code\'>undoDirectModifier()</span> の場合と同じように、<span class=\'code\'>undoCachedMesh()</span> に含まれる操作は、ノードのデータ フローが変化するため、微調整の存在によって決まります。ヒストリがないノードに戻し、ノードと直接インタフェースを取ってメッシュを復元する必要があるからです。</p>\n\
<p>微調整が存在しない場合は、<span class=\'code\'>outMesh</span> がノードを表すジオメトリになるため、これを復元するだけで済みます。これを実行するには、ヒストリ チェーンを始めるために作成された複製シェイプ ノードを使用します(最初にヒストリが存在していなかった場合に限ってこれを実行することに注意してください)。複製シェイプ ノードの <span class=\'code\'>outMesh</span> を取得し、シェイプ ノードの <span class=\'code\'>outMesh</span> にそのメッシュ データをコピーして、ノードを初期状態に戻します。</p>\n\
<p>微調整が存在する場合は、<span class=\'code\'>undoDirectModifier</span> が微調整を処理する場合と同じ方法でノードにアクセスする必要がありますが、ここではシェイプ ノードを複製する必要がありません。既に複製が存在するからです。同様に、ローカルDG モディファイアを使用して複製シェイプの <span class=\'code\'>outMesh</span> を元のシェイプの <span class=\'code\'>inMesh</span> に再接続し、DG 評価を強制実行します。次に、同じDG モディファイアを使用して接続を元に戻します。元のメッシュ データが <span class=\'code\'>outMesh</span> に入ってから微調整が再適用されて、<span class=\'code\'>outMesh</span> は <span class=\'code\'>cachedInMesh</span> にコピーされます。</p>\n\
<div class=\'section\'><a id=\"redomodifypoly\"></a><h3 id=\"redomodifypoly\">redoModifyPoly()</h3></div>\n\
<p><span class=\'code\'>redoModifyPoly()</span> は簡単です。操作に必要なものはすべて <span class=\'code\'>doModifyPoly()</span> で初期化して設定してあるからです。<span class=\'code\'>redoModifyPoly()</span> にも doModifyPoly() と同様の構造が保持されます。<span class=\'code\'>directModifier()</span> の場合は、クラス内にメッシュ データが既に存在するため、<span class=\'code\'>doModifyPoly()</span> はメッシュ データを再びキャッシュすることなくメソッドを再度呼び出します。<span class=\'code\'>connectNodes()</span> の場合は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGModifier::doIt()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_modifier.html#a984345cd272bc1a32a9fc2e93a6678b2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_modifier.html#a5c9d3d3edfc669fc8fcf31b71fe14e4c&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGModifier::doIt()</a></span> を再度呼び出して、<span class=\'code\'>doModifyPoly()</span> が以前にセットアップした操作を再実行します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> polyModifierCmd::redoModifyPoly()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status = MS::kSuccess;\n\
    if( !fHasHistory &amp;&amp; !fHasRecordHistory )\n\
    {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> meshNode = fDagPath.node();\n\
        // Call the directModifier – No need to pre-process the\n\
        // mesh data again.\n\
        //\n\
        status = directModifier( meshNode );\n\
    }\n\
    else\n\
    {\n\
        // Call the redo on the DG and DAG modifiers\n\
        //\n\
        if( !fHasHistory )\n\
        {\n\
            status = fDagModifier.doIt();\n\
        }\n\
        status = fDGModifier.doIt();\n\
    }\n\
    return status;\n\
}\n\
\n\
</pre></div><div class=\'section\'><a id=\"polymodifiercmd-コマンドの実装\"></a><h2 id=\"polymodifiercmd-コマンドの実装\">polyModifierCmd コマンドの実装</h2></div>\n\
<p>polyModifierCmd の機能について一般的に解釈すると、それに基づいてコマンドを実装する方法という問題に直面します。規則はかなり簡単です。polyModifierCmd は、Maya がノードを扱う場合と同じような方法でプロセスを構造化します。ここでは、ファクトリという概念が導入されます。以下のセクションでは、polyModifierCmd に基づいてコマンドを実装するという状況で polyModifierFty と polyModifierNode について説明します。この動作方法の詳細については、それぞれのソース ファイルを参照してください。</p>\n\
<div class=\'section\'><a id=\"polymodifier-fty\"></a><h3 id=\"polymodifier-fty\">polyModifier Fty</h3></div>\n\
<p>polyModifierCmd の内部動作からは、<span class=\'code\'>directModifier()</span> とモディファイア ノードの内部の処理部という、冗長コードが潜在する 2 つの場所を確認できます。この 2 つは、入力の取得方法が異なることを除くと、結果的に同じことを実行します。コードの重複を減らすため、ファクトリという概念が導入されました。ファクトリは、メッシュの修正を実装するクラス構造としてだけ存在します。これには、モディファイアをコールできる基本インタフェースがあります。</p>\n\
<p>ファクトリのガイドとして、polyModiferFty というベース ファクトリ クラスが提供されています。このベース ファクトリ クラスからファクトリを派生させることができます。これには特に機能はありませんが、修正する場合のアウトラインとなります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class polyModifierFty\n\
{\n\
    public:\n\
        polyModifierFty();\n\
        virtual ~polyModifierFty();\n\
        // Pure virtual doIt()\n\
        //\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> doIt() = 0;\n\
};\n\
\n\
</pre></div><div class=\'section\'><a id=\"polymodifiernode\"></a><h3 id=\"polymodifiernode\">polyModifierNode</h3></div>\n\
<p>polyModifierFty と同じように、polyModifierCmd に関連して使用する、すべてのモディファイア ノードのフレームワークとなる、別のガイダンス クラスが提供されています。このクラスは、モディファイア ノードが動作するには、<span class=\'code\'>inMesh</span> アトリビュートと <span class=\'code\'>outMesh</span> アトリビュートが必要であることなどを提案します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class polyModifierNode\n\
{\n\
    public:\n\
        polyModifierNode();\n\
        virtual ~polyModifierNode();\n\
        // There needs to be an <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> handle declared for\n\
        // each attribute that the node will have. These handles\n\
        // are needed for getting and setting the attribute\n\
        // values later.\n\
        //\n\
        static <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> inMesh;\n\
        static <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> outMesh;\n\
};\n\
\n\
</pre></div><p>polyModifierCmd コマンドの実装についての詳細は、「splitUVCmd の例」(次のセクション)とソース コードの両方を参照してください。ソース コード内では、それぞれのクラスの一般的なガイドラインが提供されています。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";