var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>splitUVCmd の例</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>splitUVCmd の例</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"splituvcmd-の例\"></a></div>\n\
<p>(ソース コードは、Developer Kit の <span class=\'code\'>\\plug-ins</span>¥plug-ins フォルダにあります)</p>\n\
<p>splitUV コマンドは、ポリゴン メッシュで選択した UV の共有を解除する、つまり「分割する」MEL コマンドです。UV は 2D テクスチャ プレーン上のポイントで、テクスチャをメッシュにマッピングするために使用します。UV をメッシュに適切に関連付けるには、それぞれのフェースのマッピングまたはマッピング解除を行います。フェースをマッピングすると、そのフェースに属するそれぞれの頂点が UV に関連付けられます。このリレーションシップをフェース - 頂点リレーションシップと呼びます。詳細については、<a href=\'#!/url=./dev_help/Polygon-API/How-polygons-are-handled.html#face-vertices\' title=\'\'>フェース頂点(Face-Vertices)</a>を参照してください。</p>\n\
<p>UV の分割の意味についてさらに理解を深めるため、Maya で以下の手順を実行してください。</p>\n\
<ol>\n\
<li>3x3 四方のポリゴン プレーンを作成します。</li>\n\
<li>プレーンを選択した状態で、UV テクスチャ エディタ(UV Texture Editor) ( UV の編集 &gt; UV テクスチャ エディタ(Edit UVs &gt; UV Texture Editor))を開きます。</li>\n\
<li>選択モードを UV に変更します。</li>\n\
<li>プレーン内部の UV (境界に沿ったものではない)を選択します。</li>\n\
<li>移動ツール(Move Tool)を選択します。</li>\n\
<li>UV をドラッグし、UV が 1 つしかないことを確認します。</li>\n\
<li>選択モードをエッジ(Edges)に変更します。</li>\n\
<li>移動した UV を囲む、4 つすべてのエッジを選択します。</li>\n\
<li>UV の編集 &gt; UV エッジのカット(Edit UVs &gt; Cut UV Edges)を選択します。</li>\n\
<li>選択モードを UV に戻します。</li>\n\
<li>選択した UV を 1 回クリックします。UV の上でドラッグしないように注意してください。ドラッグすると、すべてが選択されてしまいます。</li>\n\
<li>共有されていない UV の表示をオンにします(ディスプレイ &gt; ポリゴン &gt; 共有されていない UV (Display &gt; Polygons &gt; Unshared UVs))。</li>\n\
<li>UV をドラッグし、その UV がフェース間で共有されておらず、独自のフェースを含む単一の UV であることを確認します。</li>\n\
<li>(オプション)テクスチャ境界の表示をオンにして(ディスプレイ &gt; ポリゴン &gt; テクスチャの境界エッジ(Display &gt; Polygons &gt; Texture Border Edges))、カット操作によって新しくできた境界を表示します。</li>\n\
</ol>\n\
<p>UV エッジのカット(Cut UV Edges)コマンドはメッシュのエッジ上で動作し、splitUV は UV 上で動作します。</p>\n\
<p>UV は、フェース頂点によってインデックスが付いた、単一の 1 次配列に保存されます。それぞれのフェース頂点は特定 UVId をインデックス付けし、それぞれの UVId はテクスチャ マッピングの 1 つの UV ポイントを表します。このため、UV を共有するフェース数と同じ数だけ、共有 UVId をインデックス付けします。詳細については、<a href=\'#!/url=./dev_help/Polygon-API/How-polygons-are-handled.html#uvs\' title=\'\'>UV</a> を参照してください。</p>\n\
<p>UV を共有するフェースの総数から 1 を引いた数の UV を追加してください(同じ 2D 座標で)。1 を引くのは、すでに共有フェースに関連付けられた最低 1 つの UV があることがわかっているため、作成と関連付けを行うフェースと UV を 1 つ減らします。ここで、元の UV を共有するフェースに、それぞれ新しい UV を関連付け、1 つのフェースを元の UV にインデックス付けしたまま残します。これにより、それぞれのフェースが、それぞれのフェース頂点の場所に共有されていない UV を持つようになります。</p>\n\
<div class=\'section\'><a id=\"初期実装\"></a><h2 id=\"初期実装\">初期実装</h2></div>\n\
<p>最初に入力値、この場合は選択されている UV を収集します。セレクション リストを取得し、フィルタ処理して、UV が選択されている最初のオブジェクトを検索します。わかりやすくするために、UV が選択されている最初のオブジェクトのみを考慮します。これは、簡単に拡張して、複数のオブジェクトで動作させることができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Get the active selection list and filter for poly objects.\n\
// Also create a selection list iterator to parse the list\n\
//\n\
<a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSelectionList</a> selList;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MGlobal::getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a6d81d38246555884897fb153c93aaf42&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::getActiveSelectionList</a>( selList );\n\
<a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItSelectionList</a> selListIter( selList );\n\
selListIter.setFilter( <a href=\"javascript:void(0)\" data-symbol=\"MFn::kMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a19fd562fc0900a60162e6073df36cb62&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kMesh</a> );\n\
// Declare a dagPath and component to store a reference to the\n\
// mesh object and selected components\n\
//\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> dagPath;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> component;\n\
// Now parse the selection list for poly objects with selected\n\
// UVs\n\
//\n\
for( ; !selListIter.isDone(); selListIter.next() )\n\
{\n\
    selListIter.getDagPath( dagPath, component );\n\
    // Check for selected UVs\n\
    //\n\
    if( component.apiType() == <a href=\"javascript:void(0)\" data-symbol=\"MFn::kMeshMapComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a0b774c2a128a8b2365fff164212f2e43&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kMeshMapComponent</a> )\n\
    {\n\
        break;\n\
    }\n\
}\n\
// Now we break down the component object into an int array\n\
// of UVIds\n\
//\n\
<a href=\"javascript:void(0)\" data-symbol=\"MFnSingleIndexedComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_single_indexed_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnSingleIndexedComponent</a> compFn( component );\n\
<a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> selUVs;\n\
compFn.getElements( selUVs );\n\
\n\
</pre></div><p>これで、操作するオブジェクトと選択されている UV を取得しました。操作を実行する前に、一部の前処理データを収集する必要があります。前処理データとは、選択されているそれぞれの UV を共有するフェースと UV 頂点関連です。最後に、複数の UV セットが multiUV セットに正しく対応するようにカバーする必要があります。同時に選択できるのは 1 つの UV セットの UV だけなので、現在アクティブになっている UV セットにアクセスしてそのセットで操作を実行するだけで済みます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Declare our processing variables\n\
//\n\
<a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> mesh;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> selUVSet;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> selUVFaceIdMap;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> selUVFaceOffsetMap;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> selUVLocalVertIdMap;\n\
// Make sure our dagPath points to a shape node. That is where\n\
// the topological/geometry data is stored (not on the transform)\n\
//\n\
dagPath.extendToShape();\n\
mesh = dagPath.node();\n\
// Initialize a mesh function set to our mesh\n\
//\n\
<a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnMesh</a> meshFn( mesh );\n\
// Get the current UV set name\n\
//\n\
meshFn.getCurrentUVSetName( selUVSet);\n\
// Now parse the mesh for face and vertex UV associations\n\
//\n\
<a href=\"javascript:void(0)\" data-symbol=\"MItMeshPolygon\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_mesh_polygon.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItMeshPolygon</a> polyIter( mesh );\n\
int i;\n\
int j;\n\
int offset = 0;\n\
int selUVsCount = selUVs.length();\n\
for( i = 0; i &lt; selUVsCount; i++ )\n\
{\n\
    // Append the current offset in the faceId map to the\n\
    // faceOffset map so we have an index reference into the\n\
    // faceId map for each selected UV. In other words,\n\
    // for each offset value, we have a number of faces equal\n\
    // to (faceOffsetMap[i+1] – faceOffsetMap[i]) that share\n\
    // the UV that that offset value represents.\n\
    //\n\
    selUVFaceOffsetMap.append( offset );\n\
    // Parse the mesh for faces which share the current UV\n\
    //\n\
    for( ; !polyIter.isDone(); polyIter.next() )\n\
    {\n\
        // Only continue if the face is mapped\n\
        //\n\
        if( polyIter.hasUVs() )\n\
        {\n\
            // Now parse the vertices of each face and check for\n\
            // the current UV\n\
            //\n\
            int polyVertCount = polyIter.polygonVertexCount();\n\
            for( j = 0; j &lt; polyVertCount; j++ )\n\
            {\n\
                int UVIndex = 0;\n\
                polyIter.getUVIndex( j, UVIndex );\n\
                // If we find the UV on this face, append the faceId,\n\
                // append the local vertex (relative to the current\n\
                // face) and increment our offset.\n\
                //\n\
                if( UVIndex == selUVs[i] )\n\
                {\n\
                    selUVFaceIdMap.append( polyIter.index() );\n\
                    selUVLocalVertIdMap.append(j);\n\
                    offset++;\n\
                    break;\n\
                }\n\
            }\n\
        }\n\
    }\n\
}\n\
// Finally append the last offset value so we can obtain the\n\
// number of faces that share the last UV in the list.\n\
//\n\
selUVFaceOffsetMap.append( offset );\n\
\n\
</pre></div><p>フェースとフェース頂点の関連性は、Maya がポリゴンのトポロジ データを保存する場合と同じ技法で保存されます。この技法は、選択されているそれぞれの UV によって共有されているフェースのリストが累積する部分のコードでよくわかります。多次元配列を作成して、選択されているそれぞれの UV で共有されているフェースのリストを保存するのではなく、1 次元配列、つまり 1 つのデータ配列にすべてを保存します。これを実行するには、別の 1 次元配列(インデックス配列)を作成し、選択されているそれぞれの UV がフェースのリストを始めるそのデータ配列のインデックス値を保存します。</p>\n\
<p>それぞれの UV では、特定の UV を共有しているフェースを探すためにメッシュを分析します。これは、メッシュの各フェースのフェース頂点を分析し、関連 UVId を調べて UVId と現在のUV を比較することで実行します。ここで、フェース ID とローカル頂点 ID(現在のフェースに相対で、0 から(faceVertexCount – 1)で列挙)を保存します。UV はフェース頂点ベースで割り当てられているので、グローバル頂点 ID やメッシュ頂点 ID ではなく、ローカル頂点 ID を考慮します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Declare UV count variables so we can keep create and\n\
// keep track of the indices of the new UVs\n\
//\n\
int currentUVCount = meshFn.numUVs( selUVSet );\n\
// For each UV in our list of selected UVs, split the UV.\n\
//\n\
for( i = 0; i &lt; selUVsCount; i++ )\n\
{\n\
    // Get the current faceId map offset\n\
    //\n\
    offset = selUVFaceOffsetMap[i];\n\
    // Get the U and V values of the current UV\n\
    //\n\
    float u;\n\
    float v;\n\
    int UVId = selUVs[i];\n\
    meshFn.getUV( uvId, u, v, &amp;selUVSet );\n\
    // Get the number of faces sharing the current UV\n\
    //\n\
    int faceCount = selUVFaceOffsetMap[i+1]–selUVFaceOffsetMap[i];\n\
    // Arbitrarily choose that the last faceId in the list\n\
    // of faces sharing this UV will keep the original UV\n\
    //\n\
    for( j = 0; j &lt; faceCount – 1; j++ )\n\
    {\n\
        // Create a new UV (setUV dynamically sizes the UV array\n\
        // if the index value passed in exceeds the length of the\n\
        // UV array) with the same 2D coordinates as our UV.\n\
        //\n\
        meshFn.setUV( currentUVCount, u, v, &amp;selUVSet );\n\
        // Get the face and face-vertex info so we can assign\n\
        // our newly created UV to one of the faces in the list\n\
        // of faces sharing this UV\n\
        //\n\
        int localVertId = selUVLocalVertIdMap[offset];\n\
        int faceId = selUVFaceIdMap[offset];\n\
        // Associate the UV with the particular face vertex\n\
        //\n\
        meshFn.assignUV( faceId,\n\
            localVertId,\n\
            currentUVCount,\n\
            &amp;selUVSet );\n\
        // Increment our counters so we can create another new UV\n\
        // at the currentUVCount index. Increment the offset, so we\n\
        // can associate the next new UV with the next face in the\n\
        // the list of faces sharing this UV\n\
        //\n\
        currentUVCount++;\n\
        offset++;\n\
    }\n\
}\n\
\n\
</pre></div><p>実際に分割を行うためにコールするメソッドは、主に以下の 2 つです。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh::setUV()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html#afe8bc4718af88a29cca9ca0729c8395a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html#a57553779eb6f32cb52c761856a68a726&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnMesh::setUV()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh::assignUV()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html#aa8f5741f8b319715af87211e8274ea79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html#a2cd61a9d804f8d3df72347dabba34c41&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnMesh::assignUV()</a></span></li>\n\
</ul>\n\
<p>最初のメソッド setUV() をコールし、新しい UVId を作成します。このメソッドでは UV 配列が自動的に拡大され、メソッドに渡されたインデックスが正しく処理されます。コードには currentUVCount という名前の変数が表示されます。currentUVCount は、新しい UV が作成されるたびに増分されます。currentUVCount は常に、UV 配列中一番最後の要素より 1 大きな要素のインデックスを維持しています。ループで反復するごとに 1 を加算すると、新しい UV を 1 つずつ作成できます。</p>\n\
<p>次のメソッド assignUV() は、指定された UVId をフェースとフェース頂点に関連付けるためにコールします。</p>\n\
<div class=\'section\'><a id=\"maya-アーキテクチャへの統合\"></a><h2 id=\"maya-アーキテクチャへの統合\">Maya アーキテクチャへの統合</h2></div>\n\
<p>コンストラクション ヒストリと微調整を含むポリゴン メッシュの修正は、かなり複雑です。メッシュにヒストリがない場合は、UV の共有解除をメッシュ自体で直接実行できます。メッシュにヒストリがある場合は、メッシュ ノードのメッシュはコンストラクション ヒストリの上流ノードの DG 評価によって上書きされ、メッシュに直接加えられた修正は失われます。このような場合でも、微調整の存在は、メッシュ上で修正を書き込む適切な場所を変更します。</p>\n\
<p>メッシュ ノードを調べて状態を分析し、状態に従って操作を適用する必要があります。MPxCommand クラスの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> (<a href=\'#!/url=./dev_help/Polygon-API/polyModifierCmd-example.html\' title=\'\'>polyModifierCmd</a>の例を参照)は splitUV コマンド作成時に同時に開発され、コンストラクション ヒストリと微調整の処理を取り出すために役立ちます。polyModifierCmd は、ポリゴン メッシュを修正するコマンド用に設計された一般的なコマンド クラスです。これは、コンストラクション ヒストリと微調整の両方を考慮しながら、poly コマンドが直接メッシュを修正するコードを取得することができ、Maya フレームワークに継ぎ目なく統合する方法を提供します。</p>\n\
<p>polyModifierCmd は API の良い使用例で、コンストラクション ヒストリと微調整がどのように動作するかを示します。</p>\n\
<div class=\'section\'><a id=\"polymodifiercmd-で機能強化された-splituv\"></a><h2 id=\"polymodifiercmd-で機能強化された-splituv\">polyModifierCmd で機能強化された splitUV</h2></div>\n\
<p>このセクションを進める前に、<a href=\'#!/url=./dev_help/Polygon-API/polyModifierCmd-example.html\' title=\'\'>polyModifierCmd の例</a>を読んでおいてください。このセクションでは、polyModifierCmd に基づいてコマンドを実装する方法を手順ごとに説明します。</p>\n\
<p>polyModifierCmd には、以下のように、処理する必要がある 3 つの主な部分があります。</p>\n\
<ul>\n\
<li>splitUV コマンド</li>\n\
<li>splitUV ノード</li>\n\
<li>splitUV ファクトリ</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"splituv-ファクトリ\"></a><h3 id=\"splituv-ファクトリ\">splitUV ファクトリ</h3></div>\n\
<p>ファクトリは splitUVCmd の最下位レベルで、入力(のセット)に対する操作を実行します。入力は UV ID の整数配列と修正するメッシュへの参照です。残りはファクトリ内部に適合します。以下は、splitUVFty ファクトリ クラス インタフェースです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class splitUVFty : polyModifierFty\n\
{\n\
    public:\n\
        splitUVFty();\n\
        virtual ~splitUVFty();\n\
        void setMesh( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> mesh );\n\
        void setUVIds( <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> uvIds );\n\
        // polyModifierFty inherited methods\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> doIt();\n\
    private:\n\
        // Mesh Node\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> fMesh;\n\
        // Selected UVs\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> fSelUVs;\n\
};\n\
\n\
</pre></div><div class=\'section\'><a id=\"splituv-ノード\"></a><h3 id=\"splituv-ノード\">splitUV ノード</h3></div>\n\
<p>ファクトリを展開する方法は 2 つあります。1 つは splitUV ノードによって行う方法で、もう 1 つは、ノードが妥当でない場合の例外用コマンドによる直接的な方法です。splitUV ノードは、DG 内で既存のヒストリ チェーンへの追加または構築を行う場合に使用します。</p>\n\
<p>DG 評価がダーティなノードを通じて伝搬されると、DG は、オリジナル メッシュのコピー(オリジナルは、ノードの状態を参照するもので、このヒストリの先頭を表す)が配置されているヒストリ チェーンの最上位から評価します。次にそのメッシュのコピーが取られ、それぞれのノードを順番に渡されて、それぞれのノード評価でメッシュが変更されます。最終シェイプに達すると、すべてのモディファイアがヒストリ チェーンに保存されているシェイプにメッシュが配置されます。splitUV ノードは、メッシュ入力、修正する UV の入力を取り、ファクトリのインスタンスにそのデータを渡します。結果としてのメッシュは、メッシュ出力アトリビュートを通して渡されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class splitUVNode : polyModifierNode\n\
{\n\
    public:\n\
        splitUVNode();\n\
        virtual ~splitUVNode();\n\
        virtual <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> compute(const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; plug, <a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataBlock</a>&amp; data);\n\
        static void* creator();\n\
        static <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> initialize();\n\
    private:\n\
        // Note: There needs to be an <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> handle for each\n\
        // attribute on the node. These handles are needed for\n\
        // setting and getting values later. The standard inMesh\n\
        // and outMesh attributes are already inherited from\n\
        // polyModifierNode, thus we only need to declare splitUVNode\n\
        // specific attributes\n\
        //\n\
        static <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> uvList;\n\
        // Node type identifier\n\
        //\n\
        static <a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> id;\n\
        // We instantiate a copy of our splitUV factory on the node\n\
        // for it to perform the splitUV operation\n\
        //\n\
        splitUVFty fSplitUVFactory\n\
};\n\
\n\
</pre></div><p>標準ノード インタフェースは、上のクラス宣言にあります。注意すべき違いは、プライベート メンバーに関するものです。クラス階層により、splitUVNode は、polyModifierNode から inMesh アトリビュートと outMesh アトリビュートを継承します。splitUVNode でのみ使用する入力アトリビュート(操作する UV リスト)を追加します。</p>\n\
<p>ノード クラスには、splitUV ファクトリのインスタンスがあります。ノードごとに別個のファクトリを作成するため、splitUVFty の実装には操作をコールしているノードに関する予備知識は不要です。基本ノード セットアップを続け、上のインタフェースの基本メソッドを実装し、アトリビュートの作成と関連付けを行い、タイプ ID を割り当てます。:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MTypeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_type_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTypeId</a> splitUVNode::id( 0x34567 );\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUVNode::creator()\n\
{\n\
    return new splitUVNode();\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUVNode::initialize()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnTypedAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_typed_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnTypedAttribute</a> attrFn;\n\
    uvList = attrFn.create(&quot;inputComponents&quot;,\n\
        &quot;ics&quot;,\n\
        MFnComponentListData::kComponentList);\n\
    // To be stored during file-save\n\
    attrFn.setStorable(true);\n\
    inMesh = attrFn.create(&quot;inMesh&quot;,\n\
        &quot;im&quot;,\n\
        MFnMeshData::kMesh);\n\
    // To be stored during file-save\n\
    attrFn.setStorable(true);\n\
    // outMesh is read-only because it is an output attribute\n\
    //\n\
    outMesh = attrFn.create(&quot;outMesh&quot;,\n\
        &quot;om&quot;,\n\
        MFnMeshData::kMesh);\n\
    attrFn.setStorable(false);\n\
    attrFn.setWritable(false);\n\
    // Add the attributes we have created for the node\n\
    //\n\
    status = addAttribute( uvList );\n\
    if( !status )\n\
    {\n\
        status.perror(&quot;addAttribute&quot;);\n\
        return status;\n\
    }\n\
    status = addAttribute( inMesh );\n\
    if( !status )\n\
    {\n\
        status.perror(&quot;addAttribute&quot;);\n\
        return status;\n\
    }\n\
    status = addAttribute( outMesh );\n\
    if( !status )\n\
    {\n\
        status.perror(&quot;addAttribute&quot;);\n\
        return status;\n\
    }\n\
    // Set up a dependency between the inputs and the output.\n\
    // This will cause the output to be marked dirty when the\n\
    // input changes. The output will then be recomputed the\n\
    // next time it is requested.\n\
    //\n\
    status = attributeAffects( inMesh, outMesh );\n\
    if( !status )\n\
    {\n\
        status.perror(&quot;attributeAffects&quot;);\n\
        return status;\n\
    }\n\
    status = attributeAffects( uvList, outMesh );\n\
    if( !status )\n\
    {\n\
        status.perror(&quot;attributeAffects&quot;);\n\
        return status;\n\
    }\n\
    return MS::kSuccess;\n\
}\n\
\n\
</pre></div><p>最後に <span class=\'code\'>compute()</span> メソッドの実装に移ります。compute メソッドは、それほど複雑ではありません。ファクトリで操作を実行するので、compute メソッドでは、修正する適切なメッシュへの参照をファクトリに提供するだけで済みます。</p>\n\
<p>すべてのプラグイン ノードと同じように起動し、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a></span> から継承したノードの「state」アトリビュートを処理します。「state」アトリビュートには、DG によるノードの扱い方を表す、短い整数が保存されています。ある意味で、これは、DG 評価中にノードが扱われる方法を変更するオーバーライド メカニズムです。プラグイン ノードの場合、重要な状態は「HasNoEffect」状態か「PassThrough」状態のみで、この状態ではノードは完全に無視されます。透過的に動作するノードの場合は、渡すメッシュを変更せずに、<span class=\'code\'>inMesh</span> を <span class=\'code\'>outMesh</span> に転送する必要があります。その他の場合、ノードは通常どおりに動作します。</p>\n\
<p>ノード状態をチェックした後、コンポーネント リストと入力メッシュから UV を取得し、入力メッシュを出力メッシュに割り当て、この参照をファクトリに渡します。入力メッシュを出力メッシュに割り当てると、出力メッシュ上で直接操作が可能になり、出力メッシュには修正済みメッシュが保存されます。そこから、ファクトリが残りの操作を実行します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUVNode::compute(const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; plug, <a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataBlock</a>&amp; data)\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status = MS::kSuccess;\n\
    // Retrieve our state attribute value\n\
    //\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> stateData = data.outputValue(state,&amp;status);\n\
    MCheckStatus( status, &quot;ERROR getting state&quot; );\n\
    // Check for the HasNoEffect/PassThrough state\n\
    //\n\
    // (stateData is stored as a short)\n\
    //\n\
    // (0 = Normal)\n\
    // (1 = HasNoEffect/PassThrough)\n\
    // (2 = Blocking)\n\
    // ..\n\
    //\n\
    if( stateData.asShort() == 1 )\n\
    {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> inputData = data.inputValue(inMesh,&amp;status);\n\
        MCheckStatus(status, &quot;ERROR getting inMesh&quot;);\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> outputData = data.outputValue(outMesh,&amp;status);\n\
        MCheckStatus(status, &quot;ERROR getting outMesh&quot;);\n\
        // Simply redirect the inMesh to the outMesh\n\
        //\n\
        outputData.set(inputData.asMesh());\n\
    }\n\
    else\n\
    {\n\
        // Check which output value we have been asked to compute.\n\
        // If the node doesn’t know how to compute it, return\n\
        // MS::kUnknownParameter.\n\
        //\n\
        if( plug == outMesh )\n\
        {\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> inputData = data.inputValue( inMesh,\n\
                &amp;status );\n\
            MCheckStatus(status, &quot;ERROR getting inMesh&quot;);\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> outputData = data.outputValue( outMesh,\n\
                &amp;status );\n\
            MCheckStatus(status, &quot;ERROR getting outMesh&quot;);\n\
            // Now, we retrieve the input UV list\n\
            //\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> inputUVs = data.inputValue( uvList,\n\
                &amp;status );\n\
            MCheckStatus(status, &quot;ERROR getting uvList&quot;);\n\
            // Copy the inMesh to the outMesh so we can operate\n\
            // directly on the outMesh\n\
            //\n\
            outputData.set(inputData.asMesh());\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> mesh = outputData.asMesh();\n\
            // Retrieve the UV list from the component list\n\
            //\n\
            // Note, we use a component list to store the components\n\
            // because it is more compact memory wise. (ie.\n\
            // comp[81:85] is smaller than comp[81],...,comp[85])\n\
            //\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> compList = inputUVs.data();\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MFnComponentListData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_component_list_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnComponentListData</a> compListFn( compList );\n\
            unsigned i;\n\
            int j;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> uvIds;\n\
            for( i = 0; i &lt; compListFn.length(); i++ )\n\
            {\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> comp = compListFn[i];\n\
                if( comp.apiType() == <a href=\"javascript:void(0)\" data-symbol=\"MFn::kMeshMapComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a0b774c2a128a8b2365fff164212f2e43&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kMeshMapComponent</a> )\n\
                {\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"MFnSingleIndexedComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_single_indexed_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnSingleIndexedComponent</a> uvComp(comp);\n\
                    for( j = 0; j &lt; uvComp.elementCount(); j++ )\n\
                    {\n\
                        int uvId = uvComp.element(j);\n\
                        uvIds.append(uvId);\n\
                    }\n\
                }\n\
            }\n\
            // Set the mesh object and uvList on the factory\n\
            //\n\
            fSplitUVFactory.setMesh( mesh );\n\
            fSplitUVFactory.setUVIds( uvIds );\n\
            // Now, call the factory to perform the splitUV\n\
            //\n\
            status = fSplitUVFactory.doIt();\n\
            // Mark the outputMesh as clean\n\
            //\n\
            outputData.setClean();\n\
        }\n\
        else\n\
        {\n\
            status = MS::kUnknownParameter;\n\
        }\n\
    }\n\
    return status;\n\
}\n\
\n\
</pre></div><div class=\'section\'><a id=\"splituv-コマンド\"></a><h3 id=\"splituv-コマンド\">splitUV コマンド</h3></div>\n\
<p>これで splitUVNode を取得したので、最後に残っているのは splitUV コマンドです。これは、これまでのすべてを結び付けるものです。メッシュの修正方法が決まるのはここです(polyModifierCmd を通して)。このコマンドは操作を管理し、ユーザとの最上位レベルのインタフェースとなります。</p>\n\
<p>polyModifierCmd の子クラスである splitUVCmd には、特定の polyModifierCmd メソッドにオーバーライドして入力を取得する以外に、実行することはあまりありません。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class splitUV : polyModifierCmd\n\
{\n\
    public:\n\
        splitUV();\n\
        virtual ~splitUV();\n\
        static void* creator();\n\
        bool isUndoable();\n\
        // <a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a> inherited methods\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> redoIt();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> undoIt();\n\
        // polyModifierCmd inherited methods\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> initModifierNode( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNode );\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> directModifier( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> mesh );\n\
    private:\n\
        // Private methods\n\
        //\n\
        bool validateUVs();\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> pruneUVs();\n\
        // Private members\n\
        //\n\
\n\
        // Selected UVs\n\
        //\n\
        // We store two copies of the UVs, one that is passed down to\n\
        // the node and another kept locally for the directModifier.\n\
        // Note, the <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> member, fComponentList, is only ever\n\
        // accessed during a single call of a plugin, never between\n\
        // calls where its validity is not guaranteed.\n\
        //\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> fComponentList;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> fSelUVs;\n\
        // splitUV Factory\n\
        //\n\
        // This factory is for the directModifier to have access to\n\
        // operate directly on the mesh.\n\
        //\n\
        splitUVFty fSplitUVFactory;\n\
};\n\
\n\
</pre></div><p>これは、標準 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> クラス インタフェースとかなり似ています。ただし、polyModifierCmd の継承とパフォーマンス向上メソッドのため、多少の違いがあります。以下の 2 つのメソッドを無効にする必要があります。</p>\n\
<ul>\n\
<li><span class=\'code\'>initModifierNode()</span></li>\n\
<li><span class=\'code\'>directModifier()</span></li>\n\
</ul>\n\
<p><span class=\'code\'>initModifierNode()</span> は、モディファイア ノードの inMesh 以外の入力、このケースでは splitUVNode を初期化します。これは入力の初期化に限定されません。必要に応じて、カスタム ノードの初期化もできます。ヒストリの作成が許可されている場合は、このメソッドがコールされてから、モディファイア ノードがヒストリ チェーンに配置されます。たとえばこのケースでは、splitUVNode の UVList の入力を初期化します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUV::initModifierNode( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> modifierNode )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    // Tell the splitUVNode which UVs to operate on.\n\
    // \n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnDependencyNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dependency_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnDependencyNode</a> depNodeFn( modifierNode );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> uvListAttr;\n\
    uvListAttr = depNodeFn.attribute( &quot;inputComponents&quot; );\n\
    // Pass the component list down to the node.\n\
    // To do so, we create/retrieve the current plug\n\
    // from the uvList attribute on the node and simply\n\
    // set the value to our component list.\n\
    //\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> uvListPlug( modifierNode, uvListAttr );\n\
    status = uvListPlug.setValue( fComponentList );\n\
    return status;\n\
}\n\
\n\
</pre></div><p><span class=\'code\'>directModifier()</span> は、メッシュ ノードにヒストリがなく、ヒストリを記録するプリファレンスがオフになっている特定の例外のみで呼び出されるメソッドです。この状態から、ヒストリ チェーンをまったく含めたくないことがわかります。このため、polyModifierCmd では DG の使用が禁止されます。その結果、メッシュをダイレクト モディファイアすることになります。polyModifierCmd の説明では、この状態の意味と代替アプローチについて詳しく説明しています。しかし、認識する必要があるのは、メッシュを直接的に操作する方法を提供しなければならないということだけで、これは概念のセクションで完了しています。ファクトリのインスタンスと修正する UV のコピーが(splitUVNode のコンポーネント リストに対して)、整数配列フォーマットでコマンドに維持されているのはこのためです。</p>\n\
<p>選択した UV の 2 つのコピーを別々のフォーマットで保存するのはなぜでしょうか。プラグイン呼び出し中で <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> の有効性が保証されていないからです(<span class=\'code\'>redoIt()</span> 呼び出しも含む)。<span class=\'code\'>directModifier()</span> は <span class=\'code\'>redoIt()</span> で呼び出されるため、呼び出し間では <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> コンポーネント リストの有効性に依存します。コマンドで 2 つのコピーが保存されるのはこのためです。整数配列をコンポーネント リストではなくノード入力として受け取るようにノードを修正して、操作を合理化することもできますが、これは、パフォーマンスと保存のバランスの問題です。</p>\n\
<p>この入力を使用すると、<span class=\'code\'>directModifier()</span> メソッドは以下のように単純になります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUV::directModifier( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> mesh )\n\
{\n\
     <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
     fSplitUVFactory.setMesh( mesh );\n\
     fSplitUVFactory.setUVIds( fSelUVs );\n\
     // Now, call the factory to perform the splitUV\n\
     //\n\
     status = fSplitUVFactory.doIt();\n\
     return status;\n\
}\n\
\n\
</pre></div><p>パフォーマンス向上メソッドについて説明する前に、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> 継承メソッドについて説明します。以下のメソッドでは、コマンドのパフォーマンスの微調整方法を適切に評価できます。</p>\n\
<ul>\n\
<li><span class=\'code\'>doIt()</span></li>\n\
<li><span class=\'code\'>undoIt()</span></li>\n\
<li><span class=\'code\'>redoIt()</span></li>\n\
</ul>\n\
<p><span class=\'code\'>doIt()</span> メソッドは、操作全体を管理しながら、入力を取得して残りの操作をさまざまな部分に実行する主要メソッドです。名前からわかるように、<span class=\'code\'>doIt()</span> メソッドは、コマンドを初期化して操作を実行するメソッドです。このため、splitUV の <span class=\'code\'>doIt()</span> メソッドはこれを正確に実行します。</p>\n\
<p>最初に、元の実装と同じように、UV が選択されているオブジェクトのセレクション リストを解析します。次に polyModifierCmd 設定を初期化し、パフォーマンス向上メソッドを呼び出して <span class=\'code\'>doModifyPoly()</span> メソッドを発行します。これは、polyModifierCmd バージョンの <span class=\'code\'>doIt()</span> とみなすことができます。また、コマンドの不適切な使用についてユーザに通知するために、コード内には適切なエラー メッセージが配置されています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUV::doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSelectionList</a> selList;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a6d81d38246555884897fb153c93aaf42&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::getActiveSelectionList</a>( selList );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItSelectionList</a> selListIter( selList );\n\
    selListIter.setFilter( <a href=\"javascript:void(0)\" data-symbol=\"MFn::kMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a19fd562fc0900a60162e6073df36cb62&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kMesh</a> );\n\
    // Initialize our component list\n\
    //\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnComponentListData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_component_list_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnComponentListData</a> compListFn;\n\
    compListFn.create();\n\
    // Parse the selection list\n\
    //\n\
    bool found = false;\n\
    bool foundMultiple = false;\n\
    for( ; !selListIter.isDone(); selListIter.next() )\n\
    {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> dagPath;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> component;\n\
        selListIter.getDagPath( dagPath, component );\n\
        if( component.apiType() == <a href=\"javascript:void(0)\" data-symbol=\"MFn::kMeshMapComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a0b774c2a128a8b2365fff164212f2e43&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kMeshMapComponent</a> )\n\
        {\n\
            if( !found )\n\
            {\n\
                // Add the components to our component list.\n\
                // ‘component’ holds all selected components\n\
                // on the given object, so only a single call\n\
                // to add is needed.\n\
                //\n\
                compListFn.add( component );\n\
                fComponentList = compListFn.object();\n\
                // Locally store the selected UVIds in the command\n\
                // int array member, fSelUVs\n\
                //\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MFnSingleIndexedComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_single_indexed_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnSingleIndexedComponent</a> compFn( component );\n\
                compFn.getElements( fSelUVs );\n\
                // Ensure that our DAG path is pointing to a\n\
                // shape node. Set the DAG path for polyModifierCmd.\n\
                //\n\
                dagPath.extendToShape();\n\
                setMeshNode( dagPath );\n\
                found = true;\n\
            }\n\
            else\n\
            {\n\
                // Since we are only looking for whether or not there\n\
                // are multiple objects with selected UVs, break out\n\
                // once we have found one other object.\n\
                //\n\
                foundMultiple = true;\n\
                break;\n\
            }\n\
        }\n\
    }\n\
    if( foundMultiple )\n\
    {\n\
        displayWarning( &quot;Only operates on first found mesh&quot; );\n\
    }\n\
    // Set the modifier node type for polyModifierCmd\n\
    //\n\
    setModifierNodeType( splitUVNode::id );\n\
    if( found )\n\
    {\n\
        if( validateUVs() )\n\
        {\n\
            // Now, pass control over to polyModifierCmd\n\
            //\n\
            status = doModifyPoly();\n\
            if( status == MS::kSuccess )\n\
            {\n\
                setResult( &quot;splitUV command succeeded!&quot; );\n\
            }\n\
            else\n\
            {\n\
                setResult( &quot;splitUV command failed!&quot; );\n\
            }\n\
        }\n\
        else\n\
        {\n\
            displayError( &quot;Selected UVs are not splittable&quot; );\n\
            status = MS::kFailure;\n\
        }\n\
    }\n\
    else\n\
    {\n\
        displayError( &quot;Unable to find selected UVs&quot; );\n\
        status = MS::kFailure;\n\
    }\n\
    return status;\n\
}\n\
\n\
</pre></div><p>元に戻す/やり直しメカニズムは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_command.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxCommand</a></span> から継承した <span class=\'code\'>undoIt()</span> メソッドと <span class=\'code\'>redoIt()</span> メソッドによってサポートされます。このメソッドは、実行する最初の <span class=\'code\'>doIt()</span> からキャッシュされたデータを使用します。splitUV と polyModifierCmd も、<span class=\'code\'>undoModifyPoly()</span> と <span class=\'code\'>redoModifyPoly()</span> という形式で独自の元に戻す/やり直しをサポートしてこれを実行します。splitUV は polyModifierCmd に依存して操作を実行するので、元に戻す/やり直しによって polyModifierCmd に元に戻す/やり直しが転送されます。このため、splitUV の <span class=\'code\'>undoIt()</span> メソッドと <span class=\'code\'>redoIt()</span> メソッドは非常に直接的です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUV::redoIt()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    status = redoModifyPoly();\n\
    if( status == MS::kSuccess )\n\
    {\n\
        setResult( &quot;splitUV command succeeded!&quot; );\n\
    }\n\
    else\n\
    {\n\
        setResult( &quot;splitUV command failed!&quot; );\n\
    }\n\
    return status;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUV::undoIt()\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status;\n\
    status = undoModifyPoly();\n\
    if( status == MS::kSuccess )\n\
    {\n\
        setResult( &quot;splitUV undo succeeded!&quot; );\n\
    }\n\
    else\n\
    {\n\
        setResult( &quot;splitUV undo failed!&quot; );\n\
    }\n\
    return status;\n\
}\n\
\n\
</pre></div><p><span class=\'code\'>doIt()</span> での <span class=\'code\'>validateUVs()</span> の呼び出しはパフォーマンス向上メソッドです。このメソッドは、選択されている UV 上で主に事前状態チェックを実行しますが、分割できない UV の選択済み UV リストを切り取り、コマンドのパフォーマンスを最適化します。これにより、操作の不必要なループが削減されます。分割できない UV をチェックするため、メッシュのパスが余計に必要になりますが、これはコマンドを初めてコールした場合のみです。それ以降の <span class=\'code\'>redoIt()</span> 呼び出しやノード評価は速くなります。</p>\n\
<p>UV が無効で分割できない場合を定義するには、操作の定義を参照してください。splitUV は、ある UV を共有するフェースのそれぞれに、固有で非共有の UV を提供します。このため、複数のフェースで共有されている場合に限って、UV は分割されます。<span class=\'code\'>validateUVs()</span> メソッドはメッシュを解析し、それぞれの UV を共有しているフェースの情報を取得して有効な UV をマークします。有効な UV のリストは <span class=\'code\'>pruneUVs()</span> メソッドに送信され、コンポーネント リスト、およびローカルに保存されている、選択済み UV の整数配列を置き換えます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">bool splitUV::validateUVs()\n\
{\n\
    // Get the mesh that we are operating on\n\
    //\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> dagPath = getMeshNode();\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> mesh = dagPath.node();\n\
    // Get the number of faces sharing each UV\n\
    //\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnMesh</a> meshFn( mesh );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MItMeshPolygon\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_mesh_polygon.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItMeshPolygon</a> polyIter( mesh );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> selUVFaceCountArray;\n\
    int i;\n\
    int j;\n\
    int count = 0;\n\
    selUVsCount = fSelUVs.length();\n\
    for( i = 0; i &lt; selUVsCount; i++ )\n\
    {\n\
        for( ; !polyIter.isDone(); polyIter.next() )\n\
        {\n\
            if( polyIter.hasUVs() )\n\
            {\n\
                int UVIndex = 0;\n\
                polyIter.getUVIndex( j, UVIndex );\n\
                // If we have a matching UVId, then we have a\n\
                // face which shares this UV, so increment the\n\
                // count.\n\
                //\n\
                if( UVIndex == fSelUVs[i] )\n\
                {\n\
                    count++;\n\
                    break;\n\
                }\n\
            }\n\
        }\n\
        selUVFaceCountArray.append( count );\n\
    }\n\
    // Now, check to make sure that at least one UV has more than\n\
    // one face sharing it. So long as we have at least one valid\n\
    // UV, we should proceed with the operation by returning true\n\
    //\n\
    bool isValid = false;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> validUVIndices;\n\
    for( i = 0; i &lt; selUVsCount; i++ )\n\
    {\n\
        if( selUVFaceCountArray &gt; 1 )\n\
        {\n\
            isValid = true;\n\
            validUVIndices.append(i);\n\
        }\n\
    }\n\
    if( isValid )\n\
    {\n\
        pruneUVs( validUVIndices );\n\
    }\n\
    return isValid;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> splitUV::pruneUVs( <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a>&amp; validUVIndices )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> status = MS::kSuccess;\n\
    unsigned i;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MIntArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_int_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIntArray</a> validUVIds;\n\
    for( i = 0; i &lt; validUVIndices.length(); i++ )\n\
    {\n\
        int uvIndex = validUVIndices[i];\n\
        validUVIds.append( fSelUVs[uvIndex] );\n\
    }\n\
    // Replace our local int array of UVIds\n\
    //\n\
    fSelUVs.clear();\n\
    fSelUVs = validUVIds;\n\
    // Build our list of valid components\n\
    //\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnSingleIndexedComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_single_indexed_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnSingleIndexedComponent</a> compFn;\n\
    compFn.create( <a href=\"javascript:void(0)\" data-symbol=\"MFn::kMeshMapComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a0b774c2a128a8b2365fff164212f2e43&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kMeshMapComponent</a> );\n\
    compFn.addElements( validUVIds );\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> component = compFn.object();\n\
    // Replace the component list\n\
    //\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MFnComponentListData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_component_list_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnComponentListData</a> compListFn;\n\
    compListFn.create();\n\
    compListFn.add( component );\n\
    fComponentList = compListFn.object();\n\
    return status;\n\
}\n\
\n\
</pre></div><p>splitUV コマンドの実装の詳細については、Developer Kit の plugins フォルダに提供されているソース コードを参照してください。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";