var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>macOS 環境に Maya Developer Toolkit をインストールする</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>macOS 環境に Maya Developer Toolkit をインストールする</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"macos-環境に-maya-developer-toolkit-をインストールする\"></a></div>\n\
<p>Maya Developer Toolkit (別名 Maya devkit)は、Maya の機能を拡張するカスタム プラグイン、スクリプト、およびアプリケーションを作成するために使用されます。</p>\n\
<blockquote>\n\
<p><strong>重要:</strong> Maya は、<span class=\'code\'>SSL_CERT_FILE</span> が設定されていない場合、埋め込まれた Python Framework 内で <span class=\'code\'>cert.pem</span> ファイルを示すように <span class=\'code\'>SSL_CERT_FILE</span> 環境変数を設定します。</p>\n\
<p>Python の 証明書の使用をコントロールする別の方法を使用しているために、<span class=\'code\'>SSL_CERT_FILE</span> を未設定のままにする必要がある場合は、Maya を起動する前に <span class=\'code\'>MAYA_DO_NOT_SET_SSL_CERT_FILE</span> を設定します。****</p>\n\
<p><span class=\'code\'>export MAYA_DO_NOT_SET_SSL_CERT_FILE=1</span></p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"要件\"></a><h2 id=\"要件\">要件</h2></div>\n\
<p>Xcode バージョン 10.2.1 および CMake が必要です。</p>\n\
<p>CMake は、<a href=\'https://cmake.org/download/\' title=\'\' target=\'_blank\'>https://cmake.org/download/</a> からダウンロードできます。</p>\n\
<div class=\'section\'><a id=\"developer-toolkit-をダウンロードして設定する\"></a><h2 id=\"developer-toolkit-をダウンロードして設定する\">Developer Toolkit をダウンロードして設定する</h2></div>\n\
<p>Maya devkit は <a href=\'https://www.autodesk.com/developmaya-jpn\' title=\'\' target=\'_blank\'>Maya デベロッパー センター</a>からダウンロードできます。</p>\n\
<p>Maya デベロッパー センター ページの下部にスクロールして、devkit のパッケージを見つけます。該当するリンクをクリックして、devkit をダウンロードします。</p>\n\
<ol>\n\
<li><p>devkit の <span class=\'code\'>dmg</span> パッケージを解凍します。マウントされたディスク イメージの名前 <span class=\'code\'>devkitBase</span> が作成されます。</p></li>\n\
<li><p>マシンに <span class=\'code\'>devkitBase</span> フォルダを作成します。このフォルダは、Maya インストール フォルダ内を除く任意の場所に配置できます。</p></li>\n\
<li><p><span class=\'code\'>devkitBase</span> ディスク イメージの中身を <span class=\'code\'>devkitbase</span> フォルダにコピーします。</p></li>\n\
<li><p><span class=\'code\'>devkitBase</span> フォルダ内に <span class=\'code\'>plug-ins</span> という名前のフォルダを作成します。このフォルダに、独自のプラグインおよびスクリプトが格納されます。</p></li>\n\
<li><p><span class=\'code\'>devkitBase/plug-ins/</span> フォルダ内に <span class=\'code\'>plug-ins</span>、<span class=\'code\'>scripts</span>、および <span class=\'code\'>icons</span> フォルダを作成します。</p></li>\n\
<li><p><span class=\'code\'>$HOME/Library/Preferences/Autodesk/maya/&lt;version_number&gt;/Maya.env</span> ファイルを編集して、<span class=\'code\'>plug-ins</span>、<span class=\'code\'>scripts</span>、および <span class=\'code\'>icons</span> フォルダを示すパス変数を定義します。開発している Maya のバージョンに対応する <span class=\'code\'>Maya.env</span> ファイルを使用します。</p></li>\n\
</ol>\n\
<p><span class=\'code\'>sh     MAYA_PLUG_IN_PATH=$HOME/devkitBase/plug-ins/plug-ins/    MAYA_SCRIPT_PATH=$HOME/devkitBase/plug-ins/scripts/    XBMLANGPATH=$HOME/devkitBase/plug-ins/icons/</span></p>\n\
<p>Maya はこれらのパスを使用して、これらのフォルダ内でプラグインやスクリプトを自動的に検出します。これらのパスが設定されていない場合は、Maya のプラグイン マネージャを開き、プラグインおよびスクリプトの場所を手動で参照して、これらをロードする必要があります。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> <span class=\'code\'>$HOME/Library/Preferences/Autodesk/maya/&lt;version_number&gt;/</span> フォルダは Maya を初めて起動したときに作成されます。Finder では表示できない場合がありますが、ターミナル ウィンドウから移動できます。</p>\n\
</blockquote>\n\
<ol>\n\
<li><span class=\'code\'>MAYA_LOCATION</span>、<span class=\'code\'>DYLD_LIBRARY_PATH</span>、<span class=\'code\'>DYLD_FRAMEWORK_PATH</span>、および <span class=\'code\'>DEVKIT_LOCATION</span> 環境変数を設定します。</li>\n\
</ol>\n\
<blockquote>\n\
<p><strong>重要:</strong> 複数のバージョンの Maya をインストールしている場合は、プラグインやアプリケーションをビルドするターミナル ウィンドウでこれらの変数を設定します。<span class=\'code\'>.bash_profiles</span> ファイルでこれらの変数を設定すると、システムにインストールされている他のバージョンの Maya と競合する可能性があります。</p>\n\
</blockquote>\n\
<p>開発している Maya のバージョンを示すように <span class=\'code\'>MAYA_LOCATION</span>を設定し、<span class=\'code\'>devkitBase</span> フォルダの場所を示すように <span class=\'code\'>DEVKIT_LOCATION</span> を設定します。</p>\n\
<p>ターミナル ウィンドウを開き、以下の環境変数を設定します。</p>\n\
<p><span class=\'code\'>sh     export MAYA_LOCATION=/Applications/Autodesk/&lt;maya_version&gt;/Maya.app/Contents     export DYLD_LIBRARY_PATH=$MAYA_LOCATION/MacOS     export DYLD_FRAMEWORK_PATH=$MAYA_LOCATION/Frameworks     export DEVKIT_LOCATION=/Users/&lt;your_username&gt;/devkitBase</span></p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";