var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>CMake を使用してビルドする</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>CMake を使用してビルドする</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"cmake-を使用してビルドする\"></a></div>\n\
<p>プラグインやアプリケーションのプロジェクトを生成する場合、および生成されたプロジェクトからプラグインやアプリケーションをビルドする場合は、いずれも CMake ツールを使用します。</p>\n\
<p>プロジェクトは、CMake Generator を呼び出して生成します。プラグインまたはアプリケーションのフォルダ内にある<a href=\'#!/url=./dev_help/SettingUpCMake/The-CMakeList-File.html\' title=\'\'><span class=\'code\'>CMakeLists.txt</span> ファイル</a>には、プロジェクトを生成するために必要なライブラリ、ファイル、およびソースに関する情報が記述されています。</p>\n\
<p>プロジェクトを生成するには、次のコマンドを使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake -H. -B&lt;build_directory&gt; -G &lt;generator&gt;\n\
</pre></div><p>Maya devkit は次の 3 つのジェネレータをサポートしています。</p>\n\
<ul>\n\
<li><span class=\'code\'>Visual Studio 15 2017 Win64</span> (64 ビット Windows)</li>\n\
</ul>\n\
<p><span class=\'code\'>sh    cmake -H. -Bbuild -G &quot;Visual Studio 15 2017 Win64&quot;</span></p>\n\
<ul>\n\
<li><span class=\'code\'>Unix Makefiles</span> (macOS および Linux)</li>\n\
</ul>\n\
<p><span class=\'code\'>sh    cmake -H. -Bbuild -G &quot;Unix Makefiles&quot;</span></p>\n\
<ul>\n\
<li><span class=\'code\'>Xcode</span> (macOS)</li>\n\
</ul>\n\
<p><span class=\'code\'>sh    cmake -H. -Bbuild -G Xcode</span></p>\n\
<p>プロジェクト ファイルのターゲット フォルダを指定するには、<span class=\'code\'>-B</span> フラグを使用します。</p>\n\
<p>たとえば、<span class=\'code\'>project</span> フォルダ内に XCode プロジェクトを生成するには、次のコマンドを使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake -H. -Bproject -G Xcode\n\
</pre></div><p>プロジェクトが生成されたら、IDE でプロジェクトを開いてプラグインまたはアプリケーションをビルドするか、CMake に <span class=\'code\'>--build</span> オプションを指定してビルドすることができます</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake --build &lt;build_directory&gt;\n\
</pre></div><p>たとえば、プロジェクトを <span class=\'code\'>project</span> フォルダに生成した場合は、次のコマンドを使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake --build project/\n\
</pre></div><p><span class=\'code\'>Unix Makefiles</span> を使用してプロジェクトを生成した場合、ビルドしたアプリケーションまたはプラグインは、ビルドしたフォルダの最上位に配置されます。<span class=\'code\'>Xcode</span> または <span class=\'code\'>Visual Studio 14 2015 Win64</span> ジェネレータを使用した場合、プラグインまたはアプリケーションは、ビルドしたフォルダの <span class=\'code\'>Debug</span> サブフォルダに配置されます。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> 異なるプラットフォームでビルドされたプラグインには、異なる拡張子が付きます。Windows でビルドされたプラグインの拡張子は <span class=\'code\'>mll</span> です。Linux でビルドされたプラグインの拡張子は <span class=\'code\'>so</span> です。macOS でビルドされたプラグインの拡張子は <span class=\'code\'>bundle</span> です。</p>\n\
</blockquote>\n\
<p>スタンドアローン アプリケーションは、コマンド ラインまたは Windows エクスプローラから直接実行できます。</p>\n\
<p>「<a href=\'#!/url=./dev_help/SettingUpCMake/Setting-up-your-build-environment.html\' title=\'\'>ビルド環境を設定する</a>」の説明に従って <span class=\'code\'>Maya.env</span> 内に <span class=\'code\'>MAYA_PLUG_IN_PATH</span> パスを設定した場合は、プラグインを <span class=\'code\'>MAYA_PLUG_IN_PATH</span> にコピーして、Maya に自動的にロードされるようにすることができます。プラグインを <span class=\'code\'>MAYA_PLUG_IN_PATH</span> に配置しないで、<a href=\'#!/url=./dev_help/LoadingAndSamples-Plug-ins-Into-Maya.html\' title=\'\'>手動でロードする</a>こともできます。</p>\n\
<blockquote>\n\
<p><strong>重要:</strong> Maya 内に既にロードされているプラグインはリビルドしないでください。<a href=\'#!/url=./dev_help/LoadingAndUnloadingPlugins/Unloading-Plug-ins.html\' title=\'\'>プラグインをアップロード</a>してから、リビルドしてください。</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";