var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>CMakeLists.txt ファイル</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>CMakeLists.txt ファイル</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"cmakelists.txt-ファイル\"></a></div>\n\
<p>CMake ツールは、プラグインおよびアプリケーションのプロジェクトを生成する場合に使用します。</p>\n\
<p>プラグインまたはアプリケーションの <span class=\'code\'>CMakeLists.txt</span> ファイルには、プロジェクトを生成するために必要なライブラリ、ソース ファイル、およびビルド関数の情報が含まれています。このファイルは、ソース コードや、プラグインにパッケージ化されている任意の <span class=\'code\'>mel</span> スクリプトとともに、プラグインまたはアプリケーションのフォルダの最上位に配置されています。</p>\n\
<p>このページでは、<span class=\'code\'>CMakeLists.txt</span> ファイルの各部について説明します。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> devkit のサンプル内にある <span class=\'code\'>CMakeLists.txt</span> ファイルを独自に作成するための開始点として使用することができます。</p>\n\
</blockquote>\n\
<p><span class=\'code\'>CMakeLists.txt</span> ファイルの要素は、次のとおりです。</p>\n\
<ol>\n\
<li>最低限必要な CMake のバージョン</li>\n\
</ol>\n\
<p><span class=\'code\'>sh    cmake_minimum_required(VERSION 2.8)</span></p>\n\
<ol>\n\
<li><span class=\'code\'>pluginEntry.cmake</span> ファイルのパス。このパスは、Maya devkit で使用するすべての <span class=\'code\'>CMakeLists.txt</span> ファイルで同一です。</li>\n\
</ol>\n\
<p><span class=\'code\'>sh    include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)</span></p>\n\
<p>例:</p>\n\
<p>```sh cmake_minimum_required(VERSION 2.8)</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)\n\
</pre></div><p>```</p>\n\
<ol>\n\
<li>プロジェクト名</li>\n\
</ol>\n\
<p><span class=\'code\'>sh    set(PROJECT_NAME &lt;projectName&gt;)</span></p>\n\
<p>例:</p>\n\
<p>```sh cmake_minimum_required(VERSION 2.8)</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)\n\
</pre></div><p>set(PROJECT_NAME exampleNode) ```</p>\n\
<ol>\n\
<li>必要なリソース ファイルのリスト(不要な場合もあり)。プロジェクトで複数のリソース ファイルを使用する場合は、各ファイルをスペースで区切ります。</li>\n\
</ol>\n\
<p>```sh cmake_minimum_required(VERSION 2.8)</p>\n\
<p>include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)</p>\n\
<p>set(PROJECT_NAME exampleNode)</p>\n\
<p>set(RESOURCES_FILES myResource.xpm) ```</p>\n\
<ol>\n\
<li><span class=\'code\'>mel</span> ファイルのリスト(必要な場合)。プロジェクトで複数の <span class=\'code\'>mel</span> ファイルを使用する場合は、各ファイルをスペースで区切ります。</li>\n\
</ol>\n\
<p><span class=\'code\'>sh    set(MEL_FILES        &lt;melFileName1&gt; &lt;melFileName2&gt; &lt;melFileName3&gt;)</span></p>\n\
<p>例:</p>\n\
<p>```sh cmake_minimum_required(VERSION 2.8)</p>\n\
<p>include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)</p>\n\
<p>set(PROJECT_NAME exampleNode)</p>\n\
<p>set(RESOURCES_FILES myResource.xpm)</p>\n\
<p>set(MEL_FILES exampleNode.mel) ```</p>\n\
<ol>\n\
<li><span class=\'code\'>mel</span>、および必要に応じてリソース ファイルを含むソース ファイルのリスト。プロジェクトで複数のソース ファイルを使用する場合は、各ファイルをスペースで区切ります。</li>\n\
</ol>\n\
<p><span class=\'code\'>sh    set(SOURCE_FILES        &lt;sourceFileName1&gt; &lt;sourceFileName2&gt; &lt;sourceFileName3&gt;            ${MEL_FILES}            ${RESOURCE_FILES})</span></p>\n\
<p>例:</p>\n\
<p>```sh cmake_minimum_required(VERSION 2.8)</p>\n\
<p>include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)</p>\n\
<p>set(PROJECT_NAME exampleNode)</p>\n\
<p>set(RESOURCES_FILES myResource.xpm)</p>\n\
<p>set(MEL_FILES exampleNode.mel)</p>\n\
<p>set(SOURCE_FILES exampleNode.cpp ${MEL_FILES} ) ```</p>\n\
<ol>\n\
<li>必要な devkit ライブラリのリスト。ライブラリのリストをスペースで区切ります</li>\n\
</ol>\n\
<blockquote>\n\
<p><strong>重要:</strong> すべてのプラグインとアプリケーションに OpenMaya ライブラリと Foundation ライブラリを含める必要があります。</p>\n\
</blockquote>\n\
<p><span class=\'code\'>sh    set(LIBRARIES        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMaya</a> Foundation &lt;additionalLibrary1&gt; &lt;additionalLibrary2&gt;        )</span></p>\n\
<p>例:</p>\n\
<p>```sh cmake_minimum_required(VERSION 2.8)</p>\n\
<p>include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)</p>\n\
<p>set(PROJECT_NAME exampleNode)</p>\n\
<p>set(RESOURCES_FILES myResource.xpm)</p>\n\
<p>set(MEL_FILES exampleNode.mel)</p>\n\
<p>set(SOURCE_FILES exampleNode.cpp ${MEL_FILES} )</p>\n\
<p>set(LIBRARIES OpenMaya Foundation ) ```</p>\n\
<ol>\n\
<li><a href=\'#!/url=./dev_help/SettingUpCMake/LibraryMacros.html\' title=\'\'><span class=\'code\'>find_&lt;package_name&gt;</span></a>マクロまたは<a href=\'#!/url=./dev_help/SettingUpCMake/ThirdPartyLibs.html\' title=\'\'><span class=\'code\'>find_package()</span></a>の呼び出しを使用して追加される、必要なサードパーティ パッケージのリスト。</li>\n\
</ol>\n\
<p><span class=\'code\'>sh    find_package(MtoA)    find_alembic()</span></p>\n\
<p>例:</p>\n\
<p>```sh cmake_minimum_required(VERSION 2.8)</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)\n\
</pre></div><p>set(PROJECT_NAME exampleNode)</p>\n\
<p>set(RESOURCES_FILES myResource.xpm)</p>\n\
<p>set(MEL_FILES exampleNode.mel)</p>\n\
<p>set(SOURCE_FILES exampleNode.cpp ${MEL_FILES} )</p>\n\
<p>set(LIBRARIES OpenMaya Foundation )</p>\n\
<p>find_package(MtoA) find_alembic() ```</p>\n\
<ol>\n\
<li>最後は、ビルド関数です。</li>\n\
</ol>\n\
<p>プラグインを作成している場合は、<span class=\'code\'>build_plugin()</span> を追加します。スタンドアロン アプリケーションを作成している場合は、<span class=\'code\'>build_application()</span> を追加します。</p>\n\
<p>```sh cmake_minimum_required(VERSION 2.8)</p>\n\
<p>include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)</p>\n\
<p>set(PROJECT_NAME exampleNode)</p>\n\
<p>set(RESOURCES_FILES myResource.xpm)</p>\n\
<p>set(MEL_FILES exampleNode.mel)</p>\n\
<p>set(SOURCE_FILES exampleNode.cpp ${MEL_FILES} )</p>\n\
<p>set(LIBRARIES OpenMaya Foundation )</p>\n\
<p>find_package(MtoA) find_alembic() build_plugin() ```</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";