var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>サードパーティのライブラリを追加する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>サードパーティのライブラリを追加する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"サードパーティのライブラリを追加する\"></a></div>\n\
<p>サードパーティ ライブラリを CMake プロジェクトに追加するには、<span class=\'code\'>find_package()</span> 呼び出しを使用します。</p>\n\
<p><span class=\'code\'>find_package(&lt;package_name&gt;)</span> は、Linux と macOS では <span class=\'code\'>$DEVKIT_LOCATION/cmake/modules/</span> で、Windows では <span class=\'code\'>%DEVKIT_LOCATION%\\cmake\\modules</span> で、対応する <span class=\'code\'>Find&lt;package_name&gt;.cmake</span> ファイルを検索します。次に、<span class=\'code\'>Find&lt;package_name&gt;.cmake</span> が対応するサードパーティ ライブラリから設定を検索して、プロジェクトにロードします。</p>\n\
<p>たとえば、<span class=\'code\'>FindMtoA.cmake</span> ファイルを使用して Arnold for Maya パッケージを追加するには、<span class=\'code\'>CMakeLists.txt</span> ファイルに以下を追加します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">find_package(MtoA)\n\
</pre></div><p>例:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake_minimum_required(VERSION 2.8)\n\
\n\
include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)\n\
\n\
set(PROJECT_NAME exampleNode)\n\
\n\
set(RESOURCES_FILES myResource.xpm)\n\
\n\
set(MEL_FILES\n\
    exampleNode.mel\n\
    )\n\
\n\
set(SOURCE_FILES\n\
    exampleNode.cpp\n\
    ${MEL_FILES}\n\
    )\n\
\n\
set(LIBRARIES\n\
    OpenMaya Foundation\n\
    )\n\
\n\
find_package(MtoA)\n\
build_plugin()\n\
</pre></div><p><span class=\'code\'>find_package()</span> を呼び出す前に、パッケージで使用するサードパーティ ライブラリをインストールし、必要な環境変数を設定しておく必要があります。 たとえば、Arnold for Maya ライブラリを含めるには、<a href=\'#!/url=./dev_help/Setting-up-your-build/MtoALibs.html\' title=\'\'><span class=\'code\'>MTOA_LOCATION</span> 環境変数を設定する</a>必要があります。</p>\n\
<p><span class=\'code\'>Find&lt;package_name&gt;.cmake</span> ファイルは、ユーザ独自の CMake パッケージ ファイルを作成する際のガイドとして使用することもできます。独自のファイルを作成する場合は、ライブラリを <span class=\'code\'>modules</span> フォルダに保存して CMake が検出できるようにします。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";