var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>描画とリフレッシュ</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>描画とリフレッシュ</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"描画とリフレッシュ\"></a></div>\n\
<p>描画は、2 つの手順によるプロセスです。第 1 のプロセスでは、ジオメトリとマテリアルが評価され、描画に必要なすべての情報がキューに配置されます。第 2 のプロセスでは、実際の OpenGL 描画が発生します。この 2 つの手順によるプロセスで、シェイプに対して Maya のマルチスレッド描画機能を活用することができます。</p>\n\
<p>描画は、カメラが変更されるたび、またはビューをリフレッシュする必要が生じるたびに実行されます。これが実行されると、<span class=\'code\'>MPxSurfaceShapeUI::getDrawRequest</span> 関数が呼び出されます。これが、描画する内容を Maya がシェイプに尋ねる方法です。この関数の内部で、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_info.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_draw_info.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawInfo</a></span> を使用して描画の状態を照会し、描画要求(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawRequest\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_request.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_draw_request.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawRequest</a></span>)を作成して待ち行列に入れる必要があります。多くの場合は、この関数内で複数の要求を待ち行列(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawRequestQueue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_request_queue.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawRequestQueue</a></span>)に配置します。たとえばシェーディング モードでは、シェイプが選択された場合、シェーディング オブジェクトを描画する要求を追加し、シェーディング オブジェクトの上にワイヤフレームを描画する、別の要求を追加します。</p>\n\
<p>描画データ(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_draw_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawData</a></span>)には、Maya では本質的に識別できないシェイプに特定した情報が保持されます。描画データは、描画要求待ち行列を通してジオメトリを渡すコンテナとして働きます。それぞれの描画要求では、ジオメトリ固有の情報を含む描画データ オブジェクトを作成して追加する必要があります。この情報は、後で <span class=\'code\'>MPxSurfaceShapeUI::draw</span> を呼び出す場合に必要となります。</p>\n\
<p>描画データを作成するには関数 <span class=\'code\'>MPxSurfaceShapeUI::getDrawData</span> を使用し、データを要求に追加するには <span class=\'code\'>MDrawRequest::setDrawData</span> を使用します。以下は、ジオメトリの描画要求と描画データを作成する方法の例です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">void yourShapeUI::getDrawRequests( const <a href=\"javascript:void(0)\" data-symbol=\"MDrawInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_info.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_draw_info.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawInfo</a> &amp; info,\n\
 bool objectAndActiveOnly,\n\
 <a href=\"javascript:void(0)\" data-symbol=\"MDrawRequestQueue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_request_queue.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawRequestQueue</a> &amp; queue )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MDrawData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_draw_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawData</a> data;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MDrawRequest\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_request.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_draw_request.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawRequest</a> request = info.getPrototype( *this );\n\
    yourShape* shapeNode = (yourShape*)surfaceShape();\n\
    yourGeom* geom = shapeNode-&gt;geometry();\n\
    getDrawData( geom, data );\n\
    request.setDrawData( data );\n\
    ...\n\
}\n\
\n\
</pre></div><p>描画要求(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawRequest\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_request.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_draw_request.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawRequest</a></span>)は、オーバーライドした <span class=\'code\'>MPxSurfaceShapeUI::getDrawRequests</span> メソッド内で作成する必要があります。要求を作成したら、このクラスの適切な「設定」メソッドを使用して、要求するものを定義します。次に <span class=\'code\'>MDrawRequestQueue::add</span> を使用し、要求を描画要求待ち行列に配置します。</p>\n\
<p>描画トークンは整数値で、これを使用すると、描画するものを指定できます。これはオブジェクトに固有なので、必要な情報で enum を定義し、<span class=\'code\'>MPxSurfaceShapeUI::draw</span> メソッドで描画するものを決める必要があります。以下は、メッシュ オブジェクトの描画トークンの例です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"> enum {\n\
          kDrawVertices, // component token\n\
          kDrawWireframe,\n\
          kDrawWireframeOnShaded,\n\
          kDrawSmoothShaded,\n\
          kDrawFlatShaded,\n\
          kLastToken\n\
      };\n\
\n\
</pre></div><p>Maya は描画要求待ち行列を処理し、描画要求ごとに、対応するオブジェクト描画関数をコールします。ユーザ定義シェイプの場合は、<span class=\'code\'>MPxSurfaceShapeUI::draw</span> メソッドが呼び出されます。</p>\n\
<div class=\'section\'><a id=\"シェーディング-モードで描画する\"></a><h2 id=\"シェーディング-モードで描画する\">シェーディング モードで描画する</h2></div>\n\
<p>シェーディング モード表示のサポートは、2 つの手順で処理されます。最初の手順は <span class=\'code\'>getDrawRequests</span> 関数で行います。ここではマテリアルの「評価」つまりセットアップを行い、オブジェクトを描画する場合にマテリアルを表示できるようにします。次の手順は描画関数内で実行されます。ここでは、ビューをセットアップしてマテリアルを表示する必要があります。</p>\n\
<p>以下のコードは、シェーディング モード表示を求める要求の場合に、<span class=\'code\'>getDrawRequests</span> 関数でマテリアルをセットアップする方法の例です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"> <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> path = info.multiPath();\n\
 <a href=\"javascript:void(0)\" data-symbol=\"M3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">M3dView</a> view = info.view();\n\
 <a href=\"javascript:void(0)\" data-symbol=\"MMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMaterial</a> material = <a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShapeUI::material\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_surface_shape_u_i.html#a94d753f8b614df1c5408e36219c06577&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxSurfaceShapeUI::material</a>( path );\n\
 material.evaluateMaterial( view, path );\n\
 if ( material.materialIsTextured() ) {\n\
     material.evaluateTexture( data );\n\
 }\n\
 request.setMaterial( material );\n\
\n\
</pre></div><p>描画関数ではシーン ビューをセットアップし、マテリアルを表示できるようにする必要があります。これは <span class=\'code\'>MMaterial::setMaterial</span> を使用して実行します。シーン ビューをセットアップしてテクスチャを表示するには、<span class=\'code\'>MMaterial::applyTexture</span> を使用します。以下のコードはこの例です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">void yourShapeUI::draw( const <a href=\"javascript:void(0)\" data-symbol=\"MDrawRequest\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_draw_request.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_draw_request.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDrawRequest</a>&amp; request,\n\
 <a href=\"javascript:void(0)\" data-symbol=\"M3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">M3dView</a> &amp; view ) const\n\
{\n\
     ...\n\
     <a href=\"javascript:void(0)\" data-symbol=\"MMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMaterial</a> material = request.material();\n\
     material.setMaterial( request.isTransparent() );\n\
     drawTexture = material.materialIsTextured();\n\
     if ( drawTexture ) glEnable(GL_TEXTURE_2D);\n\
     if ( drawTexture ) {\n\
         material.applyTexture( view, data );\n\
     }\n\
     ...\n\
}\n\
\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>注:</strong> すべての OpenGLは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"M3dView::beginGL()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html#a0e318e5634c7aaf31c4eb7232d2013d4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#a091f4d5c3cd36bdd6359020da45b6cd7&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">M3dView::beginGL()</a></span> と <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"M3dView::endGL()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html#ab810c5a46d728df70ff5f44b604559f4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html#a253e4583afb5f6c8aa15cc7962f3f876&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">M3dView::endGL()</a></span> の呼び出しの間に呼び出す必要があります。</p>\n\
\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";