var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>国際化プロセス</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>国際化プロセス</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"国際化プロセス\"></a></div>\n\
<p>国際化により、プラグインは、ユーザ インタフェースでローカライズした文字列をサポートし、ローカライズ環境で正しく動作できます。文字列リソースをローカライズするプロセスは、この文書の後半で概説する、国際化とは別の一連の手順です。ローカライズは、プラグインの国際化後にいつでも実行できます。プラグインは、翻訳が使用可能になるまで、既定のリソース値を使用して動作します。</p>\n\
<p>国際化では、以下の手順が必要です。</p>\n\
<ol>\n\
<li>プラグインのローカライズが必要な面を決定します。</li>\n\
<li>別の言語でプラグインを実行するときに変更する必要があるユーザ インタフェース文字列を特定します。文字列は、C++ コードまたは MEL スクリプト内にある場合があります。ハードコードされた文字列の代わりに文字列リソースを使用するように、コードとスクリプトを修正します。</li>\n\
<li>プラグインの初期化シーケンスに文字列登録コールを追加します。</li>\n\
<li>シングル バイトとマルチバイトのエンコーディングで文字列を適切に処理するために、文字列処理コードを確認し、必要な場合は修正を加えます。</li>\n\
</ol>\n\
<div class=\'section\'><a id=\"要件の評価\"></a><h2 id=\"要件の評価\">要件の評価</h2></div>\n\
<p>プラグインを国際化する作業を行う前に、実際の要件を評価することをお勧めします。状況ごとに、プラグインの国際化の一部の面が不必要、または不適切な場合があります。</p>\n\
<p>最も重要な考慮事項は、プラグインがサポートする必要があるターゲット言語の数を決定することです。プラグインのターゲット言語が 1 言語(たとえば、日本語など)のみの場合は、文字列リソースを使用する代わりに、スクリプトをローカライズしてプラグインのカスタム UI を提供することも可能な場合があります。</p>\n\
<p>プラグインが以下の条件を 1 つ以上満たす場合は、文字列リソースが必要です。</p>\n\
<ul>\n\
<li>プラグインが複数のユーザ インタフェース言語(たとえば、英語と日本語など)をサポートする</li>\n\
<li>プラグインが C++ コードからユーザ メッセージを発行する(たとえば、<span class=\'code\'>displayError()</span> のコールなど)</li>\n\
<li>プラグインが、ローカライズしたノードとアトリビュート名のラベルを使用して UI に表示されるノードを作成する</li>\n\
</ul>\n\
<p>文字列処理のタイプやプラグイン コードが実行する入出力も検討する必要があります。文字列操作やファイル処理がほとんどまたはまったくないプラグインでは、変更はほとんど必要ないはずですが、その他のプラグインは見直して、マルチバイト文字を適切に処理することを確認する必要があります。</p>\n\
<div class=\'section\'><a id=\"文字列リソースの定義と登録\"></a><h2 id=\"文字列リソースの定義と登録\">文字列リソースの定義と登録</h2></div>\n\
<p>このセクションでは、C++ スクリプトと MEL スクリプトでどのように文字列リソースが使用されるかと、プラグインの初期化中に文字列リソースを登録する方法を説明します。</p>\n\
<div class=\'section\'><a id=\"文字列リソース-キー\"></a><h3 id=\"文字列リソース-キー\">文字列リソース キー</h3></div>\n\
<p>Maya String Catalog 内の各文字列リソースは、一意のキーによって識別されます。プラグインの場合、キーは順序が付いた文字列のペアで構成されます。ペアの最初の要素はプラグイン名で、そのプラグインで使用されるすべての文字列で共通です。キーの 2 番目の部分は、定義する文字列の一意の識別子です。たとえば、<span class=\'code\'>closestPointOnCurve</span> プラグインが使用する文字列リソース キーは、以下のような形式を持ちます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">(&quot;closestPointOnCurve&quot;, &quot;stringId1&quot;);\n\
(&quot;closestPointOnCurve&quot;, &quot;stringId2&quot;);\n\
(&quot;closestPointOnCurve&quot;, &quot;stringId3&quot;);\n\
\n\
</pre></div><div class=\'section\'><a id=\"c-の文字列リソース\"></a><h3 id=\"c-の文字列リソース\">C++ の文字列リソース</h3></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResourceId</a></span> クラスと <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStringResource\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResource</a></span> クラスは、プラグイン C++ コードで文字列リソースを定義し、文字列リソースにアクセスするために使用します。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResourceId</a></span> コンストラクタは、リソース キーを形成するために使用する 2 つの要素とリソース文字列の既定値の 3 つの引数を受け取ります。以下の例では、プラグイン名は「<span class=\'code\'>closestPointOnCurve</span>」で、この文字列に与えられるユーザ定義の一意のキーは「<span class=\'code\'>kNoValidObject</span>」です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResourceId</a> invalidObject(&quot;closestPointOnCurve&quot;, &quot;kNoValidObject&quot;, &quot;A curve or its transform node must be specified as a command argument, or using your current selection.&quot;);\n\
\n\
</pre></div><div class=\'section\'><a id=\"define-ステートメントを使用して-mstringresourceid-を定数に関連付けると各リソースの単一の定義点を提供するために役立ちます一般的にプラグインの-mstringresourceid-宣言はそれを必要とする-c-モジュール間で共有されるヘッダー-ファイルにまとめられています\"></a><h1 id=\"define-ステートメントを使用して-mstringresourceid-を定数に関連付けると各リソースの単一の定義点を提供するために役立ちます一般的にプラグインの-mstringresourceid-宣言はそれを必要とする-c-モジュール間で共有されるヘッダー-ファイルにまとめられています\">define ステートメントを使用して <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResourceId</a></span> を定数に関連付けると、各リソースの単一の定義点を提供するために役立ちます。一般的に、プラグインの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResourceId</a></span> 宣言は、それを必要とする C++ モジュール間で共有されるヘッダー ファイルにまとめられています。</h1></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#define kPluginId  &quot;closestPointOnCurve&quot;\n\
#define kNoValidObject <a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResourceId</a>(kPluginId, &quot;kNoValidObject&quot;, \\&quot;A curve or its transform node must be specified as a command argument, or using your current selection.&quot;)\n\
\n\
</pre></div><p><span class=\'code\'>MStringResource::getString</span> メソッドは、コードで文字列が必要なときに、カタログの項目を検索するために使用します。カタログ検索は、既定値またはローカライズ文字列値(使用可能な場合)のいずれかを返します。文字列をロードすると、ほかの <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a></span> 同様に使用できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a> stat;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> msg = <a href=\"javascript:void(0)\" data-symbol=\"MStringResource::getString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource.html#a121315f443a9c4ea512738dc1d39414d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResource::getString</a>(kNoValidObject, stat);\n\
displayError(msg);\n\
\n\
</pre></div><p>文字列リソースには、登録するまでアクセスできません。この処理は、<span class=\'code\'>MstringResource::registerString</span> を呼び出して実行されます。登録手順は、「文字列リソースの登録」で説明されています。</p>\n\
<div class=\'section\'><a id=\"mel-スクリプトの文字列リソース\"></a><h3 id=\"mel-スクリプトの文字列リソース\">MEL スクリプトの文字列リソース</h3></div>\n\
<p>MEL スクリプトは、C++ コードと同じような方法で文字列リソースを使用できます。</p>\n\
<p>文字列リソースを使用するには、<span class=\'code\'>getPluginResource</span> コマンドを使用して値を検索します。渡される引数は、文字列リソース キーの 2 つの要素です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">string $titleStr = getPluginResource(&quot;closestPointOnCurve&quot;, &quot;kAETitle&quot;);\n\
editorTemplate -beginScrollLayout;\n\
editorTemplate -beginLayout $titleStr -collapse 0;\n\
\n\
</pre></div><p>MEL リソースは、<span class=\'code\'>registerPluginResource</span> コマンドを使用して登録します。登録プロセスを以下に説明します。</p>\n\
<div class=\'section\'><a id=\"文字列リソースの登録\"></a><h3 id=\"文字列リソースの登録\">文字列リソースの登録</h3></div>\n\
<p>このセクションでは、プラグインで文字列リソースを登録するプロセスを説明します。すべての文字列登録は、プラグインの初期化中に実行します。</p>\n\
<p>各文字列リソースは、使用する前に登録しておく必要があります。この登録手順によって、リソースの既定値が文字列カタログに確実にロードされます。プラグイン作成者は既定値を登録後、ローカライズしたリソース値をロードするコールを追加する必要があります。Maya を実行している言語でローカライズしたリソース値を使用可能な場合、ローカライズした値が既定値をオーバーライドします。</p>\n\
<p>主要な登録メソッドは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin::registerUIStrings()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html#a92e203dc380e1d56d08d2866dcbd697e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MFnPlugin::registerUIStrings()</a></span> です。このルーチンの呼び出しは、プラグインの <span class=\'code\'>initializePlugin()</span> 関数に追加されます。文字列リソースは呼び出されるまでは使用できません。他の初期化メソッドで必要な場合があるため、初期化シーケンスの最初の方に記述してください。</p>\n\
<p><span class=\'code\'>MFnPlugin::registerUIStrings</span> 関数は次の 2 つの引数を取ります。最初の引数は、C++ コードで使用する文字列を登録するプロシージャの名前です。2 番目の引数は、MEL スクリプトで使用する文字列リソースを登録するスクリプトの名前です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"> // Register string resources used in the code and scripts\n\
status = plugin.registerUIStrings(registerMStringResources, &quot;closestPointOnCurveInitStrings&quot;);\n\
if (!status)\n\
{\n\
    status.perror(&quot;registerUIStrings&quot;);\n\
    return status;\n\
}\n\
\n\
</pre></div><p>この呼び出しで参照される C++ ルーチン <span class=\'code\'>registerMStringResources</span> は、C++ コードで使用する各 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResourceId</a></span> を登録します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Register all strings used by the plugin C++ source \n\
static <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a> registerMStringResources(void)\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStringResource::registerString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource.html#a02fc22430bb24b5bfe27a65bd2d9a762&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResource::registerString</a>(kNoValidObject);\n\
    // other resources would go here\n\
    return MS::kSuccess;\n\
}\n\
\n\
</pre></div><p>この例は、ヘッダ ファイルで事前に定義されている定数を使用します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#define kPluginId  &quot;closestPointOnCurve&quot;\n\
#define kNoValidObject <a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResourceId</a>(kPluginId, &quot;kNoValidObject&quot;, \\&quot;A curve or its transform node must be specified as a command argument, or using your current selection.&quot;)\n\
\n\
</pre></div><p>2 番目の引数は、プラグインの MEL スクリプトで使用するすべてのリソースを初期化するスクリプトの名前です。各リソースは <span class=\'code\'>registerPluginResources</span> を呼び出して登録します。</p>\n\
<p>初期化スクリプトには 2 つの目的があります。初期化リソースには、MEL リソースの登録に加え、プラグインの言語依存リソースをロードするロジックも含まれています。ルーチン <span class=\'code\'>loadPluginLanguageResources</span> は、プラグイン文字列リソースのローカライズ バージョンを含むリソース ファイルの名前を使用します。ローカライズ リソース ファイルの作成とインストールの詳細については、以下の「ローカリゼーション プロセス」を参照してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">global proc closestPointOnCurveInitStrings()\n\
{\n\
    // Register script resources\n\
    registerPluginResource(&quot;closestPointOnCurve&quot;, &quot;kAETitle&quot;,\n\
        &quot;Closest Point On Curve Attributes&quot;);\n\
    registerPluginResource(&quot;closestPointOnCurve&quot;, &quot;kInputCurve&quot;,\n\
        &quot;Input Curve&quot;);\n\
    registerPluginResource(&quot;closestPointOnCurve&quot;, &quot;kResults&quot;,\n\
        &quot;Results&quot;);\n\
    // Load any localized resources\n\
    loadPluginLanguageResources(&quot;closestPointOnCurve&quot;, &quot;closestPointOnCurve.pres.mel&quot;);\n\
}\n\
\n\
</pre></div><p>登録シーケンスが完了すると、文字列を Maya Catalog で使用し、<span class=\'code\'>MString::getStringResource</span> (C++)または <span class=\'code\'>getPluginResource</span> (MEL)を使用して検索できるようになります。リソースのローカライズ値が <span class=\'code\'>loadPluginLanguageResources</span> によって特定された場合は、既定値ではなくローカライズ値がカタログから返されます。</p>\n\
<div class=\'section\'><a id=\"文字列の処理\"></a><h2 id=\"文字列の処理\">文字列の処理</h2></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a></span> クラスを使用するプラグインの大部分は、ロケールに合わせて変更する必要はありませんが、一部の文字列処理コードは、シングル バイトとマルチバイトの両方の環境で正しく動作するように変更する必要があります。このセクションは、ローカライズ環境での <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a></span> の使用に関係する問題に主に重点を置いていますが、説明されている問題の多くは、文字処理全般にも適用できます。</p>\n\
<div class=\'section\'><a id=\"エンコーディング\"></a><h3 id=\"エンコーディング\">エンコーディング</h3></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a></span> クラスは、既定では、ロケールのコードセットで char* 形式の文字データをエンコードするという前提の下で動作します。これは、MString クラスの既存の機能の自然な拡張です。多くの場合、既存のプラグインは、ローカライズ環境でも変更なしで引き続き機能します。新しいメソッドは、国際化アプリケーションで一般的に使用される UTF-8 とワイド文字形式を使用して、明示的に文字列を割り当て、文字列にアクセスできるように追加されました。</p>\n\
<div class=\'section\'><a id=\"文字列の長さと位置の値\"></a><h3 id=\"文字列の長さと位置の値\">文字列の長さと位置の値</h3></div>\n\
<p>ローカライズしたテキストを処理する場合の最も一般的な問題は、文字列の長さの正確な解釈です。マルチバイト環境では、文字列の文字(<span class=\'code\'>char *</span>)表現は、文字列の各文字を表現するのに 1 バイトまたはそれ以上のバイトを使用します。つまり、バイト単位の文字列のストレージ長が、必ずしも文字列の個々の文字数に対応するとは限らず、この前提を使用するコードは予想どおりに動作しない場合があります。下位互換性を提供するために、<span class=\'code\'>MString::length</span> メソッドは、文字バッファ内のバイト数を引き続き返します。文字列の個々の文字の数を確定する必要がある場合は、代わりに新しいメソッドの <span class=\'code\'>MString::numChars</span> を使用できます。</p>\n\
<p>マルチバイト環境では、文字列データへの位置インデックスの解釈も同様に問題になる場合があります(たとえば、<span class=\'code\'>MString::substring</span> メソッドを使用する場合)。マルチバイト文字列を正しく処理するために追加された内容の詳細については、<a href=\'#!/url=./dev_help/Technical-Notes/Internationalizing-plug-ins/Internationalization-Process.html#new-mstring-methods\' title=\'\'>新しい MString メソッド</a>を参照してください。</p>\n\
<div class=\'section\'><a id=\"メッセージ文字列のフォーマット\"></a><h3 id=\"メッセージ文字列のフォーマット\">メッセージ文字列のフォーマット</h3></div>\n\
<p>ユーザ メッセージ文字列は、多くの場合、複数の文字列や変数を連結して構築します。別の言語では文字列の文脈や配置を変更する必要がある場合があるので、このテクニックは、ローカライズする予定の文字列には適していません。</p>\n\
<p>文字列をフォーマットするには、<span class=\'code\'>MString::format</span> メソッドまたは MEL <span class=\'code\'>format</span> コマンドを使用します。フォーマットを使用すると、文字列を翻訳するときに、位置の引数を文脈に正しく配置できます。</p>\n\
<p>次の例は、文字列の連結を使用してファイルの名前を含むエラー メッセージを作成するコードのオリジナルのブロックです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> filename;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> msg;\n\
msg = &quot;The file &quot;;\n\
msg += filename;\n\
msg += &quot; cannot be opened&quot;;\n\
displayError(msg);\n\
\n\
</pre></div><p>次の置き換えコードは、国際化したアプリケーションで、この例がどのように正しく処理されるかを示しています。このメッセージは、リソース文字列と <span class=\'code\'>MString::format</span> コマンドを使用して作成しています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#define kOpenError <a href=\"javascript:void(0)\" data-symbol=\"MStringResourceId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource_id.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResourceId</a>(&quot;myPlugin&quot;, &quot;kOpenError&quot;, &quot;File ^1s cannot be opened&quot;);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> filename;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> msgFmt = <a href=\"javascript:void(0)\" data-symbol=\"MStringResource::getString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_resource.html#a121315f443a9c4ea512738dc1d39414d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringResource::getString</a>(kOpenError,status);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> msg;\n\
msg.format(msgFmt, filename);\n\
displayError(msg);\n\
\n\
</pre></div><p>MEL スクリプトは、MEL フォーマット コマンドも同様に使用できます。</p>\n\
<div class=\'section\'><a id=\"新しい-mstring-メソッド\"></a><h3 id=\"新しい-mstring-メソッド\">新しい MString メソッド</h3></div>\n\
<p>以下の表は、国際化をサポートするために <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a></span> に追加された新しいメソッドの一覧です。各メソッドの詳細とローカライズ環境内の既存のメソッドの動作に関する注意については、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a></span> クラスのマニュアルを参照してください。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col width=\"50%\" />\n\
<col width=\"50%\" />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
新しい <span class=\"code\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a></span> メソッド\n\
</th>\n\
<th class=\"table-heading\">\n\
説明\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\">MString::numChars</span>\n\
</td>\n\
<td class=\"table-body\">\n\
このルーチンは、文字列の文字数を返します。これは、文字列のバイト数、つまり <span class=\"code\">MString::length</span> によって返される値とは必ずしも対応しません。\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
<a name=\"GUID-E30E1E57-7963-489B-85CE-729D4E3B6722\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a> MString::setUTF8( const char * utf8String )</span>\n\
</p>\n\
<a name=\"GUID-87511EB3-FA02-4981-A2CB-1DD630A15CCD\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">const char * <a href=\"javascript:void(0)\" data-symbol=\"MString::asUTF8()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html#a9b62657aaecded5f56277d2c407ec64e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString::asUTF8()</a></span>\n\
</p>\n\
<a name=\"GUID-93692639-297D-4540-87CB-B707BAB67E61\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">const char * MString::asUTF8(int *length)</span>\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
これらのメソッドは、UTF-8 エンコード文字列として文字列の値を割り当て、また文字列の値にアクセスします。\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<a name=\"GUID-D3FDF0AC-26C1-4B04-B2B1-3F69092316F3\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">Mstring::MString(wchar_t *str)</span>\n\
</p>\n\
<a name=\"GUID-5B878F7B-B901-4FCF-9160-1398F33FFFCD\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">MString::MString(wchar_ *str, int length)</span>\n\
</p>\n\
<a name=\"GUID-002AB11F-ED63-42D0-94CE-5468852B0061\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a> MString::setWChar(wchar_t *str, int length)</span>\n\
</p>\n\
<a name=\"GUID-187CF52C-C11B-4498-A615-DD330F23A931\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a> MString::setWChar(wchar_t *str, int length)</span>\n\
</p>\n\
<a name=\"GUID-4E5C9D7F-F822-43D8-A2C5-5F53001B4EAD\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">const wchar_t* <a href=\"javascript:void(0)\" data-symbol=\"MString::asWChar()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html#ade6a9ba4bd9b9d2d0ae95b05a7f75522&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString::asWChar()</a></span>\n\
</p>\n\
<a name=\"GUID-255E7BEA-6DC5-4A0B-A652-0B6A6644DA41\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">const wchar_t* MString::asWChar(int length)</span>\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
<p>これらのメソッドを使用すると、ワイド文字の値を使用して、文字列の値を設定することや、文字列の値にアクセスすることができます。</p>\n\
<blockquote>\n\
<strong>注:</strong> 永続ストレージには、ワイド文字列表現はお勧めしません。代わりに、UTF-8 などの移植可能なフォーマットの使用をお勧めします。\n\
</blockquote></td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
<a name=\"GUID-E0DD2517-BCAC-4EDC-8682-58CC56CD9B7B\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">int MString::indexW(char c) const</span>\n\
</p>\n\
<a name=\"GUID-7BFA3217-4FC2-4106-9BD6-914B457CAE6F\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">int MString::indexW(wchar_t c) const</span>\n\
</p>\n\
<a name=\"GUID-DF0A7148-F737-42D6-9829-C824490FB9A4\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">int MString::rindexW(char c) const</span>\n\
</p>\n\
<a name=\"GUID-FD077AD4-9F6F-4406-8CFC-29443AF9177E\"></a>\n\
<p class=\"table-body\">\n\
<span class=\"code\">int MString::rindexW(wchar_t c) const</span>\n\
</p>\n\
</td>\n\
<td class=\"table-body\">\n\
これらのルーチンは、それぞれ、<span class=\"code\"> MString::index</span> と <span class=\"code\">MString::rindex</span> のマルチバイト互換バージョンで、文字に基づく位置の値を返します。国際化したプラグインには、これらのルーチンを使用することをお勧めします。「<span class=\"code\">MString::substringW</span>」も参照してください。\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> MString::substringW(int start, int end)</span>\n\
</td>\n\
<td class=\"table-body\">\n\
(<span class=\"code\">MString::indexW</span> や <span class=\"code\">MString::rindexW</span> の戻り値など)文字に基づく位置の値を受け取る <span class=\"code\">MString::substring</span> のマルチバイト互換バージョンです。\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a> MString::split(wchar_t c, <a href=\"javascript:void(0)\" data-symbol=\"MStringArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStringArray</a>&amp; array) const</span>\n\
</td>\n\
<td class=\"table-body\">\n\
<span class=\"code\">MString::split</span> のこのバージョンは、区切り文字としてワイド文字の値を受け取ります。\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
<span class=\"code\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MStatus</a> MString::format( const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> &amp;fmt, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> &amp;arg1, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> &amp;arg2, ... ,const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MString</a> &amp;arg10 )</span>\n\
</td>\n\
<td class=\"table-body\">\n\
このルーチンは、フォーマット指定子と最高 10 個の位置引数を使用し、文字フォーマット機能を提供します。\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";