var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ローカリゼーション プロセス</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ローカリゼーション プロセス</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ローカリゼーション-プロセス\"></a></div>\n\
<p>プラグインを国際化した後は、文字列リソースを抽出し、翻訳するために送信できます。重要なのは、ローカライズのプロセスを後から行うことができるということです。ローカライズ バージョンを使用できない場合、プラグインは既定のリソース値を使用して実行を続行します。</p>\n\
<p>プラグインのローカライズでは、以下の手順が必要です。</p>\n\
<ol>\n\
<li>リソースの抽出: プラグインからローカライズ可能なすべての文字列を含むマスタ リソース ファイルを生成します。</li>\n\
<li>翻訳: 文字列の翻訳バージョンを準備します。</li>\n\
<li>インストール: 翻訳したリソース ファイルをプラグイン リソース パスの正しい言語領域にインストールします。</li>\n\
</ol>\n\
<div class=\'section\'><a id=\"リソースの抽出\"></a><h2 id=\"リソースの抽出\">リソースの抽出</h2></div>\n\
<p>ユーティリティ スクリプト <span class=\'code\'>pluginResourceUtil</span> を使用して、プラグインのすべての登録リソースのマスタ リストを生成します。</p>\n\
<p>ユーティリティを実行するには、プラグインの名前と生成する出力ファイルの名前を指定します。リソース抽出プロセスを実行するには、プラグインをロードする必要があります。まだロードしていない場合は、ユーティリティがプラグインをロードします。抽出プロセスは、既定言語(英語)で Maya を実行中に行う必要があります。Maya の言語設定をオーバーライドする方法については、Maya のマニュアルを参照してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">pluginResourceUtil(&quot;closestPointOnCurve&quot;, &quot;c:/extracted/closestPointOnCurve.pres.mel&quot;);\n\
\n\
</pre></div><p>リソース抽出プロセスによって出力されるのは、リソースに新しい値を設定するためのコマンドのリストを含むファイルです。このマスタ ファイルは、プラグインが使用するわけではありません。(このファイルに含まれている既定のリソース値は、マスタ ファイルなしでもプラグインで使用できます)。このファイルは、翻訳が必要な文字列のマスタ バージョンとして使用します。プラグインにはファイルの翻訳バージョンだけが提供されます。</p>\n\
<p>完全な出力ファイル <span class=\'code\'>closestPointOnCurve.pres.mel</span> については、「<a href=\'#!/url=./dev_help/Technical-Notes/Internationalizing-plug-ins/Example-code.html\' title=\'\'>例</a>」を参照してください。ファイルの一部を以下に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// File closestPointOnCurve.pres.mel\n\
// Resources for Plug-in: closestPointOnCurve\n\
// \n\
// ----------------------------\n\
// Registered string resources:\n\
// ----------------------------\n\
setPluginResource( &quot;closestPointOnCurve&quot;, &quot;kAETitle&quot;, &quot;Closest Point On Curve Attributes&quot;);\n\
setPluginResource( &quot;closestPointOnCurve&quot;, &quot;kInputCurve&quot;, &quot;Input Curve&quot;);\n\
setPluginResource( &quot;closestPointOnCurve&quot;, &quot;kInvalidType&quot;, &quot;Object ^1s has invalid type.  Only a curve or its transform can be specified.&quot;);\n\
setPluginResource( &quot;closestPointOnCurve&quot;, &quot;kNoQueryFlag&quot;, &quot;You must specify AT LEAST ONE queryable flag in query mode.  Use the `help` command to list all available flags.&quot;);\n\
setPluginResource( &quot;closestPointOnCurve&quot;, &quot;kNoValidObject&quot;, &quot;A curve or its transform node must be specified as a command argument, or using your current selection.&quot;);\n\
setPluginResource( &quot;closestPointOnCurve&quot;, &quot;kResults&quot;, &quot;Results&quot;);\n\
\n\
</pre></div><p>生成されたファイルには、プラグインが登録する各文字列リソースの項目を含みます(C++ リソースと MEL リソース両方)。さらに、プラグインがノードを登録している場合、標準化されたノードの項目と Maya で使用するアトリビュート UI 表示文字列リソースが自動的に生成されます(ノードを正しく登録する以外に、これらのリソースで追加登録は必要ありません)。</p>\n\
<div class=\'section\'><a id=\"翻訳\"></a><h2 id=\"翻訳\">翻訳</h2></div>\n\
<p>マスタ リソース ファイル内の各項目の文字列値を編集して別の言語に翻訳します。</p>\n\
<div class=\'section\'><a id=\"リソース-ファイルのエンコーディング\"></a><h3 id=\"リソース-ファイルのエンコーディング\">リソース ファイルのエンコーディング</h3></div>\n\
<p>リソース ファイルは MEL テキスト ファイルのため、実行するロケールとプラットフォームにエンコーディングが適している必要があります。たとえば、Windows プラットフォームの日本語翻訳では CP932 を使用しますが、Mac OS X では UTF-8 にすべきです。必要な場合、iconv などの変換ユーティリティをファイル フォーマットの変換に使用できます。</p>\n\
<div class=\'section\'><a id=\"ローカライズ-リソースのインストール\"></a><h2 id=\"ローカライズ-リソースのインストール\">ローカライズ リソースのインストール</h2></div>\n\
<p>翻訳リソース ファイルは、実行時にロードされるように、言語固有の適切な場所にインストールする必要があります。翻訳した各言語のリソース ファイルは、すべて同じ名前にします。保存するディレクトリによって、関連づけられる言語が決まります。リソース ファイル名は、文字列初期化スクリプト内の <span class=\'code\'>loadPluginLanguageResources</span> に渡されます。以下の例では、リソース ファイル名は <span class=\'code\'>closestPointOnCurve.pres.mel</span> です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Load any localized resources \n\
loadPluginLanguageResources(&quot;closestPointOnCurve&quot;, &quot;closestPointOnCurve.pres.mel&quot;);\n\
\n\
</pre></div><p><span class=\'code\'>loadPluginLanguageResources</span> ルーチンは、MAYA_PLUG_IN_RESOURCES_PATH に沿ってリソース ファイルを検索します。</p>\n\
<p>一般的に、プラグインはモジュールとしてインストールし、プラグインのファイルは MAYA_MODULE_PATH に沿って標準化されたフォルダ構造内にインストールします。MAYA_PLUG_IN_RESOURCES_PATH は、各モジュールの言語固有のリソース フォルダ項目を含めるために初期化されます。</p>\n\
<p>プラグイン モジュールのサンプル ディレクトリ階層を以下に示します。リソースには、使用可能なローカリゼーションごとにサブディレクトリが含まれています。日本語のリソースは、<span class=\'code\'>resources/ja_JP</span> サブフォルダにインストールされます。日本語で Maya を実行している場合、このフォルダは MAYA_PLUG_IN_RESOURCES_PATH に追加されます。</p>\n\
<p>リソース ファイルが見つからない場合でも、<span class=\'code\'>loadPluginLanguageResources</span> は実行時にエラーを生成しません。プラグインは、単に既定のリソース値を使用して動作を続けます。</p>\n\
<p><span class=\'code\'>closestPointOnCurve</span> プラグインのサンプル モジュール階層と日本語リソースの場所を以下の例に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">/SampleModule\n\
/SampleModule/data\n\
/SampleModule/docs\n\
/SampleModule/icons\n\
/SampleModule//modules\n\
/SampleModule/plug-ins\n\
/SampleModule/python\n\
/SampleModule/resources\n\
/SampleModule/resources/ja_JP\n\
/SampleModule/resources/ja_JP/closestPointOnCurve.pres.mel\n\
/SampleModule/scripts\n\
\n\
</pre></div><div class=\'section\'><a id=\"メンテナンス\"></a><h2 id=\"メンテナンス\">メンテナンス</h2></div>\n\
<p>文字列 リソース内のプラグインを修正した場合は、ローカライズ バージョンがマスタ バージョンに同期化された状態を保つために、リソース ファイルの抽出、翻訳、インストールの手順を繰り返す必要があります。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";