var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>スレッドと Maya API</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>スレッドと Maya API</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"スレッドと-maya-api\"></a></div>\n\
<p>ある特定のガイドラインに従えば、スレッド化されたコードをプラグインで利用できます。以下にあげるのは、この場合の注意事項です。</p>\n\
<ol>\n\
<li>Maya は次のタイプのスレッドを使用します。</li>\n\
</ol>\n\
<ul>\n\
<li>Linux - pthread</li>\n\
<li>Mac OS X - pthread</li>\n\
<li>Windows - Native Windows API スレッド</li>\n\
</ul>\n\
<ol>\n\
<li>API で使用可能な Maya のコンポーネントは単一スレッドです。Maya メイン スレッドから Maya API に呼び込むことが最善です。Maya API へのコールから独立しているかぎり、コードをスレッド化することは可能です。この規則の例外は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode::compute()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html#a6e1aa1e50774080d5aee55f20ffa5503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html#ae17c4b226f482e2d77c3f99375d1eea0&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode::compute()</a></span> で、ソフトウェア シェーダ用の複数のスレッド コールを持つことができます。ただしこれは、ノードとソフトウェア レンダラの設定に依存します。</li>\n\
<li>Maya の操作にはスレッド化されているものもありますが、API では公開されません。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal::executeCommandOnIdle()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a2c877a6e116f8fd3a6e76387403c023a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#ab9dab071d5c2efab3397f2fa6ed0299c&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::executeCommandOnIdle()</a></span> メソッドを使用すると、補助スレッドから Maya に呼び出すことが可能です。Python では、同等の <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal::executePythonCommandOnIdle()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#ab999a152a46888cb5dfc2871466f9c40&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::executePythonCommandOnIdle()</a></span> メソッドを使用します。コマンドが即座に実行されます。あるいは、コマンドはアイドル状態のイベント待ち行列に追加されて、アイドル処理が許可されると実行されます。コマンドの結果はコール側に返されません。このコールは、別のスレッドの進捗バーなどの項目の更新に便利です。</li>\n\
<li>スレッド化用に次の 4 つの C++ API クラスがあります。</li>\n\
</ol>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MThreadPool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MThreadAsync\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_async.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadAsync</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSpinLock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_spin_lock.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSpinLock</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MMutexLock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_mutex_lock.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMutexLock</a></span></li>\n\
</ul>\n\
<p>これらのクラスを利用し、Maya 以外の API 機能に対してスレッド アルゴリズムを実装することができます。開発キットには、これらのクラスの使用例がいくつか用意されています(Maya Python API では、これらのクラスは使用できません)。</p>\n\
<p><strong>MThreadPool</strong> は、タスクの割り当てが可能なスレッドのプールへのアクセスを提供します。タスクの数は、スレッドの数と同じである必要はありません。実際、負荷を分散させるには、スレッド数よりもタスク数の方が多いことが望ましいです。Maya では、最大限に効率化するために、複数のスレッドの間で内部的に作業が分散されます。プール内のスレッドの数は、論理プロセスの数と同じです。使用のたびにスレッド プールを削除する必要はありません。むしろ、平行領域が完了したときにスレッドは休止状態に入る、つまりスレッドはすばやく再起動できるので、パフォーマンス上の理由から言っても削除はしないことをお勧めします。</p>\n\
<p><strong>MThreadAsync</strong> では、長期間実行可能なスレッドを 1 つまたは複数作成することができます。これらは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MThreadPool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool</a></span> により作成および管理されるスレッド プールから導出されたものではなく、独立したスレッドです。これらのスレッドを使用すると、タスクを長時間実行できます。これらはスレッド プールから作成されるものではないので、サブスクリプションの超過(活動中のスレッド数が使用可能なハードウェア リソースを超過している状態)を避けるためにも、このようなスレッドの数や負荷は慎重に管理する必要があります。</p>\n\
<p><strong>MMutexLock</strong> は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MThreadPool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool</a></span> スレッドと <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MThreadAsync\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_async.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadAsync</a></span> スレッドの両方で使用可能なロッキング プリミティブです。スレッドの標準 Mutex ロッキングが可能です。</p>\n\
<p><strong>MSpinLock</strong> はスピン待機するロックなので、ロックが非常に短時間維持されるような状況では、Mutex ロックよりも効率的です。ただし、ロックはスピン待機されるため、大量の CPU が消費されますから、長時間、ロックしたままになるような状況では使用すべきではありません。</p>\n\
<ol>\n\
<li>ビルトインのスレッド モジュールを使うと、Python を使用したスレッド化が可能です。このスレッド モジュールは、Maya 以外の API 機能に対するスレッド アルゴリズムの実装に使用できます。詳細については、『**Python』マニュアルの「Python とスレッディング」セクションを参照してください。</li>\n\
</ol>\n\
<p>次の例は、シリアルとスレッド化のアプローチを使用して、素数を検索する方法を示しています。スレッド化アプローチでは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MThreadPool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool</a></span> クラスが使用されています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#include &lt;math.h&gt;\n\
#include &lt;maya/MIOStream.h&gt;\n\
#include &lt;maya/MSimple.h&gt;\n\
#include &lt;maya/MTimer.h&gt;\n\
#include &lt;maya/MGlobal.h&gt;\n\
#include &lt;maya/MThreadPool.h&gt;\n\
<a href=\"javascript:void(0)\" data-symbol=\"DeclareSimpleCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___macros.html#gaf3b44fe07495c3792b926494fca7b517&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">DeclareSimpleCommand</a>( threadTestCmd, PLUGIN_COMPANY, &quot;2017&quot;);\n\
typedef struct _threadDataTag\n\
{\n\
    int threadNo;\n\
    long primesFound;\n\
    long start, end;\n\
} threadData;\n\
\n\
typedef struct _taskDataTag\n\
{\n\
    long start, end, totalPrimes;\n\
} taskData;\n\
\n\
#define NUM_TASKS   16\n\
// No global information used in function\n\
\n\
static bool TestForPrime(int val)\n\
{\n\
    int limit, factor = 3;\n\
    limit = (long)(sqrtf((float)val)+0.5f);\n\
    while( (factor &lt;= limit) &amp;&amp; (val % factor))\n\
        factor ++;\n\
    return (factor &gt; limit);\n\
}\n\
\n\
// Primes finder. This function is called from multiple threads\n\
MThreadRetVal Primes(void *data)\n\
{\n\
    threadData *myData = (threadData *)data;\n\
    for( int i = myData-&gt;start + myData-&gt;threadNo*2; i &lt;= myData-&gt;end; i += 2*NUM_TASKS )\n\
    {\n\
        if( TestForPrime(i) )\n\
        myData-&gt;primesFound++;\n\
    }\n\
    return (MThreadRetVal)0;\n\
}\n\
\n\
// Function to create thread tasks\n\
void DecomposePrimes(void *data, MThreadRootTask *root)\n\
{\n\
    taskData *taskD = (taskData *)data;\n\
    threadData tdata[NUM_TASKS];\n\
    for( int i = 0; i &lt; NUM_TASKS; ++i )\n\
    {\n\
        tdata[i].threadNo = i;\n\
        tdata[i].primesFound = 0;\n\
        tdata[i].start = taskD-&gt;start;\n\
        tdata[i].end = taskD-&gt;end;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MThreadPool::createTask\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html#a611da972604ffe306fdb87b4ab06ed16&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool::createTask</a>(Primes, (void *)&amp;tdata[i], root);\n\
    }\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MThreadPool::executeAndJoin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html#ae9e9c1be8def42f1040adf93edf4d5e7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool::executeAndJoin</a>(root);\n\
    for( int i = 0; i &lt; NUM_TASKS; ++i )\n\
    {\n\
        taskD-&gt;totalPrimes += tdata[i].primesFound;\n\
    }\n\
}\n\
\n\
// Single threaded calculation\n\
int SerialPrimes(int start, int end)\n\
{\n\
    int primesFound = 0;\n\
    for( int i = start; i &lt;= end; i+=2)\n\
    {\n\
        if( TestForPrime(i) )\n\
            primesFound++;\n\
    }\n\
    return primesFound;\n\
}\n\
\n\
// Set up and tear down parallel tasks\n\
int ParallelPrimes(int start, int end)\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> stat = <a href=\"javascript:void(0)\" data-symbol=\"MThreadPool::init\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html#a81616e4d1ab97b678585e86b19e3cdff&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool::init</a>();\n\
    if( <a href=\"javascript:void(0)\" data-symbol=\"MStatus::kSuccess\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html#a02ab596f4febca68da503aaf8dde3a80af0536797208144380691e2b376ffc1d1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus::kSuccess</a> != stat ) {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> str = <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;Error creating threadpool&quot;);\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayError\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a4ddbe97e58a90e1ab05d45a62c006cf0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayError</a>(str);\n\
        return 0;\n\
    }\n\
\n\
    taskData tdata;\n\
    tdata.totalPrimes = 0;\n\
    tdata.start = start;\n\
    tdata.end = end;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MThreadPool::newParallelRegion\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html#a943a1eb7bb753be409a66388900890e4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool::newParallelRegion</a>(DecomposePrimes, (void *)&amp;tdata);\n\
    // pool is reference counted. Release reference to current thread instance\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MThreadPool::release\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html#a23b477d0e2d399f75d585d154c346591&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool::release</a>();\n\
    // release reference to whole pool which deletes all threads\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MThreadPool::release\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_pool.html#a23b477d0e2d399f75d585d154c346591&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadPool::release</a>();\n\
    return tdata.totalPrimes;\n\
}\n\
\n\
// MSimple command that invokes the serial and parallel thread calculations\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> threadTestCmd::doIt( const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; args )\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> introStr = <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;Computation of primes using the Maya API&quot;);\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a3d14e9f9ed022a80f664eac0136c2f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayInfo</a>(introStr);\n\
    if(args.length() != 2) {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> str = <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;Invalid number of arguments, usage: threadTestCmd 1 10000&quot;);\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayError\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a4ddbe97e58a90e1ab05d45a62c006cf0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayError</a>(str);\n\
        return <a href=\"javascript:void(0)\" data-symbol=\"MStatus::kFailure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html#a02ab596f4febca68da503aaf8dde3a80a1ef6c2d725fb4bec3e7e840d28adbc00&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus::kFailure</a>;\n\
    }\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> stat;\n\
    int start = args.asInt( 0, &amp;stat );\n\
    if ( MS::kSuccess != stat ) {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> str = <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;Invalid argument 1, usage: threadTestCmd 1 10000&quot;);\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayError\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a4ddbe97e58a90e1ab05d45a62c006cf0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayError</a>(str);\n\
        return <a href=\"javascript:void(0)\" data-symbol=\"MStatus::kFailure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html#a02ab596f4febca68da503aaf8dde3a80a1ef6c2d725fb4bec3e7e840d28adbc00&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus::kFailure</a>;\n\
    }\n\
    int end = args.asInt( 1, &amp;stat );\n\
    if ( MS::kSuccess != stat ) {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> str = <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;Invalid argument 2, usage: threadTestCmd 1 10000&quot;);\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayError\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a4ddbe97e58a90e1ab05d45a62c006cf0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayError</a>(str);\n\
        return <a href=\"javascript:void(0)\" data-symbol=\"MStatus::kFailure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html#a02ab596f4febca68da503aaf8dde3a80a1ef6c2d725fb4bec3e7e840d28adbc00&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus::kFailure</a>;\n\
    }\n\
\n\
    // start search on an odd number\n\
    if((start % 2) == 0 ) start++;\n\
    // run single threaded\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MTimer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_timer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTimer</a> timer;\n\
    timer.beginTimer();\n\
    int serialPrimes = SerialPrimes(start, end);\n\
    timer.endTimer();\n\
    double serialTime = timer.elapsedTime();\n\
    // run multithreaded\n\
    timer.beginTimer();\n\
    int parallelPrimes = ParallelPrimes(start, end);\n\
    timer.endTimer();\n\
    double parallelTime = timer.elapsedTime();\n\
    // check for correctness\n\
    if ( serialPrimes != parallelPrimes ) {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> str(&quot;Error: Computations inconsistent&quot;);\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayError\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a4ddbe97e58a90e1ab05d45a62c006cf0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayError</a>(str);\n\
        return <a href=\"javascript:void(0)\" data-symbol=\"MStatus::kFailure\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html#a02ab596f4febca68da503aaf8dde3a80a1ef6c2d725fb4bec3e7e840d28adbc00&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus::kFailure</a>;\n\
    }\n\
    // print results\n\
    double ratio = serialTime/parallelTime;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> str = <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;\\nElapsed time for serial computation: &quot;) + serialTime + <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;s\\n&quot;);\n\
    str += <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;Elapsed time for parallel computation: &quot;) + parallelTime + <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;s\\n&quot;);\n\
    str += <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;Speedup: &quot;) + ratio + <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>(&quot;x\\n&quot;);\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a3d14e9f9ed022a80f664eac0136c2f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayInfo</a>(str);\n\
    return <a href=\"javascript:void(0)\" data-symbol=\"MStatus::kSuccess\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html#a02ab596f4febca68da503aaf8dde3a80af0536797208144380691e2b376ffc1d1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus::kSuccess</a>;\n\
}\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";