var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ビューポート 2.0 の基本的なパイプライン シーケンス</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ビューポート 2.0 の基本的なパイプライン シーケンス</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ビューポート-2.0-の基本的なパイプライン-シーケンス\"></a></div>\n\
<div class=\'section\'><a id=\"はじめに\"></a><h2 id=\"はじめに\">はじめに</h2></div>\n\
<p>このセクションでは、シーンの 3D リプリゼンテーションをビューポートまたはディスク上のイメージにレンダリングするときの、ビューポート 2.0 のパイプラインの基本的なシーケンスについて説明します。さまざまなレンダー項目または描画可能 UI の処理は、このシーケンス内で行われます。</p>\n\
<p>ここでの前提は、レンダー項目および描画可能 UI が、レンダラ内部の統合、フィルタリング、および分類のメカニズムを経て、レンダー項目のリストまたは描画可能 UI のリストが生成されていることです。1 つの例が、不透明にシェーディングされたレンダー項目のリストです。</p>\n\
<p>特定の基準に基づいてソートされるリストもあります。たとえば、透明なレンダー項目は現在のカメラとの距離でソートされることがあり、マテリアル項目はシェーダの固有性(キー)でソートされることがありますソートされていない場合、リスト内での順序は。オーバーライドでレンダー項目がソートされる順序、または Maya のシーン オブジェクトの順序を必ずしも反映しているとは限りません。</p>\n\
<p>シーケンスを記述するために使用される最も細かい精度は、<strong>論理演算</strong>と呼ばれ、ビューポート 2.0 のレンダー オーバーライド(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MRenderOverride</a></span>)で使用される命名法に一致します。複雑な内部レンダー グラフでも、操作のリニア シーケンスに分割できることを前提としています。</p>\n\
<p>最も上位のレベルでは、シーケンスはフレームに分割されます。<strong>フレーム</strong>は、オフスクリーン カラーおよび深度の出力ターゲットのコンテンツを生成するためにレンダリングを実行します。インタラクティブなビューポートに提供するため、またはディスク イメージに保存するために使用されるターゲットは、<strong>最終</strong>ターゲットと呼ばれます。</p>\n\
<p>可能な場合、<strong>パス セマンティック</strong>を使用するかどうかに関する指示が、内部シーケンスのディスクリプションに表示されます。一意のパス セマンティックを指定する操作は、文字<strong>(P)</strong>を使って示されます。</p>\n\
<p>フレームのレンダリングは、大きく 3 つのパーツに分かれます。<strong>プリシーン</strong> レンダリング、<strong>シーン</strong> レンダリング、および<strong>ポストシーン</strong> レンダリングです。UI 項目の主な条件分岐は、ポスト エフェクトが有効になっているかどうかによります。これは通常、ポスト エフェクトが適用された後に UI 項目が描画するリストに移動されることを意味します。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> 以下に示すのは、一般的なフレーム レンダーのスナップショットであり、生成されるレンダー グラフによっては、実際のシーケンスがここでの説明と異なる場合があります。また、さまざまな項目の分類は、現在の実装が反映されたものであり、実装が変われば差異が生じることもあります。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"プリシーン-レンダリング\"></a><h2 id=\"プリシーン-レンダリング\">プリシーン レンダリング</h2></div>\n\
<p>プリシーン レンダリング フェーズの基本的な操作には、次の操作が含まれます。</p>\n\
<ul>\n\
<li><p>シャドウ マップの更新(以下の「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Basic-Viewport-2-0-pipeline.html#shadow-pass-rendering\' title=\'\'>シャドウ パスのレンダリング</a>」を参照してください)</p></li>\n\
<li><p>マテリアルのレンダー項目の並べ替え</p></li>\n\
<li><p>カラー ターゲットのカラー チャネル(バックグラウンド)のクリア</p></li>\n\
<li><p>オンスクリーン レンダリングが必要な場合:</p></li>\n\
<li><p>ビューポートのプリ レンダー通知</p></li>\n\
<li><p>プリフレーム通知</p></li>\n\
<li><p>プリシーン通知</p></li>\n\
<li><p>必要に応じて、深度ターゲットのコンテンツを生成するために、シーンをレンダリングします。</p></li>\n\
<li><p>不透明な非 UI レンダー項目(たとえば、シェーディングされた三角形) (P)</p></li>\n\
<li><p>不透明な UI レンダー項目(たとえば、ワイヤフレーム) (P)</p></li>\n\
<li><p>半透明のビットマップ レンダー項目(P)。例については、「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Basic-Viewport-2-0-pipeline.html#particle-rendering\' title=\'\'>パーティクルのレンダリング</a>」を参照してください。</p></li>\n\
<li><p>保持**として機能可能なレンダー項目(P)。これは、通常の非保持シーケンスとよく似ていることに注意してください。</p></li>\n\
<li><p>不透明な非 UI レンダー項目(P)</p></li>\n\
<li><p>不透明な UI 項目(P)</p></li>\n\
<li><p>透明度の描画(P)「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Basic-Viewport-2-0-pipeline.html#transparency-rendering\' title=\'\'>透明度のレンダリング</a>」を参照してください。</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"シーンをレンダーする\"></a><h2 id=\"シーンをレンダーする\">シーンをレンダーする</h2></div>\n\
<p>シーン レンダリング<strong>(ビューティ パス</strong>を表しているとも考えられます)では、次の操作を使用してレンダリングします。</p>\n\
<ul>\n\
<li><p>ポスト エフェクトが無効な場合:</p></li>\n\
<li><p>プリシーンの不透明な UI レンダー項目(P)</p></li>\n\
<li><p>不透明な非 UI レンダー項目(P)</p></li>\n\
<li><p>不透明な UI レンダー項目(P)</p></li>\n\
<li><p>半透明のビットマップ レンダー項目(P)例については、「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Basic-Viewport-2-0-pipeline.html#particle-rendering\' title=\'\'>パーティクルのレンダリング</a>」を参照してください。</p></li>\n\
<li><p>透明度の描画(P)「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Basic-Viewport-2-0-pipeline.html#transparency-rendering\' title=\'\'>透明度のレンダリング</a>」を参照してください。</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"ポストシーン-レンダリング\"></a><h2 id=\"ポストシーン-レンダリング\">ポストシーン レンダリング</h2></div>\n\
<p>ポストシーン レンダリングには、2D ポスト エフェクトの操作、およびどんな 2D ポスト エフェクトが有効でも参加しないその他の UI 描画が含まれます。既定では、特定の項目はポスト エフェクトに参加しません。それ以外の場合は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::setExcludedFromPostEffects()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a634faadbe865d745bc8ed447efe671da&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_item.html#a0704932795c36669268b767a9db4e38a&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MRenderItem::setExcludedFromPostEffects()</a></span> メソッドをオーバーライドするオプションが使用可能です。</p>\n\
<ul>\n\
<li><p>SSAO (スクリーン スペース アンビエント オクルージョン)ポスト エフェクト</p></li>\n\
<li><p>保持レンダー項目</p></li>\n\
<li><p>法線 + 深度レンダリング パス(P)</p>\n\
<ul>\n\
<li>ポスト エフェクトに参加するとマークされたレンダー項目</li>\n\
</ul></li>\n\
<li><p>2D SSAO メイン アルゴリズム</p>\n\
<ul>\n\
<li>フル スクリーンの四角形のレンダリングのみ</li>\n\
</ul></li>\n\
<li><p>モーション ブラー ポスト エフェクト</p></li>\n\
<li><p>モーション ベクトル パス</p>\n\
<ul>\n\
<li>ポスト エフェクトに参加するとマークされたレンダー項目</li>\n\
</ul></li>\n\
<li><p>2D モーション ブラー メイン アルゴリズム</p>\n\
<ul>\n\
<li>フル スクリーンの四角形のレンダリングのみ</li>\n\
</ul></li>\n\
<li><p>被写界深度ポスト エフェクト</p></li>\n\
<li><p>深度パス(P)</p>\n\
<ul>\n\
<li><p>不透明なレンダー項目</p></li>\n\
<li><p>透明なレンダー項目</p></li>\n\
</ul></li>\n\
<li><p>2D 被写界深度アルゴリズム</p>\n\
<ul>\n\
<li>フル スクリーンの四角形のレンダリングのみ</li>\n\
</ul></li>\n\
<li><p>マスク レンダリング</p></li>\n\
<li><p>マスク作成</p>\n\
<ul>\n\
<li>ポスト エフェクトに参加しないとマークされたレンダー項目(P)</li>\n\
</ul></li>\n\
<li><p>マスク合成</p>\n\
<ul>\n\
<li>フル スクリーンの四角形のレンダリングのみ</li>\n\
</ul></li>\n\
<li><p>プリシーンの不透明な UI レンダー項目(P)</p></li>\n\
<li><p>ポスト エフェクトが有効な場合</p></li>\n\
<li><p>シーン要素のポスト UI レンダリング</p></li>\n\
<li><p>ポスト エフェクトが有効な場合</p>\n\
<ul>\n\
<li><p>不透明な UI レンダー項目(P)</p></li>\n\
<li><p>不透明な 2D UI レンダー項目(P)</p></li>\n\
<li><p>半透明のビットマップ レンダー項目(P)</p></li>\n\
</ul></li>\n\
<li><p>透明な UI レンダー項目(P)</p></li>\n\
<li><p>透明な UI 2D レンダー項目(P)</p></li>\n\
<li><p><strong>X 線</strong>表示、または深度テストを描画しないとマークされた UI レンダー項目(P)。アクティブ コンポーネントの X 線表示モードは、API からの明示的な設定だけでなく、項目をこのリストに追加することでトリガできることに注意してください。</p></li>\n\
<li><p>非シーン要素のポスト UI レンダリング</p></li>\n\
<li><p>2D テキスト項目を除く、マニピュレータ UI 項目のレンダリング。(「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Advanced-Topics/Basic-Viewport-2-0-pipeline.html#manipulators\' title=\'\'>マニピュレータ</a>」を参照してください)。</p></li>\n\
<li><p>最前面**描画可能 UI のレンダリング。これには、内部 2D カメラ UI、スカルプト描画、および 2D マニピュレータ テキストが含まれます。</p></li>\n\
<li><p>2D および 3D オーバーレイ UI 項目のレンダリング</p></li>\n\
<li><p>オフスクリーン レンダリングの場合</p></li>\n\
<li><p>HUD レンダリング</p></li>\n\
<li><p>カラー管理(Color Management)</p>\n\
<ul>\n\
<li>四角形レンダリングのみ</li>\n\
</ul></li>\n\
<li><p>ポスト シーン レンダー通知</p></li>\n\
<li><p>ポスト フレーム レンダー通知</p></li>\n\
<li><p>オンスクリーン レンダリングの場合</p></li>\n\
<li><p>カラー管理(Color Management)</p></li>\n\
<li><p>HUD</p></li>\n\
<li><p>ビューポートのポスト レンダー通知</p></li>\n\
<li><p>オンスクリーン表示**</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"透明度のレンダリング\"></a><h2 id=\"透明度のレンダリング\">透明度のレンダリング</h2></div>\n\
<p>透明な項目をレンダリングするプロセスは、選択する透明度アルゴリズムおよび項目の分類によって異なります。</p>\n\
<p>基本的なロジックは次のとおりです。</p>\n\
<ul>\n\
<li><p>高度な透明度(ウェイト付けした平均値(Weighted Average)、深度ピーリング(Depth Peeling))をサポートする非 UI レンダー項目(P)</p></li>\n\
<li><p>高度な透明度をサポートしない非 UI レンダー項目、またはオブジェクトのソート(Object Sorting)、簡易(Simple)の透明度が使用されている場合。</p></li>\n\
<li><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::setSupportsAdvancedTransparency()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a1cb8ade4b1a11be0c16c7ffc2a2e292c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MRenderItem::setSupportsAdvancedTransparency()</a></span> メソッドを使用して、明示的に高度な透明度から外すことができる点に注意してください。</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"パーティクルのレンダリング\"></a><h2 id=\"パーティクルのレンダリング\">パーティクルのレンダリング</h2></div>\n\
<p>オブジェクトにはさまざまな表示バリエーションを指定できるため、パーティクル システムではさまざまなタイプの項目を作成できます。ポイントおよびストリークの大部分は、不透明または透明なレンダー項目リストおよび透明なビットマップ リストに追加されます。すべての数値は、最終的に X 線表示リストに追加されます。(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MShaderManager</a></span> から取得したストック数値シェーダも最終的に X 線表示リストに追加されることに注意してください)。球とメタボール項目は、最終的に不透明リストまたは不透明 UI リスト(後者はワイヤフレーム用)に追加されます。クラウドおよびチューブは、最終的に透明または不透明 UI リスト(後者はワイヤフレーム用)に追加されます。</p>\n\
<div class=\'section\'><a id=\"シャドウ-パスのレンダリング\"></a><h2 id=\"シャドウ-パスのレンダリング\">シャドウ パスのレンダリング</h2></div>\n\
<p>3D シーンのレンダリングに使用されるすべてのシャドウ マップは、必要に応じて、プリシーン レンダリング中に更新されます。レンダー項目(描画可能 UI を除く)だけは、次のシーケンスを使用して、シャドウ マップの作成時に考慮されます。</p>\n\
<ul>\n\
<li><p>レンダー項目のフィルタリングをすべて実行</p></li>\n\
<li><p>不透明なレンダー項目を描画(P)</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"イメージ-プレーンのレンダリング\"></a><h2 id=\"イメージ-プレーンのレンダリング\">イメージ プレーンのレンダリング</h2></div>\n\
<p>イメージ プレーンのレンダリングでは、不透明または透明なオブジェクトを作成できますが、これらのオブジェクトはポスト エフェクトに参加しないものに分類されるため、常に非ポスト エフェクト リストに追加されます。</p>\n\
<div class=\'section\'><a id=\"api-による-ui-描画マネージャ\"></a><h2 id=\"api-による-ui-描画マネージャ\">API による UI 描画マネージャ</h2></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUIDrawManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MUIDrawManager</a></span> は、さまざまな UI 描画を処理するための API インタフェースで、さまざまな API インタフェースから使用できます。API と内部描画の両方で、使用するクラス メソッドに基づいて、さまざまな描画可能項目を生成できます。</p>\n\
<p>オブジェクト オーバーライドおよびレンダー オーバーライドの描画では、次の一般的なマッピングが行われます。</p>\n\
<ul>\n\
<li><p>テキスト: X 線表示リストに項目を追加</p></li>\n\
<li><p>アイコン: 不透明 UI リストに項目を追加。X 線表示リストには追加されないことに注意してください。</p></li>\n\
<li><p>メッシュ: これにはさまざまなジオメトリ プリミティブ タイプおよびストック ジオメトリが含まれます。これらの項目は、シャドウ パスまたはポスト エフェクト パスに参加することはありませんが、プリミティブ タイプによっては、Maya のライトを使用して光を当て、シェーディングできることに注意してください。</p></li>\n\
<li><p>不透明な場合</p>\n\
<ul>\n\
<li><p>3D の場合</p>\n\
<ul>\n\
<li>不透明 UI リストに項目を追加</li>\n\
</ul></li>\n\
<li><p>3D 以外の場合</p>\n\
<ul>\n\
<li>不透明 2D UI リストに項目を追加</li>\n\
</ul></li>\n\
<li><p>項目は、UI とみなされるため、非ポスト エフェクト リストにも追加されます。</p></li>\n\
</ul></li>\n\
<li><p>不透明ではなく、透明かつ塗り潰され、ポイントとラインのどちらでもない場合</p>\n\
<ul>\n\
<li><p>3D の場合</p>\n\
<ul>\n\
<li>透明 UI リストに項目を追加</li>\n\
</ul></li>\n\
<li><p>3D 以外の場合</p>\n\
<ul>\n\
<li>透明 2D UI リストに項目を追加</li>\n\
</ul></li>\n\
<li><p>項目は、UI とみなされるため、非ポスト エフェクト リストにも追加されます。</p></li>\n\
</ul></li>\n\
<li><p>X 線モードで描画する場合</p>\n\
<ul>\n\
<li>X 線表示リストに項目を追加</li>\n\
</ul></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"マニピュレータ\"></a><h3 id=\"マニピュレータ\">マニピュレータ</h3></div>\n\
<ul>\n\
<li><p>最前面**リストに追加される 2D テキスト以外のすべての項目は、マニピュレータ項目リストに追加されます。</p></li>\n\
<li><p><em>footPrintManip</em> の例: <em>Stretch Me!</em> および <em>Stretch Me 2D!</em> のテキストは、Footprint Locator (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxDrawOverride</a></span>)のテキスト(X 線表示)、および uiDrawManager (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxDrawOverride</a></span>)のサンプル テキスト(透明な UI 2D)の上に描画されます。</p></li>\n\
</ul>\n\
<div class=\'figure\'><img src=\'dev_help/images/Basic_sequencing_uiDrawManager.png\' title=\'\' /></div>\n\
<div class=\'section\'><a id=\"ツール-コンテキストの描画\"></a><h3 id=\"ツール-コンテキストの描画\">ツール コンテキストの描画</h3></div>\n\
<ul>\n\
<li>すべての項目は、2D または 3D オーバーレイ項目リストに追加されます(下記参照)。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"uv-エディタuv-editor\"></a><h3 id=\"uv-エディタuv-editor\">UV エディタ(UV Editor)</h3></div>\n\
<ul>\n\
<li>バックグラウンド テクスチャの描画に使用される 2D メッシュは、項目としてプリ UI リストに追加されます。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"api-によるオーバーレイ-レンダリング\"></a><h2 id=\"api-によるオーバーレイ-レンダリング\">API によるオーバーレイ レンダリング</h2></div>\n\
<p>ツール コンテキストの描画はすべて、オーバーレイを描画するパイプライン操作内で行われます。このため、項目は 2D または 3D オーバーレイ リストに追加されます。これは、3D ビューポートおよび UV エディタ(UV Editor)に適用されます。通常、オーバーレイの描画時には、3D シーンの要素は再描画されません。</p>\n\
<div class=\'section\'><a id=\"api-による-uv-エディタuv-editorのレンダリング\"></a><h2 id=\"api-による-uv-エディタuv-editorのレンダリング\">API による UV エディタ(UV Editor)のレンダリング</h2></div>\n\
<p>バックグラウンド テクスチャのレンダリングは、シェーダ オーバーライド(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxShaderOverride</a></span>)で提供されます。この場合、描画は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUIDrawManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MUIDrawManager</a></span> を介して実行され、常にすべてのオブジェクト UI、または 2D マニピュレータの前に描画されます。</p>\n\
<div class=\'section\'><a id=\"api-によるオブジェクトのレンダリング\"></a><h2 id=\"api-によるオブジェクトのレンダリング\">API によるオブジェクトのレンダリング</h2></div>\n\
<div class=\'section\'><a id=\"mpxdrawoverride\"></a><h3 id=\"mpxdrawoverride\">MPxDrawOverride</h3></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxDrawOverride</a></span> による描画は、既定では不透明なレンダー項目に分類されていますが、どのポスト エフェクト、透明度にも参加しません。ただし、シャドウ マップの作成には参加できます。</p>\n\
<p>Developer Kit サンプル: <em>rawFootPrintNode</em></p>\n\
<ul>\n\
<li><p>1 つの内部定義項目が不透明のリストに追加されます。</p></li>\n\
<li><p>1 つの項目が X 線表示リストに追加されます(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUIDrawManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_u_i_draw_manager.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MUIDrawManager</a></span> を介したテキスト)。</p></li>\n\
</ul>\n\
<div class=\'section\'><a id=\"mpxgeometryoverride-および-mpxsubsceneoverride\"></a><h3 id=\"mpxgeometryoverride-および-mpxsubsceneoverride\">MPxGeometryOverride および MPxSubSceneOverride</h3></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxGeometryOverride</a></span> および <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSubSceneOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_sub_scene_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_sub_scene_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxSubSceneOverride</a></span> で作成されたレンダー項目は、項目ごとに設定されたプロパティに応じて、不透明な UI または非 UI レンダー項目に分類されることも、されないこともあります。</p>\n\
<p>Developer Kit サンプル: <em>footPrintNode_GeometryOverrride</em> (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxGeometryOverride</a></span>)</p>\n\
<ul>\n\
<li><p><span class=\'code\'>MHWRender::MRenderItem::DecorationItem</span> の <span class=\'code\'>RenderItemType</span> がすべてのカスタム レンダー項目に使用されているため、これらの項目は不透明な UI 項目として分類されます。</p></li>\n\
<li><p>明示的に定義された項目は、統合されていない場合、リストに最大 4 つ(ワイヤフレームに 2 つ、塗り潰しに 2 つ)追加でき、ワイヤフレームおよびシェーディングの描画モードがいずれも有効です。</p></li>\n\
<li><p>統合が有効な場合、最小値は、ワイヤフレームに 1 つまたは塗り潰しに 1 つで、描画モードは 1 つだけ有効です。</p></li>\n\
</ul>\n\
<p>Developer Kit サンプル: <em>apiMeshShape</em> (<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxGeometryOverride</a></span>)</p>\n\
<ul>\n\
<li>6 つの不透明な UI レンダー項目(ワイヤ、休止状態の頂点、アクティブな頂点、フェース センター、アクティブなワイヤ、塗り潰されたフェース)。<span class=\'code\'>MHWRender::MRenderItem::DecorationItem</span> の <span class=\'code\'>RenderItemType</span> があります。</li>\n\
</ul>\n\
<div class=\'figure\'><img src=\'dev_help/images/Basic_sequencing_apiMeshShape.png\' title=\'\' /></div>\n\
<ul>\n\
<li>内部のシェーダ割り当てのため、1 つの不透明なレンダー項目。<span class=\'code\'>RenderItemType</span> は <span class=\'code\'>MHWRender::MRenderItem::MaterialSceneItem</span> です。したがって、たとえば、ポスト エフェクトに参加します。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"developer-kit-サンプル-apimeshshape-mpxsubsceneoverride\"></a><h4 id=\"developer-kit-サンプル-apimeshshape-mpxsubsceneoverride\">Developer Kit サンプル: <em>apiMeshShape</em> (MPxSubSceneOverride)</h4></div>\n\
<p>このサンプルでは、同じオブジェクトのトランスフォーム インスタンスが 6 つあります。</p>\n\
<p>単一オブジェクトでは、1 つの項目が不透明リストに追加されています(シェーディング)。この項目は、ポスト エフェクト リストにも追加されます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/Basic_seq_apiMeshShape_1Shaded.png\' title=\'\' /></div>\n\
<p>サブシーン オーバーライドでは、ハードウェアによるインスタンス化を使用するため、合計で 1 つの項目しか追加されません。各項目では、インスタンスごとに異なるワールド空間でのトランスフォームを使用して、ハードウェアによるインスタンス描画を使用します。</p>\n\
<p>オブジェクトのインスタンスが選択された場合:</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/Basic_seq_apiMeshShape_1Wireframe.png\' title=\'\' /></div>\n\
<p>1 つのワイヤフレーム項目が不透明 UI リストに追加されます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/Basic_seq_apiMeshShape_Vertices.png\' title=\'\' /></div>\n\
<p>頂点が表示されるとき、他の 1 つの項目が不透明 UI リストに追加されます。</p>\n\
<p>シェーディング上にワイヤフレームを重ねると、2 つの UI 項目が追加されます。休止状態のワイヤフレームに 1 つ、アクティブなワイヤフレームに 1 つです。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/Basic_seq_apiMeshShape_2Wireframe.png\' title=\'\' /></div>\n\
<p>2 つの項目は、バウンディング ボックス用にも追加されます。これらは、<span class=\'code\'>MHWRender:: <a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::NonMaterialSceneItem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a688a4360e982358b90610f58d4eef49ea051cc5c371043b627d1d7bee0d06e030&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MRenderItem::NonMaterialSceneItem</a></span> の <span class=\'code\'>RenderType</span> であるため、シーン項目とはみなされませんが、まだ不透明 UI リストとして分類され、このリストに追加されます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/Basic_seq_apiMeshShape_BB.png\' title=\'\' /></div>\n\
<p>ワイヤフレーム、頂点およびバウンディング ボックスの項目はすべて、非ポスト エフェクト リストに追加されます。</p>\n\
<div class=\'section\'><a id=\"シェーダ\"></a><h4 id=\"シェーダ\">シェーダ</h4></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxShaderOverride</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShadingNodeOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_surface_shading_node_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_surface_shading_node_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxSurfaceShadingNodeOverride</a></span>、および Maya が割り当てる内部シェーダは常に、不透明または透明な非 UI レンダー項目を生成します。このため、これらの項目はポスト エフェクト リストに追加され、シャドウ マップ パス用にレンダリングされます。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxShaderOverride</a></span> C++ API リファレンス ドキュメントに記載されているように、プラグインのインスタンスは、既定では、オーバーライドされない限り、メイン カラー パスで描画するときのみ呼び出されます。たとえば、SSAO の法線の深度のパスは、既定ではプラグインにコールバックされません。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxSurfaceShadingNodeOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_surface_shading_node_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_surface_shading_node_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxSurfaceShadingNodeOverride</a></span> で提供するシェーダの実装は 1 つだけであり、これがメイン カラー パスで使用されます。</p>\n\
<div class=\'section\'><a id=\"項目リストのトラッキング\"></a><h3 id=\"項目リストのトラッキング\">項目リストのトラッキング</h3></div>\n\
<p>通常の 3D ビューティ レンダー、および 3D ビューポートのオーバーレイ レンダリングに使用できる空でないリストについてのトレース情報を取得できます。コマンド:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">ogs -traceRenderPipeline true;\n\
</pre></div><p>を使用して、デバッグ出力を、インタラクティブ モードではスクリプト エディタ(Script Editor)に、コマンド ライン モードでは <span class=\'code\'>stderr</span> に送信できます。</p>\n\
<p>たとえば、ワイヤフレームで塗り潰されて描画された球をトレースすると、次のように出力されることがあります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// -- VP2 Rendering [modelPanel4] [3d Beauty Render] // \n\
// Count for list: [Opaque UI] = 1 // \n\
// Count for list: [Opaque] = 1 // \n\
// Count for list: [Post Effect] = 1 // \n\
// Count for list: [Non Post Effect] = 1 //\n\
</pre></div><p>コンテキストでは、実行されたレンダーの他に、レンダリング先(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::renderingDestination()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a0df712533d76bdc96f2b49f4767ed85e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html#a3e5173af499179c84556e217b2e9b0f9&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFrameContext::renderingDestination()</a></span> から返される値と同じ)が得られます。ここでは、名前 <em>3d Beauty Render</em> が、内部レンダーを示すために返されています。</p>\n\
<p>この結果では、1 つの不透明 UI 項目(ワイヤフレーム)と、1 つの不透明項目(塗り潰し)が分類されたことを示しています。さらに、塗り潰し項目がポスト エフェクト描画の待ち行列に入れられ、ワイヤフレームが非ポスト エフェクト描画の待ち行列に入れられています。これらが使用可能であるということは、必ずしもリストがレンダリングされるということではありません。これは、ポスト エフェクトが有効になっているかどうかによります。</p>\n\
<p>リストは必ずしも使用される順番で与えられるわけではなく、各リストは、シーン レンダーにつき一度だけ与えられます。このセクションのシーケンスは、特定のリストが描画される可能性のある場所を確認するために参照する必要があります。</p>\n\
<p>複数のシーン レンダーが各レンダーの項目を表示します。たとえば、立体視のレンダリングでは次のようになることがあります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// -- VP2 Trace[StereoPanel][stereoOverrideVP2] // \n\
// Count for list: [Opaque UI] = 18 // \n\
// Count for list: [Opaque] = 34 // \n\
// Count for list: [Post Effect] = 33 // \n\
// Count for list: [Non Post Effect] = 19 // \n\
// Count for list: [Opaque UI] = 18 // \n\
// Count for list: [Opaque] = 34 // \n\
// Count for list: [Post Effect] = 33 // \n\
// Count for list: [Non Post Effect] = 19 // \n\
// Count for list: [HUD] = 1 //\n\
</pre></div><p>2 行目から 5 行目は 1 つのシーン描画を表し、6 行目から 9 行目は別の 1 つを表しています。</p>\n\
<p>レンダー オーバーライド(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MRenderOverride</a></span>)がトレースでアクティブになっている場合、オーバーライドの UI 名がトレースの一部として提供されることに注意してください。ここでは、<em>stereoOverrideVP2</em> というオーバーライド名が表示されています。</p>\n\
<p>もう 1 つの例は、<em>viewOverrideSimple</em> プラグインのトレースで、<em>Simple VP2 Override</em> という名前が示されています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// -- VP2 Trace[modelPanel1][Simple VP2 Override] // \n\
// Count for list: [Opaque UI] = 17 // \n\
// Count for list: [Pre-Opaque UI] = 2 // \n\
// Count for list: [Opaque] = 34 // \n\
// Count for list: [Post Effect] = 33 // \n\
// Count for list: [Non Post Effect] = 18 // \n\
// Count for list: [Orthographic On-Top UI] = 5 // \n\
// Count for list: [HUD] = 1 //\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";