var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>DirectX および OpenGL の描画 API に関するカメラ情報</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>DirectX および OpenGL の描画 API に関するカメラ情報</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"directx-および-opengl-の描画-api-に関するカメラ情報\"></a></div>\n\
<div class=\'section\'><a id=\"規則\"></a><h2 id=\"規則\">規則</h2></div>\n\
<p>DirectX と OpenGL には異なるカメラ規則があります。</p>\n\
<ul>\n\
<li>DirectX は左手のカメラ座標系を使用します。ビュー方向が Z+ 軸を指し、ニア クリップ プレーンとファー クリップ プレーンが Z 軸の[0,1]<em>正規化デバイス座標</em>(NDC)範囲にマッピングされます。</li>\n\
<li>OpenGL (および Maya)のカメラは、右手の座標系を使用します。さらに、OpenGL のビュー方向は Z- 軸を指し、ニア クリップ プレーンとファー クリップ プレーンが Z 軸の[-1,1]範囲にマッピングされます。</li>\n\
</ul>\n\
<p>ビューポート 2.0 は、カメラのプロジェクションの行列を設定するときに右手の座標系を使用することで、Maya の他の部分との一貫性を維持しています。ただし、ニア クリップ プレーンとファー クリップ プレーンは Z の[0,1]範囲にマッピングされます。</p>\n\
<p>そのため、</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext::getDepthRange()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html#ae1bda403fc02486d936aadc56a90e395&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html#ab5cd0dfd14aff4cbcac0325b057aa6ab&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawContext::getDepthRange()</a></span> を使用して深度の範囲を照会する場合、DirectX と OpenGL の戻り値は[0,1]範囲になります。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext::viewDirectionAlongNegZ()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html#a6913c6eda7d76d313d3ea1a8fab5318d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html#afb045b9b8551ebaab27134c427bae96a&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawContext::viewDirectionAlongNegZ()</a></span> を使用してビュー方向を照会する場合、OpenGL と DirectX の両方の戻り値はビュー方向が常に –Z に沿っていることを示します。</li>\n\
</ul>\n\
<p><span class=\'code\'>kViewDirection</span> (方向)、<span class=\'code\'>kViewUp</span> (上)、<span class=\'code\'>kViewRight</span> (右)列挙型を <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext::getTuple()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#a3a2746b602eb8dd543fa0a74497614d1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html#ad7f5d46968b6e18ac263ccdafca420eb&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFrameContext::getTuple()</a></span> メソッドに渡すことで、ワールド空間のカメラ ベクトルを照会することができます。これらの 3 つのベクトルは、右手の座標系の基礎を形成します。</p>\n\
<p>また、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawContext</a></span> はアクティブ カメラへのアクセスを提供します。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera</a></span> インタフェースを介してそのプロパティを照会すると、同じ一貫したカメラ ベクトル値を照会することができます。オブジェクト空間のベクトルが返された場合、値は Z- ビュー方向の一貫した右手の座標系を示します。</p>\n\
<p>次のような照会に使用できるいくつかの便利なメソッドがあります。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::unnormalizedNearClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a1329b457d65a26bac707a26908cbc5d4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera::unnormalizedNearClippingPlane()</a></span>. NDC ではなく、オブジェクト空間またはワールド空間の値を返します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::unnormalizedFarClippingPlane()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#af6f43d59313ce37fe5e8bf75f67d6374&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera::unnormalizedFarClippingPlane()</a></span>. NDC ではなく、オブジェクト空間またはワールド空間の値を返します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::eyePoint()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a578aa1d086c52784f1c5e7b204f70a9d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html#a32d6b12eb276b7963842c9b68312ac97&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera::eyePoint()</a></span>. ワールド空間座標を照会する場合は、<span class=\'code\'>kViewPosition</span> の照会と同等です。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::viewDirection()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a8607e1142843f35474557b5daa9489de&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html#a4d31d6f0df3d37887d21064652da25ca&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera::viewDirection()</a></span>. ワールド空間座標を照会する場合は、<span class=\'code\'>kViewDirection</span> の照会と同等です。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::upDirection()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a02c40747377d923d863cc514ef0b4d3d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html#a67c510d04a08a079d452a72f2c3d1e8a&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera::upDirection()</a></span>. ワールド空間座標を照会する場合は、<span class=\'code\'>kViewUp</span> の照会と同等です。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera::rightDirection()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html#a12417c673de907852f1d2917106b6097&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html#a4bff8c57542b11eb8cf7c8d87f755fd4&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera::rightDirection()</a></span>. ワールド空間座標を照会する場合は、<span class=\'code\'>kViewRight</span> の照会と同等です。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"クリッピング-プレーン\"></a><h2 id=\"クリッピング-プレーン\">クリッピング プレーン</h2></div>\n\
<p>旧式の既定ビューポート(ビューポート 1)では、アクティブ カメラがカメラ セットに属する場合に、OpenGL で追加クリップ プレーンを直接設定することができました。</p>\n\
<p>ビューポート 2.0 では、固定機能のユーザ クリップ プレーンが特定の描画 API で使用できない可能性があるため、デバイスを直接照会することはお勧めできません。そのため、ビューポート 1 の動作はビューポート 2.0 では既定で無効にされていますが、OpenGL (ENABLE_DEFAULT_VIEWPORT_CAMERA_SETS)の実行時に必要な場合には環境変数を介してアクセスできます。</p>\n\
<p>ワールド空間のクリップ プレーンを取得するための、描画 API に依存しないオプションを以下に示します。カメラは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawContext</a></span> から取得しますが、すべてのカメラ シェイプに対応することができます。クリップ プレーンを照会するための正規化されていないメソッドの使用に注目してください。**</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">MDrawContext context;\n\
\n\
// Get the current camera from the context\n\
<a href=\"javascript:void(0)\" data-symbol=\"MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera</a> activeCamera(context.getCurrentCameraPath());\n\
\n\
// Get relative near and far clip values with respect to the camera position\n\
// You should ignore any override values set when using a\n\
// camera set; therefore, do not use the nearClippingPlane() and farClippingPlane() \n\
// methods on MFnCamera.\n\
double nearD = activeCamera.unnormalizedNearClippingPlane();\n\
double farD = activeCamera.unnormalizedFarClippingPlane();\n\
\n\
// Get world space camera information\n\
<a href=\"javascript:void(0)\" data-symbol=\"MPoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPoint</a> eyePoint = activeCamera.eyePoint(<a href=\"javascript:void(0)\" data-symbol=\"MSpace::kWorld\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_space.html#ab11a1dda34491acff014ddfc9e6bafb8a45a60f04ac9114f0d6e865a6285f40b2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSpace::kWorld</a>);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVector</a> viewDirection = activeCamera.viewDirection(<a href=\"javascript:void(0)\" data-symbol=\"MSpace::kWorld\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_space.html#ab11a1dda34491acff014ddfc9e6bafb8a45a60f04ac9114f0d6e865a6285f40b2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSpace::kWorld</a>); // Positive value\n\
\n\
double dist = eyePoint[0]*viewDirection[0] + \n\
              eyePoint[1]*viewDirection[1] + \n\
              eyePoint[2]*viewDirection[2]; \n\
\n\
// Compute near clip plane facing away from the camera direction (for OpenGL)\n\
double distNear = -1.0 * (dist + nearD); \n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVector</a> OpenGL_NearClipPlaneVector(     \n\
       viewDirection[0], viewDirection[1], viewDirection[2], distNear);\n\
\n\
// Compute far clip plane facing towards the camera direction (for OpenGL)\n\
double distFar = dist + farD;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVector</a> OpenGL_FarClipPlaneVector(\n\
       -viewDirection[0], -viewDirection[1], -viewDirection[2], distFar);\n\
</pre></div><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawContext</a></span> のみを使用する場合の同等のコードは、次のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Query the camera coordinate system\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDoubleArray</a> vPos = context.getTuple(<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MFrameContext::kViewPosition\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670aba1d4dab9b951b21263efade0a8f6729&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MFrameContext::kViewPosition</a>);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDoubleArray</a> vDir = context.getTuple(<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MFrameContext::kViewDirection\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670a227b592bc3c59e5855866b1d9f8c997b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MFrameContext::kViewDirection</a>);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDoubleArray</a> vNear = context.getTuple(<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MFrameContext::kViewUnnormlizedNearClipValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670ab2b11196237108d7c893c6940cfe4b16&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MFrameContext::kViewUnnormlizedNearClipValue</a>);\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDoubleArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_double_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDoubleArray</a> vFar = context.getTuple(<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MFrameContext::kViewUnnormalizedFarClipValue\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html#af164f32d9bda6829f1738ef3fb2c6670a973730135c8d1f08c5de00aa2997e914&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MFrameContext::kViewUnnormalizedFarClipValue</a>);\n\
\n\
// Compute the world space planes for the near and far clip planes\n\
// The near plane is pointing away from the camera and is thus pointing in the\n\
// negative direction, while the far plane is pointing towards the camera (positive \n\
// direction.\n\
double distW = vPos[0]*vDir[0] + \n\
               vPos[1]*vDir[1] + \n\
               vPos[2]*vDir[2]; \n\
\n\
// Near clip plane faces away from the camera\n\
double distNearW = -1.0 * (distW + vNear[0]); \n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVector</a> OpenGL_NearPlane(vDir[0], vDir[1], vDir[2], distNearW);\n\
\n\
// Far clip plane faces torwards the camera\n\
double distFarW = distW + vFar[0];\n\
<a href=\"javascript:void(0)\" data-symbol=\"MVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_vector.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVector</a> OpenGL_NearPlane(-vDir[0], -vDir[1], -vDir[2], distFarW);   \n\
</pre></div><div class=\'section\'><a id=\"深度の優先順位\"></a><h2 id=\"深度の優先順位\">深度の優先順位</h2></div>\n\
<p>シェーダは、ビュー方向に沿ったジオメトリの位置をオフセットするために深度の優先順位を使用できます。シェーダ コード内での計算は、実際のデバイスの深度範囲に関連するため、OpenGL と DirectX で異なります。<span class=\'code\'>depthPriority</span> と呼ばれるユニフォーム パラメータが適切に設定されている場合は、次のサンプル コードが DirectX と OpenGL でのオフセットを実行します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// DX range is [0,1] or 1 in size.\n\
float4 iPcPriority( float3 pm, float depthPriority, float4x4 worldViewProjectionC )\n\
{ \n\
    float4 P = mul( float4(pm,1), worldViewProjectionC ); \n\
    P.z -= P.w * depthPriority; \n\
    return P; \n\
}\n\
 \n\
// OpenGL range is [-1,1] or 2 in size\n\
vec4 iPcPriority( vec3 pm, float depthPriority, mat4 worldViewProjectionC )\n\
{\n\
    vec4 P = worldViewProjectionC * vec4(pm,1.0f);\n\
    P.z -= P.w * 2.0 * depthPriority;\n\
    return P;\n\
}\n\
</pre></div><div class=\'section\'><a id=\"選択\"></a><h2 id=\"選択\">選択</h2></div>\n\
<p>選択項目は、描画用に使用されるものと同じ情報を使用します。</p>\n\
<div class=\'section\'><a id=\"スクリーンの方向\"></a><h2 id=\"スクリーンの方向\">スクリーンの方向</h2></div>\n\
<p>(ジオメトリ シェーダを使用して生成された)太い線およびポイント、またはスクリーン位置合わせジオメトリでは、反時計回りの巻上げ方向が前に向いたジオメトリを示すことに注目してください。これは DirectX と OpenGL の両方で一貫しています。</p>\n\
<p>たとえば、次の DirectX コードでは、4 つの点は次のように定義されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">static const float4 cQuadPts[4] = {  \n\
    float4( -1.0,  1.0, 0, 0 ),  \n\
    float4( -1.0, -1.0, 0, 0 ),  \n\
    float4(  1.0,  1.0, 0, 0 ),  \n\
    float4(  1.0, -1.0, 0, 0 )};\n\
</pre></div><p>ジオメトリ シェーダの展開が先に進む順序でポイントを横切り、それぞれが反時計回りの方向を持つ三角形を備えた三角ストリップが作成されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">void point2ScreenQuad( geometryInS inputs[1], float2 pointSz, float2 screenSize,\n\
     float4x4 viewProjInverse, float depthPriorityUnit, bool orthographic, float DPThresholdInView, \n\
     inout TriangleStream&lt;geometryInS&gt; outStream  ) \n\
{\n\
    geometryInS outS  = inputs[0]; \n\
    float size = max(0, max(pointSz.x, pointSz.y)); \n\
    float dpScale = orthographic ? 1.0f : -DPThresholdInView; \n\
    float dp = 2.0f * size * cDepthPriorityUnit * dpScale; \n\
    float4 sizeInZ = float4(pointSz.xy  / screenSize.xy, 0, 0) * outS.Pc.w;  \n\
    [unroll] for( int i = 0; i &lt; 4; ++i ) { \n\
        outS.Pc = inputs[0].Pc + sizeInZ * cQuadPts[i]; \n\
        outS.Pc.z = inputs[0].Pc.z - dp; \n\
        outStream.Append( outS ); \n\
    } \n\
    outStream.RestartStrip(); \n\
}\n\
</pre></div><div class=\'section\'><a id=\"例\"></a><h2 id=\"例\">例</h2></div>\n\
<ul>\n\
<li>Maya Developer Kit の <em>rawFootPrintNode</em> プラグインには、上記のワールド空間クリップ プレーンの計算を含む、さまざまな <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawContext</a></span>/<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_camera.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnCamera</a></span> および <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFrameContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFrameContext</a></span> の照会を実行するサンプル デバッグ コードがあります。</li>\n\
<li><em>cgfxShader</em> プラグインは、正規化デバイス座標(NDC)からスクリーン スペースへの変換の例を示します。</li>\n\
<li><span class=\'code\'>MayaBlinnDirectionalLightShadowGL.cgfx</span>、<span class=\'code\'>MayaBlinnDirectionalLightShadowGL.ogsfx</span>、および <span class=\'code\'>MayaBlinnDirectionalLightShadow10.fx</span> ファイルは、同じシェーダに深度の優先順位オフセットを使用する DirectX と OpenGL のサンプル実装を提供します。これらのファイルは、Maya インストール フォルダの <span class=\'code\'>bin\\Cg</span>、<span class=\'code\'>bin\\OGSFX</span>、<span class=\'code\'>bin\\HLSL</span> フォルダにあります。上記の <span class=\'code\'>iPcPriority</span> 関数であるため、<span class=\'code\'>mayaDepthPriorityShader</span> フラグメントを検討することもできます。</li>\n\
<li><span class=\'code\'>mayaFatPointShader</span> で太いラインを描画するために使用されるジオメトリ シェーダ コードのサンプルとして、<span class=\'code\'>mayaPoint2Quad</span> フラグメントを検討することができます。これには <span class=\'code\'>mayaDepthPriorityShader</span> フラグメントも組み込まれていて、ビュー方向にオフセットすることができます。</li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>注:</strong> フラグメントは、次のいずれかの方法を使用して検討することができます。 - <span class=\'code\'>ogs –xml &lt;fragmentName&gt;</span> コマンド(<span class=\'code\'>&lt;fragmentname&gt;</span> 引数はフラグメント名) - <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFragmentManager::getFragmentXML()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_fragment_manager.html#ac6fb2a8f6c193bf89911f036035cc355&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_fragment_manager.html#a9cf7a66c2e0cf3adeb0d47213aad1417&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFragmentManager::getFragmentXML()</a></span> API インタフェース<em>fragmentDumper</em> サンプル プラグインは、<span class=\'code\'>-fn</span> オプションを使用してフラグメントの検討にも使用できる <span class=\'code\'>dumpFragment</span> コマンドを実装します。</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";