var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>シェーダのジオメトリック データをカスタマイズする</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>シェーダのジオメトリック データをカスタマイズする</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"シェーダのジオメトリック-データをカスタマイズする\"></a></div>\n\
<p>Maya DAG オブジェクトのデータ表現は、シェーディング アルゴリズムの入力として使用できるジオメトリック ストリームのフォーマットと型の両方を示します。指定されたシェーダの場合、提供されたストリームのフォーマットまたは型のいずれかが不十分である可能性があります。</p>\n\
<p>こうした問題に対処するために、データをカスタマイズするための API が提供され、次のことが可能になります。</p>\n\
<ul>\n\
<li>カスタマイズされたデータ ストリームを提供できます。</li>\n\
<li>より多くのカスタム データ形式を提供できます。</li>\n\
<li>データの再パッケージ化が可能になります。</li>\n\
</ul>\n\
<p>すべてのインタフェースが統一されたシステム内で動作するため、任意のカスタマイズまたはすべてのカスタマイズを相互に組み合わせて使用することができます。</p>\n\
<p>カスタム データ ストリームとカスタム データ インデックスを提供するためのプラグイン機能を提供する 2 つのインタフェースがあります。</p>\n\
<div class=\'section\'><a id=\"ジオメトリ-ジェネレータ\"></a><h2 id=\"ジオメトリ-ジェネレータ\">ジオメトリ ジェネレータ</h2></div>\n\
<p>カスタム ストリームは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxVertexBufferGenerator</a></span> を使用して提供できます。この機能に一致する旧式のクラスはありません。</p>\n\
<p>ジェネレータは、新規データや既存のストリーム データに基づいてストリームを提供できます。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxVertexBufferGenerator</a></span> を使用するには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawRegistry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawRegistry</a></span> クラスを使用して、オーバーライドの登録方法と同様の方法でこれを登録する必要があります。</p>\n\
<p>シェーダが特定のデータ ストリームを必要とする場合は、<span class=\'code\'>MVertexBufferDescriptors</span> を使用してその要件を指定します。各 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVertexBufferDescriptor</a></span> は、ストリーム名とセマンティックを使用してそれぞれのストリームを指定します。すべての <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxVertexBufferGenerator</a></span> が、関連付けられた名前を持つ必要があります。ジェネレータを参照する場合は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVertexBufferDescriptor</a></span> でこの名前をそのセマンティック名として使用できます。</p>\n\
<p>2 つのカスタム ストリームの要件を指定する <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxShaderOverride</a></span> の例を次に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Create a custom position stream requirement. Set a unique semantic name for lookup.\n\
// Add to the list of requirements.\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> positionDesc(\n\
                empty, \n\
                <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kPosition\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4aa20581584e5f9447cb96afb4f2e10703&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kPosition</a>,\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
                3);\n\
\n\
positionDesc.setSemanticName(&quot;customPositionStream&quot;);\n\
addGeometryRequirement(positionDesc);\n\
\n\
// Create a custom normal stream requirement. Set a unique semantic name for lookup.\n\
// Add to the list of requirements.\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> normalDesc(\n\
                empty,\n\
                MHWRender::MGeometry:: kNormal,\n\
                <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
                3);\n\
normalDesc.setSemanticName(&quot;customNormalStream&quot;);\n\
addGeometryRequirement(normalDesc);\n\
\n\
</pre></div><p>データを入力するためのジェネレータが、<span class=\'code\'>createVertexStreams()</span> メソッドを使用して呼び出されます。指定した DAG パスに合わせてジェネレータが更新され、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVertexBuffer</a></span> を返します。</p>\n\
<p>既存データに基づいて新しいデータが生成される場合は、既存のソース ストリーム セットを指定できます。<span class=\'code\'>createVertexStreams()</span> が呼び出される前に、ジェネレータ(<span class=\'code\'>getSourceStreams()</span>)に照会することで、必要とされる特定のストリームが返されます。</p>\n\
<p>たとえば、既存の位置と法線ストリームを組み合わせることで、新しいストリームを形成できます。入力ストリーム(<span class=\'code\'>MVertexBuffers</span>)は GPU リソースであるため、CPU メモリにマッピングしてから読み込む必要があります。ソース ストリーム データの変更は禁じられています。</p>\n\
<p>データに正しい入力が行われるように、データ ストリームの参照に使用されるインデックスが提供されます。ジェネレータは、カスタム ストリーム(<span class=\'code\'>getSourceIndexing()</span>)に必要なインデックスを提供します。内部およびカスタムのすべてのストリームのインデックスに基づいて、インデックスの最適化を実行できます。ストリームの作成時に、オリジナルおよび共有の両方のインデックス データがジェネレータに提供されます。インデックスは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MComponentDataIndexing\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_component_data_indexing.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_component_data_indexing.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MComponentDataIndexing</a></span> インスタンスを使用して指定されます。これは、一連のインデックス値とコンポーネント タイプのラップ元です。</p>\n\
<p>ジェネレータは、提供元の <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVertexBuffer</a></span> に対し、データの割り当てと転送を正しく実行する役割を果たします。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f8d61.jpg\' title=\'\' /></div>\n\
<p>図 69: バッファ ジェネレータのメソッド順序に基づいた実行フローの概要が示されています。上から下の順番に、ソース ストリームとインデックスの要件が照会されます。作成時に、要求されたすべてのソース ストリーム、関連する DAG パス、およびすべての共有インデックスが入力として提供されます。ジェネレータは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVertexBuffer</a></span> への入力を行います。この例では、入力位置と法線ストリームを新しいストリーム内にスウィズルしています。</p>\n\
<p>カスタム ストリーム インデックスは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxPrimitiveGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxPrimitiveGenerator</a></span> を使用して指定する必要があります。</p>\n\
<p>ストリーム ジェネレータと同様に、使用できるインデックスを識別するために一意の名前が使用されます。インデックスを作成するために、シェーダ インスタンスが <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MIndexBufferDescriptor</a></span> を使用して必要なインデックスを指定します。記述子のプリミティブ名は、プリミティブ ジェネレータの名前に設定できます。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxPrimitiveGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_primitive_generator.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxPrimitiveGenerator</a></span> を使用するには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawRegistry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawRegistry</a></span> クラスを使用して、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferGenerator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_generator.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxVertexBufferGenerator</a></span> の場合と同様の方法でこれを登録する必要があります。</p>\n\
<p>現在、インデックス要件の追加をサポートしているエントリ ポイントは 2 つあります。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxShaderOverride</a></span> は、そのジオメトリ要件が定義されるときのポイントです。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxGeometryOverride</a></span> は、追加のレンダー項目に対してジオメトリ要件が定義されるときのポイントです。どちらの場合も、要件は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MIndexBufferDescriptor</a></span> によって指定されます。</p>\n\
<p>カスタム インデックスを要件として追加するには、適切に設定された <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MIndexBufferDescriptor</a></span> を追加する必要があります。タイプにはカスタム(Custom)を設定し、一意の名前を指定する必要があります。この名前は、登録したジェネレータの名前と一致する必要があります。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxGeometryOverride</a></span> に対して非カスタム インデックス要件を追加する方法を次の例に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometryRequirements\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_requirements.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometryRequirements</a> geomRequirements;\n\
\n\
// As we are not using MIndexBufferDescriptor::kCustom for custom named index buffers\n\
// just use an empty string here.\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MString</a> noName;\n\
\n\
// Add in a triangle indexing requirement\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MIndexBufferDescriptor</a> triangleDesc(\n\
        MHWRender::MIndexBufferDescriptor::kTriangle, \n\
        noName, \n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTriangles\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1eaa2c70dd76c8172a9298334473c914304&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kTriangles</a>, \n\
        3, \n\
        compObj);\n\
\n\
geomRequirements.addIndexingRequirement(triangleDesc);\n\
</pre></div><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxShaderOverride</a></span> に対してカスタム インデックス要件を追加する方法を次の例に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Name of custom indexing \n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MString</a> customPrimitiveName(&quot;customPrimitive&quot;);\n\
\n\
// Add in a custom triangle indexing requirement\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MIndexBufferDescriptor</a> indexingRequirement( \n\
        MHWRender::MIndexBufferDescriptor::kCustom, \n\
        customPrimitiveName, \n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTriangles\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1eaa2c70dd76c8172a9298334473c914304&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kTriangles</a>);\n\
        \n\
addIndexingRequirement(indexingRequirement);\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f8d67.jpg\' title=\'\'></div>\n\
</pre></div><p>図 70: サンプル コードに基づいた結果のリレーションシップです。</p>\n\
<p>カスタム インデックスが必要な場合は、ジェネレータ インスタンスに対して適切なコールが行われます。ジェネレータは、DAG オブジェクトおよび DAG コンポーネント(<span class=\'code\'>computeIndexingCount()</span>)に対する相対的なインデックス サイズを最初に提供します。その後、ジェネレータは実際のインデックスを作成するように指示されます。ソースとターゲットのインデックス データも提供されます。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIndexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MIndexBuffer</a></span> を更新して返す必要があります。これは GPU リソースであるため、CPU メモリにマッピングし直し、更新してから GPU メモリに転送し直す必要があります。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f8d6d.jpg\' title=\'\' /></div>\n\
<p>図 71</p>\n\
<p>Developer Kit に含まれる例:</p>\n\
<ul>\n\
<li><em>vertexBufferGenerator</em>: 前述したように、位置と法線のスウィズルを実行します。このプラグインは、dx11Shader および cgfxShaderNode に依存しており、これらのプラグインがサンプル エフェクト ファイルを解析して抽出したセマンティック名を名前キーとして使用してジェネレータをアクティブにします。CgFX および HLSL に使用されるシェーダのセマンティックには、わずかな違いがあります。CgFx の場合は、任意の文字列名を使用できないため、ジェネレータは「ATTR7」と「ATTR8」というアトリビュート名のセマンティックを使用します。HLSL の場合は、「myCustomStream」と「myCustomStream2」という名前を代わりに使用できます。</li>\n\
<li><em>customPrimitiveGenerator</em>: プリミティブ ジェネレータのサンプルです。このジェネレータの使用方法は、<em>hwPhongShader</em> プラグインでアクティブにできます。</li>\n\
<li><em>crackFreePrimitiveGenerator</em>: dx11Shader プラグインでテッセレーション シェーダをサポートすることを目的として、カスタムのインデックスとデータを生成するために使用されるインデックス mutator のサンプルです。</li>\n\
</ul>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f8d73.jpg\' title=\'\' /></div>\n\
<p>図 72</p>\n\
<p>クラックのない mutator が、法線三角形リストよりも詳細な情報が含まれたインデックス バッファを作成します。三角形のインデックスは、三角形ごとに 3 つの頂点のインデックスを提供します。クラックのない mutator が、テッセレーションにフィットするインデックスを提供します。</p>\n\
<p>サンプルには現在、「PN-AEN9」モードと「PN-AEN18」モード(隣接エッジ法線を使用した点法線三角形)のサポートが実装されています。</p>\n\
<p>PN-AEN9 モードでは、次のデータを使用して各三角形のインデックスが作成されます。</p>\n\
<ul>\n\
<li>3 つの三角形の頂点インデックス</li>\n\
<li>隣接エッジの 6 つの頂点インデックス</li>\n\
</ul>\n\
<p>これにより、インデックス配列のストライドは 9 になります。PN-AEN9 という名前はこれに由来します。</p>\n\
<p>頂点 a、b、c で表現された上図の三角形の場合、PNAEN9 コードは次のインデックスを生成します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"> [a b c] [d e f g h i]\n\
</pre></div><p>PN-AEN18 では、PN-AEN9 よりも多くのデータが追加されます。</p>\n\
<ul>\n\
<li>3 つの三角形の頂点インデックス</li>\n\
<li>隣接エッジの 6 つの頂点インデックス</li>\n\
<li>ドミナント エッジの 6 つの頂点インデックス</li>\n\
<li>ドミナント UV 位置の 3 つの頂点</li>\n\
</ul>\n\
<p>これにより、インデックス配列のストライドは 18 になります。</p>\n\
<p>ドミナント エッジは、最下部の頂点インデックスが含まれているエッジです。上に示した同じ例では、三角形 <span class=\'code\'>[abc]</span> の <span class=\'code\'>[ab]</span> と <span class=\'code\'>[de]</span> 間のドミナント エッジは <span class=\'code\'>[ab]</span> になります。また、三角形 <span class=\'code\'>[dej]</span> の場合でも <span class=\'code\'>[ab]</span> になります。</p>\n\
<p>ドミナント UV 位置は、各頂点に最下部の UV 座標が含まれる三角形です。上の例では、三角形 <span class=\'code\'>[abc]</span> のドミナント位置は <span class=\'code\'>[afh]</span> です。</p>\n\
<ul>\n\
<li><span class=\'code\'>[a]</span> の UV 座標が、<span class=\'code\'>[d]</span>、<span class=\'code\'>[i]</span>、<span class=\'code\'>[r]</span>、および <span class=\'code\'>[s]</span> の UV 座標よりも低い場合</li>\n\
<li><span class=\'code\'>[f]</span> の UV 座標が、<span class=\'code\'>[b], [e], [k], [l]</span> および <span class=\'code\'>[m]</span> の UV 座標よりも低い場合</li>\n\
<li><span class=\'code\'>[h]</span> の UV 座標が、<span class=\'code\'>[c], [g], [o], [p]</span> および <span class=\'code\'>[q]</span> の UV 座標よりも低い場合</li>\n\
</ul>\n\
<p>PN-AEN18 コードは、次のインデックスを生成します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">[a b c] [d e f g h i] [a b f g h i] [a f h]\n\
</pre></div><p>dx11Shader プラグインには HLSL 用ジェネレータの使用方法が、CgFx プラグインには CgFx 用ジェネレータの使用方法がそれぞれ表示されます。dx11Shader は、シェーダの「PNAEN9」セマンティックと「PNAEN18」セマンティック用にクラックのないテッセレータ mutator を明示的に登録します。</p>\n\
<p>SDK が提供するサンプル シェーダ(AutodeskUberShader.fx)は、次のテクニック宣言を使用して、API に特殊なインデックス要件を通知します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">technique11 TessellationON\n\
&lt;\n\
    string index_buffer_type = &quot;PNAEN18&quot;; // Indicate index buffer type required\n\
&gt;\n\
{  \n\
    pass p0\n\
    {\n\
        SetRasterizerState(CullFront);\n\
        SetDepthStencilState(DepthNormal, 0);\n\
        SetVertexShader(CompileShader(vs_5_0, vt()));\n\
        SetHullShader(CompileShader(hs_5_0, HS()));\n\
        SetDomainShader(CompileShader(ds_5_0, DS()));\n\
        SetGeometryShader(NULL);                                \n\
        SetPixelShader(CompileShader(ps_5_0, f()));\n\
    }\n\
}\n\
\n\
</pre></div><p>この場合、テクニックごとの注釈は、プラグイン コード内で解析されます。<em>customIndexingMutatorName</em> の文字列値「PNAEN18」は、更新時にクラックのない登録済みインデックス mutator をコールする、インデックス記述子要件におけるセマンティック名です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MString</a> customIndexingMutatorName;\n\
\n\
ID3DX11EffectTechnique * mpD3DTechnique;\n\
\n\
ID3DX11EffectVariable* indexBufferType = \n\
        mpD3DTechnique-&gt;GetAnnotationByName(&quot;index_buffer_type&quot;);\n\
\n\
if(indexBufferType &amp;&amp; indexBufferType-&gt;IsValid())\n\
{\n\
    ID3DX11EffectStringVariable* indexBufferTypeStr = indexBufferType-&gt;AsString();\n\
    if(indexBufferTypeStr &amp;&amp; indexBufferTypeStr-&gt;IsValid())\n\
    {\n\
        LPCSTR value; \n\
        if( SUCCEEDED ( indexBufferTypeStr-&gt;GetString( &amp;value ) ) )\n\
        {\n\
            customIndexingMutatorName = <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MString</a>(value);\n\
        }\n\
    }\n\
}\n\
</pre></div><div class=\'section\'><a id=\"ジオメトリ-mutator\"></a><h2 id=\"ジオメトリ-mutator\">ジオメトリ mutator</h2></div>\n\
<p>mutator は、その名前が示すように、指定された既存の頂点バッファ(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVertexBuffer</a></span>)でデータのパッキングを修正するために使用できます。ストリーム ジェネレータと同様に、mutator は、mutator と記述子(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVertexBufferDescriptor</a></span>)上のセマンティック名が一致した場合に、その記述子に関連付けられます。</p>\n\
<p>mutator は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxVertexBufferMutator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_vertex_buffer_mutator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_vertex_buffer_mutator.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxVertexBufferMutator</a></span> として表現されます。mutator は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawRegistry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawRegistry</a></span> に登録する必要があります。</p>\n\
<p>使用する既存の mutator の指定方法を次の例に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MString</a> empty;\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> positionDesc(\n\
        empty,\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kPosition\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4aa20581584e5f9447cb96afb4f2e10703&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kPosition</a>,\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
        3);\n\
        \n\
// Use the custom semantic name &quot;swizzlePosition&quot; which corresponds to a plug-in which will\n\
// swizzle the x,y, and z channels of a position stream using this positionDesc.setSemanticName(&quot;swizzlePosition&quot;); \n\
\n\
// Add the descriptor as part of the requirements for this shader\n\
addGeometryRequirement(positionDesc);\n\
\n\
</pre></div><p>次の図は、上記のコード例のリレーションシップを示しています。セマンティック名でルックアップを表示するために、「customMutator」がさらに追加されています。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f8d79.jpg\' title=\'\' /></div>\n\
<p>図 73</p>\n\
<p>mutator が更新を実行する必要がある場合、関連付けられている Maya DAG パスとデータ ストリーム インデックスが渡されます。更新を行うために既存の <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVertexBuffer</a></span> が渡され、データがその場で修正されます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f8d7f.jpg\' title=\'\' /></div>\n\
<p>図 74</p>\n\
<p>Developer Kit のサンプルである <em>vertexBufferMutator</em> には、スウィズルを実行する mutator を登録するための完全なコードがあります。hwPhongShader プラグインには、カスタム スウィズルの使用方法を例示するコードがあります。</p>\n\
<p>その場編集の実行方法を示すサンプル コードからの抜粋を次に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Input argument\n\
MVertexBuffer&amp; vertexBuffer;\n\
\n\
unsigned int vertexCount = vertexBuffer.vertexCount();\n\
if (vertexCount &lt;= 0)\n\
    return;\n\
    \n\
// Acquire the buffer to fill with data. Data is not in CPU memory\n\
float* buffer = (float*)vertexBuffer.acquire(vertexCount);\n\
float* start = buffer;\n\
\n\
for (unsigned int i = 0; i &lt; vertexCount; ++i)\n\
{\n\
    // Here we swap the x, y and z values\n\
    float x = buffer[0];\n\
    buffer[0] = buffer[1];    // y --&gt; x\n\
    buffer[1] = buffer[2];    // z --&gt; y\n\
    buffer[2] = x;            // x --&gt; z\n\
    buffer += 3;\n\
}\n\
\n\
// Commit the buffer to signal completion. CPU data will be transferred to GPU memory.\n\
vertexBuffer.commit(start);\n\
\n\
</pre></div><div class=\'section\'><a id=\"インデックス-mutator\"></a><h2 id=\"インデックス-mutator\">インデックス mutator</h2></div>\n\
<p>インデックス mutator を使用して、指定された既存のインデックス バッファ(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIndexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MIndexBuffer</a></span>)のデータを修正できます。mutator は、mutator と記述子(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MIndexBufferDescriptor</a></span>)上のセマンティック名が一致した場合に、その記述子に関連付けられます。</p>\n\
<p>mutator は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxIndexBufferMutator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_index_buffer_mutator.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_index_buffer_mutator.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxIndexBufferMutator</a></span> として表現されます。mutator は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawRegistry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_draw_registry.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawRegistry</a></span> に登録する必要があります。</p>\n\
<p>使用する既存の mutator の指定方法を次の例に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MIndexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_index_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MIndexBufferDescriptor</a> indexingRequirement(\n\
        MHWRender::MIndexBufferDescriptor::kCustom,\n\
        customIndexingMutatorName,\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTriangles\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1eaa2c70dd76c8172a9298334473c914304&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kTriangles</a>);\n\
        \n\
// Add the descriptor as part of the requirements for this shader\n\
addIndexingRequirement(indexingRequirement);\n\
\n\
</pre></div><p>次の図は、上記のコード例のリレーションシップを示しています。セマンティック名でルックアップを表示するために、「customMutator」がさらに追加されています。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/Maya%20Viewport%202%20supplementary%20diagram%2061.png\' title=\'\' /></div>\n\
<p>図 75</p>\n\
<p>mutator が更新を実行する必要がある場合、関連付けられたデータス トリーム インデックスと事前に生成された頂点バッファ配列が渡されます。更新を行うために既存の MIndexBuffer が渡され、データがその場で修正されます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/Maya%20Viewport%202%20supplementary%20diagram%2061+.png\' title=\'\' /></div>\n\
<p>図 76</p>\n\
<p>Developer Kit のサンプルであり、dx11Shader プロジェクトの一部である <em>crackFreePrimitiveGenerator</em> には、PN AEN パッチ生成を実行する mutator を登録するための完全なコードがあります。dx11Shader プラグインには、MayaUberShader.fx エフェクト ファイルの「TessellationON」または「Wireframe」テクニックが選択されているときの、カスタム パッチの使用方法を例示するコードが含まれています。</p>\n\
<p>その場編集の実行方法を示すサンプル コードからの抜粋を次に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Input argument\n\
MIndexBuffer&amp; indexBuffer;\n\
\n\
// Acquire the buffer to fill with data. Data is not in CPU memory\n\
unsigned int* buffer = (unsigned int *) indexBuffer.acquire(numTri * triSize, true);\n\
unsigned int* start = buffer;\n\
\n\
for (unsigned int i = 0; i &lt; numTri; ++i)\n\
{\n\
    // Here we fill PN AEN information\n\
    buffer[0] = vertexId0; \n\
    buffer[1] = vertexId1;\n\
    buffer[2] = vertexId2;\n\
    // ...\n\
    buffer[17] = dominantVertex2;\n\
    buffer += triSize;\n\
}\n\
\n\
// Commit the buffer to signal completion. CPU data will be transferred to GPU memory.\n\
indexBuffer.commit(start);\n\
primitiveStride = triSize; // Output argument\n\
return <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kPatch\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1ea23d4e011c2b72a286021ca9a5a121830&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kPatch</a>;\n\
\n\
</pre></div><p><strong>パイプラインの概要:</strong></p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f99e6.jpg\' title=\'\' /></div>\n\
<p>図 77</p>\n\
<p>上図には、ジェネレータと mutator をパイプライン全体にフィットさせる方法が示されています。頂点バッファの生成と変異、およびプリミティブ生成(記述子によって表現される)に関する(シェーダ パラメータに基づいた)カスタム要件を持つシェーダのオーバーライドが示されています。更新を行う必要がある場合(更新フェーズ)は、頂点またはインデックス バッファを更新または作成するために呼び出されるジェネレータおよび mutator と名前が一致することが <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGeometryOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_geometry_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxGeometryOverride</a></span> でのシェーダ要件となります。これらのカスタム バッファは、描画フェーズに到達するまで、パイプラインを流れる 1 つまたは複数のレンダー項目で使用できます。この時点で、カスタム データ要件を開始したシェーダ パラメータにカスタム頂点とインデックス バッファをバインドできます。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";