var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ハードウェア レンダリング用のジオメトリ リマッピング</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ハードウェア レンダリング用のジオメトリ リマッピング</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ハードウェア-レンダリング用のジオメトリ-リマッピング\"></a></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/Updated_Even-to-Odd.png\' title=\'\' /></div>\n\
<p>次の情報は、次の状況で発生する可能性があるジオメトリ データのリマッピングに焦点を当てています。</p>\n\
<ul>\n\
<li><p>内部的に、または <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnMesh</a></span> API インタフェースを通じてポリゴン メッシュが作成されてから</p></li>\n\
<li><p>ハードウェア レンダリング用にジオメトリが提供されるまで</p></li>\n\
</ul>\n\
<p>主な目的は、レンダリング時に提供される頂点データをどのようにオリジナルのジオメトリに再度マッピングできるかについて説明することです。特に、一連のオリジナルの四角フェースにデータをリマッピングすることが要件の場合を考慮しています。これは、Ptex テクスチャ マッピングなどの場合です。</p>\n\
<p>まず、スムーズ メッシュ プレビュー(Smooth Mesh Preview)表示オプションに使用される基本三角形分割ロジックと均一サブディビジョン ロジックについて説明します。 この情報は、カスタム リマッピングによって実行されるアルゴリズム(Maya が内部的に実行する方法と同様のアルゴリズム)を理解するために役立ちます。この情報は Maya 2016 のロジックに関するもので、VP1 (旧式の既定ビューポート) と VP2 (ビューポート 2.0)の両方に適用できます。</p>\n\
<p>次に、シェーディング時のリマッピング データへのアクセスについて検討します。リマッピングされたデータを使用することの主な利点は、Maya の内部ロジック変更の複雑さにプラグインが対応する必要がないことです。提供されるデータには、頂点ごとの他のアトリビュート(位置や法線など)と同じ方法で、すべての内部データ操作が既に行われています。</p>\n\
<p>この内部リマッピング ロジックは Maya 2016 の時点で最新のものですが、今後変更される可能性があります。このロジックのリバース エンジニアリングは推奨されていません。 また、三角形分割とスカルプトの実行、および適応型サブディビジョンに使用されるインデックス リマッピング ロジックは、VP2 の複雑さと非決定性を増します。</p>\n\
<p>VP1 と VP2 両方のハードウェア シェーダ インタフェースの同等のリマッピング データへのアクセスについても検討します。</p>\n\
<div class=\'section\'><a id=\"リマッピング-ロジック\"></a><h2 id=\"リマッピング-ロジック\">リマッピング ロジック</h2></div>\n\
<div class=\'section\'><a id=\"三角形分割\"></a><h3 id=\"三角形分割\">三角形分割</h3></div>\n\
<p>三角形分割は、ハードウェア レンダリング時に使用できるジオメトリ インデックスを生成するために行われます。三角形分割ロジックによって、分割にどのローカル頂点インデックスを使用するかが決定されます。どの分割が使用されるかについての知識が、三角形のペアのオリジナルの四角形へのマッピングを判断する際に役立ちます。</p>\n\
<p>既定では、ポリゴン シェイプに使用されるロジックは最適シェイプの三角形の提供を試みます。**しかし、リマッピングでは、どのように分割が行われるかについての予測可能性を得ることが最優先の目的です。そのためには、メッシュ シェイプの <span class=\'code\'>quadSplit</span> アトリビュートを設定して予測可能性を向上させることができます。</p>\n\
<p><span class=\'code\'>quadSplit</span> オプションは、四角形がどのように 2 つの三角形に分割されるかを決定します。<strong>左(Left)</strong>が選択されている場合は新しいエッジが 2 番目と 4 番目の頂点の間にでき、<strong>右(Right)</strong>の場合は 1 番目と 4 番目の頂点の間で分割します。<strong>最適シェイプ(Best Shape)</strong>は四角形のシェイプに基づいて最適な分割の選択を試みますが、これはアニメーション間でシェイプが変形するにつれて変化する可能性があります。</p>\n\
<p>そのため、左(Left)または右(Right)の分割を選択したほうが予測可能性が向上します。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_Triangulation_MeshControls.png\' title=\'\' /></div>\n\
<p>左(Left)の分割を以下のイメージに示します。分割が行われた箇所は点線で示しています。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_Triangulation_QuadSplit.png\' title=\'\' /></div>\n\
<p>それでも最適シェイプ(Best Shape)が必要な場合の四角形のリファレンス ロジックを以下に示します。一般的なアルゴリズムは穴がある可能性がある一般的な N 面ポリゴンを処理しますが、ここでは含まれていません。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">v0 = quad vertex 0\n\
v1 = quad vertex 1\n\
v2 = quad vertex 2\n\
v3 = quad vertex 3\n\
\n\
dist02 = distance between v0 and v2\n\
dist13 = distance between v1 and v3\n\
\n\
// Use small tolerance so exact squares triangulate consistently\n\
// one way rather than randomly due to rounding errors\n\
fudgeFactor = 0.999f\n\
canSplit = false\n\
split02 = false\n\
\n\
if( dist02 &lt; fudgeFactor*dist13 )\n\
{\n\
    n1 = normal of triangle 1, 2, 0\n\
    n2 = normal of triangle 2, 3, 0\n\
\n\
    if( angle between n1 and n2 is less than 90 degrees )\n\
    {\n\
        if( area of triangle1 &lt; 7 * area of triangle2 &amp;&amp;\n\
                    area of triangle2 &lt; 7 * area of triangle1 )\n\
        {\n\
            canSplit = true\n\
            split02 = true\n\
        } \n\
    }\n\
}\n\
else\n\
{\n\
    n1 = normal of triangle 0, 1, 3\n\
    n2 = normal of triangle 3, 1, 2\n\
\n\
    if( angle between n1 and n2 is less than 90 degrees )\n\
    {\n\
        if( area of triangle1 &lt; 7 * area of triangle2 &amp;&amp;\n\
                area of triangle2 &lt; 7 * area of triangle1 )\n\
        {\n\
            canSplit = true\n\
            split02 = false\n\
        } \n\
    }\n\
}\n\
\n\
if( canSplit )\n\
{\n\
    if( split02 )\n\
    {\n\
        set triangle 1 = 1,2,0\n\
        set triangle 2 = 0,2,3\n\
    }\n\
    else\n\
    { \n\
        set triangle 1 = 0,1,3\n\
        set triangle 2 = 3,1,2\n\
    }\n\
}\n\
else \n\
{\n\
   // Fall back to general triangulation algorithm    \n\
}\n\
</pre></div><div class=\'section\'><a id=\"mfnmesh-に関する考慮事項\"></a><h3 id=\"mfnmesh-に関する考慮事項\">MFnMesh に関する考慮事項</h3></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnMesh</a></span> の三角形分割オプションは内部的に使用されるものとは異なり、常に <strong>最適シェイプ(Best Shape)</strong> オプションを使用します。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnMesh</a></span> の三角形分割メソッドが呼び出されない場合はインデックスのリマッピングは行われず、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnMesh</a></span> のストレージのデータを提供するインタフェースは渡されたデータを再シャッフルしません。三角形分割メソッドが呼び出されない場合は、内部三角形分割ロジックに <span class=\'code\'>quadSplit</span> オプションが反映されます。</p>\n\
<div class=\'section\'><a id=\"スムーズ-メッシュ-プレビューに関する考慮事項\"></a><h3 id=\"スムーズ-メッシュ-プレビューに関する考慮事項\">スムーズ メッシュ プレビューに関する考慮事項</h3></div>\n\
<p>スムーズ メッシュ プレビュー(Smooth Mesh Preview)では、<span class=\'code\'>quadSplit</span> オプションが使用されないことに注意する必要があります。</p>\n\
<div class=\'section\'><a id=\"サブディビジョン\"></a><h2 id=\"サブディビジョン\">サブディビジョン</h2></div>\n\
<p>ポリゴン シェイプのスムーズ メッシュ プレビュー(Smooth Mesh Preview)オプションは、オリジナルのジオメトリ データがリマッピングされる可能性があるもう一つの機会です。 レンダリング時に提供されるジオメトリには、新しいジオメトリのセットを生成するために適用されたスムージング アルゴリズムがあるため、既存の頂点のインデックスを処理するためだけでなく、対応する新しいインデックスとともに導入される新しい頂点を処理するためにも追加のロジックが必要です。</p>\n\
<p>次のセクションでは、OpenSubiv (OSD)または旧式の Catmull-Clark ロジックを使用する際の均一サブディビジョンのマッピング ロジック(ルール)について説明します。具体的には、頂点とフェースの<strong>巻上げ方向</strong>と新しい頂点の<strong>ローカル パラメトリック(UV)</strong>位置について扱います。ローカル パラメータ設定は、テクスチャ マップ検索の必要性に応じてテクスチャ座標にリマッピングできます。</p>\n\
<p>オリジナル ジオメトリは<strong>ベース</strong> ジオメトリと呼びます。たとえば、オリジナル フェースはベース フェースです。</p>\n\
<div class=\'section\'><a id=\"maya-の均一-opensubdiv-サブディビジョン\"></a><h3 id=\"maya-の均一-opensubdiv-サブディビジョン\">Maya の均一 OpenSubdiv サブディビジョン</h3></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_OSD_windingOrder.png\' title=\'\' /></div>\n\
<p>上の図は、ベース フェース(左のイメージ)と、1 レベルのサブディビジョンが適用されたときのサブディバイドされたフェースと頂点の開始点と巻上げ方向(中央と右のイメージ)を示しています。</p>\n\
<p>ベース レベルに近いレベルが、高いと見なされます。**サブディバイドされたフェースの順序は、このように高いレベルと一致して表示されます。開始フェースは、ベース フェースの開始頂点と揃った左下隅にあります。同様に、サブディバイドされたフェースの頂点も、左下隅から開始されます。巻上げ方向は常に反時計回りです。</p>\n\
<p>ローカル UV の原点がベース フェースの頂点 0 にあると仮定すると、サブディバイドされたフェースにある頂点のローカル UV を推定できます。</p>\n\
<p>ローカル パラメータ値を決定するためのサンプル コードを以下に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Get the UV of the bottom-left corner of the subdivided face.\n\
//\n\
// - subdFaceIndex, the index of subdivided face within a base face.\n\
// - subdLevel, the Catmull-Clark subdivision level \n\
//\n\
// such that: \n\
//\n\
// - subdLevel &gt;= 1 \n\
// - 0 &lt;= subdFaceIndex &lt;= 4^subdLevel\n\
// - the UV value is encoded as an integer within [0, 2^subdLevel].\n\
//\n\
getSubFaceUV(subdFaceIndex, subdLevel) \n\
{\n\
    uv = (0,0);\n\
\n\
    count = pow(4, subdLevel - 1);\n\
    ofs = pow(2, subdLevel - 1);\n\
\n\
    // Iteratively find the index of a parent face in each subdivision level,\n\
    // and offset the UV accordingly.\n\
    faceIndex = subdFaceIndex;\n\
    while (count &gt; 0) {        \n\
        start = faceIndex / count;\n\
        switch (start) {\n\
            case 0:                  break;\n\
            case 1: uv += (ofs,0);   break;\n\
            case 2: uv += (ofs,ofs); break;\n\
            case 3: uv += (0,ofs);   break;\n\
        }\n\
\n\
        faceIndex %= count;\n\
        ofs &gt;&gt;= 1;\n\
        count &gt;&gt;= 2;\n\
    }    \n\
    return uv;\n\
}\n\
\n\
// Get the UV of the vertex on the subdivided face.\n\
//\n\
// - subdFaceStartUV: the UV of the bottom-left corner of the subd face.\n\
// - subdVertexIndex: vertex index on the subdivided face, 0~3.\n\
//\n\
getSubVertexUV(subdFaceStartUV, subdVertexIndex) {\n\
    uv = (0,0);\n\
    switch (subdVertexIndex) {\n\
        case 0:              break;\n\
        case 1: uv += (1,0); break;\n\
        case 2: uv += (1,1); break;\n\
        case 3: uv += (0,1); break;    \n\
    }\n\
    return subdFaceStartUV + uv;\n\
}\n\
\n\
subdFaceStartUV = getSubFaceUV(subdFaceIndex, subdLevel);\n\
subdVertexUV = getSubVertexUV (subdFaceStartUV, subdVertexIndex);\n\
subdVertexUV /= pow(2, subdLevel);\n\
</pre></div><div class=\'section\'><a id=\"maya-の旧式の-catmull-clark-サブディビジョン\"></a><h3 id=\"maya-の旧式の-catmull-clark-サブディビジョン\">Maya の旧式の Catmull-Clark サブディビジョン</h3></div>\n\
<p>Maya の旧式のサブディビジョンのためのロジックは少し複雑です。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_Catmull_windingOrder.png\' title=\'\' /></div>\n\
<p>上の図は、ベース フェース(左)と、1 レベルのサブディビジョンが適用されたときのサブディバイドされたフェースと頂点の開始点と巻上げ方向(中央と右のイメージ)を示しています。サブディバイドされたフェースの開始点はベース フェースの 2 番目(インデックスが 1)の頂点と揃っていて、開始頂点はサブディバイドされたフェースの番号に基づいて移動し続けます。</p>\n\
<p>サンプル コードを以下に示します。OpenSubdiv アルゴリズムと異なるコードのセクションは、<strong>太字で強調表示</strong>されています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Get the UV of the bottom-left corner of the subdivided face.\n\
// \n\
// - subdFaceIndex, the index of subdivided face within a base face\n\
// - subdLevel, the Catmull-Clark subdivision level\n\
// \n\
// such that:\n\
//\n\
// - subdLevel &gt;= 1. \n\
// - 0 &lt;= subdFaceIndex &lt;= 4^subdLevel,\n\
// - the uv is encoded as integer within [0, 2^subdLevel].\n\
//\n\
getSubFaceUV(subdFaceIndex, subdLevel) {\n\
    uv = (0,0);    \n\
    start = 1;\n\
\n\
    count = pow(4, subdLevel - 1);\n\
    ofs = pow(2, subdLevel - 1);\n\
\n\
    // Iteratively find the index of parent face in each subdivision level,\n\
    // and offset the UV&#39;s accordingly.\n\
    faceIndex = subdFaceIndex;\n\
    while (count &gt; 0) {\n\
        // Unlike OSD subdivided topology, the start position of the child face \n\
        // is related to that of the parent face.\n\
        start = (start + faceIndex / count) % 4;\n\
        switch (start) {\n\
            case 0:                  break;\n\
            case 1: uv += (ofs,0);   break;\n\
            case 2: uv += (ofs,ofs); break;\n\
            case 3: uv += (0,ofs);   break;\n\
        }\n\
\n\
        faceIndex %= count;\n\
        ofs &gt;&gt;= 1;\n\
        count &gt;&gt;= 2;\n\
    }\n\
    // The start position of the face is also returned.\n\
    return (uv, start);\n\
}\n\
\n\
// Get the uv of the vertex on the subdivided face.\n\
//\n\
// - subdFaceStartUV, the UV of the bottom-left corner of the subdivided face.\n\
// - subdVertexIndex, vertex index on the subdivided face, 0~3.\n\
//\n\
getSubVertexUV(subFaceStartIndex, subFaceStartUV, subdVertexIndex) {\n\
    uv = (0,0);\n\
    // Unlike OSD subdivided topology, the start of the vertex relies on \n\
    // the start position of the face.\n\
    start = (subdFaceIndex - 1 + 4) % 4;\n\
    switch ((start + subdVertexIndex) % 4) {\n\
        case 0:              break;\n\
        case 1: uv += (1,0); break;\n\
        case 2: uv += (1,1); break;\n\
        case 3: uv += (0,1); break;    \n\
    }\n\
    return subFaceStartUV + uv;\n\
}\n\
\n\
(subdFaceStartUV, start) = getSubFaceUV(subdFaceIndex, subdLevel);\n\
subdVertexUV = getSubVertexUV(start, subdFaceStartUV, subdVertexIndex);\n\
subdVertexUV /= pow(2, subdLevel);\n\
</pre></div><div class=\'section\'><a id=\"データのリマッピング-インタフェース\"></a><h2 id=\"データのリマッピング-インタフェース\">データのリマッピング インタフェース</h2></div>\n\
<p>ビューポート 1 とビューポート 2.0 の両方で、適切なハードウェア シェーダ インタフェースを介して次のデータ バッファの要件を指定することで、リマッピングされたデータを取得できます。次のリマッピング データが現在使用できます。</p>\n\
<ul>\n\
<li><p>頂点 ID</p></li>\n\
<li><p>フェース ID</p></li>\n\
<li><p>フェース単位のローカル パラメータ設定</p></li>\n\
</ul>\n\
<p>描画時に先ほど説明したロジックを使用してリマッピングを計算する代わりに、このデータを直接使用できます。さらに、このデータはキャッシュされ、トポロジ操作がポリゴン シェイプに影響を与えるときにのみ必要に応じて更新されます。</p>\n\
<p>オブジェクトのジオメトリが表示用にスムーズされていない場合:</p>\n\
<ul>\n\
<li>オリジナル フェースの ID が昇順で返されます。</li>\n\
<li><p>オリジナルの頂点の ID がフェースごとに返されます。</p></li>\n\
<li><p>ローカル パラメータ設定がフェースごとの単位正方形まで縮退します。</p></li>\n\
</ul>\n\
<p>表示用のスムージングが有効になっている場合:</p>\n\
<ul>\n\
<li><p>ベース フェースの ID が返されます。順序はサブディバイドされたフェースごとに昇順です。</p></li>\n\
<li><p>サブディバイドされた頂点の ID が返されます。順序はサブディバイドされたフェースごとに昇順です。表示用に頂点が生成される可能性があるため、ベース メッシュの頂点と対応しない頂点 ID があります。必要に応じて、これらの頂点を <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_mesh.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnMesh</a></span> インタフェースを介して抽出されたスムーズ メッシュ ジオメトリの頂点 ID と一致させることができます。</p></li>\n\
<li><p>ローカル パラメータ設定はベース フェースの単位正方形に各頂点をマッピングします。順序はサブディバイドされたフェースごとに昇順です。</p></li>\n\
</ul>\n\
<p>VP2 バッファへの要求に共有されていないデータへの要求が含まれている限り、VP1 と VP2 に返されるデータ バッファのデータと順序は一貫しています。VP1 は常に共有されていないデータを返します。</p>\n\
<p>リマッピングのために追加データが必要な場合には、オブジェクト レベル(カラー セットなど)で頂点単位のストリームを追加することで行うことができます。</p>\n\
<div class=\'section\'><a id=\"ビューポート-1-mpxhwshadernode-アクセス\"></a><h3 id=\"ビューポート-1-mpxhwshadernode-アクセス\">ビューポート 1: MPxHwShaderNode アクセス</h3></div>\n\
<p>追加情報を要求するために、次の API メソッドを <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_hw_shader_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxHwShaderNode</a></span> から派生するクラスでオーバーライドできます。</p>\n\
<ul>\n\
<li>頂点 ID は次のメソッドのオーバーライドによって要求できます。</li>\n\
<li><span class=\'code\'>bool <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::provideVertexIDs()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#ac8569dc0556726f17320788563f034c6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_hw_shader_node.html#a8f7f3674c24e31185e58db1de5d02074&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxHwShaderNode::provideVertexIDs()</a></span></li>\n\
<li>フェース ID は次のメソッドのオーバーライドによって要求できます。</li>\n\
<li><span class=\'code\'>bool <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::provideFaceIDs()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#afa61effad561b9564e161fe930bd038c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxHwShaderNode::provideFaceIDs()</a></span></li>\n\
<li>ローカル パラメータ設定は次のメソッドのオーバーライドによって要求できます。</li>\n\
<li><span class=\'code\'>bool <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::provideLocalUVCoord()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#a276892ea9def000206de6522deccc137&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxHwShaderNode::provideLocalUVCoord()</a></span></li>\n\
</ul>\n\
<p>この情報は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::geometry()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#acd6773ef64b27965c09ed584830bf8f3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_hw_shader_node.html#af1baeed92db0ea0cbf886dba96bc3ded&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxHwShaderNode::geometry()</a></span> メソッドまたは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::glGeometry()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#a495a60eaa1df3815d5565e79e08c90ac&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_hw_shader_node.html#aaad4a5849a82c09fdd362affff51fcf4&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxHwShaderNode::glGeometry()</a></span> メソッドを介して CPU データ バッファとしてキャッシュされ、返されます。<span class=\'code\'>glGeometry()</span> の署名は次のとおりです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MStatus</a> <a href=\"javascript:void(0)\" data-symbol=\"MPxHwShaderNode::glGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_hw_shader_node.html#a495a60eaa1df3815d5565e79e08c90ac&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxHwShaderNode::glGeometry</a>( const <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath</a>&amp; shapePath,\n\
    int prim,\n\
    unsigned int writable,\n\
    int indexCount,\n\
    const unsigned int * indexArray,\n\
    int vertexCount,\n\
    const int * vertexIDs,\n\
    const float* vertexArray,\n\
    int normalCount,\n\
    floatArrayPtr normalArrays,\n\
    int colorCount,\n\
    floatArrayPtr colorArrays,\n\
    int texCoordCount,\n\
    floatArrayPtr texCoordArrays,\n\
    const int * faceIDs,\n\
    const float * localUVCoord)\n\
</pre></div><p>このデータを取得するためのサンプル コードが、<em>hwPhongShader</em> プラグイン サンプルにあります。<span class=\'code\'>glGeometry()</span> メソッドの実装のコード サンプルを以下に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Dump out vertexIDs\n\
if (vertexIDs)\n\
{\n\
    for (int i=0; i&lt;vertexCount; i++)\n\
    {\n\
        printf(&quot;%d\\n&quot;, vertexIDs[i]);\n\
    }\n\
}\n\
\n\
// Dump out face IDs\n\
if (faceIDs)\n\
{\n\
    for (int i=0; i&lt;vertexCount; i++)\n\
    {\n\
        printf(&quot;%d\\n&quot;, faceIDs[i]);\n\
    }\n\
}\n\
}\n\
\n\
// Dump out float pairs for the local parameterization (UV)\n\
if (localUVCoord)\n\
{\n\
    for (int i = 0; i &lt; vertexCount; i++)\n\
    {\n\
        printf(&quot;(%g, %g)\\n&quot;, localUVCoord[i*2], localUVCoord[i*2 + 1]);\n\
    }\n\
}\n\
</pre></div><div class=\'section\'><a id=\"ビューポート-2.0-mpxshaderoverride-のアクセス\"></a><h3 id=\"ビューポート-2.0-mpxshaderoverride-のアクセス\">ビューポート 2.0: MPxShaderOverride のアクセス</h3></div>\n\
<p>既定では、VP2 は完全に共有されていないデータを返しません。次を介してこの要件を指定するための新しいインタフェースが追加されています。</p>\n\
<ul>\n\
<li><span class=\'code\'>bool MPxShaderOverride::requiresUnsharedGeometricSteams()</span></li>\n\
</ul>\n\
<p>プラグインはこのメソッドをオーバーライドして、ジオメトリ ストリームの拡大を強制するために true を返すことができます。</p>\n\
<p>フェース ID、頂点 ID、またはローカル パラメータ設定を取得するために、(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxShaderOverride</a></span> の新しいインタフェースの代わりに)次の <em>セマンティック</em> が追加されています。</p>\n\
<ul>\n\
<li><p>vertexid: 設定すると頂点 ID バッファが返されます</p></li>\n\
<li><p>faceid: 設定するとフェース ID バッファが返されます</p></li>\n\
<li><p>localuvcoord: 設定するとローカル UV 座標バッファが返されます</p></li>\n\
</ul>\n\
<p><em>hwPhongShader</em> プラグイン サンプルの次のサンプル コードは、<span class=\'code\'>initialize()</span> メソッド内で 3 つの追加のストリームを指定します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Ask for vertex IDs\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> vertexIdDesc(\n\
    empty,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kTexture</a>,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
    1);\n\
vertexIdDesc.setSemanticName(&quot;vertexid&quot;);\n\
addGeometryRequirement(vertexIdDesc);\n\
\n\
// Ask for face IDs\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> faceIdDesc(\n\
    empty,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kTexture</a>,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
    1);\n\
faceIdDesc.setSemanticName(&quot;faceid&quot;);\n\
addGeometryRequirement(faceIdDesc);\n\
\n\
// Ask for local parameterization data\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> localUvCoordDesc(\n\
    empty,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kTexture</a>,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
    1);\n\
faceIdDesc.setSemanticName(&quot;localuvcoord&quot;);\n\
addGeometryRequirement(localUvCoordDesc);\n\
\n\
</pre></div><p>(同じプラグインの)サンプル抽出コードを以下に示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">for (int vbIdx=0; vbIdx&lt;geometry-&gt;vertexBufferCount(); vbIdx++)\n\
{\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBuffer</a>* vb = geometry-&gt;vertexBuffer(vbIdx);\n\
    if (!vb) continue;\n\
\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptor</a>&amp; desc = vb-&gt;descriptor();\n\
    if (desc.dimension() != 1) continue;\n\
\n\
    // Check if semantic is for the streams we’re looking for.\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MString</a> semanticName = desc.semanticName();\n\
\n\
    // Dump out local parameterization. Each pair of float values gives\n\
    // a local UV on the base face.\n\
    if (semanticName == &quot;localuvcoord&quot;)\n\
    {\n\
        // Cancel constness to map buffer and dump data.\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBuffer</a>* \n\
        nonConstVB = const_cast&lt;<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBuffer</a>*&gt;(vb);\n\
    \n\
        const float *ptr = (const float*)nonConstVB-&gt;map();\n\
        for (unsigned int k = 0; k &lt; vb-&gt;vertexCount(); k++)\n\
        {\n\
            printf(&quot;%s[%d] = (%g, %g)\\n&quot;, semanticName.asChar(), \n\
                k, ptr[2*k], ptr[2*k + 1]);\n\
        }\n\
        nonConstVB-&gt;unmap();\n\
    }\n\
\n\
    // Dump out vertex or face identifiers. If smoothed the vertex ids will be\n\
    // the smoothed ids, but the face ids are always the base face ids.\n\
    //\n\
    if (semanticName != &quot;vertexid&quot; &amp;&amp; semanticName != &quot;faceid&quot;) continue;\n\
\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBuffer</a>* nonConstVB = const_cast&lt;<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBuffer</a>*&gt;(vb);\n\
    const float *ptr = (const float*)nonConstVB-&gt;map();\n\
    for (unsigned int k=0; k&lt;vb-&gt;vertexCount(); k++)\n\
    {\n\
        printf(&quot;%s[%d] = %f\\n&quot;, semanticName.asChar(), k, ptr[k] );\n\
    }\n\
    nonConstVB-&gt;unmap();\n\
}\n\
</pre></div><div class=\'section\'><a id=\"ビューポート-2.0-mgeometryextractor-のアクセス\"></a><h3 id=\"ビューポート-2.0-mgeometryextractor-のアクセス\">ビューポート 2.0: MGeometryExtractor のアクセス</h3></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/New_Odd.png\' title=\'\' /></div>\n\
<p>ビューポート 2.0 では、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGeometryExtractor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MGeometryExtractor</a></span> インタフェースを介して頂点 ID、フェース ID、およびローカル パラメータ設定のアクセスも公開されます。完全に共有されていないジオメトリ データを DAG シェイプから抽出するには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGeometryExtractor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MGeometryExtractor</a></span> インスタンスを構築するときに <span class=\'code\'>kPolyGeom_NotSharing</span> を指定する必要があります。</p>\n\
<p>ここに <em>geometryReplicator</em> プラグインのサンプル コードを示します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MStatus</a> status;\n\
MHWRender::MPolyGeomOptions options = <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::kPolyGeom_Normal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_m_h_w_render.html#adc29c2ff13d900c2f185ee95427fb06ca6f4996143f966bf5534e8dae77fb015d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::kPolyGeom_Normal</a>;\n\
if (requiresUnsharedGeometricStreams(requirements))\n\
{\n\
    options = options | <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::kPolyGeom_NotSharing\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_m_h_w_render.html#adc29c2ff13d900c2f185ee95427fb06ca891eaab0dc4731ae402710120a0aa503&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::kPolyGeom_NotSharing</a>;\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometryExtractor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometryExtractor</a> extractor(requirements, fPath, options, &amp;status);\n\
</pre></div><p>次のコード スニペットは、<em>geometryReplicator</em> プラグインが、ジオメトリ要件に応じて、共有されていないデータを必要とするかどうかを決定する方法を示しています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">bool requiresUnsharedGeometricStreams(const <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometryRequirements\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_requirements.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometryRequirements</a>&amp; requirements)\n\
{\n\
    // Only when vertexid, faceid or localuvcoord is required do the unshared geometric\n\
    // streams need to be extracted\n\
    const <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptorList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptorList</a>&amp; descList = requirements.vertexRequirements();\n\
    for (int reqNum = 0; reqNum &lt; descList.length(); ++reqNum)\n\
    {\n\
        <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> desc;\n\
        if (descList.getDescriptor(reqNum, desc) &amp;&amp;\n\
            desc.semantic() == <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kTexture</a>)\n\
        {\n\
            const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MString</a> semanticName = desc.semanticName();\n\
            if (semanticName == &quot;vertexid&quot; ||\n\
                semanticName == &quot;faceid&quot; ||\n\
                semanticName == &quot;localuvcoord&quot;)\n\
            {\n\
                    return true;\n\
            }\n\
        }\n\
    }\n\
    return false;\n\
}\n\
</pre></div><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxShaderOverride</a></span> と同様、頂点 ID、フェース ID、およびローカル パラメータ設定を要求する <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGeometryExtractor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_geometry_extractor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MGeometryExtractor</a></span> に新しいインタフェースはありません。これらの頂点バッファを設定するには、次のセマンティック名を使用して <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MVertexBufferDescriptor</a></span> を指定する必要があります。</p>\n\
<ul>\n\
<li>“vertexid”: 設定すると頂点 ID バッファが返されます</li>\n\
<li>“faceid”: 設定するとフェース ID バッファが返されます</li>\n\
<li>“localuvcoord”: 設定するとローカル UV 座標バッファが返されます</li>\n\
</ul>\n\
<p>これらのセマンティック名は <em>geometryReplicator</em> プラグインでは直接指定されませんが、<em>geometryReplicator</em> ノードに <em>hwPhongShader</em> が割り当てられている場合、これらはジオメトリ要件に含まれます。次の例は、これらを明示的に指定する方法を示しています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Request vertex IDs (or face IDs, local parameterization)\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBufferDescriptor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer_descriptor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBufferDescriptor</a> vertexIdDesc(\n\
    empty,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a5a5b1d8320f94d3c3d142753f5527fc4a6de4261b95102b5402b425d62e1bda93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kTexture</a>,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MGeometry::kFloat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#ad8ed01ff3ff33333d8e19db4d2818bb6a5686197bafb177bdc82550848416a1ad&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MGeometry::kFloat</a>,\n\
    1);\n\
vertexIdDesc.setSemanticName(&quot;vertexid&quot;);\n\
\n\
// Create a vertex buffer via MGeometry interface, extract and fill the data.\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MVertexBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_vertex_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MVertexBuffer</a> vertexBuffer = geometry.createVertexBuffer(vertexIdDesc);\n\
unsigned int vertexCount = extractor.vertexCount();\n\
float* data = (float*)vertexBuffer-&gt;acquire(vertexCount, true);\n\
if (data &amp;&amp; extractor.populateVertexBuffer(data, vertexCount, vertexIdDesc))\n\
{\n\
    vertexBuffer-&gt;commit(data);\n\
}\n\
</pre></div><div class=\'section\'><a id=\"インデックス-バッファを介してデータにアクセスする\"></a><h3 id=\"インデックス-バッファを介してデータにアクセスする\">インデックス バッファを介してデータにアクセスする</h3></div>\n\
<p>レンダー時に提供されるインデックス バッファは、三角形ごとにデータ バッファにアクセスするために使用できます。</p>\n\
<p>VP1 には統合がなく、頂点は共有されていないため、3 つごとのインデックスがフェースの昇順で三角形の頂点 ID を参照します。</p>\n\
<p>VP2 の場合、統合を行うとインデックス バッファに部分的な範囲のセットが生成される場合があります。統合された各オブジェクトに使用されるデータを各範囲が示します。不明瞭なマッピングを回避するために、常に共有されていないデータを要求する必要があります。範囲の処理の詳細については、「<a href=\'#!/url=./dev_help/Viewport-2-0-API/Maya-Viewport-2-0-API-Guide/Plug-in-Entry-Points/Effect-Overrides.html#consolidation-considerations\' title=\'\'>統合に関する考慮事項</a>」を参照してください。</p>\n\
<p><em>hwPhongShader</em> プラグインには、VP1 と VP2 両方のためのインデックス情報を抽出する方法を示すサンプル コードが含まれています。VP2 用に、範囲処理サンプル デバッグ コードが提供されています。</p>\n\
<div class=\'section\'><a id=\"例-1-スムーズされていない四角形\"></a><h3 id=\"例-1-スムーズされていない四角形\">例 1: スムーズされていない四角形</h3></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_UnsmoothedQuad.png\' title=\'\' /></div>\n\
<p>行われるリマッピングを検討するために、追加データ バッファを抽出するための API を使用する <em>hwPhongShader</em> プラグインがサンプルに使用されています。この場合、上に示したようにそのシェーダのインスタンスが単一の四角形のシェイプに割り当てられます。ベース フェース ID と頂点 ID、開始頂点(ドット)、巻上げ方向(曲がった矢印)が表示されます。</p>\n\
<p>レンダー時のバッファは次のようになります。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">頂点 ID (反時計回りの巻上げ)</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">フェース ID</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">ローカル UV</em>\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0)\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<div class=\'section\'><a id=\"例-2-スムーズ-レベル-1-の四角形---opensubdiv-catmull-clark\"></a><h3 id=\"例-2-スムーズ-レベル-1-の四角形---opensubdiv-catmull-clark\">例 2: スムーズ レベル 1 の四角形 - OpenSubdiv Catmull-Clark</h3></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_SmoothedLevel1Quad_OpenSubd.png\' title=\'\' /></div>\n\
<p>上に示したトポロジは、OpenSubdiv を使用した 1 レベルのスムージングを示しています。サブフェースとサブ頂点ごとの開始点と巻上げ方向は、すべてのレベルとベース フェースで一貫しています。</p>\n\
<p>データ バッファは次のようになります。次の点に注意してください。</p>\n\
<ul>\n\
<li><p>上記のトポロジとの相関関係を示すためにサブフェース ID 列が追加されていますが、個別の頂点バッファとしては提供されていません。</p></li>\n\
<li><p>頂点 ID 6 ～ 8 は、ベース メッシュの一部ではありません。</p></li>\n\
</ul>\n\
<p>頂点 ID 4、5、6、7、8 は、スムージングの一部として導入された頂点です。ベース メッシュには頂点 0、1、2、3 があります。点線はスムージング操作によって行われたサブディビジョンの位置を示します。</p>\n\
<ul>\n\
<li><strong>ローカル パラメータ設定は、単にベース頂点に関連した補間を示すために値を提供しています</strong>。ベース フェース内の頂点の実際の配置とは関係ありません。たとえば、次のジオメトリのように頂点 8 が実際には頂点 0 の近くに配置されている場合も、ローカル UV 値は(0.5,0.5)になります。</li>\n\
</ul>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_SmoothedLevel1Quad_OpenSubd2.png\' title=\'\' /></div>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">頂点 ID (反時計回り)</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">フェース ID</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">サブフェース ID</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">ローカル UV</em>\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0)\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p>提供されたインデックス バッファは三角形ごとの情報へのアクセスに使用できます。</p>\n\
<p>前述のとおり、三角形分割がポリゴン シェイプの <span class=\'code\'>quadSpit</span> アトリビュートに指定された値と一致しない場合があります。次の三角形分割が与えられた場合、</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_SmoothedLevel1Quad_Triangulation.png\' title=\'\' /></div>\n\
<p>インデックス バッファは次のようになります。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">三角形の番号</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">頂点 ID</em>\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<div class=\'section\'><a id=\"例-3-スムーズ-レベル-1-の四角形---旧式の-catmull-clark\"></a><h3 id=\"例-3-スムーズ-レベル-1-の四角形---旧式の-catmull-clark\">例 3: スムーズ レベル 1 の四角形 - 旧式の Catmull-Clark</h3></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_SmoothedLevel1Quad_LegacyCatmull.png\' title=\'\' /></div>\n\
<p>上記のトポロジは、旧式の Catmull-Clark サブディビジョン メソッドを使用したレベル 1 のスムージングを示しています。サブフェースとサブ頂点の開始点の移動が確認できます。</p>\n\
<p>データ バッファは次のようになります。例 2 のように、上記のトポロジとの相関関係を示すためにサブフェース ID 列が追加されていますが、バッファとしては提供されていません。</p>\n\
<p>サブフェースとサブ頂点の開始位置の移動は、図に示された内容を反映しています。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">頂点 ID (反時計回り)</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">フェース ID</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">サブフェース ID</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">ローカル UV</em>\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p>開始フェースと開始頂点が異なるという事実に基づいて、旧式の Catmull-Clark は、OpenSubdiv Catmull-Clark とは異なるインデックスを使用しています。そのため、同じ例を使用すると、三角形分割は次のようになります。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_SmoothedLevel1Quad_LegacyCatmull_Triangulate.png\' title=\'\' /></div>\n\
<p>インデックスは次のようになります。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">三角形の番号</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">頂点 ID</em>\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<div class=\'section\'><a id=\"例-4-スムーズ-レベル-2-の四角形---旧式の-catmull-clark\"></a><h3 id=\"例-4-スムーズ-レベル-2-の四角形---旧式の-catmull-clark\">例 4: スムーズ レベル 2 の四角形 - 旧式の Catmull-Clark</h3></div>\n\
<p>次のイメージは、旧式の Catmull-Clark メソッドを使用したレベル 2 のサブディビジョンと、サブディビジョン パターンの繰り返しを示しています。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/GeomRemap_SmoothedLevel2Quad_LegacyCatmull.png\' title=\'\' /></div>\n\
<p><em>hwPhongShader</em> プラグインから次のデータがトレースされます。</p>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-heading\">\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">頂点 ID (反時計回り)</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">フェース ID</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">サブフェース ID</em>\n\
</th>\n\
<th class=\"table-heading\">\n\
<em class=\"strong\">ローカル UV</em>\n\
</th>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
10\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
13\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
21\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
13\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
18\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
21\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
1\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
18\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
17\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
21\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
17\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
10\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
21\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
14\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
3\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
16\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
22\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
16\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
19\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
22\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
19\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
18\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
22\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
18\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
6\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
14\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 1)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
22\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.75)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
15\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
2\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
12\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
23\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
12\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
9\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
9\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
20\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
9\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
23\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
9\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
20\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
10\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
10\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
19\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
10\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
23\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
10\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
19\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
11\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
7\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
11\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
15\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
11\n\
</td>\n\
<td class=\"table-body\">\n\
(1, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
23\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
11\n\
</td>\n\
<td class=\"table-body\">\n\
(0.75, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
11\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
12\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
12\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
9\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
12\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
24\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
12\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
9\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
13\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
4\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
13\n\
</td>\n\
<td class=\"table-body\">\n\
(0, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
17\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
13\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
24\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
13\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
17\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
14\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
8\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
14\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.5)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
20\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
14\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
24\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
14\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
20\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
15\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0.25)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
5\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
15\n\
</td>\n\
<td class=\"table-body\">\n\
(0.5, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
11\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
15\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
24\n\
</td>\n\
<td class=\"table-body\">\n\
0\n\
</td>\n\
<td class=\"table-body\">\n\
15\n\
</td>\n\
<td class=\"table-body\">\n\
(0.25, 0.25)\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";