var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>イメージ ベースド ライティング</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>イメージ ベースド ライティング</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"イメージ-ベースド-ライティング\"></a></div>\n\
<div class=\'section\'><a id=\"プラグイン-ノードをイメージ-ライトとして分類する\"></a><h2 id=\"プラグイン-ノードをイメージ-ライトとして分類する\">プラグイン ノードをイメージ ライトとして分類する</h2></div>\n\
<p>プラグイン ノードを登録する際、ルートとともに分類を指定することにより、環境に対する内部ハードウェア ライティング評価の使用を選択することが可能です。これにより、プラグイン ノードが Maya の内部 IBL (イメージ)ライトのように動作することが可能になります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">/drawdb/light/image\n\
</pre></div><p>たとえば、次のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">/drawdb/light/image/environment\n\
</pre></div><p>指定された場合は、既定の 3D UI 描画実装が使用されます。明示的なオーバーライド分類が指定された場合は、描画にそのオーバーライドが使用されます。</p>\n\
<p>複数のノードがイメージ分類を使用する場合、最初のノードのみが内部ライティングに影響するものとして考慮されます。</p>\n\
<p>Arnold for Maya プラグインの aiSkyDomeLight ライトはこの分類を使用します。したがって、環境ライティングをサポートします。</p>\n\
<div class=\'section\'><a id=\"評価\"></a><h2 id=\"評価\">評価</h2></div>\n\
<p>現在、内部ハードウェア ライティング評価は、Maya のノードに定義されている場合に、次のアトリビュートをサポートします。</p>\n\
<ul>\n\
<li>color: 3 つの float 型のカラー アトリビュート。<strong>このアトリビュートは必ず定義されている必要があります</strong>。定義されない場合、ノードが黒で表示されてしまいます。 ファイル テクスチャ ノードがこのアトリビュートに接続された場合、入力環境マップとしてディスク イメージが使用されます。他のすべての上流ネットワーク環境設定はベイク処理され、入力イメージとして使用されます。上流ネットワークが存在しない場合は、アトリビュート カラーが入力イメージとして使用されます。入力イメージは緯度/経度形式であると仮定されます。</li>\n\
<li>envRotationY: 既定では、ルックアップのために入力イメージは Y 軸に 180 度回転されます。ノードにこのアトリビュートが存在する場合、そのノードは異なるユーザ定義の値に設定できます。</li>\n\
<li>sampling: 必要に応じて、上流ネットワークのベイク処理を実行するための解像度を指定します。1 から 4 の値を指定することにより、それに対応してイメージのサイズが変化します。</li>\n\
<li>intensity または exposure: マップのルックアップ中に使用されるカラー ゲインの計算に使用されます。</li>\n\
</ul>\n\
<p>カラー入力を指定すると、シェーダで使用する<strong>放射環境マップ</strong>と<strong>スペキュラ環境マップ</strong>という 2 つのマップが内部的に生成されます。</p>\n\
<p>スペキュラ マップは、異なるレベルの鏡面性のサンプルが含まれた Z スライスを持つ 3D マップです。</p>\n\
<p>以下に例を示します。これらのイメージは 8 レベルのサンプリングで生成された 3D マップを表現しています。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/IBL_IrradiancePower.png\' title=\'\' /></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/IBL_SpecPower.png\' title=\'\' /></div>\n\
<p>このイメージは、生成された放射 2D テクスチャを表現しています。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/IBL_Irradiance_inputmap.png\' title=\'\' /></div>\n\
<p>このイメージは、入力環境テクスチャを表現しています。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/IBL_hdmi_inputmap.png\' title=\'\' /></div>\n\
<p>このイメージは、イメージ ライトとして分類されるプラグイン ノードで指定されているように、サンプルの環境マップを使用して Blinn シェーダを表現しています。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/IBL_blinn_materialViewer.png\' title=\'\' /></div>\n\
<div class=\'section\'><a id=\"api-アクセス\"></a><h2 id=\"api-アクセス\">API アクセス</h2></div>\n\
<p>シェーダ フラグメントを作成するとき、次の名前を使用して入力シェーダ プロパティを指定することにより、環境データに暗黙的にアクセスできます。</p>\n\
<ul>\n\
<li>IrradianceEnv: この値は、放射マップの入力値から計算されます。</li>\n\
<li>SpecularEnv: この値は、スペキュラ環境の入力値から計算されます。</li>\n\
</ul>\n\
<p>たとえば、最終カラーを計算するために IrradianceEnv と SpecularEnv を取得するコンバイナは次の通りです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;fragment uiName=&quot;myShaderCombiner&quot; name=&quot;myShaderCombiner&quot; type=&quot;plumbing&quot; class=&quot;ShadeFragment&quot; version=&quot;1.0&quot; feature_level=&quot;0&quot;&gt;\n\
    &lt;description&gt;&lt;![CDATA[Combines inputs from shader fragments.]]&gt;&lt;/description&gt;\n\
    &lt;properties&gt;\n\
        &lt;float3 name=&quot;color&quot; /&gt;\n\
        &lt;float3 name=&quot;specularColor&quot; /&gt;\n\
        &lt;float name=&quot;Ks&quot; /&gt;\n\
        &lt;float name=&quot;Kd&quot; /&gt;\n\
        &lt;float3 name=&quot;IrradianceEnv&quot; /&gt;\n\
        &lt;float3 name=&quot;SpecularEnv&quot; /&gt;\n\
    &lt;/properties&gt;\n\
    &lt;values&gt;\n\
        &lt;float3 name=&quot;color&quot; value=&quot;1.0 1.0 1.0&quot; /&gt;\n\
        &lt;float3 name=&quot;specularColor&quot; value=&quot;0.0 0.0 0.0&quot; /&gt;\n\
        &lt;float name=&quot;Ks&quot; value=”0.2”/&gt;\n\
        &lt;float name=&quot;Kd&quot; value=“0.8”/&gt;\n\
        &lt;float3 name=&quot;IrradianceEnv&quot; value=&quot;0.0 0.0 0.0&quot; /&gt;\n\
        &lt;float3 name=&quot;SpecularEnv&quot; value=&quot;0.0 0.0 0.0&quot; /&gt;\n\
    &lt;/values&gt;\n\
    &lt;outputs&gt;\n\
        &lt;struct name=&quot;myShaderCombiner&quot; struct_name=&quot;mayaSurfaceShaderOutput&quot; /&gt;\n\
    &lt;/outputs&gt;\n\
    &lt;implementation&gt;\n\
        // Sample implementation using environment inputs\n\
        &lt;implementation render=&quot;OGSRenderer&quot; language=&quot;Cg&quot; lang_version=&quot;2.1&quot;&gt;\n\
            &lt;function_name val=&quot;myShaderCombiner&quot; /&gt;\n\
            &lt;source&gt;\n\
                &lt;![CDATA[\n\
                mayaSurfaceShaderOutput myShaderCombiner(\n\
                float3 color,\n\
                float3 specularColor,\n\
                float Ks,\n\
                float Kd,\n\
                float3 IrradianceEnv,\n\
                float3 SpecularEnv)\n\
{\n\
    mayaSurfaceShaderOutput result;\n\
    float3 diffuse = color * IrradianceEnv * Kd;\n\
    float3 specular = specularColor * SpecularEnv * Ks;\n\
\n\
    result.outColor = diffuse + specular;\n\
    result.outTransparency = float3(0.0f, 0.0f, 0.0f);\n\
    result.outGlowColor = float3(0.0f, 0.0f, 0.0f);\n\
    result.outMatteOpacity = float3(-1.0e+06f, -1.0e+06f, -1.0e+06f);\n\
    result.outSurfaceFinal = float4(result.outColor, 1.0f);\n\
    return result;\n\
}\n\
</pre></div><p>Maya のシーンにイメージ ベースのライトが存在する場合は、ビューポートとバッチ レンダリングに対して暗黙的バインドが実行されます。ハードウェア レンダラが選択されている場合は、ハイパーシェード(Hypershade)内のマテリアル ビューア(Material Viewer)に対して暗黙的環境ライティングのバインドが実行されます。 ハードウェア スウォッチ レンダリングはどの環境ライティングもバインドしません。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDrawContext::getInternalTexture()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_draw_context.html#ae73c53b8f05ae3a36dfb3716a7b67f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDrawContext::getInternalTexture()</a></span> インタフェースの <span class=\'code\'>kIrradianceEnvironment</span> と <span class=\'code\'>kSpecularEnvironment</span> の enum により、内部放射とスペキュラ環境マップに対する暗黙的アクセスが許可されます。</p>\n\
<p>テクスチャは、描画コンテキストが使用可能なときにアクティブな最初のイメージ ライトに対して使用できます。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";