var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>リソース ハンドルとデバイス ハンドルにアクセスする</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>リソース ハンドルとデバイス ハンドルにアクセスする</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"リソース-ハンドルとデバイス-ハンドルにアクセスする\"></a></div>\n\
<p>デバイスまたは描画 API に固有のコードを書くことは推奨されませんが、デバイス固有の情報が必要なときにアクセスする必要がある場合があります。この例は、プラグインが GPU の計算を使用していくつかの操作を実行する場合です。</p>\n\
<p>描画 API 固有の情報は、リソースへのハンドルにアクセスすることによって取得できます。ハンドルには、次のレベルでアクセスすることができます。</p>\n\
<ul>\n\
<li><strong>デバイス</strong>: DirectX 11 の場合、フレームワークによって使用される D3D デバイスへのリファレンスを返すことができます。OpenGL の場合、これは、プラグインによって作成されたコンテキストで共有するために使用できる OpenGL コンテキストです。Windows での API 共有は一方向なので、共有先が既存のフレームワークのコンテキストになることはありません。さもなければ、フレームワークのすべてのリソースが破壊されます。</li>\n\
<li><strong>テクスチャ</strong>(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_texture.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MTexture</a></span>): DirectX 11 のシェーダ リソース ビューへのポインタ リファレンスまたは OpenGL のテクスチャ識別子が返されます。</li>\n\
<li><strong>ターゲット</strong>(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderTarget\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_target.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MRenderTarget</a></span>): DirectX のレンダー ターゲット ビューまたは深度ステンシル ビュー(ターゲット タイプに応じる)へのポインタ リファレンスとして公開されます。OpenGL の場合、テクスチャ ID へのポインタとして返されます。</li>\n\
<li><strong>頂点およびインデックス バッファ</strong>: DirectX 11 の場合、バッファへのポインタ リファレンスが返されます。OpenGL の場合、バッファ ID へのポインタ リファレンスが返されます。</li>\n\
<li><strong>状態オブジェクト</strong>:</li>\n\
<li><strong>ブレンドの状態</strong>: DirectX の場合、Direct3D 状態オブジェクトへのポインタが返されます。</li>\n\
<li><strong>ラスタライザの状態</strong>: DirectX の場合、Direct3D 状態オブジェクトへのポインタが返されます。</li>\n\
<li><strong>深度ステンシルの状態</strong>: DirectX の場合、Direct3D 状態オブジェクトへのポインタが返されます。</li>\n\
<li><strong>サンプラの状態</strong>: DirectX の場合、Direct3D 状態オブジェクトへのポインタが返されます。</li>\n\
<li>OpenGL では、状態オブジェクトに相当するものがありません。したがって、状態にアクセスするには、各状態タイプの説明を使用する必要があります。内部フレームワークが変更を追跡できないので、API 状態オブジェクトを使用せずに状態を設定することは推奨されません。</li>\n\
</ul>\n\
<p>お勧めの方法は、プラグインで、API を介して必要なすべてのリソースを作成し、適切な GPU リファレンスを抽出することです。</p>\n\
<p>プラグインが API ラッパーへのリファレンスを保持している限り、このリファレンスが存在し、非表示になることはありません。リソース管理処理のためにハンドルが変更された場合に備えて、ハンドルを再度照会することをお勧めします。リソース ハンドルを単一のフレーム レンダー内で変更することはできません。</p>\n\
<p>GPU 上に直接作成される(API を介さずに)リソースの管理は、プラグイン作成者の責任です。また、このデータを使用して、エクスポーズされた API ラッパー コンストラクトを介してリソースを作成することはできません。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxShaderOverride</a></span> は、一般的に GPU データにアクセスするためのインタフェースです。CgFX および dx11Shader SDK プラグインは、パラメータをシェーダにバインドするために、または描画のジオメトリをバンドするために、未処理データにアクセスする方法の例を示しています。さらに、プラグインには、GPU コンテキストにアクセスして、内部フレームワークによって追跡されていないリソースを作成するコードが含まれます。</p>\n\
<p>DirectCompute の例</p>\n\
<p>GPU の計算を使用して、手続き的に生成されたジオメトリをサポートすることができます。これを設定するには、関連付けられた描画オーバーライド(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxDrawOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_draw_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxDrawOverride</a></span>)とともにカスタム DAG ノード(たとえば、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxLocatorNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_locator_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m_px_locator_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MPxLocatorNode</a></span>)を追加するプラグインを作成します。オーバーライドの描画ルーチンでは、DirectX 11 デバイスが照会されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Get the device and context\n\
ID3D11Device* dxDevice = NULL;\n\
ID3D11DeviceContext* dxContext = NULL;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MRenderer</a>* theRenderer = <a href=\"javascript:void(0)\" data-symbol=\"MHWRender::MRenderer::theRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_renderer.html#a4678a72ac6959ed21d422d27928d0343&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::MRenderer::theRenderer</a>();\n\
if (theRenderer-&gt;drawAPI() == MHWRender::DrawAPI::kDirectX11)\n\
{\n\
    // init device\n\
    ID3D11Device* dxDevice = (ID3D11Device*)theRenderer-&gt;GPUDeviceHandle();\n\
    if (!dxDevice) return;\n\
\n\
    // get context\n\
    dxDevice-&gt;GetImmediateContext(&amp;dxContext);\n\
    if (!dxContext) return;\n\
}\n\
\n\
</pre></div><p>この情報を抽出したら、計算シェーダを使用してテクスチャを塗り潰します。次に、このテクスチャはピクセル シェーダによって使用され、ジオメトリがレンダリングされます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// Load in a compute shader\n\
<a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MString</a> shaderPath(&quot;myComputeShader.hlsl&quot;);\n\
ID3D11ComputeShader* aComputeShader = NULL;\n\
\n\
ID3D10Blob* pPSBuf = NULL;  \n\
HRESULT hr = D3DX11CompileFromFile( shaderPath.asChar(), NULL, NULL, &quot;AComputeShader&quot;, &quot;cs_5_0&quot;,    dwShaderFlags, NULL, NULL, &amp;pPSBuf, NULL, NULL );\n\
hr = dxDevice-&gt;CreateComputeShader( ( DWORD* )pPSBuf-&gt;GetBufferPointer(), pPSBuf-&gt;GetBufferSize(), NULL, &amp;aComputeShader );\n\
pPSBuf-&gt;Release();\n\
\n\
// The “resource” to update. Filled by the compute shader(s), and\n\
// rendered by the pixel shader.\n\
ID3D11ShaderResourceView*  shaderResourceView; // Pixel shader view\n\
ID3D11UnorderedAccessView* computeResourceView; // Compute shader view\n\
Resource pRenderOutput;\n\
ID3D11Texture2D* outputTexture = NULL;\n\
\n\
// Create a 2D texture to write into\n\
D3D11_TEXTURE2D_DESC tdesc;\n\
tdesc.Width = g_width;\n\
tdesc.Height = g_height;\n\
tdesc.MipLevels = 1;\n\
tdesc.ArraySize = 1;\n\
tdesc.SampleDesc.Count = 1;\n\
tdesc.SampleDesc.Quality = 0;\n\
tdesc.Usage = D3D11_USAGE_DEFAULT;\n\
tdesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;\n\
tdesc.BindFlags = D3D11_BIND_SHADER_RESOURCE | D3D11_BIND_UNORDERED_ACCESS;\n\
tdesc.CPUAccessFlags = 0;\n\
tdesc.MiscFlags = 0;\n\
        \n\
hr = dxDevice-&gt;CreateTexture2D(&amp;tdesc, NULL, &amp;outputTexture);\n\
\n\
// Create an unordered access view to the texture which a compute shader \n\
// can write into.\n\
dxDevice-&gt;CreateUnorderedAccessView( outputTexture, NULL, &amp;computeResourceView);\n\
// Create a resource view to the texture that will be used by a pixel shader \n\
dxDevice-&gt;CreateShaderResourceView(  outputTexture, NULL, &amp;shaderResourceView);\n\
\n\
// Set inputs\n\
dxContext-&gt;CSSetShaderResources( 0, 1, shaderResourceView);\n\
// Set outputs\n\
dxContext-&gt;CSSetUnorderedAccessViews(0, 1, computeResourceView, (UINT*)(&amp;computeResourceView));\n\
\n\
// Set the compute shader\n\
dxContext-&gt;CSSetShader(aComputeShader, NULL, 0 );\n\
// Run the compute shader with 32 x 32 groups (e.g.)\n\
dxContext-&gt;Dispatch( 32, 32, 1 );\n\
\n\
//...\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";