var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>複数の描画 API</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>複数の描画 API</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"複数の描画-api\"></a></div>\n\
<p>API は、ほとんどの場合は依存しない描画 API で表されます。描画 API に固有のエントリ ポイントに対するプラグインを記述している場合は、それが使用される API を返す必要があります。<span class=\'code\'>supportedDrawAPIs()</span> インタフェースは、関連するすべてのエントリ ポイントに用意されています。</p>\n\
<p>返されたデバイス API に、ビューポート 2.0 が実行されている現在のデバイス API が含まれていない場合(たとえば、VP2 が OpenGL コア プロファイル モードで実行されているにもかかわらず、<span class=\'code\'>supportedDrawAPIs()</span> が <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MHWRender::kOpenGLCoreProfile\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_m_h_w_render.html#ad970d5c990d4803d0e9d73c1ff4fda49aaebf48c70b63878eff38483392f19fb7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MHWRender::kOpenGLCoreProfile</a></span> を返さない場合)は、次のような警告が表示されます。</p>\n\
<p><span class=\'code\'>Error: line 0: Failed to create evaluator for &quot;drawdb/geometry/apiMesh&quot; classification because the current drawing API isn&#39;t supported.</span></p>\n\
<p>従属描画 API ライブラリまたはインタフェースの設定は、プラグインで行う必要があります。サポートされる各描画 API のライブラリの特定のバージョンに、SDK が用意されています。現在の依存ライブラリは、CgFX、DirectX 11、コンパイル済みの DX11 エフェクト ランタイム ライブラリです。DirectX SDK にはソース コードが付属しているので、コンパイル済み DX11 エフェクト ライブラリは、プラグイン作成者が再コンパイルし、独自のプラグインに明示的にリンクできます。現在のライブラリのバージョンは、出荷リソース ノートの一部として表示されます。</p>\n\
<p>重要な描画 API の注意事項を次に示します。これの制限は描画 API ライブラリによるものではなく、Maya API での制限です。</p>\n\
<ul>\n\
<li>提供されているテクスチャまたはターゲット マネージャを使用するとき、描画 API によっては使用できない形式があります。各 API に付属する外部公開されたドキュメンテーションを参照してください。</li>\n\
<li>テクスチャ マネージャからアクセスするテクスチャは、左上コーナーを原点として使用します。必要に応じて垂直反転を実行するには、シェーダを適切なテクスチャ座標で記述する必要があります。</li>\n\
<li>立方体マップ テクスチャ面の方向は、描画 API に固有です。</li>\n\
<li>シェーダ マネージャによって提供されるストック シェーダは、シェーディング言語間の細かな違いを隠ぺいします。ストック シェーダを使用しない場合、プラグイン作成者はそのシェーディング言語に固有のコードを記述する必要があります。たとえば、Cg と HLSL におけるベクトル/行列乗算の相違点の処理などです。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFragmentManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_fragment_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_fragment_manager.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFragmentManager</a></span> で登録されるユーザ作成のシェーダ フラグメントでは、OpenGL (Cg)と DirectX (HLSL)の両方に対する実装を定義する必要はありません。ただし、両方の実装が定義されている場合は、作成者が 2 つの間の違いを処理する必要があります(テクスチャのアクセスまたはマトリックス計算など)。場合によっては、フラグメントを使用するクラスで現在アクティブなデバイスの正しいフラグメントを選択し、完全に異なるフラグメントを作成する必要があります。</li>\n\
<li><span class=\'code\'>MPxShaderNode</span> によって指定される一部のジオメトリ要件が満たされないことがよくあります。その場合、プラグインでこの状況を処理する必要があります。特に、DirectX は OpenGL より頂点ストリーム不一致に対する許容度がどの程度小さいかに注意してください。</li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";