var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>プラグイン エントリ ポイント</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>プラグイン エントリ ポイント</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"プラグイン-エントリ-ポイント\"></a></div>\n\
<p>レンダリング フレームワークおよび API で公開される基本構造について基本的に理解できたものとして、このドキュメントの残りではレンダリング パイプラインで公開されるエントリ ポイントについて説明します。</p>\n\
<p>現在は、次の目的で使用する 6 つのメイン エントリ ポイントがあります。</p>\n\
<ol>\n\
<li><strong>ジオメトリ オーバーライド</strong>: プラグイン DAG オブジェクトの描画に使用するカスタム ジオメトリック データ ストリームを、プラグインで定義できるようにします。</li>\n\
<li><strong>シェーダ オーバーライド</strong>: カスタム シェーディングを実行できるようにします。従来のハードウェア シェーダ プラグイン インタフェースとほぼ同等の機能を提供します。</li>\n\
<li><strong>シェーディング ノード オーバーライド</strong>: ビューポートでのソフトウェア シェーディング ノードの描画で使用するためのハードウェア シェーダ フラグメントをプラグインで定義できるようにします。</li>\n\
<li><strong>描画オーバーライド</strong>: プラグイン DAG オブジェクトのすべての描画を完全にコントロールできるようにします。このレベルのコントロールは、従来のプラグイン ロケータまたはプラグイン シェイプの描画と似ています。これは描画のオーバーライドだけです。</li>\n\
<li><strong>サブシーン オーバーライド</strong>: 単一の DAG オブジェクトを描画するために必要な多数のレンダー項目を、プラグインで効率よく定義できるようにします。</li>\n\
<li><strong>レンダリング ループ オーバーライド</strong>: カスタム レンダリング ループを作成できるようにします。これは、内部レンダリング ループをオーバーライドします。これは、マルチパス レンダリングを実行する、よりフォーマライズされた方法です。</li>\n\
</ol>\n\
<p>次の図は、これらのエントリ ポイントが存在する場所の概要です。これは詳細な説明ではなく、エントリ ポイントが存在するパイプライン内のフェーズを示したものです。ただし、レンダリング ループ オーバーライドは例外であり、これはパイプラインを使用またはリファインするものです。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f8cbf.jpg\' title=\'\' /></div>\n\
<p>図 34: ジオメトリ オーバーライドは、パイプラインを下方に送られるようにレンダー項目を更新するジオメトリ プロバイダとして機能するので、パイプラインの更新フェーズで相互作用します。シェーダ オーバーライドと描画オーバーライドは、パイプラインの描画フェーズで相互作用して、アイテムの描画方法をコントロールします。図をわかりやすくするために、サブシーン オーバーライドとシェーディング ノード オーバーライドは示されていません。ただし、どちらのオーバーライドも更新フェーズの間に相互作用します。</p>\n\
<p><strong>アタッチ</strong>という言葉の意味に注意してください。これらのエントリ ポイントは、新しいノード タイプを導入するのとは対照的に、既存のノードに新しい機能を追加またはアタッチすることによって、できるだけ影響が小さくなるように意図されています。主なアタッチメント ポイントは、プラグイン DAG オブジェクト、プラグイン シェーディング ノード、およびレンダラに対するものです。最後のレンダラは、特定のレンダラ オブジェクトではなく、「レンダラ」という概念を指します。</p>\n\
<p>このフレームワークでは、プラグインは、他のエントリ ポイントの他のプラグインに依存することなく、任意のエントリ ポイントにアタッチできます。ただし、1 つまたは複数のエントリ ポイントにプラグインがアタッチされている場合、それらは古いインタフェースより密接に連携して動作します。たとえば、古い API プラグインでは、プラグイン ジオメトリ メカニズム(ジオメトリ オーバーライドに相当)とプラグイン シェーダ メカニズム(シェーダ オーバーライドに相当)は、一緒には動作しません。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";