var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>レンダリング フレームワーク</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>レンダリング フレームワーク</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"レンダリング-フレームワーク\"></a></div>\n\
<p>プラグイン インタフェースと Maya との相互作用を理解するためには、リファレンスのフレームが提供される必要があります。ここでは、現在のハードウェア レンダラのレンダリング フレームワークの概要を説明します。また、「古い」レンダリング ロジックと「新しい」レンダリング ロジックの違いと類似点についても説明します。</p>\n\
<p>現在は役割が明確に分離され、基になるハードウェア レンダリング フレームワークが存在します。古いシステムでは、レンダリングは主に DAG オブジェクトが行っていましたが、現在はレンダラが行います。</p>\n\
<p>まず、レンダリングに使用されるデータと、Maya のコンストラクトを表すために使用されるデータが区別されます。Maya は DAG オブジェクトを管理しますが、レンダリング フレームワークは Maya DAG オブジェクトのインスタンスを追跡する別のデータベースを管理します。このデータベースは、<strong>レンダリング可能オブジェクト</strong>を呼び出すコンストラクトで構成されます。一般に、レンダリング可能オブジェクトと DAG インスタンス間には 1 対 1 の関係があることがほとんどです。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f41f1.jpg\' title=\'\' /></div>\n\
<p>図 1: 左に示されているのが階層における DAG オブジェクト セットの例です。結果は 2 つの Maya DAG オブジェクト インスタンスに対して 2 つのレンダリング可能オブジェクトが存在します。</p>\n\
<p>Maya コンストラクトとレンダリング データベースとの間の<strong>同期</strong>は、「ダーティ」、つまりノードごとまたは DAG オブジェクトごとに、該当するすべての変更を追跡する変更管理メカニズムで実行されます。このメカニズムは、クライアントの任意のセットに変更をブロードキャストする必要があった前のメカニズムとは異なります。</p>\n\
<p>古いモデルと異なり、データの<strong>更新</strong>は同期によって制御されません。実際、更新により同期を行うことはできなくなりました。更新により同期が行われると、再帰的な更新になるからです。同期は常にアクティブに実行されますが、更新はレンダラが必要な場合にオンデマンドで実行されます。新しいフレームワークでは、レンダリング要求はコマンド ラインを介して非インタラクティブに起動することも、インタラクティブな(ビューポート)レンダリングに使用される既存の待機リフレッシュ メカニズムを使用して起動することもできます。注目すべき大きな違いは、非インタラクティブな要求は常に満たされますが、インタラクティブな要求は、リフレッシュが実行されるかどうかによって満たされない場合もあるという点です。</p>\n\
<p>レンダリング要求を満たすには、一種のレンダリング ループ ロジックを実行する必要があります。このレンダリング ループは、さまざまな「フェーズ」を持つパイプラインとして表示できます。分かりやすくするため、次の使い慣れたフェーズから始めます。</p>\n\
<ol>\n\
<li>「レンダリング可能オブジェクト」のオブジェクト レベルの削減(可視性に基づくなど)</li>\n\
<li>データの更新(更新フェーズ)</li>\n\
<li>下位への「レンダリング可能オブジェクト」の送信</li>\n\
<li>「レンダリング可能オブジェクト」の描画</li>\n\
</ol>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f41f7.jpg\' title=\'\' /></div>\n\
<p>図 2: レンダリング可能オブジェクトが入力として送信され、必要に応じて削減されます。削減されないオブジェクトでは、同期が実行され、必要に応じて更新されてレンダリング可能オブジェクトが生成されます。これらのレンダリング可能オブジェクトは、レンダリングのために送信される前にさらに削減が行われます。</p>\n\
<p><strong>更新フェーズ</strong>は、同期および「レンダリング可能」オブジェクトの決定を行います。このようなレンダリング可能オブジェクトをレンダー項目と呼びます。レンダー項目が下位のパイプラインに渡されると、追加のロジックが適用されて、フィルタ、つまり実際に描画する必要のある内容の削減が行われます(「レンダリング可能な削減」)。パイプラインの末端は、実際にレンダリングが実行される<strong>描画フェーズ</strong>になります。</p>\n\
<p><strong>レンダー項目</strong>は一時的に不明瞭になります。現時点では、レンダー項目がレンダー データとレンダー アルゴリズムの両方を含むアトミック単位を表していることを認識していれば十分です。各一意のアルゴリズムと各一意のジオメトリック プリミティブは、通常は一意のレンダリング可能項目になります。たとえば、コントロール ポイントを描画するためのアルゴリズムには 1 つのレンダリング可能項目が必要で、バンプ マッピングで塗り潰された三角形を描画するためのアルゴリズムには別のレンダリング可能項目が必要です。この例では、プリミティブとアルゴリズムの両方のデータが変化しています。</p>\n\
<p>新しい構成とは対照的に、古いシステムは次のようになります。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f41fd.jpg\' title=\'\' /></div>\n\
<p>図 3: データベースを使用しない場合、シーンの走査が必要です。オブジェクトは、更新と描画に必要なすべてのタスクを行います。</p>\n\
<p>別のデータベースを使用しない場合は、シーン内の Maya コンストラクトの完全なスキャンが実行されます。初期のオブジェクトの削減後、各オブジェクトはそれ自体を自由に描画できます。更新と描画の間には明確な分離はないため、インターリーブ評価、移動、および描画を 1 つの「フェーズ」で実行することができます。レンダラがないため、オブジェクト間の最適化はほとんど実行できません。これらはすべての望ましくないプロパティであり、新しいフレームワークでは非推奨であるか禁止されています。</p>\n\
<p>更新の新しいシステムは、データがオンデマンドおよび必要な場合にのみ更新される<strong>引き寄せ</strong>モデルとみなされます。レンダー間で何も変更されない場合、パイプラインは Maya シーンと相互作用せずに動作することができます。古いモデルは、すべてのレンダーでシーン全体を再スキャンし、関連性について後から調べることができるようにすべての内容を更新しようとするため、<strong>押し込み</strong>モデルとみなされます。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";