var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>レンダー ループ</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>レンダー ループ</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"レンダー-ループ\"></a></div>\n\
<p>パイプラインは、バッチまたはビューポート レンダリングのいずれかの要件に基づいて設定することができます。各設定は呼び出すことができる場合とできない場合があり、一連の設定はレンダーごとに呼び出すことができます。したがって、レンダー ループのロジックは、単一フレーム内で実行されるすべての設定で構成されます。</p>\n\
<p>このスキームでは、レンダー項目を設定で定義されているとおりに、さまざまな<strong>レンダリング コンテキスト</strong>に基づいて更新および描画することができます(またこれは一般的な動作です)。</p>\n\
<p>レンダリング コンテキストは、使用可能なデータに基づいて論理的に 2 つのパーツに分割することができます。描画時に使用できるデータの使用可能なセットは、<strong>描画コンテキスト</strong>と呼ばれます。</p>\n\
<p>描画コンテキストには、基になる GPU コンテキストや状態が反映されます。一般的に、状態の最も大きな変化は、レンダー項目の描画中に発生します。状態の変化には、オブジェクトからワールドへの行列、バインドされたシェーダ、現在のブレンド状態、現在バインドされているテクスチャなどがあります。一般的に、カメラの行列やビューポートの寸法などの状態はパイプライン内で一定であるため、描画時にも一定です。</p>\n\
<p>描画時に使用できる情報に加えて、<strong>セマンティック分類</strong>のレイヤを含む<strong>レンダリングの基本設定</strong>をトラッキングすることもできます。特に、コンテキストには、表示モード分類およびオブジェクトの論理分類を反映することができます。表示モードには、ワイヤフレーム、シェーディング、テクスチャ、ハイライト、透明などの分類があります。たとえば、レンダー項目は、「透明」であることを示すセマンティックで明示的にタグを付けることができます。後者の例には、塗り潰されたサーフェス、UI、グリッド、オーバーレイなどがあります。</p>\n\
<p>これらの追加の概念により、前のパイプラインの説明をレンダリングおよび描画コンテキストの概念、リストとしてレンダリング可能なオブジェクトのコレクションで拡張し、分類フェーズを追加することができます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f4763.jpg\' title=\'\' /></div>\n\
<p>図 9</p>\n\
<p>分類では、セマンティックに加え、シェーダとデータのプロパティを利用して、追加のリストを作成するかどうかを決定します。これらのリストのレンダー項目は、追加のリストにフィルタされない項目と同じようにパイプラインに送られます。</p>\n\
<p>特定の時間に読み取りまたは書き込みできるデータを含むコンテキストがパイプライン全体に存在します。必要ではない場合、描画コンテキストは提供されません。特に、ジオメトリ データの更新中、描画コンテキストは不要です。</p>\n\
<p>具体的な例として、透明度の処理があります。透明度リストは分類によって作成される場合があり、その結果、不透明なレンダー項目を処理する描画フェーズと、透明な項目を処理する描画フェーズが生成されます。多くの場合、古いシステムであっても、プラグインがさまざまなコンテキストで複数回描画される可能性があることは考慮されません。これはレンダリングの設定に基づいて、さまざまな理由で一般的に起こる可能性があります。</p>\n\
<p>以下に示すもう 1 つの例では、シャドウ マップ生成「パス」の後にビューティ「パス」が続いています。各パスには、そのパスに関連するセマンティックがあるといえます。「パス コンテキスト」は、このような情報をグループ化します。それぞれが独自の設定パラメータを使用してパイプラインを実行します。レンダー項目は合計で 2 回以上描画されることがあります。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f4769.jpg\' title=\'\' /></div>\n\
<p>図 10</p>\n\
<p>シャドウ マップの生成パイプラインでは、レンダー コンテキストに、影付けするライトに基づくカメラがあります。パス コンテキストは、シャドウ マップを作成するためのレンダリングが行われていることを示します。分類によって、「シャドウ キャスタ」以外のすべてが削減され、他のすべてのレンダー項目は破棄されます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/aa0f4775.jpg\' title=\'\' /></div>\n\
<p>図 11</p>\n\
<p>この例では、ビューティ パス パイプラインで、不透明なオブジェクトと透明なオブジェクトがすべて抽出されて、それらはレンダリング用に 2 つのリストに配置されます。その他のすべてのレンダー項目は破棄されます。ビューティ パス コンテキストは、ビューティ パスが実行されていることを示す情報を提供し、さらに不透明または透明どちらのリストがレンダーされているかを示します。</p>\n\
<p>これらは、単に内部シナリオの例です。API はカスタマイズ可能なレンダー ループに対してオープンであるため、プラグインを呼び出してフレーム レンダーで一度だけ更新または描画されるとは限りません。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";