var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ビューポート 2.0 API の概要</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ビューポート 2.0 API の概要</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ビューポート-2.0-api-の概要\"></a></div>\n\
<p>Maya 2012 では、ビューポート 2.0 およびハードウェア レンダラ 2.0 (ビューポート 2.0 の新しいバッチ/レンダー ビュー バージョン)の両方でカスタム描画、シェーディングおよびエフェクトを定義するための API クラスの新しいセットが導入されました。</p>\n\
<p>Maya のビューポート 2.0 は、Maya の最新のレンダリング アーキテクチャを搭載しています。このアーキテクチャは、プログラマブル シェーダ システムの最上部にある大規模シーンでの高パフォーマンスを実現するために新しく設計されたもので、ピクセルごとの高品質のライティングおよびエフェクトを提供します。 ただし、これによって多くの既存 Maya API クラスとの互換性がなくなります。これは、システム メモリのジオメトリ データ、C++ 駆動レンダリング、および状態の切り替えにおける高いオーバヘッドに依存するためです。 その結果、ほとんどの既存のプラグインは、ビューポート 2.0 で正しく動作するために新しい API クラスをサポートするように更新される必要があります。</p>\n\
<p>このセクションでは、新しいクラスについて紹介し、古い API から新しい API へのマイグレーション パスについて詳しく説明します。 ほとんどの場合、必要に応じて、新しい API と古い API を同時に実装するプラグイン ノードを書くことは可能です。これにより、アーティスト、ツールおよびパイプラインがビューポート 2.0 に移植される間に、両方のビューポートで動作する単一のプラグインが維持されます。</p>\n\
<p>新しい API についての説明は、以下のサブセクションに分割されます。</p>\n\
<ul>\n\
<li><a href=\'#!/url=./dev_help/Viewport-2-0-API/Overview-of-the-Viewport-2-0-API/Data-Classes.html\' title=\'\'>データ クラス</a>: シーン内のジオメトリおよびシェーダについて記述し、それらへのアクセスを提供するオブジェクト。</li>\n\
<li><a href=\'#!/url=./dev_help/Viewport-2-0-API/Overview-of-the-Viewport-2-0-API/Scene-Overrides.html\' title=\'\'>シーンのオーバーライド</a>: シーン内のカスタム描画、シェーディングおよびエフェクトを定義するために使用されるインタフェース。</li>\n\
<li><a href=\'#!/url=./dev_help/Viewport-2-0-API/Overview-of-the-Viewport-2-0-API/Rendering-Overrides.html\' title=\'\'>レンダリング オーバーライド</a>: カスタムのレンダリング、マルチパス エフェクトおよびフィルタリングを定義するために使用されているオブジェクト。</li>\n\
<li><a href=\'#!/url=./dev_help/Viewport-2-0-API/Overview-of-the-Viewport-2-0-API/Framework-Classes.html\' title=\'\'>フレームワーク クラス</a>: プラグインにサービスおよびデバイスの状態についての情報を提供するオブジェクト。</li>\n\
</ul>\n\
<p>この後に、新しい API への移行を迅速に行うために参考となる 2 つのサブセクションがあります。</p>\n\
<ul>\n\
<li><a href=\'#!/url=./dev_help/Viewport-2-0-API/Overview-of-the-Viewport-2-0-API/Transition-Guide.html\' title=\'\'>移行ガイド</a>: 旧式のインタフェースから新しいビューポート 2.0 API に移植する際に役に立つヒント。</li>\n\
<li><a href=\'#!/url=./dev_help/Viewport-2-0-API/Overview-of-the-Viewport-2-0-API/Developer-Kit-Samples.html\' title=\'\'>Developer Kit サンプル</a> - ビューポート 2.0 API を使用して更新された Developer Kit サンプルの概要。</li>\n\
</ul>\n\
<p>新しいクラスはすべて、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MHWRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_m_h_w_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MHWRender</a></span> と呼ばれる Maya API 内の新しいネームスペースに存在します(この文書内では、クラス名に言及する場合は常にこのネームスペースを想定します)。これによって、ビューポートおよびバッチ ハードウェア レンダリングに関係するクラスのすべてを簡単に見つけることができ、ビューポート 2.0 または Hardware Renderer 2.0 ではサポートされない古いハードウェア API クラスとそれらがどのように違うのかを簡単に識別できるようになります。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";