var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>レンダリング オーバーライド</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>レンダリング オーバーライド</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"レンダリング-オーバーライド\"></a></div>\n\
<p>このセクションでは、新しいレンダリング インタフェースについて説明します。 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPx3dModelView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px3d_model_view.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPx3dModelView</a></span> で公開されている既存のハードウェア「マルチパス」インタフェースを含めることが意図されています。</p>\n\
<p>新しいインタフェースの主な機能</p>\n\
<ul>\n\
<li>更新またはバッチ レンダーの開始時にレンダー ループを制御することができます。</li>\n\
<li>明示的なレンダリング「操作」 (シーン レンダーなど)を定義し、それらのレンダー操作を任意の数だけ実行することができます。</li>\n\
<li>明示的な「レンダー ターゲット」 (カラー、深度ステンシル バッファなど)を定義することができます。</li>\n\
<li>レンダリングがどこで発生するかについての「コンテキスト」を認識できます(レンダリングが発生するビューポートなど)。</li>\n\
<li>現在利用可能なものに類似したレンダー操作の「オーバーライド」、およびオーバーライドの将来の拡張が可能です。</li>\n\
<li>シーンの描画と UI 要素を論理的に分離します。</li>\n\
<li>ハードウェア リソースにアクセスすることができます。</li>\n\
</ul>\n\
<p>新しいインタフェースにおける主な相違点</p>\n\
<ul>\n\
<li>レンダリングの実行方法をオーバーライドまたは拡張するために統合レベルをビューまたはパネルにする必要はありません。 つまり、新しい API ビューと API パネルは不要です。 オーバーライドを導入するためのオーバーヘッドの量が大幅に減少しました。</li>\n\
<li>前後にコールバックがある N 回の更新反復が必要な固定のループ ロジックはありません。</li>\n\
<li>内部のレンダー ループ ロジックからのコールバックを遮断する代わりに、ロジックによって API ライタはレンダリング操作のセットをキューに入れることができます。</li>\n\
<li>レンダー ターゲットまたは出力バッファを外部的に定義する必要はなく、それらは公式のレンダリング リソースとして表示されます。</li>\n\
<li>メカニズムは標準化され、対話レンダリングとバッチ レンダリングの両方に対して動作します。</li>\n\
<li>レンダー ロジックの記述は、レンダラを実行するためにユーザによって公式に定義されます。 これは、「保持されたモード実行」と「即時のモード実行」の関係として考えることができます。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"主要なコンセプトと構成\"></a><h2 id=\"主要なコンセプトと構成\">主要なコンセプトと構成</h2></div>\n\
<div class=\'section\'><a id=\"レンダー-オーバーライドrender-override\"></a><h3 id=\"レンダー-オーバーライドrender-override\">レンダー オーバーライド(Render Override)</h3></div>\n\
<p>レンダリング オーバーライドについては公式の概念があります。 オーバーライドは、インタラクティブ レンダリングの場合は更新ごと、バッチ レンダリング場合はフレーム出力ごとにレンダリングをすべてオーバーライドします。 オーバーライドはレンダリング操作のセットで構成されています。 このセットの主要なクラスが <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MRenderOverride</a></span> です。</p>\n\
<div class=\'section\'><a id=\"レンダー操作render-operation\"></a><h3 id=\"レンダー操作render-operation\">レンダー操作(Render Operation)</h3></div>\n\
<p>概して、操作は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPx3dModelView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px3d_model_view.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPx3dModelView</a></span> のパス ベース システムの「パス」と同じものと考えることができますが、明示的に定義されるという点が異なります。このセットの主要なクラスが <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MRenderOperation</a></span> です。カスタムのユーザ操作のほかに、事前定義された操作があります。 基本の操作セットには以下が含まれます。</p>\n\
<ul>\n\
<li>バックグラウンドのクリア操作(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MClearOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_clear_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_clear_operation.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MClearOperation</a></span>)</li>\n\
<li>3D シーンのレンダー操作(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MSceneRender</a></span>)</li>\n\
<li>2D HUD (ヘッドアップ ディスプレイ操作)(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MHUDRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_h_u_d_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_h_u_d_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MHUDRender</a></span>)</li>\n\
<li>ユーザ定義操作(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUserRenderOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_user_render_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_user_render_operation.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MUserRenderOperation</a></span>)</li>\n\
<li>2D スクリーンのスペース四角形をレンダリングする quad blit 操作(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQuadRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_quad_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_quad_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MQuadRender</a></span>)</li>\n\
<li>ターゲット表現操作(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPresentTarget\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_present_target.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_present_target.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPresentTarget</a></span>)</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"レンダー-ターゲットのオーバーライドrender-target-overrides\"></a><h3 id=\"レンダー-ターゲットのオーバーライドrender-target-overrides\">レンダー ターゲットのオーバーライド(Render Target Overrides)</h3></div>\n\
<p>レンダー ターゲットがフォーマライズされました。 そのため、レンダラとプラグイン ライタの両方で使用できる、管理され認識されるリソースのセットがあります。 フォーマライズされているということは、リソースを描画 API に依存しない方法で定義できるということです(たとえば OpenGL や DirectX など)。 提示されるインタフェースはレンダー ターゲットの記述、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderTargetDescription\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_target_description.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_target_description.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MRenderTargetDescription</a></span> です。記述は、レンダリング動作に対する希望のレンダー ターゲット入力または出力を記述するために使用されます。</p>\n\
<ul>\n\
<li>デバイス レベル リソースへのアクセスは、ユーザがターゲットにアクセスするためのカスタム コードを書くことができるように提供されています。</li>\n\
<li>ユーザ定義のレンダー ターゲットを使用することもできますが、デバイスの状態を復元しないと、レンダラのレンダー ターゲットの状態が破損します。 これは新しい制限ではありません。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"シェーダのオーバーライドshader-overrides\"></a><h3 id=\"シェーダのオーバーライドshader-overrides\">シェーダのオーバーライド(Shader Overrides)</h3></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MShaderManager</a></span> インタフェースを使用すると、いくつかの単純なストック シェーダや、ファイル ベースのエフェクトにアクセスすることができます。続いて、これらのシェーダは、オーバーライドとして以下の 2 つの場所のいずれかに適用することができます。</p>\n\
<ul>\n\
<li>3d シーン レンダーに対するオブジェクト シェーダ オーバーライドにより適用。</li>\n\
<li>quad blits に対する四角形レンダー シェーダーにより適用。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"状態のオーバーライドstate-overrides\"></a><h3 id=\"状態のオーバーライドstate-overrides\">状態のオーバーライド(State Overrides)</h3></div>\n\
<p>状態の設定はフォーマライズされており、レンダラによって管理されます。 状態の設定はレンダー操作ごとに実行することができます。</p>\n\
<div class=\'section\'><a id=\"シーン全般とユーザ操作のオーバーライドgeneral-scene-and-user-operation-overrides\"></a><h3 id=\"シーン全般とユーザ操作のオーバーライドgeneral-scene-and-user-operation-overrides\">シーン全般とユーザ操作のオーバーライド(General Scene and User Operation Overrides)</h3></div>\n\
<p>公式に提示される基本オーバーライドには以下が含まれます。</p>\n\
<ul>\n\
<li>カメラ仕様</li>\n\
<li>ワールドまたはシーンのフィルタリング</li>\n\
<li>オブジェクト タイプ フィルタ</li>\n\
<li>描画モードのフィルタリング(塗り潰し、ワイヤ、コンポーネントなど)</li>\n\
<li>ユーザが別の既存オーバーライドを使用できるようにするインタラクティブ レンダリングのための <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"M3dView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m3d_view.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_u_i_1_1_m3d_view.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">M3dView</a></span> へのアクセス。</li>\n\
<li>バッチ レンダリングの場合、ユーザはハードウェアおよび共通のレンダー グローバルにアクセスすることもできます。</li>\n\
<li>カスタムのユーザー動作が利用可能なので、ユーザは、以前のデバイスレベルの状態を復元するという制限のもと、自分自身の直接描画を自由に実行することができます。 同じ制限が、現在 <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPx3dModelView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px3d_model_view.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MPx3dModelView</a></span> オーバーライドを含むすべての既存のハードウェア レンダリング インタフェースに適用されます。</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"レンダー-ロジックの構築\"></a><h2 id=\"レンダー-ロジックの構築\">レンダー ロジックの構築</h2></div>\n\
<p>レンダー オーバーライドの定義のおもな手順は次のとおりです。</p>\n\
<ol>\n\
<li>カスタムのレンダー オーバーライドを派生させます。</li>\n\
<li>オーバーライドをレンダラに登録します。 オーバーライドはいくつでも登録できます。</li>\n\
<li>ビューポートまたはバッチ レンダリングのためのアクティブなオーバーライドを設定します。</li>\n\
<li>レンダー操作およびオーバーライドのセットを順番に並んだリストとして設定します。 レンダー ロジックがグラフの場合は、一連のレンダー操作に分割することができます。</li>\n\
<li>照会された操作のリストを提供し、必要に応じて操作ごとにパラメータを更新します。</li>\n\
<li>カスタムの動作およびカスタムのオーバーライドは、中間および最終のレンダー ターゲットを遮断することができ、必要に応じてリソースを使用する場合にその機能を実行します(ディスクへの保存、カスタムのレンダリング コードへのルーティングなど)。</li>\n\
</ol>\n\
<div class=\'section\'><a id=\"主要な制限\"></a><h2 id=\"主要な制限\">主要な制限</h2></div>\n\
<ul>\n\
<li>レンダリング中にはシーン修正は発生しません。 これは新しい制限ではありません。</li>\n\
<li>現在、シーン レンダーの特定のポイントに対するフィードバック(ループ)オーバーライドを提供するために使用できる正式なメカニズムはありません。このような特定のポイントに対するインタフェースはまだ存在しないからです。たとえば、シャドウ マップからカスタム ライトへのループは現在は不可能です。現在、カスタムのライト インタフェースが存在していないからです。</li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";