var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>フラグメント レンダラ サンプル プラグインを作成する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>フラグメント レンダラ サンプル プラグインを作成する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"フラグメント-レンダラ-サンプル-プラグインを作成する\"></a></div>\n\
<p>サンプル プラグイン <em>viewRenderOverrideFromFragments</em> を使用することができます。このプラグインは、シーンおよび希望するポスト エフェクトをレンダリングするためにスクリプト フラグメントとフラグメント グラフを使用するための、新しい API セットの使用例を示します。スクリプト フラグメントは、標準のビューポート レンダリング エフェクトを適用するために Maya 内部で使用される構築ブロックです。Maya インストール フォルダの <span class=\'code\'>bin/ScriptFragment</span> フォルダ内の一連の <span class=\'code\'>.xml</span> ファイル内に格納されています。</p>\n\
<p>これらの API を使用すると、Maya 独自の標準構築ブロックと自分自身で作成した構築ブロックを組み合わせて、Maya ビューポートおよびハードウェア レンダラを再使用、修正、拡張することができます。</p>\n\
<p>サンプル プラグインの機能は次のとおりです。</p>\n\
<ul>\n\
<li>メイン シーンをレンダリングする</li>\n\
<li>平面を通してカメラを反転し、オフスクリーン バッファにシーンを再レンダリングし、このオフスクリーン バッファを次のパスのテクスチャとして使用する</li>\n\
<li>四角形の上にテクスチャを配置して、その四角形をメイン スクリーンにレンダリングする</li>\n\
</ul>\n\
<p>サンプル プラグインについては、<span class=\'code\'>pyGroundReflectionRenderer.py</span> を参照してください。</p>\n\
<p>このサンプルを使用すると、<strong>Renderer</strong> ビューポート パネル メニューに <strong>Ground Reflections</strong> レンダラが作成されます。Ground Reflections レンダラに切り替えると、ビューポートによってオブジェクトおよびその反射がレンダリングされます。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/FragmentRenderer_Example.png\' title=\'\' /></div>\n\
<blockquote>\n\
<p><strong>注:</strong> サンプルをロードする前に、<span class=\'code\'>pyGroundReflectionRenderer.py</span> ファイルの <span class=\'code\'>initializePlugin</span> 関数(行 242)にプラグインのパスを設定する必要があります。********</p>\n\
</blockquote>\n\
<p>フラグメント xml ファイルは <span class=\'code\'>viewRenderOverrideFromFragments</span> プラグイン フォルダの <span class=\'code\'>ScriptFragment</span> フォルダ内にあります。このレンダラのメイン フラグメント グラフは <span class=\'code\'>GroundReflections.xml</span> です。指定した <span class=\'code\'>.xml</span> ファイルはシェーダ検索パス内になければなりません。</p>\n\
<p>プラグイン コードの <span class=\'code\'>initializePlugin</span> 関数も、このプラグインの <span class=\'code\'>Shaders</span> フォルダをシェーダ検索パスに追加します。</p>\n\
<p>フラグメント マネージャにアクセスして、新しいフラグメント グラフを追加するには、次のように <span class=\'code\'>MRenderer.getFragmentManager()</span> を呼び出します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">omr.MRenderer.getFragmentManager().addFragmentGraphFromFile(&quot;GroundReflections.xml&quot;)\n\
</pre></div><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MSceneRender</a></span> を使用してシーン レンダーを作成し、フラグメント グラフの名前を指定します(ここでは「GroundReflections」)。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class FragmentSceneRender(omr.MSceneRender):\n\
    def __init__(self, name):\n\
        super(FragmentSceneRender, self).__init__(name, &quot;GroundReflections&quot;)\n\
</pre></div><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MRenderOverride</a></span> を作成してフラグメント レンダラを作成し、以下を呼び出してこのレンダラを登録します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">omr.MRenderer.registerOverride(fragmentRenderer)\n\
</pre></div><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOverride\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_override.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MRenderOverride</a></span> を作成する場合は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderOperation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_operation.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MRenderOperation</a></span> から派生したカスタム レンダー操作が含まれている <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MSceneRender</a></span> のリストを指定します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class FragmentRenderOverride(omr.MRenderOverride):\n\
\n\
    def __init__(self, name):\n\
        self.operatioIndex = 0\n\
        self.operations =  [FragmentSceneRender(&quot;sceneAndGroundReflections&quot;),\n\
                           omr.MHUDRender(),\n\
                           omr.MPresentTarget(&quot;present&quot;)]\n\
\n\
</pre></div><p><span class=\'code\'>preSceneRender</span> 関数をオーバーライドする場合は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender::getParameters()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html#a426c26adb287500c03beeabeee48851c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html#af148b038cde45838c9969718ace4dc1f&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MSceneRender::getParameters()</a></span> を呼び出して、一連のレンダー パラメータを取得します。詳細については、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_parameters.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MRenderParameters</a></span>を参照してください。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">def preSceneRender(self, context):\n\
    params = self.getParameters()\n\
</pre></div><p>まだ存在していない場合は、オプション ノードを作成します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">optionsNodeName = &#39;groundReflectionOptions&#39;\n\
optionObj = nameToNode(optionsNodeName)\n\
if optionObj is None:\n\
    optionObj = nameToNode(cmds.createNode(RenderOverrideOptions.kTypeName, name=optionsNodeName, skipSelect=True))\n\
</pre></div><p>次にオプション ノードからプラグを取得し、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderParameters::setParameter()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_parameters.html#aa17e2c9a17b86064950103066fa307ef&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_render_parameters.html#a05a48ff6065d53bea08285c7ca7b164b&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MRenderParameters::setParameter()</a></span> を呼び出して、カスタム <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSceneRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_scene_render.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MSceneRender</a></span> (カスタム シーン レンダー操作)で使用されるレンダー フラグメントに値を渡します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">if optionObj is not None:\n\
    # set the fragment&#39;s enabled input\n\
    optionPlug = om.MPlug(optionObj, RenderOverrideOptions.enableReflections)\n\
    if optionPlug is not None:\n\
        enabled = getBoolPlugValue(optionPlug)\n\
        params.setParameter(&#39;EnableReflection&#39;, enabled)\n\
</pre></div><p>GroundReflections フラグメント グラフには DepthTarget などのフラグメント、およびフラグメント グラフ Reflection_Renderer を含む ReflectionPass などの他のフラグメント グラフが含まれています。フラグメント グラフ Reflection_Renderer には、simpleBlitScript、MayaShadedBeauty、DrawPreUIOption などのフラグメントが含まれています。GroundReflections フラグメント グラフでは、ハードコードされた C++ プロシージャ フラグメント VE_ReflectCamera も使用されます。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> ReflectionPass フラグメント グラフは、わかりやすくするために名前が変更された<em>既定</em> のフラグメント グラフです。その中のサブフラグメントは、Maya の標準シーン レンダラで使用されます。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"エフェクトエフェクトのパラメータ関連付けられたテクスチャを設定するには\"></a><h2 id=\"エフェクトエフェクトのパラメータ関連付けられたテクスチャを設定するには\">エフェクト、エフェクトのパラメータ、関連付けられたテクスチャを設定するには</h2></div>\n\
<p>サンプル フラグメント グラフ内のフラグメントの一部は、スクリプト フラグメントです。これらは、レンダリング操作を実行する場合に使用されるコマンドを含む、グラフ内のリーフ フラグメントです。これらのコマンドの中には、パスにエフェクトを割り当てて、エフェクト パラメータをコントロールできるものがあります。</p>\n\
<ol>\n\
<li>エフェクトを設定するには <span class=\'code\'>SetEffect</span> コマンドを使用します。</li>\n\
</ol>\n\
<p>これらのコマンドの使用例については、<span class=\'code\'>VE_PlanarReflection_RenderFragment.xml</span> を参照してください。</p>\n\
<p><span class=\'code\'>&lt;SetEffect name=&quot;DilateH&quot; path=&quot;DistanceDilate&quot; technique=&quot;DilateHoriz&quot; /&gt;    &lt;SetEffectParameter effect=&quot;DilateH&quot; name=&quot;gAmount&quot; value=&quot;_UseDistanceDilate_Amount&quot; /&gt;    &lt;SetTexture effect=&quot;DilateH&quot; name=&quot;gSourceTex&quot; value=&quot;PointClamp&quot; texture=&quot;@DistanceMap&quot; /&gt;    &lt;SetEffectParameter effect=&quot;DilateH&quot; name=&quot;gSourceSamp&quot; value=&quot;PointClamp&quot; /&gt;    &lt;SetTarget index=&quot;0&quot; value=&quot;tempDilate&quot; /&gt;    &lt;Render name=&quot;Quad&quot; /&gt;</span></p>\n\
<p>エフェクトはフラグメントでない <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_instance.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../&quot;}]\">MShaderInstance</a></span> のインスタンスと同等ですが、スクリプト内で直接使用することはできません。name アトリビュートはこのエフェクトを参照する場合に使用される名前です。path アトリビュートはエフェクト ファイルのパスおよび名前です。ファイル拡張子を指定する必要はありません。Maya では、使用されているデバイスに基づいて適切な拡張子が検索されます(DX11 の場合は <span class=\'code\'>.fx</span>、コア プロファイルの場合は <span class=\'code\'>.ogsfx</span>、コア プロファイル以外の OpenGL の場合は <span class=\'code\'>.cgfx</span>)。technique アトリビュートは、使用する必要があるエフェクト ファイル内のテクニックを示します。1 つのファイル内に複数のテクニックが存在することがあります。</p>\n\
<ol>\n\
<li><span class=\'code\'>SetEffectParameter</span> コマンドを使用してエフェクト値を設定してから、<span class=\'code\'>SetTexture</span> コマンドを使用してエフェクトで使用されるテクスチャを設定します。</li>\n\
</ol>\n\
<p>参照しているシェーダがマクロを使用する場合は、<em>macrolist</em> 値を設定してシェーダのコンパイル方法をコントロールすることもできます。</p>\n\
<p><span class=\'code\'>&lt;SetEffect name=&quot;BlurH&quot; path=&quot;Blur&quot; technique=&quot;BlurHoriz&quot; macrolist=&quot;BLUR_AMOUNT=12&quot; /&gt;</span></p>\n\
<ol>\n\
<li>スクリプトの最後にこのコマンドを呼び出して、元のビューポート 2.0 オーバーライド エフェクトを復元します。<span class=\'code\'>SetEffect</span> コマンドを使用する場合は、ビューポート 2.0 でローカル オーバーライド エフェクトを設定します。</li>\n\
</ol>\n\
<p><span class=\'code\'>&lt;RestoreOverrideEffect /&gt;</span></p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";