var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Maya 2018 devkit の新機能</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Maya 2018 devkit の新機能</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maya-2018-devkit-の新機能\"></a></div>\n\
<p>Maya 2018 devkit には、API の更新プログラムや追加機能がいくつか含まれており、プラグインの再コンパイルが必要になります。更新内容は次のとおりです。</p>\n\
<div class=\'section\'><a id=\"新しい-openmaya-ネームスペース\"></a><h2 id=\"新しい-openmaya-ネームスペース\">新しい OpenMaya ネームスペース</h2></div>\n\
<p>Maya 2018 には新しい OpenMaya ネームスペースが導入されています。この導入は、Maya プラグインの開発中断を最小化し、複数の更新にわたって Maya API のバイナリ互換性が維持されるように拡張する API を提供する取り組みの一環として行われています。OpenMaya ネームスペースは、すべての OpenMaya API モジュール(OpenMaya、OpenMayaUI、OpenMayaRender、OpenMayaFx、OpenMayaAnim)を対象としています。</p>\n\
<p>OpenMaya ネームスペースを使用するには:</p>\n\
<ul>\n\
<li>API シンボルを更新するには、以前のバージョンの Maya API に対してビルドされたすべてのプラグインを、新しい <span class=\'code\'>Autodesk::Maya::OpenMaya20180000</span> ネームスペースで再コンパイルする必要があります。</li>\n\
</ul>\n\
<p>通常、プラグインに対して何らかのアクションを行う必要はありません。コンパイラはシンボルをネームスペース付きのシンボルに自動的に解決します。</p>\n\
<ul>\n\
<li>OpenMaya classes のすべての前方宣言を除去します。これらのすべてのクラスは、<span class=\'code\'>MApiNamespace.h</span> で自動的に前方宣言され、正しいバージョンのクラスに解決されます。</li>\n\
<li>buildconfig ファイルまたは Xcode プロジェクト ファイルを変更して、次のシンボルをグローバル スコープにプロモートした場合は、これらを除去する必要があります。</li>\n\
</ul>\n\
<p>``` LFLAGS += -Wl,-exported_symbol,__Z16initializePlugin7MObject<br /><br /> ```</p>\n\
<p><span class=\'code\'>-Wl,-exported_symbol,__Z18uninitializePlugin7MObject</span></p>\n\
<div class=\'section\'><a id=\"c11-キーワードのサポート\"></a><h2 id=\"c11-キーワードのサポート\">C++11 キーワードのサポート</h2></div>\n\
<p>VFX 参照プラットフォームをサポートするために、Maya 2018 API は C++ 11 の機能をサポートするようになりました。 <span class=\'code\'>nullptr</span>、<span class=\'code\'>final</span>、<span class=\'code\'>override</span> など、ヘッダ ファイルで使用される C++11 の新しいキーワードなどが該当します。以前のバージョンの C++ を使用してこの API に対してプラグインをコンパイルすると、次のようなエラーが表示されることがあります。</p>\n\
<p><span class=\'code\'>error: ?nullptr? was not declared in this scope</span></p>\n\
<p>通常、このエラーは C++ 98 内に <span class=\'code\'>nullptr</span> がない場合に表示されます。</p>\n\
<div class=\'section\'><a id=\"解決方法\"></a><h3 id=\"解決方法\">解決方法</h3></div>\n\
<p>C++11 に更新しない場合は、OpenMaya ヘッダ ファイルより先に <span class=\'code\'>maya/MCppCompat.h</span> をインクルードする必要があります。このヘッダ ファイルをインクルードしても、これらの C++11 キーワード機能は実装されませんが、古いコンパイラと互換性のあるものにキーワードが再定義されます(たとえば、<span class=\'code\'>nullptr</span> は <span class=\'code\'>NULL</span> に定義されます)。これにより、C++11 キーワードがヘッダ ファイルに含まれていない場合も、古いコンパイラを使用してプラグインをコンパイルすることができます。</p>\n\
<div class=\'section\'><a id=\"非推奨のマーキング-システムの更新\"></a><h2 id=\"非推奨のマーキング-システムの更新\">非推奨のマーキング システムの更新</h2></div>\n\
<p>Maya 2018 以降では、非推奨のメソッドは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"OPENMAYA_DEPRECATED\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___open_maya.html#ga6e3c1a1ce7eafb1dc26dc9114c037361&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OPENMAYA_DEPRECATED</a></span> C++ アトリビュートを使用してマークされています。例:</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"OPENMAYA_DEPRECATED\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___open_maya.html#ga6e3c1a1ce7eafb1dc26dc9114c037361&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OPENMAYA_DEPRECATED</a>(version, &quot;message&quot;)</span></p>\n\
<p>新しいマーキング システムでは、マークされたメソッドが呼び出されると、コンパイラに関する警告が生成されます。これにより、都合のいいときにプラグインから非推奨メソッドを除去することができます。このような警告の例:</p>\n\
<p><span class=\'code\'>warning C4996: &#39;MPxTransform::validateAndSetValue&#39;: Override validateAndSetValue(const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp;, const <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a>&amp;) instead.</span> <span class=\'code\'>If needed, useMDGContext::current() to get the context.</span></p>\n\
<p>コンパイラで <span class=\'code\'>treat warning as error</span> (警告をエラーとして扱う)が有効になっていて、移行中に関連するビルド エラーが発生した場合は、非推奨の警告を無効にすることができます。</p>\n\
<p>非推奨の警告を非表示にするには、次の操作を実行します。</p>\n\
<ul>\n\
<li>プリプロセッサ マクロを定義します。</li>\n\
<li><span class=\'code\'>_OPENMAYA_DEPRECATION_DISABLE_WARNING</span></li>\n\
<li>次のコンパイラ スイッチを使用します。</li>\n\
</ul>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
MSVC\n\
</td>\n\
<td class=\"table-body\">\n\
/Wd&quot;4996&quot;\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
ICC\n\
</td>\n\
<td class=\"table-body\">\n\
-diag-disable 1786\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
Clang\n\
</td>\n\
<td class=\"table-body\">\n\
-Wno-error=deprecated-declarations\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
GCC\n\
</td>\n\
<td class=\"table-body\">\n\
-Wno-error=deprecated-declarations\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p>非推奨をエラーとして扱うには、次の操作を実行します。</p>\n\
<ul>\n\
<li>次のプリプロセッサ マクロを定義します。</li>\n\
<li><span class=\'code\'>_OPENMAYA_DEPRECATION_ERROR_2018</span></li>\n\
<li><span class=\'code\'>_OPENMAYA_DEPRECATION_ERROR_ALL</span></li>\n\
<li>または、次のコンパイラ スイッチを使用します。</li>\n\
</ul>\n\
<table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
<colgroup>\n\
<col />\n\
<col />\n\
</colgroup>\n\
<tbody>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
MSVC\n\
</td>\n\
<td class=\"table-body\">\n\
/We&quot;4996&quot; (/D_CRT_NONSTDC_NO_DEPRECATE)\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
ICC\n\
</td>\n\
<td class=\"table-body\">\n\
-diag-error 1786\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-odd-row\">\n\
<td class=\"table-body\">\n\
Clang\n\
</td>\n\
<td class=\"table-body\">\n\
-Werror=deprecated-declarations\n\
</td>\n\
</tr>\n\
<tr class=\"ruled-even-row\">\n\
<td class=\"table-body\">\n\
GCC\n\
</td>\n\
<td class=\"table-body\">\n\
-Werror=deprecated-declarations\n\
</td>\n\
</tr>\n\
</tbody>\n\
</table>\n\
<p>非推奨メソッドの下位互換性と非推奨メソッドのオーバーライドの詳細については、「<a href=\'#!/url=./dev_help/Deprecating-Maya-API.html\' title=\'\'>Maya API を非推奨にする</a>」を参照してください。</p>\n\
<div class=\'section\'><a id=\"現在のコンテキストを使用して評価する\"></a><h2 id=\"現在のコンテキストを使用して評価する\">現在のコンテキストを使用して評価する</h2></div>\n\
<p>Maya 2018 では、Maya API に現在の評価コンテキストという概念が導入されています。新しいメソッドおよび新しい評価スキーマによって、コードのコンテキスト評価が効率化されます</p>\n\
<p>以前のバージョンの Maya では、標準以外のコンテキストで評価する場合、そのコンテキストをメソッドに渡す必要があります。例:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::getTranslation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#afdb40f5632edbefb787db386d445b157&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform::getTranslation</a>( <a href=\"javascript:void(0)\" data-symbol=\"MSpace::Space\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_space.html#ab11a1dda34491acff014ddfc9e6bafb8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSpace::Space</a>, const\n\
<a href=\"javascript:void(0)\" data-symbol=\"MDGContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContext</a>&amp;, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a>* );\n\
</pre></div><p>これにより、コンテキストがさらに次のメソッドに渡されて、コンテキストを渡すメソッドが長いチェーンを形成することがあります。現在の評価コンテキストという概念と新しいユーティリティが導入されたことに伴い、このチェーンを作成する必要はなくなりました。次の操作を実行できるようになりました。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGContext::current()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context.html#a11a98edcfc027fb57d3a66fcfbc580a8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_context.html#a6834aee4cb837cd1309a5def7615d83a&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContext::current()</a></span> を使用して現在のコンテキストを取得します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGContext::makeCurrent()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context.html#a0a8c271d5088d769845269dc99d73a7e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_d_g_context.html#a3dcdc521f9d31ee6c93eb9991e615549&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContext::makeCurrent()</a></span> を使用して現在のコンテキストを設定します。</li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDGContextGuard\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context_guard.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContextGuard</a> guard(temporaryCurrentContext);</span> を使用して、スコープが設定されたコード ブロック内で現在のコンテキストを一時的に設定します。</li>\n\
</ul>\n\
<p>コンテキスト パラメータを含む既存のメソッドを引き続き使用することができますが、コンテキストに依存しないバリエーションを使用することをお勧めします。例:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">return myTransform.getTranslation(<a href=\"javascript:void(0)\" data-symbol=\"MSpace::kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_space.html#ab11a1dda34491acff014ddfc9e6bafb8adafa274206df602835f0f22ae887e126&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSpace::kTransform</a>, myNewContext, &amp;status);\n\
</pre></div><p>機能的に以下と同等になりました。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">                {\n\
                                <a href=\"javascript:void(0)\" data-symbol=\"MDGContextGuard\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context_guard.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContextGuard</a> ctxGuard( myNewContext );\n\
                                return myTransform.getTranslation( <a href=\"javascript:void(0)\" data-symbol=\"MSpace::kTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_space.html#ab11a1dda34491acff014ddfc9e6bafb8adafa274206df602835f0f22ae887e126&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSpace::kTransform</a>, &amp;status );\n\
                }\n\
\n\
</pre></div><p>ほとんどのコードは現在のコンテキストで評価する必要があるため、通常の場合、<span class=\'code\'>myNewContext</span> は不要です。例外は、代わりのコンテキストで意図的に評価される時間ベースのキャッシュとゴースト化などです。</p>\n\
<p>別のコンテキスト内で呼び出される長いシーケンスがある場合は、現在のコンテキストのスコープ付き変更を使用することができます。例:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">                {\n\
                                            <a href=\"javascript:void(0)\" data-symbol=\"MDGContextGuard\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_d_g_context_guard.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDGContextGuard</a> tempContext( myDifferentContext );\n\
                                firstPlug.getValue( value1 );\n\
                                secondPlug.getValue( value2 );\n\
                                thirdPlug.getValue( value3 );\n\
                …\n\
}\n\
\n\
</pre></div><p>複数のメソッド内をコンテキストが通過しないようにします。マルチスレッド評価に対するコードの安全性を維持するには、常に現在のコンテキストを使用します。</p>\n\
<div class=\'section\'><a id=\"ワークスペース-コントロール\"></a><h2 id=\"ワークスペース-コントロール\">ワークスペース コントロール</h2></div>\n\
<p>Maya のワークスペース システム内でドラッグ、ドッキング、保存できるカスタム UI を作成するには、ワークスペース コントロールを使用します。ワークスペース コントロールは、<span class=\'code\'>workspaceControl</span> コマンドを使用して作成することができます。ドッキング可能な UI を作成するために以前に使用されていた <span class=\'code\'>dockControl</span> コマンドは、ワークスペース コントロールで置き換えられています。<span class=\'code\'>dockControl</span> 機能はサポートされなくなりました。つまり、内部 UI を含むウィンドウを作成し、<span class=\'code\'>content</span> フラグを介してこのウィンドウを <span class=\'code\'>dockControl</span> コマンドにアタッチしてはなりません。</p>\n\
<p>MEL、Python、および C++ を使用してワークスペース コントロールを作成することができます。詳細については、「<a href=\'#!/url=./dev_help/Writing-Workspace-controls.html\' title=\'\'>ワークスペース コントロールを記述する</a>」を参照してください。</p>\n\
<p>Python のサンプルについては、Maya devkit の pythonScripts フォルダ内の <span class=\'code\'>dockableWorkspaceWidget.py</span> のサンプルを参照してください。</p>\n\
<p>C++ のサンプルについては、Maya API の <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"workspaceControlCmd.cpp\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/workspace_control_cmd_8cpp-example.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">workspaceControlCmd.cpp</a></span> のサンプルを参照してください。</p>\n\
<div class=\'section\'><a id=\"maya-ビューポート-2.0-ホワイトペーパーの更新\"></a><h2 id=\"maya-ビューポート-2.0-ホワイトペーパーの更新\">Maya ビューポート 2.0 ホワイトペーパーの更新</h2></div>\n\
<p>「<em>Maya ビューポート 2.0 API ポーティング ガイド</em>」が変更されて、Maya 2018 API に対する変更が追加されました。更新されたホワイトペーパーでは、プラグイン ロケータ(MPxLocatorNode)をビューポート 2.0 に移行するための方法についても解析しています。</p>\n\
<p>Maya ビューポート 2.0 のホワイトペーパーは、<a href=\'http://www.autodesk.com/developmaya\' title=\'\' target=\'_blank\'>http://www.autodesk.com/developmaya</a> で参照できます。</p>\n\
<div class=\'section\'><a id=\"api-のバージョンとバイナリ互換性\"></a><h2 id=\"api-のバージョンとバイナリ互換性\">API のバージョンとバイナリ互換性</h2></div>\n\
<p>Maya の API のバージョンが更新されました(現在の MAYA_API_VERSION は 20180000 です)。Maya 2018 に対してコンパイルされたすべてのプラグイン(Maya 2017 Update 1、2、3、または 4 を含む)は、このバージョンの Maya で認識されるように、Maya 2018 に対して再コンパイルする必要があります。</p>\n\
<div class=\'section\'><a id=\"更新されたコンパイラ要件\"></a><h3 id=\"更新されたコンパイラ要件\">更新されたコンパイラ要件</h3></div>\n\
<p>Windows および Mac OS X でプラグインとスタンドアロン アプリケーションをコンパイルするには、以下がインストールされている必要があります。</p>\n\
<ul>\n\
<li>Windows— Visual Studio 2015 Update 3。「<a href=\'#!/url=./dev_help/Setting-up-your-build/Windows-environment-64-bit-.html\' title=\'\'>Windows 環境(64 ビット)</a>」を参照してください。</li>\n\
<li>Mac OS X— El Capitan 10.11.6、Xcode 7.3.1 with SDK 10.11、clang with libc++。「<a href=\'#!/url=./dev_help/Setting-up-your-build/Mac-OS-X-environment.html\' title=\'\'>Mac OS X 環境</a>」を参照してください。</li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";