var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>プラグインでの Qt の使用方法</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>プラグインでの Qt の使用方法</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"プラグインでの-qt-の使用方法\"></a></div>\n\
<div class=\'section\'><a id=\"開発者の準備作業\"></a><h2 id=\"開発者の準備作業\">開発者の準備作業</h2></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/Updated_Even-to-Odd.png\' title=\'\' /></div>\n\
<p>Maya は Qt Company のカスタマイズ バージョンの Qt フレームワークを使用し、プラグインで Qt を使用する場合に必要となるすべての独自バージョンのライブラリとヘッダー ファイルが付属しています。Linux と OS X では、ライブラリは Maya の <strong>lib</strong> フォルダにあります。Windows では、リンク ライブラリが Maya の <strong>lib</strong> フォルダ、DLL が Maya の <strong>bin</strong> フォルダにあります。すべてのプラットフォームにおいて、ヘッダー ファイルは、圧縮アーカイブ(例: qt-5.6.1-include.tar.gz)として Developer Kit インストールの <strong>include</strong> フォルダ内に含まれています。Qt プラグインの作業を開始する前に、圧縮アーカイブを書き出し権限があるフォルダに解凍し、そのフォルダが他のフォルダの前にくるようにインクルード パスを指定します。</p>\n\
<p>Qt Designer を使用して Maya のカスタム UI を作成できます。(Windows および Linux) Qt Designer は Maya と一緒にインストールされます。(Mac OS X) Qt Designer を Qt Development Tools の Web サイトから直接ダウンロードできます。または、ソースから Qt をビルドすることもできます。</p>\n\
<p>Qt Designer を取得するには、システムに Qt Company の 標準バージョンの Qt をインストールするか、オートデスクのオープン ソース Web サイト(<a href=\'http://www.autodesk.com/lgplsource\' title=\'\' target=\'_blank\'>http://www.autodesk.com/lgplsource</a>)からカスタマイズされた Qt ソースのコピーをダウンロードしてツール自体をビルドします。 後者の方法を選択した場合、Maya のサポート対象のプラットフォームで Qt を設定、ビルド、インストールする方法が記載されたテキスト ファイルを参照できます。</p>\n\
<div class=\'section\'><a id=\"プラグインの作成\"></a><h2 id=\"プラグインの作成\">プラグインの作成</h2></div>\n\
<p>独自の Qt アプリケーションを一から作成するには、独自の QCoreApplication または QApplication のインスタンスを作成してそのアプリケーションのイベント ループを処理できるようにする必要があります。代わって、Maya プラグインの作成には、Qt の <strong>qApp</strong> マクロで読み出せる Maya 独自のアプリケーション オブジェクトを使用します。以下のサンプル コードでは、<strong>qApp</strong> マクロを使用して Maya のアプリケーション名を読み出しています。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">QCoreApplication*  app = qApp;\n\
if (app) {\n\
    cout &lt;&lt; &quot;Application name is &#39;&quot; &lt;&lt; app-&gt;applicationName().toStdString() &lt;&lt; &quot;&#39;&quot; &lt;&lt; endl;\n\
}\n\
\n\
</pre></div><p>Qt を使用した新規ウィンドウやダイアログの作成は、Qt の標準的なアプリケーションの作成と同じ方法で行います。開発キットの helixQtCmd プラグインにごく単純なサンプルが用意されています。このプラグインには、Qt ベースのボタンを作成する helixQt コマンドがあります。このボタンを押すと、常に API コールを使用してらせん状のカーブが作成されます。</p>\n\
<p>このボタンは、カーブの作成を処理するために createHelix() スロットを追加した通常の Qt pushButton です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">class HelixButton : public QPushButton\n\
{\n\
   Q_OBJECT\n\
public:\n\
   HelixButton(const QString&amp; text, QWidget* parent = 0); \n\
   virtual  ~HelixButton();\n\
public slots:\n\
   void createHelix(bool checked);\n\
};\n\
\n\
</pre></div><p>helixQt コマンドを実行すると、常に、まずそのボタンの有無が確認されます。ボタンがない場合は作成し、<strong>クリックした</strong>信号をその <strong>createHelix</strong> スロットに接続して、ボタンをクリックしたときにらせんを作成するコードが必ず実行されるようにします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">QPointer    HelixQtCmd::button;\n\
<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> HelixQtCmd::doIt(const <a href=\"javascript:void(0)\" data-symbol=\"MArgList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_arg_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArgList</a>&amp; /* args */)\n\
{\n\
   if (button.isNull()) {\n\
       button = new HelixButton(&quot;Create Helix&quot;);\n\
       button-&gt;connect(button, SIGNAL(clicked(bool)), button, SLOT(createHelix(bool)));\n\
       button-&gt;show();\n\
       }\n\
\n\
</pre></div><p>ボタンがある場合、このコマンドは、そのボタンを確実に表示して他のウィンドウの後ろに隠れないようにします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   else {\n\
       button-&gt;showNormal();\n\
       button-&gt;raise();\n\
       } \n\
   return MS::kSuccess;\n\
}\n\
\n\
</pre></div><p>Qt を使用して直接作成したコントロールは、通常、Maya の UI コマンドで認識されません。<span class=\'code\'>IsUI</span> コマンドではそれらのコントロールはリストされず、<span class=\'code\'>button</span> などの特定タイプのコントロールのコマンドではそれらは認識されません。ただし、汎用のコントロール コマンドは例外です。一意の名前を指定してさえいれば、<span class=\'code\'>control</span> コマンドを使用してその有無をテストし、表示設定などコントロールに関する基本操作を実行できます。</p>\n\
<p>たとえば、helixQtCmd プラグインの createHelix メソッドでボタンに「myButton」という一意の名前が指定されているとします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   button = new HelixButton(&quot;Create Helix&quot;);\n\
   button-&gt;setObjectName(&quot;myButton&quot;);\n\
\n\
</pre></div><p>その場合、ボタンを非表示にするために以下の MEL スクリプトを使用できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">if (`control -q -exists myButton`) {\n\
   control -e -visible false myButton;\n\
}\n\
\n\
</pre></div><p>ただし、同じコードで <span class=\'code\'>button</span> コマンドを使用しても、動作しません。これは、<span class=\'code\'>button</span> コマンドが自身で作成したボタンしか認識しないためです。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">if (`button -q -exists myButton`) {      // Will always be false.\n\
   button -e -visible false myButton;   // Will never be executed.\n\
}\n\
\n\
</pre></div><p>Qt を使用して Maya コマンドで作成した UI 要素に直接アクセスできるようにした方が望ましい場合もあります。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil</a></span> API クラスには、Maya のコントロール、レイアウト、ウィンドウ、メニュー項目の基本となる Qt オブジェクトを読み出すためのメソッドが用意されています。たとえば、以下の MEL スクリプトで作成した「myCheckBox」という名前の Maya checkBox コントロールがあるとします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">window;\n\
columnLayout;\n\
checkBox myCheckBox;\n\
showWindow;\n\
\n\
</pre></div><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil</a></span> クラスを使用して checkBox の QWidget ポインタを取得し、それにより checkBox の現在の状態を確認することができます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">QWidget* control = <a href=\"javascript:void(0)\" data-symbol=\"MQtUtil::findControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html#a4117d34bd18ee0fa108c4952bda68e94&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil::findControl</a>(&quot;myCheckBox&quot;);\n\
if (control) {\n\
   QCheckBox* cb = qobject_cast(control);\n\
   if (cb) {\n\
      if (cb-&gt;isChecked()) {\n\
          <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a3d14e9f9ed022a80f664eac0136c2f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayInfo</a>(&quot;myCheckBox is checked&quot;);\n\
      } else {\n\
          <a href=\"javascript:void(0)\" data-symbol=\"MGlobal::displayInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a3d14e9f9ed022a80f664eac0136c2f7a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::displayInfo</a>(&quot;myCheckBox is not checked&quot;);\n\
      }\n\
   }\n\
}\n\
\n\
</pre></div><p>前述の例では、MQtUtil を使用する場合は常に十分な注意が必要であることもわかります。このコードは、Maya の <span class=\'code\'>checkbox</span> コマンドで QCheckBox ウィジェットまたは QCheckBox 由来の要素を作成する場合のみ動作します。これは Maya の現行バージョンの場合で、将来的には変更される可能性があります。Qt を使用して Maya のコマンドで作成した UI 要素に直接アクセスするようにコードを記述する場合、Maya の新しいリリースでも確実に意図した通りに動作するか確認するのはユーザ自身の責任になります。</p>\n\
<p>レイアウトは、注意して作成しなければ、さまざまな問題のもとになりかねません。</p>\n\
<ul>\n\
<li>Maya ではレイアウトはウィジェット階層の一部と捉えられていますが、Qt はそうではありません。つまり、Maya は、すべてとは言わないまでも、ほとんどのレイアウトにプロキシ ウィジェットを作成します。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil</a></span> には、レイアウトを容易にナビゲートするためのメソッドが用意されていますが、プラグイン作成者にとっては実際のレイアウトに対してプロキシを記録する作業はまだまだ大変であり、バグの原因としてよく知られています。</li>\n\
<li>Maya のコントロールやレイアウトの中には、相互に作用する特殊なコードを持つものがあります。Qt で作成した独自のコントロールを Maya のレイアウトに追加する場合、または Maya のコントロールを Qt で作成した独自のレイアウトに追加する場合、予期せぬ結果が生じることがあります。Qt を使用して Maya のコントロールを Maya のレイアウトに追加する場合でさえ問題が生じることがあります。</li>\n\
<li>Maya のレイアウトの中には、単一の Qt レイアウトではなく、レイアウトやコントロールの小さな階層として実装されているものがあります。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil</a></span> にはこのような複雑なレイアウトをナビゲートするためのメソッドが用意されていますが、使用には注意する必要があります。</li>\n\
</ul>\n\
<p>レイアウトに関するこれらの問題およびその他の問題の詳細については、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil</a></span> を参照してください。</p>\n\
<div class=\'section\'><a id=\"プラグインのビルド\"></a><h2 id=\"プラグインのビルド\">プラグインのビルド</h2></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/Updated_Even-to-Odd.png\' title=\'\' /></div>\n\
<p>このセクションの最初で説明したとおり、Maya にはカスタマイズ バージョンの Qt ライブラリとヘッダー ファイルが付属しています。Maya のバージョンのヘッダーを含むフォルダが、システムの他の場所の別の Qt インストールにあるフォルダの前にくるようにインクルード パスを指定し、Maya のバージョンのライブラリを含むフォルダが、他のフォルダの前にくるようにライブラリ パスを指定することが重要です。</p>\n\
<p>Maya Developer Kit に付属している qmake のバージョンを使用することが重要です。qmake の実行後、Qt プラグインのビルドに使用できる makefile が生成されます。</p>\n\
<p>Maya Developer Kit に付属している Qt プラグインをビルドするには、次の手順に従います。</p>\n\
<ol>\n\
<li>Maya とともにインストールされている次の Qt アーカイブを使用し、解凍して配置します。</li>\n\
</ol>\n\
<p>Maya 開発キットから同じファイルを取得することもできます。</p>\n\
<ul>\n\
<li><span class=\'code\'>include/qt-5.6.1-include.tar.gz</span></li>\n\
<li><span class=\'code\'>mkspecs/qt-5.6.1-mkspecs.tar.gz</span></li>\n\
<li><span class=\'code\'>lib/cmake/qt-5.6.1-cmake.tar.gz</span></li>\n\
</ul>\n\
<ol>\n\
<li>Maya Developer Kit からプラグイン サンプル ファイルを取得します。<em>helixQtCmd</em> サンプルの場合は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"helixQtCmd.cpp\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/helix_qt_cmd_8cpp-example.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">helixQtCmd.cpp</a></span>、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"helixQtCmd.h\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/helix_qt_cmd_8h-example.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">helixQtCmd.h</a></span>、および <span class=\'code\'>helixQtCmd.pro</span> ファイルなどになります。</li>\n\
<li><span class=\'code\'>helixQtCmd</span> フォルダを作成します。</li>\n\
</ol>\n\
<p>前述の <span class=\'code\'>helixQtCmd.*</span> ファイルを <span class=\'code\'>helixQtCmd</span> フォルダにコピーします。</p>\n\
<ol>\n\
<li><span class=\'code\'>qtconfig</span> ファイル(<span class=\'code\'>devkit/plug-ins</span> フォルダ内)を <span class=\'code\'>helixQtCmd</span> フォルダにコピーします。</li>\n\
<li>環境変数 MAYA_LOCATION には Maya のインストール場所を設定し、環境変数 DEVKIT_LOCATION には devkit の <span class=\'code\'>include</span>、<span class=\'code\'>mkspecs</span>、<span class=\'code\'>cmake</span> フォルダが存在する場所を設定します。</li>\n\
<li><span class=\'code\'>helixQtCmd</span> フォルダに移動します。</li>\n\
<li><strong>Maya Developer Kit に付属する</strong> <strong>qmake</strong> のバージョンを実行します。</li>\n\
</ol>\n\
<p><span class=\'code\'>$DEVKIT_LOCATION/devkit/bin/qmake helixQtCmd.pro</span></p>\n\
<p>その結果、<span class=\'code\'>makefile</span> が作成されます。Mac OS X では、プラグインに従った名前が makefile に付けられ、<span class=\'code\'>.mak</span> 拡張子が付加されます。Linux と Windows では、<span class=\'code\'>Makefile</span> という名前になります。</p>\n\
<ul>\n\
<li>Linux/Windows: <span class=\'code\'>Makefile</span></li>\n\
<li>Mac OS X: <span class=\'code\'>helixQtCmd.mak</span></li>\n\
</ul>\n\
<p>Linux および Windows にはトップ レベルの <span class=\'code\'>Makefile.qt</span> が用意されていて、Mac OS X には <span class=\'code\'>make –fhelixQtCmd.mak</span> が用意されています。既定の Qt プラグインをビルドするには、これらのファイルを使用します。</p>\n\
<ol>\n\
<li>次の手順に従って、 生成された <span class=\'code\'>Makefile</span> を使用して <span class=\'code\'>make</span> を実行します。</li>\n\
</ol>\n\
<ul>\n\
<li>Linux: <span class=\'code\'>make –f Makefile</span></li>\n\
<li>Mac OS X: <span class=\'code\'>make –f helixQtCmd.mak</span></li>\n\
<li>Windows: <span class=\'code\'>nmake /f Makefile</span></li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>注:</strong> <span class=\'code\'>Makefile</span> には、末尾に拡張子 <span class=\'code\'>.pro</span> が付いている qmake プロジェクト ファイルが必要です。以下に示す <span class=\'code\'>helixQtCmd.pro</span> は、Developer Kit で helixQtCmd プラグインに用意されているプロジェクト ファイルです。これで、大部分のプロジェクト ファイルは単純な構成であることが良くわかります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">include(qtconfig)\n\
TARGET = helixQtCmd    \n\
HEADERS += helixQtCmd.h\n\
SOURCES += helixQtCmd.cpp\n\
LIBS += -lOpenMayaUI   \n\
\n\
</pre></div><p><strong>TARGET</strong> 設定には、プラットフォーム固有の拡張子を除いたプラグインの名前を記述します。</p>\n\
<p><strong>HEADERS</strong> 設定には、プラグインの一部であるすべてのヘッダー ファイルの一覧をスペースで区切って記述します。</p>\n\
<p><strong>SOURCES</strong> 設定には、プラグインの一部であるすべてのソース ファイルの一覧をスペースで区切って記述します。</p>\n\
<p>既定では、プラグインは Maya の <strong>Foundation</strong> ライブラリと <strong>OpenMaya</strong> ライブラリに自動的にリンクされます。他のライブラリが必要な場合は、<strong>LIBS</strong> 設定に追加します。 ライブラリの名前の前には「-l」を付け、追加ライブラリのディレクトリは「-L」で指定する必要があります。たとえば、次のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">LIBS += -L/usr/local/lib -lxml\n\
\n\
</pre></div><p>さらに複雑な事例の場合は、Qt qmake のマニュアルを参照してください。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"デバッグ\"></a><h2 id=\"デバッグ\">デバッグ</h2></div>\n\
<p>Qt のサンプル プラグインは、すべてリリース(非デバッグ)モードでビルドされています。デバッグ用にビルドするには、.pro ファイルで以下の手順に従って qmake のデバッグ構成パラメータをオンにします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">CONFIG += debug\n\
\n\
</pre></div><p>Linux と OS X でのデバッグ用にプラグインをビルドする場合はこれで十分です。ただし、残念ながら、Windows の場合は、デバッグ構成の設定はデバッグ情報付きのプラグインをコンパイルするだけではなく、デバッグ バージョンの Qt ライブラリに強制的にリンクします。このため、Qt ライブラリのリリース バージョンでリンクされた Maya との互換性が失われてしまいます。プラグインに使用する Qt のクラスによっては、Maya にロードできたりできなかったりしますが、ロードされた場合でも、正しく動作しないと思われます。これは、Maya の QCoreApplication またはその他の Qt のグローバル値にアクセスできないためです。この問題を回避するには、<em>debug</em> 構成パラメータを前述のように設定し、以下のコマンドを使用して <em>myPlugin</em> のプラグイン名を置き換えて中間的な makefile をビルドします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">nmake /f Makefile.qt myPlugin.mak\n\
\n\
</pre></div><p>これは特に、プラグイン用の <span class=\'code\'>.mak.Debug</span> ファイル(<span class=\'code\'>myPlugin.mak.Debug</span> など)を生成します。生成されたファイルを編集して<strong>LIBS</strong> 行を探し、ファイル名の末尾の <em>d</em> を削除してすべてのデバッグ用の Qt ライブラリを非デバッグ バージョンに置き換えます。たとえば、<span class=\'code\'>helixQtCmd.mak.Debug</span> の <strong>LIBS</strong> 行の冒頭は以下のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">LIBS = /LIBPATH:..\\..\\lib ..\\..\\lib\\OpenMaya.lib ..\\..\\lib\\Foundation.lib ..\\..\\lib\\OpenMayaUI.lib c:\\qt-adsk-5.6.1\\lib\\QtGuid4.lib c:\\qt-adsk-5.6.1\\lib\\QtCored4.lib`\n\
\n\
</pre></div><p><span class=\'code\'>QtGuid4.lib</span> を <span class=\'code\'>QtGui4.lib</span>、<span class=\'code\'>QtCored4.lib</span> を <span class=\'code\'>QtCore4.lib</span> に置き換えると、以下のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">LIBS = /LIBPATH:..\\..\\lib ..\\..\\lib\\OpenMaya.lib ..\\..\\lib\\Foundation.lib ..\\..\\lib\\OpenMayaUI.lib c:\\qt-adsk-5.6.1\\lib\\QtGui4.lib c:\\qt-adsk-5.6.1\\lib\\QtCore4.lib`\n\
\n\
</pre></div><p>ここで、変更した <span class=\'code\'>.mak.Debug</span> ファイルを使用し、以下のようにプラグインを明示的にビルドします。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">nmake /f myPlugin.mak.Debug debug\\myPlugin.mll\n\
\n\
</pre></div><p>これでも、Windows の場合はまだ問題が残ります。Qt の QList テンプレート クラスには、Qt オブジェクトを作成、破棄できるインライン メソッドがあります。 このメソッドはインライン化されているため、デバッグ用にビルドしたプラグイン コードによってコールされると、作成または削除したすべてのオブジェクトが Microsoft の C Runtime Library のデバッグ バージョンからメモリ アロケータを使用します。メソッドを Maya 内でコールした場合、C Runtime Library のリリース バージョンが使用されます。したがって、Maya 内でリリース バージョンのランタイム ライブラリを使用してオブジェクト割り当てて、デバッグ バージョンのランタイム ライブラリで削除する、またはその逆の状況が考えられます。ところが、Microsoft の C Runtime Library のリリース バージョンとデバッグ バージョンでは互換性がないため、このような操作を行うとクラッシュしてしまいます。</p>\n\
<p>現在のところ、このような問題の可能性が確認されている Qt クラスはQList だけですが、他の Qt テンプレート クラスでも同様の問題が発生する可能性はあります。これに対する現段階での回避策は、コードに Qt テンプレート クラスを使用しないこと、または Windows ではプラグインのビルドをリリース モードでのみ行うことのいずれかです。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";