var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>ワークスペース コントロールを記述する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>ワークスペース コントロールを記述する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ワークスペース-コントロールを記述する\"></a></div>\n\
<div class=\'figure\'><img src=\'dev_help/images/New_Even.png\' title=\'\' /></div>\n\
<p>ワークスペース コントロールを使用して、Maya のワークスペース システム内でドラッグ、ドッキング、保存できるカスタム UI を作成することができます。ワークスペース コントロールは、<span class=\'code\'>workspaceControl</span> コマンドを使用して作成されます。このコマンドを呼び出して、内部 UI を作成する <span class=\'code\'>uiScript</span> フラグにスクリプトを渡すと、ワークスペース システムはワークスペース コントロールを指定したワークスペースに保存し、次回に開いたときにそのコントロールを適切に復元できるようになります。このスクリプトで呼び出すあらゆるものは、これ以降に Maya を起動し、保存したワークスペースが復元されたときに実行することができます。</p>\n\
<p>MEL スクリプトはソースから取得する必要がありますが、Python モジュールは読み込む必要があります。唯一の例外は次のとおりです。</p>\n\
<ul>\n\
<li>別のワークスペース コントロールまたはそこに含まれている UI にアクセスするための呼び出し。この場合は、<span class=\'code\'>requiredControl</span> フラグに他のワークスペース コントロールの名前を指定する必要があります。コントロールが互いに呼び出しあうなどの循環従属にご注意ください。</li>\n\
<li>プラグインからの機能の呼び出し。この場合は、<span class=\'code\'>requiredPlugin</span> フラグにプラグインの名前を指定する必要があります。</li>\n\
</ul>\n\
<p>中央ビューポートの 4 辺の周りにドッキング可能な UI を作成するために使用されていた <span class=\'code\'>dockControl</span> コマンドは、ワークスペース コントロールによって置き換えられました。<span class=\'code\'>dockControl</span> 機能はサポートされなくなりました。workspaceControl 機能に移行するには、実行時に内部 UI を生成するスクリプトを作成します。この機能を <span class=\'code\'>workspaceControl</span> コマンドの呼び出しにアタッチするには、<span class=\'code\'>uiScript</span> フラグを使用します。内部 UI を含むウィンドウを作成してから、<span class=\'code\'>content</span> フラグを介して <span class=\'code\'>dockControl</span> コマンド呼び出しにアタッチすることはできなくなりました。</p>\n\
<div class=\'section\'><a id=\"mel-を使用してワークスペース-コントロールを作成する\"></a><h2 id=\"mel-を使用してワークスペース-コントロールを作成する\">MEL を使用してワークスペース コントロールを作成する</h2></div>\n\
<p>次の例では、MEL を使用してワークスペース コントロールを作成する最も簡単な方法を示します。この例では、このスクリプトが <span class=\'code\'>customWorkspaceControlFile.mel</span> にあることが前提となります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">    global proc createCustomWorkspaceControlUI()\n\
    {\n\
                    columnLayout;\n\
                    button;\n\
                    button;\n\
                    button;\n\
    }\n\
     \n\
\n\
</pre></div><p>次のコマンドを実行して、最初のコントロールを作成します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">workspaceControl -retain false -floating true \n\
-uiScript &quot;if(!`exists createCustomWorkspaceControlUI`) source customWorkspaceControlFile; createCustomWorkspaceControlUI();&quot; \n\
myCustomWorkspaceControl;\n\
</pre></div><div class=\'section\'><a id=\"python-と-pyside-のバインディングを使用してワークスペース-コントロールを作成する\"></a><h2 id=\"python-と-pyside-のバインディングを使用してワークスペース-コントロールを作成する\">Python と Pyside のバインディングを使用してワークスペース コントロールを作成する</h2></div>\n\
<p>Maya コマンド スクリプトを使用して、Python でワークスペース コントロールを作成することができます。ワークスペース コントロールの UI の内容が PySide ベースの場合は、PySide のみが適用されます。</p>\n\
<p>次の操作を実行して、PySide UI 内でワークスペース コントロールを作成します。</p>\n\
<ol>\n\
<li><span class=\'code\'>MayaQWidgetDockableMixin</span> クラスから最上位のウィジェットを取得します。</li>\n\
<li><span class=\'code\'>dockable</span> が <span class=\'code\'>True</span> に設定された状態で <span class=\'code\'>show()</span> に対する呼び出しを使用して、ウィジェットを開きます。</li>\n\
<li><span class=\'code\'>uiScript</span> に、このウィジェットを再作成するスクリプトを設定します。このスクリプトでは、<span class=\'code\'>MQtUtil.addWidgetToMayaLayout</span> を使用して、再作成されたウィジェットを復元されたワークスペース コントロール(<span class=\'code\'>MQtUtil.findControl</span> を使用して検索)にペアレント化する必要があります。</li>\n\
</ol>\n\
<p>Python を使用してワークスペース コントロールを作成する方法の詳細については、<span class=\'code\'>dockableWorkspaceWidget.py</span> devkit サンプルを参照してください。このサンプルを実行するには、スクリプト エディタ(Script Editor)で開いて実行します。 「<a href=\'#!/url=./dev_help/Maya-Python-API/Working-with-PySide-in-Maya/PyQt-and-PySide-Widget-Best.html\' title=\'\'>PyQt および PySide ウィジェットのベスト プラクティス</a>」も参照してください。</p>\n\
<div class=\'section\'><a id=\"c-を使用してワークスペース-コントロールを作成する\"></a><h2 id=\"c-を使用してワークスペース-コントロールを作成する\"><strong>C++ を使用してワークスペース コントロールを作成する</strong></h2></div>\n\
<p>C++ を使用している場合は、最初に <span class=\'code\'>workspaceControl</span> MEL コマンドを使用してワークスペース コントロールを作成する必要があります。このコマンドを実行するには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal::executeCommand()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a09e405631e7cf680f8ac9d934ad73434&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MGlobal::executeCommand()</a></span> メソッドを使用します。次に、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil::addWidgetToMayaLayout()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html#a42ba7b27654231ee3b1add771f0b7896&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">MQtUtil::addWidgetToMayaLayout()</a></span> メソッドを使用して C++ で作成された Qt UI をワークスペース コントロールにペアレント化できます。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"workspaceControlCmd.cpp\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/workspace_control_cmd_8cpp-example.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">workspaceControlCmd.cpp</a></span> サンプルは、ワークスペース コントロールおよびそれらを含む UI を生成するコマンドの作成方法を示します。また、この UI を workspaceControl の <span class=\'code\'>uiScript</span> フラグに渡して、再度開くときに UI を復元する方法も示します。このコマンドはプラグインの一部であるため、<span class=\'code\'>requiredPlugin</span> フラグを使用してワークスペース コントロールがこのプラグインを認識し、この UI の復元コマンドを実行できるようにする必要があります。</p>\n\
<p>workspaceControlCmd サンプルをビルドするには、「<a href=\'#!/url=./dev_help/Working-with-Qt/Using-Qt-in-Plug-ins.html\' title=\'\'>プラグインでの Qt の使用方法</a>」トピックの「<em>プラグインのビルド</em>」セクションを参照してください。 プラグインがビルドされたら、プラグインを Maya にロードし、次の MEL スクリプトを実行します。</p>\n\
<p><span class=\'code\'>workspaceControlWindow;</span> .</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";