var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>カスタム トランスフォームを実装する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>カスタム トランスフォームを実装する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"カスタム-トランスフォームを実装する\"></a></div>\n\
<p>カスタム トランスフォームを実装する場合、トランスフォームの構築やアトリビュートの設定などを行う必要があります。</p>\n\
<div class=\'section\'><a id=\"単純なカスタム-トランスフォームと複雑なカスタム-トランスフォーム\"></a><h2 id=\"単純なカスタム-トランスフォームと複雑なカスタム-トランスフォーム\">単純なカスタム トランスフォームと複雑なカスタム トランスフォーム</h2></div>\n\
<p>トランスフォームには、トランスフォーム情報の処理と格納に使用される入力と出力アトリビュートがあります。最も単純なカスタム トランスフォームは、変換行列に影響を与える可能性のある新規アトリビュートを一切導入しないトランスフォームです。たとえば、この種のトランスフォームは、事前に決められた計算を利用して、<span class=\'code\'>translate</span> アトリビュートを一定のワールド空間領域に制限します。</p>\n\
<p>複雑なカスタム トランスフォームは、変換行列に影響を与える 1 つまたは複数のアトリビュートを導入するトランスフォームです。たとえば、この種のトランスフォームは、変換行列の最終的な計算で使用される新しいタイプの回転パラメータを導入することができます。この場合、カスタム トランスフォームは 2 種類の回転を認識するため、新しい回転を計算する際にオリジナルの回転アトリビュート(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a></span> によって提供される)が影響を受けることはありません。</p>\n\
<div class=\'section\'><a id=\"ワールド空間world-spaceアトリビュート\"></a><h2 id=\"ワールド空間world-spaceアトリビュート\">ワールド空間(World space)アトリビュート</h2></div>\n\
<p>オブジェクトをインスタンス化するとシステム メモリが節約され、正確なプロパティを維持しながら 1 つのオブジェクトを複数回表示するのに便利です。ただし、同一のオブジェクトに対する複数のパスが存在するため、オブジェクトをインスタンス化すると、コーディング上の問題が表れます。Maya はワールド空間に分類される配列アトリビュートを使用してこの状況に対処します。複数のパスを処理するには、配列が必要です。</p>\n\
<p>ワールド空間アトリビュートは、独自の座標変換に加えてオブジェクトの親の座標変換に依存しています。アトリビュートをワールド空間としてマーキングすると、親のいずれかが変換された場合にアトリビュートが再計算されます(要求時)。ワールド空間アトリビュートは、上記の例のインスタンス化を処理する配列です。<span class=\'code\'>worldMatrix</span> はワールド空間アトリビュートの一例です。アトリビュートを配列として設定し、ワールド空間にする処理は、カスタム トランスフォーム ノードの <span class=\'code\'>initialize()</span> メソッドで <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnAttribute</a></span> クラスを使用して実行されます。</p>\n\
<p>ワールド空間アトリビュートが配列である場合は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MArrayDataBuilder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_array_data_builder.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_array_data_builder.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MArrayDataBuilder</a></span> クラスを使用してアトリビュートに配置される情報を作成できます。その後、<span class=\'code\'>initialize()</span> メソッドで <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute::setUsesArrayDataBuilder()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html#a08fb5fd3764795485a0d799616646ef1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnAttribute::setUsesArrayDataBuilder()</a></span> を使用してアトリビュートを設定する必要があります。</p>\n\
<div class=\'section\'><a id=\"ワールド空間に作用affects-world-spaceアトリビュート\"></a><h2 id=\"ワールド空間に作用affects-world-spaceアトリビュート\">ワールド空間に作用(Affects world space)アトリビュート</h2></div>\n\
<p>**ワールド空間に作用(Affects world space)としてマーキングされたアトリビュートは、特定のノードとそのノードの子 DAG でワールド空間アトリビュートを再計算させます(ワールド空間が要求される場合)。このタイプのアトリビュートに対する配列の要件はありません。DAG ノードにある <span class=\'code\'>translate</span> アトリビュートはワールド空間に作用(Affects world space)アトリビュートの一例です。アトリビュートをワールド空間として設定する処理は、カスタム トランスフォーム ノードの <span class=\'code\'>initialize()</span> メソッドで <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnAttribute</a></span> クラスを使用して実行されます。</p>\n\
<div class=\'section\'><a id=\"トランスフォームの制限\"></a><h2 id=\"トランスフォームの制限\">トランスフォームの制限</h2></div>\n\
<p>トランスフォーム ノード(およびカスタム トランスフォームノード)には特別なアトリビュートが存在します。このアトリビュートは関連するアトリビュートの値をクランプする場合に使用します。トランスフォームの制限は、<span class=\'code\'>translate</span>、<span class=\'code\'>rotate</span>、および <span class=\'code\'>scale</span> で使用できます。それぞれの操作には、有効(Enabled)、最小(Minimum)、最大(Maximum)の 3 つのアトリビュートが含まれます。これらのアトリビュートを変更するカスタム トランスフォームを使用すると、<span class=\'code\'>translate</span>、<span class=\'code\'>rotate</span>、<span class=\'code\'>scale</span> をワールド空間の一部に制限するノードを実現できます。これは、カスタム トランスフォームの単純な実施例です。複雑なカスタム トランスフォームを使用すると、別のオブジェクトまでの距離などの外部アトリビュート入力に基づいて最小値と最大値を変更できます。</p>\n\
<div class=\'section\'><a id=\"トランスフォームのバランシング\"></a><h2 id=\"トランスフォームのバランシング\">トランスフォームのバランシング</h2></div>\n\
<p>Maya のトランスフォーム ノードでは、ピボット(回転とスケール)や回転順序を変更しても変換行列を同じ状態に維持できます。これは、**トランスフォームのバランシングと呼ばれます。バランシングは、ピボットや回転順序情報の変更に関連するメソッドに含まれるパラメータです。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a></span> と <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransformationMatrix</a></span> の仮想メソッドは、カスタム トランスフォームが Maya の標準的なピボットの処理方法を変更しようとしない限り、バランシングを正しく処理します。</p>\n\
<div class=\'section\'><a id=\"検証および設定\"></a><h2 id=\"検証および設定\">検証および設定</h2></div>\n\
<p>Maya は標準的な**検証と設定の仕組みを使ってカスタム トランスフォームのアトリビュート値を更新します。行列に影響を与えるアトリビュートの場合、必ずこの仕組みを使用する必要があります。トランスフォームの行列に影響を与えるアトリビュートの場合、<span class=\'code\'>initialize()</span> メソッドで必ず <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::mustCallValidateAndSet()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#a0533b06e6c41eed320612ce1aae241f9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform::mustCallValidateAndSet()</a></span> を呼び出す必要があります。このようにすると、アトリビュートが明示的に設定されたときに行列が正しく計算され、このアトリビュートに対して <span class=\'code\'>MPxTransform::validateAndSet()</span> メソッドが呼び出されます。</p>\n\
<div class=\'section\'><a id=\"行列を返す方法\"></a><h2 id=\"行列を返す方法\">行列を返す方法</h2></div>\n\
<p>Maya は DG 更新処理の一環として、カスタム トランスフォームに変換行列を要求します。この要求は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::getMatrix()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#af6e52bdebc5f622b643dfdf60d9e15fb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform::getMatrix()</a></span> 呼び出しに直接渡されます。次に、この仮想メソッドは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix::asMatrix()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html#a8e2933c5f73e8cfb7409366582caa596&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransformationMatrix::asMatrix()</a></span> を呼び出します。カスタム トランスフォームが Maya に行列を返すようにするには、これらの 2 つのメソッドを実装する必要があります。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";