var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>OGSFX プリプロセッサ命令</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>OGSFX プリプロセッサ命令</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ogsfx-プリプロセッサ命令\"></a></div>\n\
<p>シェーダ コードに条件を含めるには、次のプリプロセッサ命令を追加します。これは特定の条件下でコードのブロックの実行のみを行う場合に最も便利です。たとえば、指定したシェーダ ステージのみでコードを実行する場合や、シェーダをコンパイルするのに使用する OGSFX のバージョンを指定する場合などです。</p>\n\
<div class=\'section\'><a id=\"シェーダのコンパイルに使用する-ogsfx-のバージョンを指定するには\"></a><h2 id=\"シェーダのコンパイルに使用する-ogsfx-のバージョンを指定するには\">シェーダのコンパイルに使用する OGSFX のバージョンを指定するには</h2></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#version versionNumber\n\
</pre></div><p>指定する場合は、ファイルの 1 番最初の行をこの命令にする必要があります。これにより、シェーダのコンパイルとリンクに使用される OGSFX のバージョンが指定されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">OGSFX           GLSL            OpenGL version\n\
#version 100    #version 150    OpenGL 3.2\n\
#version 150    #version 150    OpenGL 3.2\n\
#version 330    #version 330    OpenGL 3.3  * default for Windows and Linux\n\
#version 400    #version 400    OpenGL 4.0\n\
#version 410    #version 410    OpenGL 4.1\n\
#version 420    #version 420    OpenGL 4.2  * default for OS/X\n\
#version 430    #version 430    OpenGL 4.3\n\
</pre></div><div class=\'section\'><a id=\"内部機能を有効無効にするには\"></a><h2 id=\"内部機能を有効無効にするには\">内部機能を有効/無効にするには</h2></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#pragma pragmaName : Boolean\n\
</pre></div><p>現在は、次のプラグマを使用できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#pragma Usecb : true            // Use constant buffers (default - true)\n\
#pragma OptimizeUniforms : true // Optimize uniforms by packing them into a single constant buffer (default - true)\n\
</pre></div><div class=\'section\'><a id=\"エラー-メッセージをプリントするには\"></a><h2 id=\"エラー-メッセージをプリントするには\">エラー メッセージをプリントするには</h2></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#error &quot;Should not be there!&quot;\n\
</pre></div><p>この命令は、診断メッセージをシェーダの情報ログに書き込むための実装に影響を与えます。メッセージは <span class=\'code\'>#error</span> 命令に続くトークンとなり、最初の改行までとなります。実装では、シェーダが不適格になることを考慮する必要があります。</p>\n\
<div class=\'section\'><a id=\"その他のシェーダ-ファイルを読み込むには\"></a><h2 id=\"その他のシェーダ-ファイルを読み込むには\">その他のシェーダ ファイルを読み込むには</h2></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#include &quot;resources.ogsfh&quot;\n\
</pre></div><p><span class=\'code\'>#include</span> 命令は、命令を発行したポイントで、指定したファイルの内容がソース プログラム内に存在するかのように扱うことをプリプロセッサに指示します。</p>\n\
<div class=\'section\'><a id=\"if-条件\"></a><h2 id=\"if-条件\">If 条件</h2></div>\n\
<p><span class=\'code\'>#if</span>、<span class=\'code\'>#ifdef</span>、<span class=\'code\'>#ifndef</span>、<span class=\'code\'>#else</span>、<span class=\'code\'>#elif</span>、<span class=\'code\'>#endif</span> は、ANSI C プリプロセッサの標準として動作するために定義されています。</p>\n\
<p><span class=\'code\'>#define</span> と <span class=\'code\'>#undef</span> は、マクロ定義、およびマクロ パラメータあり/なし用の ANSI C プリプロセッサの標準として定義されています。</p>\n\
<p><span class=\'code\'>#if</span> および <span class=\'code\'>#elif</span> に続く式は、リテラル整数定数で動作する式か、定義された演算子によって使用される識別子に制限されています。文字定数はサポートされていません。</p>\n\
<div class=\'section\'><a id=\"シェーダ-ステージを定義する\"></a><h2 id=\"シェーダ-ステージを定義する\">シェーダ ステージを定義する</h2></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#vertexshader\n\
#pixelshader\n\
#geometryshader\n\
#tessevalshader\n\
#tesscontrolshader\n\
#endshader\n\
</pre></div><p>これらの命令は、指定したシェーダ ステージのコードを有効にするために使用できます。<span class=\'code\'>#vertexshader ... #endshader</span> のペアによって区切られたすべてのコードは、頂点シェーダのみでコンパイルされます。同様に、<span class=\'code\'>#pixelshader ... #endshader</span> または <span class=\'code\'>#geometryshader ... #endshader</span> で区切られたコードは、ピクセル シェーダまたはジオメトリ シェーダのみでコンパイルされます。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";