var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../../scripts/prettify.js\"></script><script src=\"../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>OGSFX のシェーダ ステージ間で共通の機能を共有する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>OGSFX のシェーダ ステージ間で共通の機能を共有する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"ogsfx-のシェーダ-ステージ間で共通の機能を共有する\"></a></div>\n\
<p>「<a href=\'#!/url=./dev_help/Writing-a-Hardware-Shading-Node/Creating-GLSL-hardware-shaders/Convert-existing-GLSL-shaders-to.html\' title=\'\'>既存の GLSL シェーダを OGSFX 形式に変換する</a>」のセクションで説明したように、各シェーダ ステージにはそのそれぞれに対する GLSLShader の<em>ブロック</em>があり、それらには使用する関数が含まれています。</p>\n\
<p>次に示すサンプルは、2 つのステージで同じ関数を使うためのコードを作成する方法について説明します。</p>\n\
<div class=\'section\'><a id=\"ogsfx-ファイル内で複製された関数\"></a><h2 id=\"ogsfx-ファイル内で複製された関数\">.ogsfx ファイル内で複製された関数</h2></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// World-view-projection transformation.\n\
uniform mat4 gWVPXf : WorldViewProjection;\n\
\n\
attribute vs_input\n\
{\n\
    vec3 in_position : POSITION;\n\
};\n\
 \n\
attribute vs_to_ps\n\
{\n\
    // None\n\
};\n\
 \n\
attribute ps_output \n\
{\n\
    vec4 out_color : COLOR0;\n\
}\n\
 \n\
GLSLShader VS\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
 \n\
    void main() \n\
    {\n\
        gl_Position = gWVPXf*convertVec3ToVec4(in_position);\n\
    }\n\
}\n\
 \n\
GLSLShader PS1\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
 \n\
    vec4 computeTransparency(vec3 color3)\n\
    {\n\
        vec4 color4 = convertVec3ToVec4(color3);\n\
         \n\
        float alpha = 1;\n\
        // ... perform a number of calculations\n\
        color4.w = alpha;\n\
 \n\
        return color4;\n\
    }\n\
 \n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(1, 0, 0));\n\
    }\n\
}\n\
 \n\
GLSLShader PS2\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
 \n\
    vec4 computeTransparency(vec3 color3)\n\
    {\n\
        vec4 color4 = convertVec3ToVec4(color3);\n\
 \n\
        float alpha = 1;\n\
        // ... perform a number of calculations\n\
        color4.w = alpha;\n\
 \n\
        return color4;\n\
    }\n\
 \n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(0, 1, 0));\n\
    }\n\
}\n\
  \n\
technique Main\n\
{\n\
    pass p1\n\
    {\n\
        VertexShader (in vs_input, out vs_to_ps) = VS;\n\
        PixelShader (in vs_to_ps, out ps_output) = PS1;\n\
    }\n\
 \n\
    pass p2\n\
    {\n\
        VertexShader (in vs_input, out vs_to_ps) = VS;\n\
        PixelShader (in vs_to_ps, out ps_output) = PS2;\n\
    }\n\
}\n\
</pre></div><div class=\'section\'><a id=\"ogsfx-ファイル内で暗黙的に共有された関数\"></a><h2 id=\"ogsfx-ファイル内で暗黙的に共有された関数\">.ogsfx ファイル内で暗黙的に共有された関数</h2></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// World-view-projection transformation.\n\
uniform mat4 gWVPXf : WorldViewProjection;\n\
\n\
attribute vs_input\n\
{\n\
    vec3 in_position : POSITION;\n\
};\n\
 \n\
attribute vs_to_ps\n\
{\n\
    // None\n\
};\n\
 \n\
attribute ps_output \n\
{\n\
    vec4 out_color : COLOR0;\n\
}\n\
 \n\
// Declare the functions that can be shared among all the shader stages\n\
GLSLShader Common_Functions\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
}\n\
  \n\
// Declare the functions that can be shared among the pixel shader stages\n\
GLSLShader Common_Pixel_Functions\n\
{\n\
    vec4 computeTransparency(vec3 color3)\n\
    {\n\
        vec4 color4 = convertVec3ToVec4(color3);\n\
 \n\
        float alpha = 1;\n\
        // ... perform a number of calculations\n\
        color4.w = alpha;\n\
 \n\
        return color4;\n\
    }\n\
}\n\
 \n\
GLSLShader VS\n\
{\n\
    void main() \n\
    {\n\
        gl_Position = gWVPXf*convertVec3ToVec4(in_position);\n\
    }\n\
}\n\
 \n\
GLSLShader PS1\n\
{\n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(1, 0, 0));\n\
    }\n\
}\n\
 \n\
GLSLShader PS2\n\
{\n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(0, 1, 0));\n\
    }\n\
}\n\
  \n\
technique Main\n\
{\n\
    pass p1\n\
    {\n\
        // Declare the vertex shader stage to include the functions\n\
        // from the VS GLSLShader block.\n\
        // The stage will also include all the functions\n\
        // from blocks that do not contain a main().\n\
        // The vertex shader stage will then contain functions from\n\
        // Common_Functions, Common_Pixel_Functions and VS.\n\
        VertexShader (in vs_input, out vs_to_ps) = VS;\n\
 \n\
        // The pixel shader stage will contain functions from\n\
        // Common_Functions, Common_Pixel_Functions and PS1.\n\
        PixelShader (in vs_to_ps, out ps_output) = PS1;\n\
    }\n\
 \n\
    pass p2\n\
    {\n\
        VertexShader (in vs_input, out vs_to_ps) = VS;\n\
        PixelShader (in vs_to_ps, out ps_output) = PS2;\n\
    }\n\
}\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>注</strong>: 暗黙的に共有されているブロックは、シェーダ コンパイラに負荷を与える場合があります。たとえば、<span class=\'code\'>computeTransparency</span> は、たとえこれが使用されていなくても、頂点シェーダによって処理されます。また、すべての GLSL 組み込み関数/キーワードがすべてのシェーダ ステージで使用できるわけではないため、コンパイルが失敗する場合があります。たとえば、<span class=\'code\'>discard</span> はピクセル シェーダ ステージでのみ使用でき、頂点シェーダでは失敗します。ただし、プリプロセッサ命令を使用することにより、指定のシェーダ ステージの間にコードの一部のみを有効にすることができます。「<a href=\'#!/url=./dev_help/Writing-a-Hardware-Shading-Node/Creating-GLSL-hardware-shaders/OGSFX-preprocessor-directives.html#defining-shader-stages\' title=\'\'>OGSFX プリプロセッサ命令</a>」を参照してください。</p>\n\
\n\
<div class=\'section\'><a id=\"ogsfx-ファイル内で関数を明示的に共有\"></a><h2 id=\"ogsfx-ファイル内で関数を明示的に共有\">.ogsfx ファイル内で関数を明示的に共有</h2></div>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">// World-view-projection transformation.\n\
uniform mat4 gWVPXf : WorldViewProjection;\n\
\n\
attribute vs_input\n\
{\n\
    vec3 in_position : POSITION;\n\
};\n\
 \n\
attribute vs_to_ps\n\
{\n\
    // None\n\
};\n\
 \n\
attribute ps_output \n\
{\n\
    vec4 out_color : COLOR0;\n\
}\n\
 \n\
// Declare the functions that can be shared among all the stages\n\
GLSLShader Common_Functions\n\
{\n\
    vec4 convertVec3ToVec4(vec3 input)\n\
    {\n\
        return vec4(input, 1);\n\
    }\n\
}\n\
 \n\
// Declare the functions that can be shared among the pixel shader stages\n\
GLSLShader Common_Pixel_Functions\n\
{\n\
    vec4 computeTransparency(vec3 color3)\n\
    {\n\
        vec4 color4 = convertVec3ToVec4(color3);\n\
 \n\
        float alpha = 1;\n\
        // ... perform a number of calculations\n\
        color4.w = alpha;\n\
 \n\
        return color4;\n\
    }\n\
}\n\
 \n\
GLSLShader VS\n\
{\n\
    void main() \n\
    {\n\
        gl_Position = gWVPXf*convertVec3ToVec4(in_position);\n\
    }\n\
}\n\
 \n\
GLSLShader PS1\n\
{\n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(1, 0, 0));\n\
    }\n\
}\n\
 \n\
GLSLShader PS2\n\
{\n\
    void main()\n\
    {\n\
        out_color = computeTransparency(vec3(0, 1, 0));\n\
    }\n\
}\n\
  \n\
technique Main\n\
{\n\
    pass p1\n\
    {\n\
        // Declare the vertex shader stage to include ONLY the functions\n\
        // from the Common_Functions and VS GLSLShader blocks\n\
        // Note that the order is important as each block will only &#39;know&#39;\n\
        // the functions that have been included in previous blocks\n\
        VertexShader (in vs_input, out vs_to_ps) = { Common_Functions, VS };\n\
 \n\
        // Declare the vertex shader stage to include ONLY the functions\n\
        // from Common_Functions, Common_Pixel_Functions and PS1\n\
        PixelShader (in vs_to_ps, out ps_output) = { Common_Functions, Common_Pixel_Functions, PS1 };\n\
    }\n\
 \n\
    pass p2\n\
    {\n\
        VertexShader (in vs_input, out vs_to_ps) = { Common_Functions, VS };\n\
        PixelShader (in vs_to_ps, out ps_output) = { Common_Functions, Common_Pixel_Functions, PS2 };\n\
    }\n\
}\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";