var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>シェーディング ノード プラグインを分析する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>シェーディング ノード プラグインを分析する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"シェーディング-ノード-プラグインを分析する\"></a></div>\n\
<p>Maya のシェーディング ノード プラグインには、ヘッダ ファイル &lt;<span class=\'code\'>maya/MPxNode.h</span>&gt; が含まれており、クラス <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a></span> から派生します。このコマンドにはメソッドが豊富にありますが、実用的なシェーディング ノードの作成で実際に必要となるのは少数です。</p>\n\
<div class=\'section\'><a id=\"コンストラクタ\"></a><h2 id=\"コンストラクタ\">コンストラクタ</h2></div>\n\
<p>新しいクラス自体の要素を初期化します。</p>\n\
<div class=\'section\'><a id=\"デストラクタ\"></a><h2 id=\"デストラクタ\">デストラクタ</h2></div>\n\
<p>クラスで作成されたものをすべて削除します。</p>\n\
<div class=\'section\'><a id=\"クリエータ\"></a><h2 id=\"クリエータ\">クリエータ</h2></div>\n\
<p>このスタティックなメソッドは、新しいクラス(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a></span> から派生します)のインスタンスを実際に作成する役割を担います。新しいオブジェクトを登録する場合、実際には <span class=\'code\'>creator()</span> メソッドを登録することにより、Maya がこのメソッドを呼び出して、オブジェクトの新しいインスタンスを割り当てられるようにします。事実上すべてのケースで以下のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">void* NodeClassName::creator()\n\
{\n\
     return new NodeClassName;\n\
}\n\
\n\
</pre></div><div class=\'section\'><a id=\"initializepluginuninitializeplugin\"></a><h2 id=\"initializepluginuninitializeplugin\">initializePlugin/uninitializePlugin</h2></div>\n\
<p>前者のメソッドは、プラグインがロードされるときにコールされます。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnPlugin</a></span> クラスのインスタンスを作成し(ルーチンに渡された <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> で初期化)、そのクラス内で register メソッドを呼び出して機能を Maya に通知することが目的です。</p>\n\
<blockquote>\n\
<p><strong>重要:</strong> <span class=\'code\'>initializePlugin()</span> と <span class=\'code\'>uninitializePlugin()</span> の両方がすべてのプラグインに存在する必要があります。両方またはどちらか一方がなければ、プラグインはロードされません。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"初期化\"></a><h2 id=\"初期化\">初期化</h2></div>\n\
<p>新しいノードのすべてのアトリビュートは、派生元クラスのスタティック <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a></span> メンバとして宣言されます。initialize メソッドは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnAttribute\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_attribute.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnAttribute</a></span> を呼び出して、アトリビュートの型情報を実際に提供します。デフォルト値や範囲の設定も行います。creator 関数と同様に、これはクラスのスタティック メソッドで、Maya によって 1 回だけコールされます。</p>\n\
<div class=\'section\'><a id=\"id-文字列\"></a><h2 id=\"id-文字列\">ID 文字列</h2></div>\n\
<p>ノードの必須アトリビュートのうちの 1 つは、<span class=\'code\'>MTypeID</span> 型にする必要があります。これは Maya の内部 IFF フラグにマッピングし、一意である必要があります。このアトリビュートの値は、<span class=\'code\'>MTypeID</span> コンストラクタ内で設定されます。</p>\n\
<p>ノードをローカルでテストする場合は、0x00000000 から 0x0007ffff までの識別子を使用できますが、永続的な目的でノードを使用する場合は、世界で固有な識別子を <a href=\'http://mayaid.autodesk.io/\' title=\'\' target=\'_blank\'>http://mayaid.autodesk.io/</a> から取得してください。ユーザごとに独自で管理できる、固有の範囲が割り当てられます。</p>\n\
<div class=\'section\'><a id=\"compute-メソッド\"></a><h2 id=\"compute-メソッド\">compute メソッド</h2></div>\n\
<p>これは、内部ディペンデンシー ノードの compute メソッドに似ています。データ ハンドルをデータ ブロックに渡して、要求した出力アトリビュートの新しい値を計算するために、データ ブロックから入力アトリビュートを抽出する役割があります。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";