var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>シェーディング ノード プラグインを作成する</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>シェーディング ノード プラグインを作成する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"シェーディング-ノード-プラグインを作成する\"></a></div>\n\
<p>カスタム ディペンデンシー グラフ ノードには、以下のヘッダ ファイルを含めます。</p>\n\
<p>&lt;<span class=\'code\'>maya/MPxNode.h</span>&gt;</p>\n\
<p>そして、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a></span> クラスから派生させます。独自のシェーディング ノードを Maya のプラグインとしてビルドするには、ディペンデンシー ノードの作成と同じガイドラインに従います(<a href=\'#!/url=./dev_help/Dependency-graph-plug-ins/About-the-dependency-graph.html\' title=\'\'>ディペンデンシー グラフ(DG)ノード</a>を参照)。</p>\n\
<p>プラグインに関する特定のレンダリング情報は、レンダー時に提供される定義済みアトリビュートで要求します。レンダリング固有のアトリビュートとその名前については、<a href=\'#!/url=./dev_help/Appendices/Appendix-B-Rendering-attributes.html\' title=\'\'>付録 C: レンダリング アトリビュート</a>を参照してください。</p>\n\
<p>Maya では現在、以下の 5 種類のシェーディング ノードを作成できます。</p>\n\
<ul>\n\
<li>サーフェス シェーダ</li>\n\
<li>ライト シェーダ マテリアル</li>\n\
<li>テクスチャ(Texture) シェーダ マテリアル</li>\n\
<li>ディスプレイメント シェーダ(Displacement Shaders)</li>\n\
<li>ボリューム(Volumetric) シェーダ マテリアル</li>\n\
</ul>\n\
<p>シェーディング ノードが接続されて、シェーダ ネットワークが形成されます。どのような Maya ディペンデンシー ノードでも、シェーダ ネットワークの一部にすることができます。Maya では、各シェーダ、テクスチャ、ライトに多くのエフェクトをハード コーディングする代わりに、同じ機能がユーティリティ ノードによって提供されています。これにより、同等以上のエフェクトを実装できます。またシェーディング ノードは、複数のシェーダ ネットワークに同時に貢献できます。</p>\n\
<p>以下のサンプルは、Lambert ノードのカラー アトリビュートにテクスチャ ノードが入力として接続されている、単純な Lambert シェーディング ノード(強調表示)の Maya のハイパーグラフ(Hypergraph)表示です。</p>\n\
<p>この図は、テクスチャ座標を変換するためにチェッカー テクスチャに接続された配置ノードも示しています。それぞれの矢印は、2 つのディペンデンシー ノード間のアトリビュート接続を表します。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/1.png\' title=\'\' /></div>\n\
<p>シェーディング ネットワークは、シェーディング グループ(Shading Group)に接続しないと完成しません。 シェーディング グループ(Shading Group)は、オブジェクトのリストまたは同じシェーダ ネットワークを使用してレンダーされるオブジェクトのコンポーネントのリストのいずれか一方または両方を含む、「レンダリング可能なセット」です。 シェーディング グループでは、オブジェクトのリストに加えて、シェーディング ネットワークへの接続も維持されています。シェーディング グループは、シーン内のオブジェクトおよびレンダー方法を説明するシェーダ ネットワークの間の接続ポイントです。</p>\n\
<p>以下は、シェーディング グループ(強調表示)に接続され、既定の NURBS 球に割り当てられたシェーダ ネットワークの図です。シーン内でディレクショナル ライトが照明用に使用されていることに注意してください。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/2.png\' title=\'\' /></div>\n\
<p>さまざまなシェーディング ノードを使用して複雑なシェーダ ネットワークを構築していくうちに、Lambert ノードの入力(強調表示)につながるすべての接続、および Lambert シェーディング ノードの出力の計算済み結果が、シェーディング グループに接続されているのが分かります。</p>\n\
<div class=\'figure\'><img src=\'dev_help/images/3.png\' title=\'\' /></div>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";