var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>カスタム トランスフォームの概要</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>カスタム トランスフォームの概要</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"カスタム-トランスフォームの概要\"></a></div>\n\
<p>Maya API には、**カスタム トランスフォーム ノードの作成と操作が可能なプロキシ クラスが用意されています。カスタム トランスフォームは、Maya API の高度な利用方法です。トランスフォーム ノードは DAG (Directed Acyclic Graph)ですべてのシェイプ(Shape)ノードやジオメトリ ノードの上になければならないため、Maya の標準的なトランスフォーム ノードは非常に重要です。しかし、カスタム トランスフォームを使用すると、Maya のトランスフォーム ノードをさらに細かく制御できます。</p>\n\
<p>Maya のトランスフォーム ノード(カスタム トランスフォームを含む)は Maya の DAG ノードから派生しており、他の DAG ノードのグループ化や変換を行う場合に使用します。トランスフォーム ノードは、トランスフォーム ノードの下に DAG ノードをいくつでも持つことができます。DAG ノードがトランスフォーム ノードではない場合、この DAG ノードはトランスフォーム ノードの子でなければなりません。</p>\n\
<p>トランスフォーム ノードには、Maya のその他のノードと同様に、入力と出力アトリビュートが含まれています。最も重要な入力アトリビュートは<span class=\'code\'>translate</span>、<span class=\'code\'>rotate</span>、<span class=\'code\'>scale</span> で、最も重要な出力アトリビュートは変換 <span class=\'code\'>matrix</span> です。</p>\n\
<p>カスタム トランスフォームを使用するには、次のクラスについて理解しておく必要があります。</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnTransform</a></span> と <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MTransformationMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_transformation_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_transformation_matrix.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTransformationMatrix</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_matrix.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MMatrix</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxNode</a></span> とそのディペンデンシー グラフ(DG)内での操作方法</li>\n\
</ul>\n\
<p>カスタム トランスフォームを使用するには、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a></span> API クラスから新しいクラスを派生させる必要があります。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a></span> クラスは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransformationMatrix</a></span> クラスと組み合わせて使用します。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a></span> から派生させたクラスと提供された <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransformationMatrix</a></span> を使用して、新しいカスタム トランスフォームを実行することができます。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform</a></span> クラスおよび <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransformationMatrix</a></span> クラスには、新しいトランスフォームの機能を優先的に提供する仮想メソッドが含まれます。これらのクラスで利用できる仮想メソッドを使用すると、Maya の標準的なトランスフォームに対する適切な既定動作を実現できます。</p>\n\
<p>これらのクラスを同時に表示する場合、使用可能なメソッドに存在する平行部分に注意する必要があります。たとえば、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::scaleTo()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#aa0c6cbffd04edd72fe94f3977ef6e486&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform::scaleTo()</a></span> および <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix::scaleTo()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html#aa0c6cbffd04edd72fe94f3977ef6e486&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransformationMatrix::scaleTo()</a></span> があります。これらのクラスでは、DG ノードと変換行列は区別されます。ノード メソッド <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::scaleTo()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#aa0c6cbffd04edd72fe94f3977ef6e486&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform::scaleTo()</a></span> は <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransformationMatrix::scaleTo()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transformation_matrix.html#aa0c6cbffd04edd72fe94f3977ef6e486&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransformationMatrix::scaleTo()</a></span> を呼び出し、処理を実行して結果を返します。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxTransform::scaleTo()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_transform.html#aa0c6cbffd04edd72fe94f3977ef6e486&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxTransform::scaleTo()</a></span> はこの結果を取得して、ノードに格納します。カスタム トランスフォームに新しいアトリビュートを追加するには、同様の方法を行う必要があります。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";